/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2015 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

!function(){define("Core/defined",[],function(){"use strict";function e(e){return void 0!==e&&null!==e}return e}),define("Core/freezeObject",["./defined"],function(e){"use strict";var t=Object.freeze;return e(t)||(t=function(e){return e}),t}),define("Core/defaultValue",["./freezeObject"],function(e){"use strict";function t(e,t){return void 0!==e?e:t}return t.EMPTY_OBJECT=e({}),t}),define("Core/DeveloperError",["./defined"],function(e){"use strict";function t(e){this.name="DeveloperError",this.message=e;var t;try{throw new Error}catch(r){t=r.stack}this.stack=t}return e(Object.create)&&(t.prototype=Object.create(Error.prototype),t.prototype.constructor=t),t.prototype.toString=function(){var t=this.name+": "+this.message;return e(this.stack)&&(t+="\n"+this.stack.toString()),t},t.throwInstantiationError=function(){throw new t("This function defines an interface and should not be called directly.")},t}),define("ThirdParty/mersenne-twister",[],function(){var e=function(e){void 0==e&&(e=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(e)};return e.prototype.init_genrand=function(e){for(this.mt[0]=e>>>0,this.mti=1;this.mti<this.N;this.mti++){var e=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&e)>>>16)<<16)+1812433253*(65535&e)+this.mti,this.mt[this.mti]>>>=0}},e.prototype.genrand_int32=function(){var e,t=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var r;for(this.mti==this.N+1&&this.init_genrand(5489),r=0;r<this.N-this.M;r++)e=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+this.M]^e>>>1^t[1&e];for(;r<this.N-1;r++)e=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+(this.M-this.N)]^e>>>1^t[1&e];e=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^e>>>1^t[1&e],this.mti=0}return e=this.mt[this.mti++],e^=e>>>11,e^=e<<7&2636928640,e^=e<<15&4022730752,e^=e>>>18,e>>>0},e.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},e}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(e,t,r,n){"use strict";var a={};a.EPSILON1=.1,a.EPSILON2=.01,a.EPSILON3=.001,a.EPSILON4=1e-4,a.EPSILON5=1e-5,a.EPSILON6=1e-6,a.EPSILON7=1e-7,a.EPSILON8=1e-8,a.EPSILON9=1e-9,a.EPSILON10=1e-10,a.EPSILON11=1e-11,a.EPSILON12=1e-12,a.EPSILON13=1e-13,a.EPSILON14=1e-14,a.EPSILON15=1e-15,a.EPSILON16=1e-16,a.EPSILON17=1e-17,a.EPSILON18=1e-18,a.EPSILON19=1e-19,a.EPSILON20=1e-20,a.GRAVITATIONALPARAMETER=3986004418e5,a.SOLAR_RADIUS=6955e5,a.LUNAR_RADIUS=1737400,a.SIXTY_FOUR_KILOBYTES=65536,a.sign=function(e){return e>0?1:0>e?-1:0},a.signNotZero=function(e){return 0>e?-1:1},a.toSNorm=function(e){return Math.round(255*(.5*a.clamp(e,-1,1)+.5))},a.fromSNorm=function(e){return a.clamp(e,0,255)/255*2-1},a.sinh=function(e){var t=Math.pow(Math.E,e),r=Math.pow(Math.E,-1*e);return.5*(t-r)},a.cosh=function(e){var t=Math.pow(Math.E,e),r=Math.pow(Math.E,-1*e);return.5*(t+r)},a.lerp=function(e,t,r){return(1-r)*e+r*t},a.PI=Math.PI,a.ONE_OVER_PI=1/Math.PI,a.PI_OVER_TWO=.5*Math.PI,a.PI_OVER_THREE=Math.PI/3,a.PI_OVER_FOUR=Math.PI/4,a.PI_OVER_SIX=Math.PI/6,a.THREE_PI_OVER_TWO=3*Math.PI*.5,a.TWO_PI=2*Math.PI,a.ONE_OVER_TWO_PI=1/(2*Math.PI),a.RADIANS_PER_DEGREE=Math.PI/180,a.DEGREES_PER_RADIAN=180/Math.PI,a.RADIANS_PER_ARCSECOND=a.RADIANS_PER_DEGREE/3600,a.toRadians=function(e){return e*a.RADIANS_PER_DEGREE},a.toDegrees=function(e){return e*a.DEGREES_PER_RADIAN},a.convertLongitudeRange=function(e){var t=a.TWO_PI,r=e-Math.floor(e/t)*t;return r<-Math.PI?r+t:r>=Math.PI?r-t:r},a.negativePiToPi=function(e){return a.zeroToTwoPi(e+a.PI)-a.PI},a.zeroToTwoPi=function(e){var t=a.mod(e,a.TWO_PI);return Math.abs(t)<a.EPSILON14&&Math.abs(e)>a.EPSILON14?a.TWO_PI:t},a.mod=function(e,t){return(e%t+t)%t},a.equalsEpsilon=function(e,r,n,a){a=t(a,n);var o=Math.abs(e-r);return a>=o||o<=n*Math.max(Math.abs(e),Math.abs(r))};var o=[1];a.factorial=function(e){var t=o.length;if(e>=t)for(var r=o[t-1],n=t;e>=n;n++)o.push(r*n);return o[e]},a.incrementWrap=function(e,r,n){return n=t(n,0),++e,e>r&&(e=n),e},a.isPowerOfTwo=function(e){return 0!==e&&0===(e&e-1)},a.nextPowerOfTwo=function(e){return--e,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e,e},a.clamp=function(e,t,r){return t>e?t:e>r?r:e};var i=new e;return a.setRandomNumberSeed=function(t){i=new e(t)},a.nextRandomNumber=function(){return i.random()},a.acosClamped=function(e){return Math.acos(a.clamp(e,-1,1))},a.asinClamped=function(e){return Math.asin(a.clamp(e,-1,1))},a.chordLength=function(e,t){return 2*t*Math.sin(.5*e)},a.logBase=function(e,t){return Math.log(e)/Math.log(t)},a.fog=function(e,t){var r=e*t;return 1-Math.exp(-(r*r))},a}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,a){"use strict";function o(t,r,n){this.x=e(t,0),this.y=e(r,0),this.z=e(n,0)}o.fromSpherical=function(r,n){t(n)||(n=new o);var a=r.clock,i=r.cone,u=e(r.magnitude,1),s=u*Math.sin(i);return n.x=s*Math.cos(a),n.y=s*Math.sin(a),n.z=u*Math.cos(i),n},o.fromElements=function(e,r,n,a){return t(a)?(a.x=e,a.y=r,a.z=n,a):new o(e,r,n)},o.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r.z=e.z,r):new o(e.x,e.y,e.z):void 0},o.fromCartesian4=o.clone,o.packedLength=3,o.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n++]=t.y,r[n]=t.z},o.unpack=function(r,n,a){return n=e(n,0),t(a)||(a=new o),a.x=r[n++],a.y=r[n++],a.z=r[n],a},o.packArray=function(e,r){var n=e.length;t(r)?r.length=3*n:r=new Array(3*n);for(var a=0;n>a;++a)o.pack(e[a],r,3*a);return r},o.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/3:r=new Array(n/3);for(var a=0;n>a;a+=3){var i=a/3;r[i]=o.unpack(e,a,r[i])}return r},o.fromArray=o.unpack,o.maximumComponent=function(e){return Math.max(e.x,e.y,e.z)},o.minimumComponent=function(e){return Math.min(e.x,e.y,e.z)},o.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r.z=Math.min(e.z,t.z),r},o.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r.z=Math.max(e.z,t.z),r},o.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z},o.magnitude=function(e){return Math.sqrt(o.magnitudeSquared(e))};var i=new o;o.distance=function(e,t){return o.subtract(e,t,i),o.magnitude(i)},o.distanceSquared=function(e,t){return o.subtract(e,t,i),o.magnitudeSquared(i)},o.normalize=function(e,t){var r=o.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t},o.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z},o.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r.z=e.z*t.z,r},o.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r.z=e.z+t.z,r},o.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r.z=e.z-t.z,r},o.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r.z=e.z*t,r},o.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r},o.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t},o.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t.z=Math.abs(e.z),t};var u=new o;o.lerp=function(e,t,r,n){return o.multiplyByScalar(t,r,u),n=o.multiplyByScalar(e,1-r,n),o.add(u,n,n)};var s=new o,c=new o;o.angleBetween=function(e,t){o.normalize(e,s),o.normalize(t,c);var r=o.dot(s,c),n=o.magnitude(o.cross(s,c,s));return Math.atan2(n,r)};var l=new o;o.mostOrthogonalAxis=function(e,t){var r=o.normalize(e,l);return o.abs(r,r),t=r.x<=r.y?r.x<=r.z?o.clone(o.UNIT_X,t):o.clone(o.UNIT_Z,t):r.y<=r.z?o.clone(o.UNIT_Y,t):o.clone(o.UNIT_Z,t)},o.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y&&e.z===r.z},o.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]&&e.z===t[r+2]},o.equalsEpsilon=function(e,r,n,o){return e===r||t(e)&&t(r)&&a.equalsEpsilon(e.x,r.x,n,o)&&a.equalsEpsilon(e.y,r.y,n,o)&&a.equalsEpsilon(e.z,r.z,n,o)},o.cross=function(e,t,r){var n=e.x,a=e.y,o=e.z,i=t.x,u=t.y,s=t.z,c=a*s-o*u,l=o*i-n*s,E=n*u-a*i;return r.x=c,r.y=l,r.z=E,r},o.fromDegrees=function(e,t,r,n,i){return e=a.toRadians(e),t=a.toRadians(t),o.fromRadians(e,t,r,n,i)};var E=new o,f=new o,h=new o(40680631590769,40680631590769,40408299984661.445);return o.fromRadians=function(r,n,a,i,u){a=e(a,0);var s=t(i)?i.radiiSquared:h,c=Math.cos(n);E.x=c*Math.cos(r),E.y=c*Math.sin(r),E.z=Math.sin(n),E=o.normalize(E,E),o.multiplyComponents(s,E,f);var l=Math.sqrt(o.dot(E,f));return f=o.divideByScalar(f,l,f),E=o.multiplyByScalar(E,a,E),t(u)||(u=new o),o.add(f,E,u)},o.fromDegreesArray=function(e,r,n){var a=e.length;t(n)?n.length=a/2:n=new Array(a/2);for(var i=0;a>i;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=o.fromDegrees(u,s,0,r,n[c])}return n},o.fromRadiansArray=function(e,r,n){var a=e.length;t(n)?n.length=a/2:n=new Array(a/2);for(var i=0;a>i;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=o.fromRadians(u,s,0,r,n[c])}return n},o.fromDegreesArrayHeights=function(e,r,n){var a=e.length;t(n)?n.length=a/3:n=new Array(a/3);for(var i=0;a>i;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=o.fromDegrees(u,s,c,r,n[l])}return n},o.fromRadiansArrayHeights=function(e,r,n){var a=e.length;t(n)?n.length=a/3:n=new Array(a/3);for(var i=0;a>i;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=o.fromRadians(u,s,c,r,n[l])}return n},o.ZERO=n(new o(0,0,0)),o.UNIT_X=n(new o(1,0,0)),o.UNIT_Y=n(new o(0,1,0)),o.UNIT_Z=n(new o(0,0,1)),o.prototype.clone=function(e){return o.clone(this,e)},o.prototype.equals=function(e){return o.equals(this,e)},o.prototype.equalsEpsilon=function(e,t,r){return o.equalsEpsilon(this,e,t,r)},o.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},o}),define("Core/scaleToGeodeticSurface",["./Cartesian3","./defined","./DeveloperError","./Math"],function(e,t,r,n){"use strict";function a(r,a,u,s,c){var l=r.x,E=r.y,f=r.z,h=a.x,m=a.y,d=a.z,p=l*l*h*h,A=E*E*m*m,T=f*f*d*d,R=p+A+T,y=Math.sqrt(1/R),_=e.multiplyByScalar(r,y,o);if(s>R)return isFinite(y)?e.clone(_,c):void 0;var v=u.x,S=u.y,g=u.z,C=i;C.x=_.x*v*2,C.y=_.y*S*2,C.z=_.z*g*2;var N,I,M,O,L,F,P,b,w,D,x,U=(1-y)*e.magnitude(r)/(.5*e.magnitude(C)),B=0;do{U-=B,M=1/(1+U*v),O=1/(1+U*S),L=1/(1+U*g),F=M*M,P=O*O,b=L*L,w=F*M,D=P*O,x=b*L,N=p*F+A*P+T*b-1,I=p*w*v+A*D*S+T*x*g;var G=-2*I;B=N/G}while(Math.abs(N)>n.EPSILON12);return t(c)?(c.x=l*M,c.y=E*O,c.z=f*L,c):new e(l*M,E*O,f*L)}var o=new e,i=new e;return a}),define("Core/Cartographic",["./Cartesian3","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,t,r,n,a,o,i){"use strict";function u(e,r,n){this.longitude=t(e,0),this.latitude=t(r,0),this.height=t(n,0)}u.fromRadians=function(e,n,a,o){return a=t(a,0),r(o)?(o.longitude=e,o.latitude=n,o.height=a,o):new u(e,n,a)},u.fromDegrees=function(e,t,r,n){return e=o.toRadians(e),t=o.toRadians(t),u.fromRadians(e,t,r,n)};var s=new e,c=new e,l=new e,E=new e(1/6378137,1/6378137,1/6356752.314245179),f=new e(1/40680631590769,1/40680631590769,1/40408299984661.445),h=o.EPSILON1;return u.fromCartesian=function(t,n,a){var m=r(n)?n.oneOverRadii:E,d=r(n)?n.oneOverRadiiSquared:f,p=r(n)?n._centerToleranceSquared:h,A=i(t,m,d,p,c);if(r(A)){var T=e.multiplyComponents(t,d,s);T=e.normalize(T,T);var R=e.subtract(t,A,l),y=Math.atan2(T.y,T.x),_=Math.asin(T.z),v=o.sign(e.dot(R,t))*e.magnitude(R);return r(a)?(a.longitude=y,a.latitude=_,a.height=v,a):new u(y,_,v)}},u.clone=function(e,t){return r(e)?r(t)?(t.longitude=e.longitude,t.latitude=e.latitude,t.height=e.height,t):new u(e.longitude,e.latitude,e.height):void 0},u.equals=function(e,t){return e===t||r(e)&&r(t)&&e.longitude===t.longitude&&e.latitude===t.latitude&&e.height===t.height},u.equalsEpsilon=function(e,t,n){return e===t||r(e)&&r(t)&&Math.abs(e.longitude-t.longitude)<=n&&Math.abs(e.latitude-t.latitude)<=n&&Math.abs(e.height-t.height)<=n},u.ZERO=a(new u(0,0,0)),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,t){return u.equalsEpsilon(this,e,t)},u.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},u}),define("Core/defineProperties",["./defined"],function(e){"use strict";var t=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(e){return!1}}(),r=Object.defineProperties;return t&&e(r)||(r=function(e){return e}),r}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,t,r,n,a,o,i,u,s){"use strict";function c(t,n,a,o){n=r(n,0),a=r(a,0),o=r(o,0),t._radii=new e(n,a,o),t._radiiSquared=new e(n*n,a*a,o*o),t._radiiToTheFourth=new e(n*n*n*n,a*a*a*a,o*o*o*o),t._oneOverRadii=new e(0===n?0:1/n,0===a?0:1/a,0===o?0:1/o),t._oneOverRadiiSquared=new e(0===n?0:1/(n*n),0===a?0:1/(a*a),0===o?0:1/(o*o)),t._minimumRadius=Math.min(n,a,o),t._maximumRadius=Math.max(n,a,o),t._centerToleranceSquared=u.EPSILON1}function l(e,t,r){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,c(this,e,t,r)}a(l.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),l.clone=function(t,r){if(n(t)){var a=t._radii;return n(r)?(e.clone(a,r._radii),e.clone(t._radiiSquared,r._radiiSquared),e.clone(t._radiiToTheFourth,r._radiiToTheFourth),e.clone(t._oneOverRadii,r._oneOverRadii),e.clone(t._oneOverRadiiSquared,r._oneOverRadiiSquared),r._minimumRadius=t._minimumRadius,r._maximumRadius=t._maximumRadius,r._centerToleranceSquared=t._centerToleranceSquared,r):new l(a.x,a.y,a.z)}},l.fromCartesian3=function(e,t){return n(t)||(t=new l),n(e)?(c(t,e.x,e.y,e.z),t):t},l.WGS84=i(new l(6378137,6378137,6356752.314245179)),l.UNIT_SPHERE=i(new l(1,1,1)),l.MOON=i(new l(u.LUNAR_RADIUS,u.LUNAR_RADIUS,u.LUNAR_RADIUS)),l.prototype.clone=function(e){return l.clone(this,e)},l.packedLength=e.packedLength,l.pack=function(t,n,a){a=r(a,0),e.pack(t._radii,n,a)},l.unpack=function(t,n,a){n=r(n,0);var o=e.unpack(t,n);return l.fromCartesian3(o,a)},l.prototype.geocentricSurfaceNormal=e.normalize,l.prototype.geodeticSurfaceNormalCartographic=function(t,r){var a=t.longitude,o=t.latitude,i=Math.cos(o),u=i*Math.cos(a),s=i*Math.sin(a),c=Math.sin(o);return n(r)||(r=new e),r.x=u,r.y=s,r.z=c,e.normalize(r,r)},l.prototype.geodeticSurfaceNormal=function(t,r){return n(r)||(r=new e),r=e.multiplyComponents(t,this._oneOverRadiiSquared,r),e.normalize(r,r)};var E=new e,f=new e;l.prototype.cartographicToCartesian=function(t,r){var a=E,o=f;this.geodeticSurfaceNormalCartographic(t,a),e.multiplyComponents(this._radiiSquared,a,o);var i=Math.sqrt(e.dot(a,o));return e.divideByScalar(o,i,o),e.multiplyByScalar(a,t.height,a),n(r)||(r=new e),e.add(o,a,r)},l.prototype.cartographicArrayToCartesianArray=function(e,t){var r=e.length;n(t)?t.length=r:t=new Array(r);for(var a=0;r>a;a++)t[a]=this.cartographicToCartesian(e[a],t[a]);return t};var h=new e,m=new e,d=new e;return l.prototype.cartesianToCartographic=function(r,a){var o=this.scaleToGeodeticSurface(r,m);if(n(o)){var i=this.geodeticSurfaceNormal(o,h),s=e.subtract(r,o,d),c=Math.atan2(i.y,i.x),l=Math.asin(i.z),E=u.sign(e.dot(s,r))*e.magnitude(s);return n(a)?(a.longitude=c,a.latitude=l,a.height=E,a):new t(c,l,E)}},l.prototype.cartesianArrayToCartographicArray=function(e,t){var r=e.length;n(t)?t.length=r:t=new Array(r);for(var a=0;r>a;++a)t[a]=this.cartesianToCartographic(e[a],t[a]);return t},l.prototype.scaleToGeodeticSurface=function(e,t){return s(e,this._oneOverRadii,this._oneOverRadiiSquared,this._centerToleranceSquared,t)},l.prototype.scaleToGeocentricSurface=function(t,r){n(r)||(r=new e);var a=t.x,o=t.y,i=t.z,u=this._oneOverRadiiSquared,s=1/Math.sqrt(a*a*u.x+o*o*u.y+i*i*u.z);return e.multiplyByScalar(t,s,r)},l.prototype.transformPositionToScaledSpace=function(t,r){return n(r)||(r=new e),e.multiplyComponents(t,this._oneOverRadii,r)},l.prototype.transformPositionFromScaledSpace=function(t,r){return n(r)||(r=new e),e.multiplyComponents(t,this._radii,r)},l.prototype.equals=function(t){return this===t||n(t)&&e.equals(this._radii,t._radii)},l.prototype.toString=function(){return this._radii.toString()},l}),define("Core/GeographicProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid"],function(e,t,r,n,a,o,i){"use strict";function u(e){this._ellipsoid=r(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return a(u.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),u.prototype.project=function(t,r){var a=this._semimajorAxis,o=t.longitude*a,i=t.latitude*a,u=t.height;return n(r)?(r.x=o,r.y=i,r.z=u,r):new e(o,i,u)},u.prototype.unproject=function(e,r){var a=this._oneOverSemimajorAxis,o=e.x*a,i=e.y*a,u=e.z;return n(r)?(r.longitude=o,r.latitude=i,r.height=u,r):new t(o,i,u)},u}),define("Core/Intersect",["./freezeObject"],function(e){"use strict";var t={OUTSIDE:-1,INTERSECTING:0,INSIDE:1};return e(t)}),define("Core/Interval",["./defaultValue"],function(e){"use strict";function t(t,r){this.start=e(t,0),this.stop=e(r,0)}return t}),define("Core/Matrix3",["./Cartesian3","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,a,o,i){"use strict";function u(e,r,n,a,o,i,u,s,c){this[0]=t(e,0),this[1]=t(a,0),this[2]=t(u,0),this[3]=t(r,0),this[4]=t(o,0),this[5]=t(s,0),this[6]=t(n,0),this[7]=t(i,0),this[8]=t(c,0)}function s(e){for(var t=0,r=0;9>r;++r){var n=e[r];t+=n*n}return Math.sqrt(t)}function c(e){for(var t=0,r=0;3>r;++r){var n=e[u.getElementIndex(m[r],h[r])];t+=2*n*n}return Math.sqrt(t)}function l(e,t){for(var r=i.EPSILON15,n=0,a=1,o=0;3>o;++o){var s=Math.abs(e[u.getElementIndex(m[o],h[o])]);s>n&&(a=o,n=s)}var c=1,l=0,E=h[a],f=m[a];if(Math.abs(e[u.getElementIndex(f,E)])>r){var d,p=e[u.getElementIndex(f,f)],A=e[u.getElementIndex(E,E)],T=e[u.getElementIndex(f,E)],R=(p-A)/2/T;d=0>R?-1/(-R+Math.sqrt(1+R*R)):1/(R+Math.sqrt(1+R*R)),c=1/Math.sqrt(1+d*d),l=d*c}return t=u.clone(u.IDENTITY,t),t[u.getElementIndex(E,E)]=t[u.getElementIndex(f,f)]=c,t[u.getElementIndex(f,E)]=l,t[u.getElementIndex(E,f)]=-l,t}u.packedLength=9,u.pack=function(e,r,n){n=t(n,0),r[n++]=e[0],r[n++]=e[1],r[n++]=e[2],r[n++]=e[3],r[n++]=e[4],r[n++]=e[5],r[n++]=e[6],r[n++]=e[7],r[n++]=e[8]},u.unpack=function(e,n,a){return n=t(n,0),r(a)||(a=new u),a[0]=e[n++],a[1]=e[n++],a[2]=e[n++],a[3]=e[n++],a[4]=e[n++],a[5]=e[n++],a[6]=e[n++],a[7]=e[n++],a[8]=e[n++],a},u.clone=function(e,t){return r(e)?r(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):new u(e[0],e[3],e[6],e[1],e[4],e[7],e[2],e[5],e[8]):void 0},u.fromArray=function(e,n,a){return n=t(n,0),r(a)||(a=new u),a[0]=e[n],a[1]=e[n+1],a[2]=e[n+2],a[3]=e[n+3],a[4]=e[n+4],a[5]=e[n+5],a[6]=e[n+6],a[7]=e[n+7],a[8]=e[n+8],a},u.fromColumnMajorArray=function(e,t){return u.clone(e,t)},u.fromRowMajorArray=function(e,t){return r(t)?(t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8],t):new u(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8])},u.fromQuaternion=function(e,t){var n=e.x*e.x,a=e.x*e.y,o=e.x*e.z,i=e.x*e.w,s=e.y*e.y,c=e.y*e.z,l=e.y*e.w,E=e.z*e.z,f=e.z*e.w,h=e.w*e.w,m=n-s-E+h,d=2*(a-f),p=2*(o+l),A=2*(a+f),T=-n+s-E+h,R=2*(c-i),y=2*(o-l),_=2*(c+i),v=-n-s+E+h;return r(t)?(t[0]=m,t[1]=A,t[2]=y,t[3]=d,t[4]=T,t[5]=_,t[6]=p,t[7]=R,t[8]=v,t):new u(m,d,p,A,T,R,y,_,v)},u.fromScale=function(e,t){return r(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=e.y,t[5]=0,t[6]=0,t[7]=0,t[8]=e.z,t):new u(e.x,0,0,0,e.y,0,0,0,e.z)},u.fromUniformScale=function(e,t){return r(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=e,t[5]=0,t[6]=0,t[7]=0,t[8]=e,t):new u(e,0,0,0,e,0,0,0,e)},u.fromCrossProduct=function(e,t){return r(t)?(t[0]=0,t[1]=e.z,t[2]=-e.y,t[3]=-e.z,t[4]=0,t[5]=e.x,t[6]=e.y,t[7]=-e.x,t[8]=0,t):new u(0,-e.z,e.y,e.z,0,-e.x,-e.y,e.x,0)},u.fromRotationX=function(e,t){var n=Math.cos(e),a=Math.sin(e);return r(t)?(t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=n,t[5]=a,t[6]=0,t[7]=-a,t[8]=n,t):new u(1,0,0,0,n,-a,0,a,n)},u.fromRotationY=function(e,t){var n=Math.cos(e),a=Math.sin(e);return r(t)?(t[0]=n,t[1]=0,t[2]=-a,t[3]=0,t[4]=1,t[5]=0,t[6]=a,t[7]=0,t[8]=n,t):new u(n,0,a,0,1,0,-a,0,n)},u.fromRotationZ=function(e,t){var n=Math.cos(e),a=Math.sin(e);return r(t)?(t[0]=n,t[1]=a,t[2]=0,t[3]=-a,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t):new u(n,-a,0,a,n,0,0,0,1)},u.toArray=function(e,t){return r(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8]]},u.getElementIndex=function(e,t){return 3*e+t},u.getColumn=function(e,t,r){var n=3*t,a=e[n],o=e[n+1],i=e[n+2];return r.x=a,r.y=o,r.z=i,r},u.setColumn=function(e,t,r,n){n=u.clone(e,n);var a=3*t;return n[a]=r.x,n[a+1]=r.y,n[a+2]=r.z,n},u.getRow=function(e,t,r){var n=e[t],a=e[t+3],o=e[t+6];return r.x=n,r.y=a,r.z=o,r},u.setRow=function(e,t,r,n){return n=u.clone(e,n),n[t]=r.x,n[t+3]=r.y,n[t+6]=r.z,n};var E=new e;u.getScale=function(t,r){return r.x=e.magnitude(e.fromElements(t[0],t[1],t[2],E)),r.y=e.magnitude(e.fromElements(t[3],t[4],t[5],E)),r.z=e.magnitude(e.fromElements(t[6],t[7],t[8],E)),r};var f=new e;u.getMaximumScale=function(t){return u.getScale(t,f),e.maximumComponent(f)},u.multiply=function(e,t,r){var n=e[0]*t[0]+e[3]*t[1]+e[6]*t[2],a=e[1]*t[0]+e[4]*t[1]+e[7]*t[2],o=e[2]*t[0]+e[5]*t[1]+e[8]*t[2],i=e[0]*t[3]+e[3]*t[4]+e[6]*t[5],u=e[1]*t[3]+e[4]*t[4]+e[7]*t[5],s=e[2]*t[3]+e[5]*t[4]+e[8]*t[5],c=e[0]*t[6]+e[3]*t[7]+e[6]*t[8],l=e[1]*t[6]+e[4]*t[7]+e[7]*t[8],E=e[2]*t[6]+e[5]*t[7]+e[8]*t[8];return r[0]=n,r[1]=a,r[2]=o,r[3]=i,r[4]=u,r[5]=s,r[6]=c,r[7]=l,r[8]=E,r},u.add=function(e,t,r){return r[0]=e[0]+t[0],r[1]=e[1]+t[1],r[2]=e[2]+t[2],r[3]=e[3]+t[3],r[4]=e[4]+t[4],r[5]=e[5]+t[5],r[6]=e[6]+t[6],r[7]=e[7]+t[7],r[8]=e[8]+t[8],r},u.subtract=function(e,t,r){return r[0]=e[0]-t[0],r[1]=e[1]-t[1],r[2]=e[2]-t[2],r[3]=e[3]-t[3],r[4]=e[4]-t[4],r[5]=e[5]-t[5],r[6]=e[6]-t[6],r[7]=e[7]-t[7],r[8]=e[8]-t[8],r},u.multiplyByVector=function(e,t,r){var n=t.x,a=t.y,o=t.z,i=e[0]*n+e[3]*a+e[6]*o,u=e[1]*n+e[4]*a+e[7]*o,s=e[2]*n+e[5]*a+e[8]*o;return r.x=i,r.y=u,r.z=s,r},u.multiplyByScalar=function(e,t,r){return r[0]=e[0]*t,r[1]=e[1]*t,r[2]=e[2]*t,r[3]=e[3]*t,r[4]=e[4]*t,r[5]=e[5]*t,r[6]=e[6]*t,r[7]=e[7]*t,r[8]=e[8]*t,r},u.multiplyByScale=function(e,t,r){return r[0]=e[0]*t.x,r[1]=e[1]*t.x,r[2]=e[2]*t.x,r[3]=e[3]*t.y,r[4]=e[4]*t.y,r[5]=e[5]*t.y,r[6]=e[6]*t.z,r[7]=e[7]*t.z,r[8]=e[8]*t.z,r},u.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t},u.transpose=function(e,t){var r=e[0],n=e[3],a=e[6],o=e[1],i=e[4],u=e[7],s=e[2],c=e[5],l=e[8];return t[0]=r,t[1]=n,t[2]=a,t[3]=o,t[4]=i,t[5]=u,t[6]=s,t[7]=c,t[8]=l,t};var h=[1,0,0],m=[2,2,1],d=new u,p=new u;return u.computeEigenDecomposition=function(e,t){var n=i.EPSILON20,a=10,o=0,E=0;r(t)||(t={});for(var f=t.unitary=u.clone(u.IDENTITY,t.unitary),h=t.diagonal=u.clone(e,t.diagonal),m=n*s(h);a>E&&c(h)>m;)l(h,d),u.transpose(d,p),u.multiply(h,d,h),u.multiply(p,h,h),u.multiply(f,d,f),++o>2&&(++E,o=0);return t},u.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t},u.determinant=function(e){var t=e[0],r=e[3],n=e[6],a=e[1],o=e[4],i=e[7],u=e[2],s=e[5],c=e[8];return t*(o*c-s*i)+a*(s*n-r*c)+u*(r*i-o*n)},u.inverse=function(e,t){var r=e[0],n=e[1],o=e[2],s=e[3],c=e[4],l=e[5],E=e[6],f=e[7],h=e[8],m=u.determinant(e);if(Math.abs(m)<=i.EPSILON15)throw new a("matrix is not invertible");t[0]=c*h-f*l,t[1]=f*o-n*h,t[2]=n*l-c*o,t[3]=E*l-s*h,t[4]=r*h-E*o,t[5]=s*o-r*l,t[6]=s*f-E*c,t[7]=E*n-r*f,t[8]=r*c-s*n;var d=1/m;return u.multiplyByScalar(t,d,t)},u.equals=function(e,t){return e===t||r(e)&&r(t)&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]},u.equalsEpsilon=function(e,t,n){return e===t||r(e)&&r(t)&&Math.abs(e[0]-t[0])<=n&&Math.abs(e[1]-t[1])<=n&&Math.abs(e[2]-t[2])<=n&&Math.abs(e[3]-t[3])<=n&&Math.abs(e[4]-t[4])<=n&&Math.abs(e[5]-t[5])<=n&&Math.abs(e[6]-t[6])<=n&&Math.abs(e[7]-t[7])<=n&&Math.abs(e[8]-t[8])<=n},u.IDENTITY=o(new u(1,0,0,0,1,0,0,0,1)),u.ZERO=o(new u(0,0,0,0,0,0,0,0,0)),u.COLUMN0ROW0=0,u.COLUMN0ROW1=1,u.COLUMN0ROW2=2,u.COLUMN1ROW0=3,u.COLUMN1ROW1=4,u.COLUMN1ROW2=5,u.COLUMN2ROW0=6,u.COLUMN2ROW1=7,u.COLUMN2ROW2=8,n(u.prototype,{length:{get:function(){return u.packedLength}}}),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.equalsArray=function(e,t,r){return e[0]===t[r]&&e[1]===t[r+1]&&e[2]===t[r+2]&&e[3]===t[r+3]&&e[4]===t[r+4]&&e[5]===t[r+5]&&e[6]===t[r+6]&&e[7]===t[r+7]&&e[8]===t[r+8]},u.prototype.equalsEpsilon=function(e,t){return u.equalsEpsilon(this,e,t)},u.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n("+this[1]+", "+this[4]+", "+this[7]+")\n("+this[2]+", "+this[5]+", "+this[8]+")"},u}),define("Core/Cartesian4",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,a){"use strict";function o(t,r,n,a){this.x=e(t,0),this.y=e(r,0),this.z=e(n,0),this.w=e(a,0)}o.fromElements=function(e,r,n,a,i){return t(i)?(i.x=e,i.y=r,i.z=n,i.w=a,i):new o(e,r,n,a)},o.fromColor=function(e,r){return t(r)?(r.x=e.red,r.y=e.green,r.z=e.blue,r.w=e.alpha,r):new o(e.red,e.green,e.blue,e.alpha)},o.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r.z=e.z,r.w=e.w,r):new o(e.x,e.y,e.z,e.w):void 0},o.packedLength=4,o.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n++]=t.y,r[n++]=t.z,r[n]=t.w},o.unpack=function(r,n,a){return n=e(n,0),t(a)||(a=new o),a.x=r[n++],a.y=r[n++],a.z=r[n++],a.w=r[n],a},o.packArray=function(e,r){var n=e.length;t(r)?r.length=4*n:r=new Array(4*n);for(var a=0;n>a;++a)o.pack(e[a],r,4*a);return r},o.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/4:r=new Array(n/4);for(var a=0;n>a;a+=4){var i=a/4;r[i]=o.unpack(e,a,r[i])}return r},o.fromArray=o.unpack,o.maximumComponent=function(e){return Math.max(e.x,e.y,e.z,e.w)},o.minimumComponent=function(e){return Math.min(e.x,e.y,e.z,e.w)},o.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r.z=Math.min(e.z,t.z),r.w=Math.min(e.w,t.w),r},o.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r.z=Math.max(e.z,t.z),r.w=Math.max(e.w,t.w),r},o.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w},o.magnitude=function(e){return Math.sqrt(o.magnitudeSquared(e))};var i=new o;o.distance=function(e,t){return o.subtract(e,t,i),o.magnitude(i)},o.distanceSquared=function(e,t){return o.subtract(e,t,i),o.magnitudeSquared(i)},o.normalize=function(e,t){var r=o.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t.w=e.w/r,t},o.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z+e.w*t.w},o.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r.z=e.z*t.z,r.w=e.w*t.w,r},o.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r.z=e.z+t.z,r.w=e.w+t.w,r},o.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r.z=e.z-t.z,r.w=e.w-t.w,r},o.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r.z=e.z*t,r.w=e.w*t,r},o.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r.w=e.w/t,r},o.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=-e.w,t},o.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t.z=Math.abs(e.z),t.w=Math.abs(e.w),t};var u=new o;o.lerp=function(e,t,r,n){return o.multiplyByScalar(t,r,u),n=o.multiplyByScalar(e,1-r,n),o.add(u,n,n)};var s=new o;return o.mostOrthogonalAxis=function(e,t){var r=o.normalize(e,s);return o.abs(r,r),t=r.x<=r.y?r.x<=r.z?r.x<=r.w?o.clone(o.UNIT_X,t):o.clone(o.UNIT_W,t):r.z<=r.w?o.clone(o.UNIT_Z,t):o.clone(o.UNIT_W,t):r.y<=r.z?r.y<=r.w?o.clone(o.UNIT_Y,t):o.clone(o.UNIT_W,t):r.z<=r.w?o.clone(o.UNIT_Z,t):o.clone(o.UNIT_W,t)},o.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y&&e.z===r.z&&e.w===r.w},o.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]&&e.z===t[r+2]&&e.w===t[r+3]},o.equalsEpsilon=function(e,r,n,o){return e===r||t(e)&&t(r)&&a.equalsEpsilon(e.x,r.x,n,o)&&a.equalsEpsilon(e.y,r.y,n,o)&&a.equalsEpsilon(e.z,r.z,n,o)&&a.equalsEpsilon(e.w,r.w,n,o)},o.ZERO=n(new o(0,0,0,0)),o.UNIT_X=n(new o(1,0,0,0)),o.UNIT_Y=n(new o(0,1,0,0)),o.UNIT_Z=n(new o(0,0,1,0)),o.UNIT_W=n(new o(0,0,0,1)),o.prototype.clone=function(e){return o.clone(this,e)},o.prototype.equals=function(e){return o.equals(this,e)},o.prototype.equalsEpsilon=function(e,t,r){return o.equalsEpsilon(this,e,t,r)},o.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"},o}),define("Core/RuntimeError",["./defined"],function(e){"use strict";function t(e){this.name="RuntimeError",this.message=e;var t;try{throw new Error}catch(r){t=r.stack}this.stack=t}return e(Object.create)&&(t.prototype=Object.create(Error.prototype),t.prototype.constructor=t),t.prototype.toString=function(){var t=this.name+": "+this.message;return e(this.stack)&&(t+="\n"+this.stack.toString()),t},t}),define("Core/Matrix4",["./Cartesian3","./Cartesian4","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./Matrix3","./RuntimeError"],function(e,t,r,n,a,o,i,u,s,c){"use strict";function l(e,t,n,a,o,i,u,s,c,l,E,f,h,m,d,p){this[0]=r(e,0),this[1]=r(o,0),this[2]=r(c,0),this[3]=r(h,0),this[4]=r(t,0),this[5]=r(i,0),this[6]=r(l,0),this[7]=r(m,0),this[8]=r(n,0),this[9]=r(u,0),this[10]=r(E,0),this[11]=r(d,0),this[12]=r(a,0),this[13]=r(s,0),this[14]=r(f,0),this[15]=r(p,0)}l.packedLength=16,l.pack=function(e,t,n){n=r(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t[n++]=e[4],t[n++]=e[5],t[n++]=e[6],t[n++]=e[7],t[n++]=e[8],t[n++]=e[9],t[n++]=e[10],t[n++]=e[11],t[n++]=e[12],t[n++]=e[13],t[n++]=e[14],t[n]=e[15]},l.unpack=function(e,t,a){return t=r(t,0),n(a)||(a=new l),a[0]=e[t++],a[1]=e[t++],a[2]=e[t++],a[3]=e[t++],a[4]=e[t++],a[5]=e[t++],a[6]=e[t++],a[7]=e[t++],a[8]=e[t++],a[9]=e[t++],a[10]=e[t++],a[11]=e[t++],a[12]=e[t++],a[13]=e[t++],a[14]=e[t++],a[15]=e[t],a},l.clone=function(e,t){return n(e)?n(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):new l(e[0],e[4],e[8],e[12],e[1],e[5],e[9],e[13],e[2],e[6],e[10],e[14],e[3],e[7],e[11],e[15]):void 0},l.fromArray=l.unpack,l.fromColumnMajorArray=function(e,t){return l.clone(e,t)},l.fromRowMajorArray=function(e,t){return n(t)?(t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15],t):new l(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15])},l.fromRotationTranslation=function(t,a,o){return a=r(a,e.ZERO),n(o)?(o[0]=t[0],o[1]=t[1],o[2]=t[2],o[3]=0,o[4]=t[3],o[5]=t[4],o[6]=t[5],o[7]=0,o[8]=t[6],o[9]=t[7],o[10]=t[8],o[11]=0,o[12]=a.x,o[13]=a.y,o[14]=a.z,o[15]=1,o):new l(t[0],t[3],t[6],a.x,t[1],t[4],t[7],a.y,t[2],t[5],t[8],a.z,0,0,0,1)},l.fromTranslationQuaternionRotationScale=function(e,t,r,a){n(a)||(a=new l);var o=r.x,i=r.y,u=r.z,s=t.x*t.x,c=t.x*t.y,E=t.x*t.z,f=t.x*t.w,h=t.y*t.y,m=t.y*t.z,d=t.y*t.w,p=t.z*t.z,A=t.z*t.w,T=t.w*t.w,R=s-h-p+T,y=2*(c-A),_=2*(E+d),v=2*(c+A),S=-s+h-p+T,g=2*(m-f),C=2*(E-d),N=2*(m+f),I=-s-h+p+T;return a[0]=R*o,a[1]=v*o,a[2]=C*o,a[3]=0,a[4]=y*i,a[5]=S*i,a[6]=N*i,a[7]=0,a[8]=_*u,a[9]=g*u,a[10]=I*u,a[11]=0,a[12]=e.x,a[13]=e.y,a[14]=e.z,
a[15]=1,a},l.fromTranslationRotationScale=function(e,t){return l.fromTranslationQuaternionRotationScale(e.translation,e.rotation,e.scale,t)},l.fromTranslation=function(e,t){return l.fromRotationTranslation(s.IDENTITY,e,t)},l.fromScale=function(e,t){return n(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e.y,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e.z,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new l(e.x,0,0,0,0,e.y,0,0,0,0,e.z,0,0,0,0,1)},l.fromUniformScale=function(e,t){return n(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new l(e,0,0,0,0,e,0,0,0,0,e,0,0,0,0,1)};var E=new e,f=new e,h=new e;l.fromCamera=function(t,r){var a=t.position,o=t.direction,i=t.up;e.normalize(o,E),e.normalize(e.cross(E,i,f),f),e.normalize(e.cross(f,E,h),h);var u=f.x,s=f.y,c=f.z,m=E.x,d=E.y,p=E.z,A=h.x,T=h.y,R=h.z,y=a.x,_=a.y,v=a.z,S=u*-y+s*-_+c*-v,g=A*-y+T*-_+R*-v,C=m*y+d*_+p*v;return n(r)?(r[0]=u,r[1]=A,r[2]=-m,r[3]=0,r[4]=s,r[5]=T,r[6]=-d,r[7]=0,r[8]=c,r[9]=R,r[10]=-p,r[11]=0,r[12]=S,r[13]=g,r[14]=C,r[15]=1,r):new l(u,s,c,S,A,T,R,g,-m,-d,-p,C,0,0,0,1)},l.computePerspectiveFieldOfView=function(e,t,r,n,a){var o=Math.tan(.5*e),i=1/o,u=i/t,s=(n+r)/(r-n),c=2*n*r/(r-n);return a[0]=u,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=i,a[6]=0,a[7]=0,a[8]=0,a[9]=0,a[10]=s,a[11]=-1,a[12]=0,a[13]=0,a[14]=c,a[15]=0,a},l.computeOrthographicOffCenter=function(e,t,r,n,a,o,i){var u=1/(t-e),s=1/(n-r),c=1/(o-a),l=-(t+e)*u,E=-(n+r)*s,f=-(o+a)*c;return u*=2,s*=2,c*=-2,i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=0,i[9]=0,i[10]=c,i[11]=0,i[12]=l,i[13]=E,i[14]=f,i[15]=1,i},l.computePerspectiveOffCenter=function(e,t,r,n,a,o,i){var u=2*a/(t-e),s=2*a/(n-r),c=(t+e)/(t-e),l=(n+r)/(n-r),E=-(o+a)/(o-a),f=-1,h=-2*o*a/(o-a);return i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=c,i[9]=l,i[10]=E,i[11]=f,i[12]=0,i[13]=0,i[14]=h,i[15]=0,i},l.computeInfinitePerspectiveOffCenter=function(e,t,r,n,a,o){var i=2*a/(t-e),u=2*a/(n-r),s=(t+e)/(t-e),c=(n+r)/(n-r),l=-1,E=-1,f=-2*a;return o[0]=i,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=u,o[6]=0,o[7]=0,o[8]=s,o[9]=c,o[10]=l,o[11]=E,o[12]=0,o[13]=0,o[14]=f,o[15]=0,o},l.computeViewportTransformation=function(e,t,n,a){e=r(e,r.EMPTY_OBJECT);var o=r(e.x,0),i=r(e.y,0),u=r(e.width,0),s=r(e.height,0);t=r(t,0),n=r(n,1);var c=.5*u,l=.5*s,E=.5*(n-t),f=c,h=l,m=E,d=o+c,p=i+l,A=t+E,T=1;return a[0]=f,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=h,a[6]=0,a[7]=0,a[8]=0,a[9]=0,a[10]=m,a[11]=0,a[12]=d,a[13]=p,a[14]=A,a[15]=T,a},l.computeView=function(t,r,n,a,o){return o[0]=a.x,o[1]=n.x,o[2]=-r.x,o[3]=0,o[4]=a.y,o[5]=n.y,o[6]=-r.y,o[7]=0,o[8]=a.z,o[9]=n.z,o[10]=-r.z,o[11]=0,o[12]=-e.dot(a,t),o[13]=-e.dot(n,t),o[14]=e.dot(r,t),o[15]=1,o},l.toArray=function(e,t){return n(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15]]},l.getElementIndex=function(e,t){return 4*e+t},l.getColumn=function(e,t,r){var n=4*t,a=e[n],o=e[n+1],i=e[n+2],u=e[n+3];return r.x=a,r.y=o,r.z=i,r.w=u,r},l.setColumn=function(e,t,r,n){n=l.clone(e,n);var a=4*t;return n[a]=r.x,n[a+1]=r.y,n[a+2]=r.z,n[a+3]=r.w,n},l.setTranslation=function(e,t,r){return r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=t.x,r[13]=t.y,r[14]=t.z,r[15]=e[15],r},l.getRow=function(e,t,r){var n=e[t],a=e[t+4],o=e[t+8],i=e[t+12];return r.x=n,r.y=a,r.z=o,r.w=i,r},l.setRow=function(e,t,r,n){return n=l.clone(e,n),n[t]=r.x,n[t+4]=r.y,n[t+8]=r.z,n[t+12]=r.w,n};var m=new e;l.getScale=function(t,r){return r.x=e.magnitude(e.fromElements(t[0],t[1],t[2],m)),r.y=e.magnitude(e.fromElements(t[4],t[5],t[6],m)),r.z=e.magnitude(e.fromElements(t[8],t[9],t[10],m)),r};var d=new e;l.getMaximumScale=function(t){return l.getScale(t,d),e.maximumComponent(d)},l.multiply=function(e,t,r){var n=e[0],a=e[1],o=e[2],i=e[3],u=e[4],s=e[5],c=e[6],l=e[7],E=e[8],f=e[9],h=e[10],m=e[11],d=e[12],p=e[13],A=e[14],T=e[15],R=t[0],y=t[1],_=t[2],v=t[3],S=t[4],g=t[5],C=t[6],N=t[7],I=t[8],M=t[9],O=t[10],L=t[11],F=t[12],P=t[13],b=t[14],w=t[15],D=n*R+u*y+E*_+d*v,x=a*R+s*y+f*_+p*v,U=o*R+c*y+h*_+A*v,B=i*R+l*y+m*_+T*v,G=n*S+u*g+E*C+d*N,z=a*S+s*g+f*C+p*N,V=o*S+c*g+h*C+A*N,H=i*S+l*g+m*C+T*N,W=n*I+u*M+E*O+d*L,q=a*I+s*M+f*O+p*L,X=o*I+c*M+h*O+A*L,Y=i*I+l*M+m*O+T*L,k=n*F+u*P+E*b+d*w,K=a*F+s*P+f*b+p*w,Z=o*F+c*P+h*b+A*w,j=i*F+l*P+m*b+T*w;return r[0]=D,r[1]=x,r[2]=U,r[3]=B,r[4]=G,r[5]=z,r[6]=V,r[7]=H,r[8]=W,r[9]=q,r[10]=X,r[11]=Y,r[12]=k,r[13]=K,r[14]=Z,r[15]=j,r},l.add=function(e,t,r){return r[0]=e[0]+t[0],r[1]=e[1]+t[1],r[2]=e[2]+t[2],r[3]=e[3]+t[3],r[4]=e[4]+t[4],r[5]=e[5]+t[5],r[6]=e[6]+t[6],r[7]=e[7]+t[7],r[8]=e[8]+t[8],r[9]=e[9]+t[9],r[10]=e[10]+t[10],r[11]=e[11]+t[11],r[12]=e[12]+t[12],r[13]=e[13]+t[13],r[14]=e[14]+t[14],r[15]=e[15]+t[15],r},l.subtract=function(e,t,r){return r[0]=e[0]-t[0],r[1]=e[1]-t[1],r[2]=e[2]-t[2],r[3]=e[3]-t[3],r[4]=e[4]-t[4],r[5]=e[5]-t[5],r[6]=e[6]-t[6],r[7]=e[7]-t[7],r[8]=e[8]-t[8],r[9]=e[9]-t[9],r[10]=e[10]-t[10],r[11]=e[11]-t[11],r[12]=e[12]-t[12],r[13]=e[13]-t[13],r[14]=e[14]-t[14],r[15]=e[15]-t[15],r},l.multiplyTransformation=function(e,t,r){var n=e[0],a=e[1],o=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=e[12],h=e[13],m=e[14],d=t[0],p=t[1],A=t[2],T=t[4],R=t[5],y=t[6],_=t[8],v=t[9],S=t[10],g=t[12],C=t[13],N=t[14],I=n*d+i*p+c*A,M=a*d+u*p+l*A,O=o*d+s*p+E*A,L=n*T+i*R+c*y,F=a*T+u*R+l*y,P=o*T+s*R+E*y,b=n*_+i*v+c*S,w=a*_+u*v+l*S,D=o*_+s*v+E*S,x=n*g+i*C+c*N+f,U=a*g+u*C+l*N+h,B=o*g+s*C+E*N+m;return r[0]=I,r[1]=M,r[2]=O,r[3]=0,r[4]=L,r[5]=F,r[6]=P,r[7]=0,r[8]=b,r[9]=w,r[10]=D,r[11]=0,r[12]=x,r[13]=U,r[14]=B,r[15]=1,r},l.multiplyByMatrix3=function(e,t,r){var n=e[0],a=e[1],o=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=t[0],h=t[1],m=t[2],d=t[3],p=t[4],A=t[5],T=t[6],R=t[7],y=t[8],_=n*f+i*h+c*m,v=a*f+u*h+l*m,S=o*f+s*h+E*m,g=n*d+i*p+c*A,C=a*d+u*p+l*A,N=o*d+s*p+E*A,I=n*T+i*R+c*y,M=a*T+u*R+l*y,O=o*T+s*R+E*y;return r[0]=_,r[1]=v,r[2]=S,r[3]=0,r[4]=g,r[5]=C,r[6]=N,r[7]=0,r[8]=I,r[9]=M,r[10]=O,r[11]=0,r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=e[15],r},l.multiplyByTranslation=function(e,t,r){var n=t.x,a=t.y,o=t.z,i=n*e[0]+a*e[4]+o*e[8]+e[12],u=n*e[1]+a*e[5]+o*e[9]+e[13],s=n*e[2]+a*e[6]+o*e[10]+e[14];return r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=i,r[13]=u,r[14]=s,r[15]=e[15],r};var p=new e;l.multiplyByUniformScale=function(e,t,r){return p.x=t,p.y=t,p.z=t,l.multiplyByScale(e,p,r)},l.multiplyByScale=function(e,t,r){var n=t.x,a=t.y,o=t.z;return 1===n&&1===a&&1===o?l.clone(e,r):(r[0]=n*e[0],r[1]=n*e[1],r[2]=n*e[2],r[3]=0,r[4]=a*e[4],r[5]=a*e[5],r[6]=a*e[6],r[7]=0,r[8]=o*e[8],r[9]=o*e[9],r[10]=o*e[10],r[11]=0,r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=1,r)},l.multiplyByVector=function(e,t,r){var n=t.x,a=t.y,o=t.z,i=t.w,u=e[0]*n+e[4]*a+e[8]*o+e[12]*i,s=e[1]*n+e[5]*a+e[9]*o+e[13]*i,c=e[2]*n+e[6]*a+e[10]*o+e[14]*i,l=e[3]*n+e[7]*a+e[11]*o+e[15]*i;return r.x=u,r.y=s,r.z=c,r.w=l,r},l.multiplyByPointAsVector=function(e,t,r){var n=t.x,a=t.y,o=t.z,i=e[0]*n+e[4]*a+e[8]*o,u=e[1]*n+e[5]*a+e[9]*o,s=e[2]*n+e[6]*a+e[10]*o;return r.x=i,r.y=u,r.z=s,r},l.multiplyByPoint=function(e,t,r){var n=t.x,a=t.y,o=t.z,i=e[0]*n+e[4]*a+e[8]*o+e[12],u=e[1]*n+e[5]*a+e[9]*o+e[13],s=e[2]*n+e[6]*a+e[10]*o+e[14];return r.x=i,r.y=u,r.z=s,r},l.multiplyByScalar=function(e,t,r){return r[0]=e[0]*t,r[1]=e[1]*t,r[2]=e[2]*t,r[3]=e[3]*t,r[4]=e[4]*t,r[5]=e[5]*t,r[6]=e[6]*t,r[7]=e[7]*t,r[8]=e[8]*t,r[9]=e[9]*t,r[10]=e[10]*t,r[11]=e[11]*t,r[12]=e[12]*t,r[13]=e[13]*t,r[14]=e[14]*t,r[15]=e[15]*t,r},l.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t[9]=-e[9],t[10]=-e[10],t[11]=-e[11],t[12]=-e[12],t[13]=-e[13],t[14]=-e[14],t[15]=-e[15],t},l.transpose=function(e,t){var r=e[1],n=e[2],a=e[3],o=e[6],i=e[7],u=e[11];return t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=o,t[10]=e[10],t[11]=e[14],t[12]=a,t[13]=i,t[14]=u,t[15]=e[15],t},l.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t[9]=Math.abs(e[9]),t[10]=Math.abs(e[10]),t[11]=Math.abs(e[11]),t[12]=Math.abs(e[12]),t[13]=Math.abs(e[13]),t[14]=Math.abs(e[14]),t[15]=Math.abs(e[15]),t},l.equals=function(e,t){return e===t||n(e)&&n(t)&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[3]===t[3]&&e[7]===t[7]&&e[11]===t[11]&&e[15]===t[15]},l.equalsEpsilon=function(e,t,r){return e===t||n(e)&&n(t)&&Math.abs(e[0]-t[0])<=r&&Math.abs(e[1]-t[1])<=r&&Math.abs(e[2]-t[2])<=r&&Math.abs(e[3]-t[3])<=r&&Math.abs(e[4]-t[4])<=r&&Math.abs(e[5]-t[5])<=r&&Math.abs(e[6]-t[6])<=r&&Math.abs(e[7]-t[7])<=r&&Math.abs(e[8]-t[8])<=r&&Math.abs(e[9]-t[9])<=r&&Math.abs(e[10]-t[10])<=r&&Math.abs(e[11]-t[11])<=r&&Math.abs(e[12]-t[12])<=r&&Math.abs(e[13]-t[13])<=r&&Math.abs(e[14]-t[14])<=r&&Math.abs(e[15]-t[15])<=r},l.getTranslation=function(e,t){return t.x=e[12],t.y=e[13],t.z=e[14],t},l.getRotation=function(e,t){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t};var A=new s,T=new s,R=new t,y=new t(0,0,0,1);return l.inverse=function(e,r){if(s.equalsEpsilon(l.getRotation(e,A),T,u.EPSILON7)&&t.equals(l.getRow(e,3,R),y))return r[0]=0,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=0,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=0,r[11]=0,r[12]=-e[12],r[13]=-e[13],r[14]=-e[14],r[15]=1,r;var n=e[0],a=e[4],o=e[8],i=e[12],E=e[1],f=e[5],h=e[9],m=e[13],d=e[2],p=e[6],_=e[10],v=e[14],S=e[3],g=e[7],C=e[11],N=e[15],I=_*N,M=v*C,O=p*N,L=v*g,F=p*C,P=_*g,b=d*N,w=v*S,D=d*C,x=_*S,U=d*g,B=p*S,G=I*f+L*h+F*m-(M*f+O*h+P*m),z=M*E+b*h+x*m-(I*E+w*h+D*m),V=O*E+w*f+U*m-(L*E+b*f+B*m),H=P*E+D*f+B*h-(F*E+x*f+U*h),W=M*a+O*o+P*i-(I*a+L*o+F*i),q=I*n+w*o+D*i-(M*n+b*o+x*i),X=L*n+b*a+B*i-(O*n+w*a+U*i),Y=F*n+x*a+U*o-(P*n+D*a+B*o);I=o*m,M=i*h,O=a*m,L=i*f,F=a*h,P=o*f,b=n*m,w=i*E,D=n*h,x=o*E,U=n*f,B=a*E;var k=I*g+L*C+F*N-(M*g+O*C+P*N),K=M*S+b*C+x*N-(I*S+w*C+D*N),Z=O*S+w*g+U*N-(L*S+b*g+B*N),j=P*S+D*g+B*C-(F*S+x*g+U*C),Q=O*_+P*v+M*p-(F*v+I*p+L*_),J=D*v+I*d+w*_-(b*_+x*v+M*d),$=b*p+B*v+L*d-(U*v+O*d+w*p),ee=U*_+F*d+x*p-(D*p+B*_+P*d),te=n*G+a*z+o*V+i*H;if(Math.abs(te)<u.EPSILON20)throw new c("matrix is not invertible because its determinate is zero.");return te=1/te,r[0]=G*te,r[1]=z*te,r[2]=V*te,r[3]=H*te,r[4]=W*te,r[5]=q*te,r[6]=X*te,r[7]=Y*te,r[8]=k*te,r[9]=K*te,r[10]=Z*te,r[11]=j*te,r[12]=Q*te,r[13]=J*te,r[14]=$*te,r[15]=ee*te,r},l.inverseTransformation=function(e,t){var r=e[0],n=e[1],a=e[2],o=e[4],i=e[5],u=e[6],s=e[8],c=e[9],l=e[10],E=e[12],f=e[13],h=e[14],m=-r*E-n*f-a*h,d=-o*E-i*f-u*h,p=-s*E-c*f-l*h;return t[0]=r,t[1]=o,t[2]=s,t[3]=0,t[4]=n,t[5]=i,t[6]=c,t[7]=0,t[8]=a,t[9]=u,t[10]=l,t[11]=0,t[12]=m,t[13]=d,t[14]=p,t[15]=1,t},l.IDENTITY=i(new l(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),l.ZERO=i(new l(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN0ROW3=3,l.COLUMN1ROW0=4,l.COLUMN1ROW1=5,l.COLUMN1ROW2=6,l.COLUMN1ROW3=7,l.COLUMN2ROW0=8,l.COLUMN2ROW1=9,l.COLUMN2ROW2=10,l.COLUMN2ROW3=11,l.COLUMN3ROW0=12,l.COLUMN3ROW1=13,l.COLUMN3ROW2=14,l.COLUMN3ROW3=15,a(l.prototype,{length:{get:function(){return l.packedLength}}}),l.prototype.clone=function(e){return l.clone(this,e)},l.prototype.equals=function(e){return l.equals(this,e)},l.equalsArray=function(e,t,r){return e[0]===t[r]&&e[1]===t[r+1]&&e[2]===t[r+2]&&e[3]===t[r+3]&&e[4]===t[r+4]&&e[5]===t[r+5]&&e[6]===t[r+6]&&e[7]===t[r+7]&&e[8]===t[r+8]&&e[9]===t[r+9]&&e[10]===t[r+10]&&e[11]===t[r+11]&&e[12]===t[r+12]&&e[13]===t[r+13]&&e[14]===t[r+14]&&e[15]===t[r+15]},l.prototype.equalsEpsilon=function(e,t){return l.equalsEpsilon(this,e,t)},l.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"},l}),define("Core/Plane",["./Cartesian3","./defined","./DeveloperError","./freezeObject"],function(e,t,r,n){"use strict";function a(t,r){this.normal=e.clone(t),this.distance=r}a.fromPointNormal=function(r,n,o){var i=-e.dot(n,r);return t(o)?(e.clone(n,o.normal),o.distance=i,o):new a(n,i)};var o=new e;return a.fromCartesian4=function(r,n){var i=e.fromCartesian4(r,o),u=r.w;return t(n)?(e.clone(i,n.normal),n.distance=u,n):new a(i,u)},a.getPointDistance=function(t,r){return e.dot(t.normal,r)+t.distance},a.ORIGIN_XY_PLANE=n(new a(e.UNIT_Z,0)),a.ORIGIN_YZ_PLANE=n(new a(e.UNIT_X,0)),a.ORIGIN_ZX_PLANE=n(new a(e.UNIT_Y,0)),a}),define("Core/Rectangle",["./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./freezeObject","./Math"],function(e,t,r,n,a,o,i,u){"use strict";function s(e,r,n,a){this.west=t(e,0),this.south=t(r,0),this.east=t(n,0),this.north=t(a,0)}n(s.prototype,{width:{get:function(){return s.computeWidth(this)}},height:{get:function(){return s.computeHeight(this)}}}),s.packedLength=4,s.pack=function(e,r,n){n=t(n,0),r[n++]=e.west,r[n++]=e.south,r[n++]=e.east,r[n]=e.north},s.unpack=function(e,n,a){return n=t(n,0),r(a)||(a=new s),a.west=e[n++],a.south=e[n++],a.east=e[n++],a.north=e[n],a},s.computeWidth=function(e){var t=e.east,r=e.west;return r>t&&(t+=u.TWO_PI),t-r},s.computeHeight=function(e){return e.north-e.south},s.fromDegrees=function(e,n,a,o,i){return e=u.toRadians(t(e,0)),n=u.toRadians(t(n,0)),a=u.toRadians(t(a,0)),o=u.toRadians(t(o,0)),r(i)?(i.west=e,i.south=n,i.east=a,i.north=o,i):new s(e,n,a,o)},s.fromCartographicArray=function(e,t){for(var n=Number.MAX_VALUE,a=-Number.MAX_VALUE,o=Number.MAX_VALUE,i=-Number.MAX_VALUE,c=Number.MAX_VALUE,l=-Number.MAX_VALUE,E=0,f=e.length;f>E;E++){var h=e[E];n=Math.min(n,h.longitude),a=Math.max(a,h.longitude),c=Math.min(c,h.latitude),l=Math.max(l,h.latitude);var m=h.longitude>=0?h.longitude:h.longitude+u.TWO_PI;o=Math.min(o,m),i=Math.max(i,m)}return a-n>i-o&&(n=o,a=i,a>u.PI&&(a-=u.TWO_PI),n>u.PI&&(n-=u.TWO_PI)),r(t)?(t.west=n,t.south=c,t.east=a,t.north=l,t):new s(n,c,a,l)},s.fromCartesianArray=function(e,t,n){for(var a=Number.MAX_VALUE,o=-Number.MAX_VALUE,i=Number.MAX_VALUE,c=-Number.MAX_VALUE,l=Number.MAX_VALUE,E=-Number.MAX_VALUE,f=0,h=e.length;h>f;f++){var m=t.cartesianToCartographic(e[f]);a=Math.min(a,m.longitude),o=Math.max(o,m.longitude),l=Math.min(l,m.latitude),E=Math.max(E,m.latitude);var d=m.longitude>=0?m.longitude:m.longitude+u.TWO_PI;i=Math.min(i,d),c=Math.max(c,d)}return o-a>c-i&&(a=i,o=c,o>u.PI&&(o-=u.TWO_PI),a>u.PI&&(a-=u.TWO_PI)),r(n)?(n.west=a,n.south=l,n.east=o,n.north=E,n):new s(a,l,o,E)},s.clone=function(e,t){return r(e)?r(t)?(t.west=e.west,t.south=e.south,t.east=e.east,t.north=e.north,t):new s(e.west,e.south,e.east,e.north):void 0},s.prototype.clone=function(e){return s.clone(this,e)},s.prototype.equals=function(e){return s.equals(this,e)},s.equals=function(e,t){return e===t||r(e)&&r(t)&&e.west===t.west&&e.south===t.south&&e.east===t.east&&e.north===t.north},s.prototype.equalsEpsilon=function(e,t){return r(e)&&Math.abs(this.west-e.west)<=t&&Math.abs(this.south-e.south)<=t&&Math.abs(this.east-e.east)<=t&&Math.abs(this.north-e.north)<=t},s.validate=function(e){},s.southwest=function(t,n){return r(n)?(n.longitude=t.west,n.latitude=t.south,n.height=0,n):new e(t.west,t.south)},s.northwest=function(t,n){return r(n)?(n.longitude=t.west,n.latitude=t.north,n.height=0,n):new e(t.west,t.north)},s.northeast=function(t,n){return r(n)?(n.longitude=t.east,n.latitude=t.north,n.height=0,n):new e(t.east,t.north)},s.southeast=function(t,n){return r(n)?(n.longitude=t.east,n.latitude=t.south,n.height=0,n):new e(t.east,t.south)},s.center=function(t,n){var a=t.east,o=t.west;o>a&&(a+=u.TWO_PI);var i=u.negativePiToPi(.5*(o+a)),s=.5*(t.south+t.north);return r(n)?(n.longitude=i,n.latitude=s,n.height=0,n):new e(i,s)},s.intersection=function(e,t,n){var a=e.east,o=e.west,i=t.east,c=t.west;o>a&&i>0?a+=u.TWO_PI:c>i&&a>0&&(i+=u.TWO_PI),o>a&&0>c?c+=u.TWO_PI:c>i&&0>o&&(o+=u.TWO_PI);var l=u.negativePiToPi(Math.max(o,c)),E=u.negativePiToPi(Math.min(a,i));if(!((e.west<e.east||t.west<t.east)&&l>=E)){var f=Math.max(e.south,t.south),h=Math.min(e.north,t.north);if(!(f>=h))return r(n)?(n.west=l,n.south=f,n.east=E,n.north=h,n):new s(l,f,E,h)}},s.union=function(e,t,n){return r(n)||(n=new s),n.west=Math.min(e.west,t.west),n.south=Math.min(e.south,t.south),n.east=Math.max(e.east,t.east),n.north=Math.max(e.north,t.north),n},s.expand=function(e,t,n){return r(n)||(n=new s),n.west=Math.min(e.west,t.longitude),n.south=Math.min(e.south,t.latitude),n.east=Math.max(e.east,t.longitude),n.north=Math.max(e.north,t.latitude),n},s.contains=function(e,t){var r=t.longitude,n=t.latitude,a=e.west,o=e.east;return a>o&&(o+=u.TWO_PI,0>r&&(r+=u.TWO_PI)),(r>a||u.equalsEpsilon(r,a,u.EPSILON14))&&(o>r||u.equalsEpsilon(r,o,u.EPSILON14))&&n>=e.south&&n<=e.north};var c=new e;return s.subsample=function(e,n,a,i){n=t(n,o.WGS84),a=t(a,0),r(i)||(i=[]);var l=0,E=e.north,f=e.south,h=e.east,m=e.west,d=c;d.height=a,d.longitude=m,d.latitude=E,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.latitude=f,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++,0>E?d.latitude=E:f>0?d.latitude=f:d.latitude=0;for(var p=1;8>p;++p)d.longitude=-Math.PI+p*u.PI_OVER_TWO,s.contains(e,d)&&(i[l]=n.cartographicToCartesian(d,i[l]),l++);return 0===d.latitude&&(d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++),i.length=l,i},s.MAX_VALUE=i(new s(-Math.PI,-u.PI_OVER_TWO,Math.PI,u.PI_OVER_TWO)),s}),define("Core/BoundingSphere",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./GeographicProjection","./Intersect","./Interval","./Matrix3","./Matrix4","./Plane","./Rectangle"],function(e,t,r,n,a,o,i,u,s,c,l,E,f){"use strict";function h(t,n){this.center=e.clone(r(t,e.ZERO)),this.radius=r(n,0)}var m=new e,d=new e,p=new e,A=new e,T=new e,R=new e,y=new e,_=new e,v=new e,S=new e,g=new e,C=new e;h.fromPoints=function(t,r){if(n(r)||(r=new h),!n(t)||0===t.length)return r.center=e.clone(e.ZERO,r.center),r.radius=0,r;for(var a=e.clone(t[0],y),o=e.clone(a,m),i=e.clone(a,d),u=e.clone(a,p),s=e.clone(a,A),c=e.clone(a,T),l=e.clone(a,R),E=t.length,f=1;E>f;f++){e.clone(t[f],a);var N=a.x,I=a.y,M=a.z;N<o.x&&e.clone(a,o),N>s.x&&e.clone(a,s),I<i.y&&e.clone(a,i),I>c.y&&e.clone(a,c),M<u.z&&e.clone(a,u),M>l.z&&e.clone(a,l)}var O=e.magnitudeSquared(e.subtract(s,o,_)),L=e.magnitudeSquared(e.subtract(c,i,_)),F=e.magnitudeSquared(e.subtract(l,u,_)),P=o,b=s,w=O;L>w&&(w=L,P=i,b=c),F>w&&(w=F,P=u,b=l);var D=v;D.x=.5*(P.x+b.x),D.y=.5*(P.y+b.y),D.z=.5*(P.z+b.z);var x=e.magnitudeSquared(e.subtract(b,D,_)),U=Math.sqrt(x),B=S;B.x=o.x,B.y=i.y,B.z=u.z;var G=g;G.x=s.x,G.y=c.y,G.z=l.z;var z=e.multiplyByScalar(e.add(B,G,_),.5,C),V=0;for(f=0;E>f;f++){e.clone(t[f],a);var H=e.magnitude(e.subtract(a,z,_));H>V&&(V=H);var W=e.magnitudeSquared(e.subtract(a,D,_));if(W>x){var q=Math.sqrt(W);U=.5*(U+q),x=U*U;var X=q-U;D.x=(U*D.x+X*a.x)/q,D.y=(U*D.y+X*a.y)/q,D.z=(U*D.z+X*a.z)/q}}return V>U?(e.clone(D,r.center),r.radius=U):(e.clone(z,r.center),r.radius=V),r};var N=new i,I=new e,M=new e,O=new t,L=new t;h.fromRectangle2D=function(e,t,r){return h.fromRectangleWithHeights2D(e,t,0,0,r)},h.fromRectangleWithHeights2D=function(t,a,o,i,u){if(n(u)||(u=new h),!n(t))return u.center=e.clone(e.ZERO,u.center),u.radius=0,u;a=r(a,N),f.southwest(t,O),O.height=o,f.northeast(t,L),L.height=i;var s=a.project(O,I),c=a.project(L,M),l=c.x-s.x,E=c.y-s.y,m=c.z-s.z;u.radius=.5*Math.sqrt(l*l+E*E+m*m);var d=u.center;return d.x=s.x+.5*l,d.y=s.y+.5*E,d.z=s.z+.5*m,u};var F=[];h.fromRectangle3D=function(e,t,a,i){t=r(t,o.WGS84),a=r(a,0);var u;return n(e)&&(u=f.subsample(e,t,a,F)),h.fromPoints(u,i)},h.fromVertices=function(t,a,o,i){if(n(i)||(i=new h),!n(t)||0===t.length)return i.center=e.clone(e.ZERO,i.center),i.radius=0,i;a=r(a,e.ZERO),o=r(o,3);var u=y;u.x=t[0]+a.x,u.y=t[1]+a.y,u.z=t[2]+a.z;for(var s=e.clone(u,m),c=e.clone(u,d),l=e.clone(u,p),E=e.clone(u,A),f=e.clone(u,T),N=e.clone(u,R),I=t.length,M=0;I>M;M+=o){var O=t[M]+a.x,L=t[M+1]+a.y,F=t[M+2]+a.z;u.x=O,u.y=L,u.z=F,O<s.x&&e.clone(u,s),O>E.x&&e.clone(u,E),L<c.y&&e.clone(u,c),L>f.y&&e.clone(u,f),F<l.z&&e.clone(u,l),F>N.z&&e.clone(u,N)}var P=e.magnitudeSquared(e.subtract(E,s,_)),b=e.magnitudeSquared(e.subtract(f,c,_)),w=e.magnitudeSquared(e.subtract(N,l,_)),D=s,x=E,U=P;b>U&&(U=b,D=c,x=f),w>U&&(U=w,D=l,x=N);var B=v;B.x=.5*(D.x+x.x),B.y=.5*(D.y+x.y),B.z=.5*(D.z+x.z);var G=e.magnitudeSquared(e.subtract(x,B,_)),z=Math.sqrt(G),V=S;V.x=s.x,V.y=c.y,V.z=l.z;var H=g;H.x=E.x,H.y=f.y,H.z=N.z;var W=e.multiplyByScalar(e.add(V,H,_),.5,C),q=0;for(M=0;I>M;M+=o){u.x=t[M]+a.x,u.y=t[M+1]+a.y,u.z=t[M+2]+a.z;var X=e.magnitude(e.subtract(u,W,_));X>q&&(q=X);var Y=e.magnitudeSquared(e.subtract(u,B,_));if(Y>G){var k=Math.sqrt(Y);z=.5*(z+k),G=z*z;var K=k-z;B.x=(z*B.x+K*u.x)/k,B.y=(z*B.y+K*u.y)/k,B.z=(z*B.z+K*u.z)/k}}return q>z?(e.clone(B,i.center),i.radius=z):(e.clone(W,i.center),i.radius=q),i},h.fromEncodedCartesianVertices=function(t,r,a){if(n(a)||(a=new h),!n(t)||!n(r)||t.length!==r.length||0===t.length)return a.center=e.clone(e.ZERO,a.center),a.radius=0,a;var o=y;o.x=t[0]+r[0],o.y=t[1]+r[1],o.z=t[2]+r[2];for(var i=e.clone(o,m),u=e.clone(o,d),s=e.clone(o,p),c=e.clone(o,A),l=e.clone(o,T),E=e.clone(o,R),f=t.length,N=0;f>N;N+=3){var I=t[N]+r[N],M=t[N+1]+r[N+1],O=t[N+2]+r[N+2];o.x=I,o.y=M,o.z=O,I<i.x&&e.clone(o,i),I>c.x&&e.clone(o,c),M<u.y&&e.clone(o,u),M>l.y&&e.clone(o,l),O<s.z&&e.clone(o,s),O>E.z&&e.clone(o,E)}var L=e.magnitudeSquared(e.subtract(c,i,_)),F=e.magnitudeSquared(e.subtract(l,u,_)),P=e.magnitudeSquared(e.subtract(E,s,_)),b=i,w=c,D=L;F>D&&(D=F,b=u,w=l),P>D&&(D=P,b=s,w=E);var x=v;x.x=.5*(b.x+w.x),x.y=.5*(b.y+w.y),x.z=.5*(b.z+w.z);var U=e.magnitudeSquared(e.subtract(w,x,_)),B=Math.sqrt(U),G=S;G.x=i.x,G.y=u.y,G.z=s.z;var z=g;z.x=c.x,z.y=l.y,z.z=E.z;var V=e.multiplyByScalar(e.add(G,z,_),.5,C),H=0;for(N=0;f>N;N+=3){o.x=t[N]+r[N],o.y=t[N+1]+r[N+1],o.z=t[N+2]+r[N+2];var W=e.magnitude(e.subtract(o,V,_));W>H&&(H=W);var q=e.magnitudeSquared(e.subtract(o,x,_));if(q>U){var X=Math.sqrt(q);B=.5*(B+X),U=B*B;var Y=X-B;x.x=(B*x.x+Y*o.x)/X,x.y=(B*x.y+Y*o.y)/X,x.z=(B*x.z+Y*o.z)/X}}return H>B?(e.clone(x,a.center),a.radius=B):(e.clone(V,a.center),a.radius=H),a},h.fromCornerPoints=function(t,r,a){n(a)||(a=new h);var o=a.center;return e.add(t,r,o),e.multiplyByScalar(o,.5,o),a.radius=e.distance(o,r),a},h.fromEllipsoid=function(t,r){return n(r)||(r=new h),e.clone(e.ZERO,r.center),r.radius=t.maximumRadius,r};var P=new e;h.fromBoundingSpheres=function(t,r){if(n(r)||(r=new h),!n(t)||0===t.length)return r.center=e.clone(e.ZERO,r.center),r.radius=0,r;var a=t.length;if(1===a)return h.clone(t[0],r);if(2===a)return h.union(t[0],t[1],r);for(var o=[],i=0;a>i;i++)o.push(t[i].center);r=h.fromPoints(o,r);var u=r.center,s=r.radius;for(i=0;a>i;i++){var c=t[i];s=Math.max(s,e.distance(u,c.center,P)+c.radius)}return r.radius=s,r};var b=new e,w=new e,D=new e;h.fromOrientedBoundingBox=function(t,r){n(r)||(r=new h);var a=t.halfAxes,o=c.getColumn(a,0,b),i=c.getColumn(a,1,w),u=c.getColumn(a,2,D),s=e.magnitude(o),l=e.magnitude(i),E=e.magnitude(u);return r.center=e.clone(t.center,r.center),r.radius=Math.max(s,l,E),r},h.clone=function(t,r){return n(t)?n(r)?(r.center=e.clone(t.center,r.center),r.radius=t.radius,r):new h(t.center,t.radius):void 0},h.packedLength=4,h.pack=function(e,t,n){n=r(n,0);var a=e.center;t[n++]=a.x,t[n++]=a.y,t[n++]=a.z,t[n]=e.radius},h.unpack=function(e,t,a){t=r(t,0),n(a)||(a=new h);var o=a.center;return o.x=e[t++],o.y=e[t++],o.z=e[t++],a.radius=e[t],a};var x=new e,U=new e;h.union=function(t,r,a){n(a)||(a=new h);var o=t.center,i=t.radius,u=r.center,s=r.radius,c=e.subtract(u,o,x),l=e.magnitude(c);if(i>=l+s)return t.clone(a),a;if(s>=l+i)return r.clone(a),a;var E=.5*(i+l+s),f=e.multiplyByScalar(c,(-i+E)/l,U);return e.add(f,o,f),e.clone(f,a.center),a.radius=E,a};var B=new e;h.expand=function(t,r,n){n=h.clone(t,n);var a=e.magnitude(e.subtract(r,n.center,B));return a>n.radius&&(n.radius=a),n},h.intersectPlane=function(t,r){var n=t.center,a=t.radius,o=r.normal,i=e.dot(o,n)+r.distance;return-a>i?u.OUTSIDE:a>i?u.INTERSECTING:u.INSIDE},h.transform=function(e,t,r){return n(r)||(r=new h),r.center=l.multiplyByPoint(t,e.center,r.center),r.radius=l.getMaximumScale(t)*e.radius,r};var G=new e;h.distanceSquaredTo=function(t,r){var n=e.subtract(t.center,r,G);return e.magnitudeSquared(n)-t.radius*t.radius},h.transformWithoutScale=function(e,t,r){return n(r)||(r=new h),r.center=l.multiplyByPoint(t,e.center,r.center),r.radius=e.radius,r};var z=new e;h.computePlaneDistances=function(t,r,a,o){n(o)||(o=new s);var i=e.subtract(t.center,r,z),u=e.dot(a,i);return o.start=u-t.radius,o.stop=u+t.radius,o};for(var V=new e,H=new e,W=new e,q=new e,X=new e,Y=new t,k=new Array(8),K=0;8>K;++K)k[K]=new e;var Z=new i;return h.projectTo2D=function(t,n,a){n=r(n,Z);var o=n.ellipsoid,i=t.center,u=t.radius,s=o.geodeticSurfaceNormal(i,V),c=e.cross(e.UNIT_Z,s,H);e.normalize(c,c);var l=e.cross(s,c,W);e.normalize(l,l),e.multiplyByScalar(s,u,s),e.multiplyByScalar(l,u,l),e.multiplyByScalar(c,u,c);var E=e.negate(l,X),f=e.negate(c,q),m=k,d=m[0];e.add(s,l,d),e.add(d,c,d),d=m[1],e.add(s,l,d),e.add(d,f,d),d=m[2],e.add(s,E,d),e.add(d,f,d),d=m[3],e.add(s,E,d),e.add(d,c,d),e.negate(s,s),d=m[4],e.add(s,l,d),e.add(d,c,d),d=m[5],e.add(s,l,d),e.add(d,f,d),d=m[6],e.add(s,E,d),e.add(d,f,d),d=m[7],e.add(s,E,d),e.add(d,c,d);for(var p=m.length,A=0;p>A;++A){var T=m[A];e.add(i,T,T);var R=o.cartesianToCartographic(T,Y);n.project(R,T)}a=h.fromPoints(m,a),i=a.center;var y=i.x,_=i.y,v=i.z;return i.x=v,i.y=y,i.z=_,a},h.isOccluded=function(e,t){return!t.isBoundingSphereVisible(e)},h.equals=function(t,r){return t===r||n(t)&&n(r)&&e.equals(t.center,r.center)&&t.radius===r.radius},h.prototype.intersectPlane=function(e){return h.intersectPlane(this,e)},h.prototype.distanceSquaredTo=function(e){return h.distanceSquaredTo(this,e)},h.prototype.computePlaneDistances=function(e,t,r){return h.computePlaneDistances(this,e,t,r)},h.prototype.isOccluded=function(e){return h.isOccluded(this,e)},h.prototype.equals=function(e){return h.equals(this,e)},h.prototype.clone=function(e){return h.clone(this,e)},h}),define("Core/Fullscreen",["./defined","./defineProperties"],function(e,t){"use strict";var r,n={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},a={};return t(a,{element:{get:function(){return a.supportsFullscreen()?document[n.fullscreenElement]:void 0}},changeEventName:{get:function(){return a.supportsFullscreen()?n.fullscreenchange:void 0}},errorEventName:{get:function(){return a.supportsFullscreen()?n.fullscreenerror:void 0}},enabled:{get:function(){return a.supportsFullscreen()?document[n.fullscreenEnabled]:void 0}},fullscreen:{get:function(){return a.supportsFullscreen()?null!==a.element:void 0}}}),a.supportsFullscreen=function(){if(e(r))return r;r=!1;var t=document.body;if("function"==typeof t.requestFullscreen)return n.requestFullscreen="requestFullscreen",n.exitFullscreen="exitFullscreen",n.fullscreenEnabled="fullscreenEnabled",n.fullscreenElement="fullscreenElement",n.fullscreenchange="fullscreenchange",n.fullscreenerror="fullscreenerror",r=!0;for(var a,o=["webkit","moz","o","ms","khtml"],i=0,u=o.length;u>i;++i){var s=o[i];a=s+"RequestFullscreen","function"==typeof t[a]?(n.requestFullscreen=a,r=!0):(a=s+"RequestFullScreen","function"==typeof t[a]&&(n.requestFullscreen=a,r=!0)),a=s+"ExitFullscreen","function"==typeof document[a]?n.exitFullscreen=a:(a=s+"CancelFullScreen","function"==typeof document[a]&&(n.exitFullscreen=a)),a=s+"FullscreenEnabled",void 0!==document[a]?n.fullscreenEnabled=a:(a=s+"FullScreenEnabled",void 0!==document[a]&&(n.fullscreenEnabled=a)),a=s+"FullscreenElement",void 0!==document[a]?n.fullscreenElement=a:(a=s+"FullScreenElement",void 0!==document[a]&&(n.fullscreenElement=a)),a=s+"fullscreenchange",void 0!==document["on"+a]&&("ms"===s&&(a="MSFullscreenChange"),n.fullscreenchange=a),a=s+"fullscreenerror",void 0!==document["on"+a]&&("ms"===s&&(a="MSFullscreenError"),n.fullscreenerror=a)}return r},a.requestFullscreen=function(e,t){a.supportsFullscreen()&&e[n.requestFullscreen]({vrDisplay:t})},a.exitFullscreen=function(){a.supportsFullscreen()&&document[n.exitFullscreen]()},a}),define("Core/FeatureDetection",["./defaultValue","./defined","./Fullscreen"],function(e,t,r){"use strict";function n(e){for(var t=e.split("."),r=0,n=t.length;n>r;++r)t[r]=parseInt(t[r],10);return t}function a(){if(!t(R)){R=!1;var e=/ Chrome\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(R=!0,y=n(e[1]))}return R}function o(){return a()&&y}function i(){if(!t(_)&&(_=!1,!a()&&/ Safari\/[\.0-9]+/.test(T.userAgent))){var e=/ Version\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(_=!0,v=n(e[1]))}return _}function u(){return i()&&v}function s(){if(!t(S)){S=!1;var e=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(T.userAgent);null!==e&&(S=!0,g=n(e[1]),g.isNightly=!!e[2])}return S}function c(){return s()&&g}function l(){if(!t(C)){C=!1;var e;"Microsoft Internet Explorer"===T.appName?(e=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(T.userAgent),null!==e&&(C=!0,N=n(e[1]))):"Netscape"===T.appName&&(e=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(T.userAgent),null!==e&&(C=!0,N=n(e[1])))}return C}function E(){return l()&&N}function f(){if(!t(I)){I=!1;var e=/Firefox\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(I=!0,M=n(e[1]))}return I}function h(){return t(O)||(O=/Windows/i.test(T.appVersion)),O}function m(){return f()&&M}function d(){return t(L)||(L="undefined"!=typeof PointerEvent&&(!t(T.pointerEnabled)||T.pointerEnabled)),L}function p(){if(!t(P)){var e=document.createElement("canvas");e.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");var r=e.style.imageRendering;P=t(r)&&""!==r,P&&(F=r)}return P}function A(){return p()?F:void 0}var T;T="undefined"!=typeof navigator?navigator:{};var R,y,_,v,S,g,C,N,I,M,O,L,F,P,b={isChrome:a,chromeVersion:o,isSafari:i,safariVersion:u,isWebkit:s,webkitVersion:c,isInternetExplorer:l,internetExplorerVersion:E,isFirefox:f,firefoxVersion:m,isWindows:h,hardwareConcurrency:e(T.hardwareConcurrency,3),supportsPointerEvents:d,supportsImageRenderingPixelated:p,imageRenderingValue:A};return b.supportsFullscreen=function(){return r.supportsFullscreen()},b.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},b.supportsWebWorkers=function(){return"undefined"!=typeof Worker},b}),define("Core/Color",["./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject","./Math"],function(e,t,r,n,a,o){"use strict";function i(e,t,r){return 0>r&&(r+=1),r>1&&(r-=1),1>6*r?e+6*(t-e)*r:1>2*r?t:2>3*r?e+(t-e)*(2/3-r)*6:e}function u(t,r,n,a){this.red=e(t,1),this.green=e(r,1),this.blue=e(n,1),this.alpha=e(a,1)}u.fromCartesian4=function(e,r){return t(r)?(r.red=e.x,r.green=e.y,r.blue=e.z,r.alpha=e.w,r):new u(e.x,e.y,e.z,e.w)},u.fromBytes=function(r,n,a,o,i){return r=u.byteToFloat(e(r,255)),n=u.byteToFloat(e(n,255)),a=u.byteToFloat(e(a,255)),o=u.byteToFloat(e(o,255)),t(i)?(i.red=r,i.green=n,i.blue=a,i.alpha=o,i):new u(r,n,a,o)},u.fromAlpha=function(e,r,n){return t(n)?(n.red=e.red,n.green=e.green,n.blue=e.blue,n.alpha=r,n):new u(e.red,e.green,e.blue,r)};var s,c,l;n.supportsTypedArrays()&&(s=new ArrayBuffer(4),c=new Uint32Array(s),l=new Uint8Array(s)),u.fromRgba=function(e,t){return c[0]=e,u.fromBytes(l[0],l[1],l[2],l[3],t)},u.fromHsl=function(r,n,a,o,s){r=e(r,0)%1,n=e(n,0),a=e(a,0),o=e(o,1);var c=a,l=a,E=a;if(0!==n){var f;f=.5>a?a*(1+n):a+n-a*n;var h=2*a-f;c=i(h,f,r+1/3),l=i(h,f,r),E=i(h,f,r-1/3)}return t(s)?(s.red=c,s.green=l,s.blue=E,s.alpha=o,s):new u(c,l,E,o);
},u.fromRandom=function(r,n){r=e(r,e.EMPTY_OBJECT);var a=r.red;if(!t(a)){var i=e(r.minimumRed,0),s=e(r.maximumRed,1);a=i+o.nextRandomNumber()*(s-i)}var c=r.green;if(!t(c)){var l=e(r.minimumGreen,0),E=e(r.maximumGreen,1);c=l+o.nextRandomNumber()*(E-l)}var f=r.blue;if(!t(f)){var h=e(r.minimumBlue,0),m=e(r.maximumBlue,1);f=h+o.nextRandomNumber()*(m-h)}var d=r.alpha;if(!t(d)){var p=e(r.minimumAlpha,0),A=e(r.maximumAlpha,1);d=p+o.nextRandomNumber()*(A-p)}return t(n)?(n.red=a,n.green=c,n.blue=f,n.alpha=d,n):new u(a,c,f,d)};var E=/^#([0-9a-f])([0-9a-f])([0-9a-f])$/i,f=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i,h=/^rgba?\(\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)(?:\s*,\s*([0-9.]+))?\s*\)$/i,m=/^hsla?\(\s*([0-9.]+)\s*,\s*([0-9.]+%)\s*,\s*([0-9.]+%)(?:\s*,\s*([0-9.]+))?\s*\)$/i;return u.fromCssColorString=function(r,n){t(n)||(n=new u);var a=u[r.toUpperCase()];if(t(a))return u.clone(a,n),n;var o=E.exec(r);return null!==o?(n.red=parseInt(o[1],16)/15,n.green=parseInt(o[2],16)/15,n.blue=parseInt(o[3],16)/15,n.alpha=1,n):(o=f.exec(r),null!==o?(n.red=parseInt(o[1],16)/255,n.green=parseInt(o[2],16)/255,n.blue=parseInt(o[3],16)/255,n.alpha=1,n):(o=h.exec(r),null!==o?(n.red=parseFloat(o[1])/("%"===o[1].substr(-1)?100:255),n.green=parseFloat(o[2])/("%"===o[2].substr(-1)?100:255),n.blue=parseFloat(o[3])/("%"===o[3].substr(-1)?100:255),n.alpha=parseFloat(e(o[4],"1.0")),n):(o=m.exec(r),null!==o?u.fromHsl(parseFloat(o[1])/360,parseFloat(o[2])/100,parseFloat(o[3])/100,parseFloat(e(o[4],"1.0")),n):n=void 0)))},u.packedLength=4,u.pack=function(t,r,n){n=e(n,0),r[n++]=t.red,r[n++]=t.green,r[n++]=t.blue,r[n]=t.alpha},u.unpack=function(r,n,a){return n=e(n,0),t(a)||(a=new u),a.red=r[n++],a.green=r[n++],a.blue=r[n++],a.alpha=r[n],a},u.byteToFloat=function(e){return e/255},u.floatToByte=function(e){return 1===e?255:256*e|0},u.clone=function(e,r){return t(e)?t(r)?(r.red=e.red,r.green=e.green,r.blue=e.blue,r.alpha=e.alpha,r):new u(e.red,e.green,e.blue,e.alpha):void 0},u.equals=function(e,r){return e===r||t(e)&&t(r)&&e.red===r.red&&e.green===r.green&&e.blue===r.blue&&e.alpha===r.alpha},u.equalsArray=function(e,t,r){return e.red===t[r]&&e.green===t[r+1]&&e.blue===t[r+2]&&e.alpha===t[r+3]},u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,r){return this===e||t(e)&&Math.abs(this.red-e.red)<=r&&Math.abs(this.green-e.green)<=r&&Math.abs(this.blue-e.blue)<=r&&Math.abs(this.alpha-e.alpha)<=r},u.prototype.toString=function(){return"("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},u.prototype.toCssColorString=function(){var e=u.floatToByte(this.red),t=u.floatToByte(this.green),r=u.floatToByte(this.blue);return 1===this.alpha?"rgb("+e+","+t+","+r+")":"rgba("+e+","+t+","+r+","+this.alpha+")"},u.prototype.toBytes=function(e){var r=u.floatToByte(this.red),n=u.floatToByte(this.green),a=u.floatToByte(this.blue),o=u.floatToByte(this.alpha);return t(e)?(e[0]=r,e[1]=n,e[2]=a,e[3]=o,e):[r,n,a,o]},u.prototype.toRgba=function(){return l[0]=u.floatToByte(this.red),l[1]=u.floatToByte(this.green),l[2]=u.floatToByte(this.blue),l[3]=u.floatToByte(this.alpha),c[0]},u.prototype.brighten=function(e,t){return e=1-e,t.red=1-(1-this.red)*e,t.green=1-(1-this.green)*e,t.blue=1-(1-this.blue)*e,t.alpha=this.alpha,t},u.prototype.darken=function(e,t){return e=1-e,t.red=this.red*e,t.green=this.green*e,t.blue=this.blue*e,t.alpha=this.alpha,t},u.prototype.withAlpha=function(e,t){return u.fromAlpha(this,e,t)},u.add=function(e,t,r){return r.red=e.red+t.red,r.green=e.green+t.green,r.blue=e.blue+t.blue,r.alpha=e.alpha+t.alpha,r},u.subtract=function(e,t,r){return r.red=e.red-t.red,r.green=e.green-t.green,r.blue=e.blue-t.blue,r.alpha=e.alpha-t.alpha,r},u.multiply=function(e,t,r){return r.red=e.red*t.red,r.green=e.green*t.green,r.blue=e.blue*t.blue,r.alpha=e.alpha*t.alpha,r},u.divide=function(e,t,r){return r.red=e.red/t.red,r.green=e.green/t.green,r.blue=e.blue/t.blue,r.alpha=e.alpha/t.alpha,r},u.mod=function(e,t,r){return r.red=e.red%t.red,r.green=e.green%t.green,r.blue=e.blue%t.blue,r.alpha=e.alpha%t.alpha,r},u.multiplyByScalar=function(e,t,r){return r.red=e.red*t,r.green=e.green*t,r.blue=e.blue*t,r.alpha=e.alpha*t,r},u.divideByScalar=function(e,t,r){return r.red=e.red/t,r.green=e.green/t,r.blue=e.blue/t,r.alpha=e.alpha/t,r},u.ALICEBLUE=a(u.fromCssColorString("#F0F8FF")),u.ANTIQUEWHITE=a(u.fromCssColorString("#FAEBD7")),u.AQUA=a(u.fromCssColorString("#00FFFF")),u.AQUAMARINE=a(u.fromCssColorString("#7FFFD4")),u.AZURE=a(u.fromCssColorString("#F0FFFF")),u.BEIGE=a(u.fromCssColorString("#F5F5DC")),u.BISQUE=a(u.fromCssColorString("#FFE4C4")),u.BLACK=a(u.fromCssColorString("#000000")),u.BLANCHEDALMOND=a(u.fromCssColorString("#FFEBCD")),u.BLUE=a(u.fromCssColorString("#0000FF")),u.BLUEVIOLET=a(u.fromCssColorString("#8A2BE2")),u.BROWN=a(u.fromCssColorString("#A52A2A")),u.BURLYWOOD=a(u.fromCssColorString("#DEB887")),u.CADETBLUE=a(u.fromCssColorString("#5F9EA0")),u.CHARTREUSE=a(u.fromCssColorString("#7FFF00")),u.CHOCOLATE=a(u.fromCssColorString("#D2691E")),u.CORAL=a(u.fromCssColorString("#FF7F50")),u.CORNFLOWERBLUE=a(u.fromCssColorString("#6495ED")),u.CORNSILK=a(u.fromCssColorString("#FFF8DC")),u.CRIMSON=a(u.fromCssColorString("#DC143C")),u.CYAN=a(u.fromCssColorString("#00FFFF")),u.DARKBLUE=a(u.fromCssColorString("#00008B")),u.DARKCYAN=a(u.fromCssColorString("#008B8B")),u.DARKGOLDENROD=a(u.fromCssColorString("#B8860B")),u.DARKGRAY=a(u.fromCssColorString("#A9A9A9")),u.DARKGREEN=a(u.fromCssColorString("#006400")),u.DARKGREY=u.DARKGRAY,u.DARKKHAKI=a(u.fromCssColorString("#BDB76B")),u.DARKMAGENTA=a(u.fromCssColorString("#8B008B")),u.DARKOLIVEGREEN=a(u.fromCssColorString("#556B2F")),u.DARKORANGE=a(u.fromCssColorString("#FF8C00")),u.DARKORCHID=a(u.fromCssColorString("#9932CC")),u.DARKRED=a(u.fromCssColorString("#8B0000")),u.DARKSALMON=a(u.fromCssColorString("#E9967A")),u.DARKSEAGREEN=a(u.fromCssColorString("#8FBC8F")),u.DARKSLATEBLUE=a(u.fromCssColorString("#483D8B")),u.DARKSLATEGRAY=a(u.fromCssColorString("#2F4F4F")),u.DARKSLATEGREY=u.DARKSLATEGRAY,u.DARKTURQUOISE=a(u.fromCssColorString("#00CED1")),u.DARKVIOLET=a(u.fromCssColorString("#9400D3")),u.DEEPPINK=a(u.fromCssColorString("#FF1493")),u.DEEPSKYBLUE=a(u.fromCssColorString("#00BFFF")),u.DIMGRAY=a(u.fromCssColorString("#696969")),u.DIMGREY=u.DIMGRAY,u.DODGERBLUE=a(u.fromCssColorString("#1E90FF")),u.FIREBRICK=a(u.fromCssColorString("#B22222")),u.FLORALWHITE=a(u.fromCssColorString("#FFFAF0")),u.FORESTGREEN=a(u.fromCssColorString("#228B22")),u.FUSCHIA=a(u.fromCssColorString("#FF00FF")),u.GAINSBORO=a(u.fromCssColorString("#DCDCDC")),u.GHOSTWHITE=a(u.fromCssColorString("#F8F8FF")),u.GOLD=a(u.fromCssColorString("#FFD700")),u.GOLDENROD=a(u.fromCssColorString("#DAA520")),u.GRAY=a(u.fromCssColorString("#808080")),u.GREEN=a(u.fromCssColorString("#008000")),u.GREENYELLOW=a(u.fromCssColorString("#ADFF2F")),u.GREY=u.GRAY,u.HONEYDEW=a(u.fromCssColorString("#F0FFF0")),u.HOTPINK=a(u.fromCssColorString("#FF69B4")),u.INDIANRED=a(u.fromCssColorString("#CD5C5C")),u.INDIGO=a(u.fromCssColorString("#4B0082")),u.IVORY=a(u.fromCssColorString("#FFFFF0")),u.KHAKI=a(u.fromCssColorString("#F0E68C")),u.LAVENDER=a(u.fromCssColorString("#E6E6FA")),u.LAVENDAR_BLUSH=a(u.fromCssColorString("#FFF0F5")),u.LAWNGREEN=a(u.fromCssColorString("#7CFC00")),u.LEMONCHIFFON=a(u.fromCssColorString("#FFFACD")),u.LIGHTBLUE=a(u.fromCssColorString("#ADD8E6")),u.LIGHTCORAL=a(u.fromCssColorString("#F08080")),u.LIGHTCYAN=a(u.fromCssColorString("#E0FFFF")),u.LIGHTGOLDENRODYELLOW=a(u.fromCssColorString("#FAFAD2")),u.LIGHTGRAY=a(u.fromCssColorString("#D3D3D3")),u.LIGHTGREEN=a(u.fromCssColorString("#90EE90")),u.LIGHTGREY=u.LIGHTGRAY,u.LIGHTPINK=a(u.fromCssColorString("#FFB6C1")),u.LIGHTSEAGREEN=a(u.fromCssColorString("#20B2AA")),u.LIGHTSKYBLUE=a(u.fromCssColorString("#87CEFA")),u.LIGHTSLATEGRAY=a(u.fromCssColorString("#778899")),u.LIGHTSLATEGREY=u.LIGHTSLATEGRAY,u.LIGHTSTEELBLUE=a(u.fromCssColorString("#B0C4DE")),u.LIGHTYELLOW=a(u.fromCssColorString("#FFFFE0")),u.LIME=a(u.fromCssColorString("#00FF00")),u.LIMEGREEN=a(u.fromCssColorString("#32CD32")),u.LINEN=a(u.fromCssColorString("#FAF0E6")),u.MAGENTA=a(u.fromCssColorString("#FF00FF")),u.MAROON=a(u.fromCssColorString("#800000")),u.MEDIUMAQUAMARINE=a(u.fromCssColorString("#66CDAA")),u.MEDIUMBLUE=a(u.fromCssColorString("#0000CD")),u.MEDIUMORCHID=a(u.fromCssColorString("#BA55D3")),u.MEDIUMPURPLE=a(u.fromCssColorString("#9370DB")),u.MEDIUMSEAGREEN=a(u.fromCssColorString("#3CB371")),u.MEDIUMSLATEBLUE=a(u.fromCssColorString("#7B68EE")),u.MEDIUMSPRINGGREEN=a(u.fromCssColorString("#00FA9A")),u.MEDIUMTURQUOISE=a(u.fromCssColorString("#48D1CC")),u.MEDIUMVIOLETRED=a(u.fromCssColorString("#C71585")),u.MIDNIGHTBLUE=a(u.fromCssColorString("#191970")),u.MINTCREAM=a(u.fromCssColorString("#F5FFFA")),u.MISTYROSE=a(u.fromCssColorString("#FFE4E1")),u.MOCCASIN=a(u.fromCssColorString("#FFE4B5")),u.NAVAJOWHITE=a(u.fromCssColorString("#FFDEAD")),u.NAVY=a(u.fromCssColorString("#000080")),u.OLDLACE=a(u.fromCssColorString("#FDF5E6")),u.OLIVE=a(u.fromCssColorString("#808000")),u.OLIVEDRAB=a(u.fromCssColorString("#6B8E23")),u.ORANGE=a(u.fromCssColorString("#FFA500")),u.ORANGERED=a(u.fromCssColorString("#FF4500")),u.ORCHID=a(u.fromCssColorString("#DA70D6")),u.PALEGOLDENROD=a(u.fromCssColorString("#EEE8AA")),u.PALEGREEN=a(u.fromCssColorString("#98FB98")),u.PALETURQUOISE=a(u.fromCssColorString("#AFEEEE")),u.PALEVIOLETRED=a(u.fromCssColorString("#DB7093")),u.PAPAYAWHIP=a(u.fromCssColorString("#FFEFD5")),u.PEACHPUFF=a(u.fromCssColorString("#FFDAB9")),u.PERU=a(u.fromCssColorString("#CD853F")),u.PINK=a(u.fromCssColorString("#FFC0CB")),u.PLUM=a(u.fromCssColorString("#DDA0DD")),u.POWDERBLUE=a(u.fromCssColorString("#B0E0E6")),u.PURPLE=a(u.fromCssColorString("#800080")),u.RED=a(u.fromCssColorString("#FF0000")),u.ROSYBROWN=a(u.fromCssColorString("#BC8F8F")),u.ROYALBLUE=a(u.fromCssColorString("#4169E1")),u.SADDLEBROWN=a(u.fromCssColorString("#8B4513")),u.SALMON=a(u.fromCssColorString("#FA8072")),u.SANDYBROWN=a(u.fromCssColorString("#F4A460")),u.SEAGREEN=a(u.fromCssColorString("#2E8B57")),u.SEASHELL=a(u.fromCssColorString("#FFF5EE")),u.SIENNA=a(u.fromCssColorString("#A0522D")),u.SILVER=a(u.fromCssColorString("#C0C0C0")),u.SKYBLUE=a(u.fromCssColorString("#87CEEB")),u.SLATEBLUE=a(u.fromCssColorString("#6A5ACD")),u.SLATEGRAY=a(u.fromCssColorString("#708090")),u.SLATEGREY=u.SLATEGRAY,u.SNOW=a(u.fromCssColorString("#FFFAFA")),u.SPRINGGREEN=a(u.fromCssColorString("#00FF7F")),u.STEELBLUE=a(u.fromCssColorString("#4682B4")),u.TAN=a(u.fromCssColorString("#D2B48C")),u.TEAL=a(u.fromCssColorString("#008080")),u.THISTLE=a(u.fromCssColorString("#D8BFD8")),u.TOMATO=a(u.fromCssColorString("#FF6347")),u.TURQUOISE=a(u.fromCssColorString("#40E0D0")),u.VIOLET=a(u.fromCssColorString("#EE82EE")),u.WHEAT=a(u.fromCssColorString("#F5DEB3")),u.WHITE=a(u.fromCssColorString("#FFFFFF")),u.WHITESMOKE=a(u.fromCssColorString("#F5F5F5")),u.YELLOW=a(u.fromCssColorString("#FFFF00")),u.YELLOWGREEN=a(u.fromCssColorString("#9ACD32")),u.TRANSPARENT=a(new u(0,0,0,0)),u}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(e){"use strict";var t={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,DOUBLE:5130,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,COLOR:6144,DEPTH:6145,STENCIL:6146,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,MAX_3D_TEXTURE_SIZE:32883,UNSIGNED_INT_2_10_10_10_REV:33640,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,MAX_TEXTURE_LOD_BIAS:34045,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,VERTEX_ATTRIB_ARRAY_INTEGER:35069,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,UNSIGNED_INT_10F_11F_11F_REV:35899,RGB9_E5:35901,UNSIGNED_INT_5_9_9_9_REV:35902,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,RASTERIZER_DISCARD:35977,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,UNSIGNED_INT_24_8:34042,DEPTH24_STENCIL8:35056,UNSIGNED_NORMALIZED:35863,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,MAX_SAMPLES:36183,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,VERTEX_ARRAY_BINDING:34229,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,SIGNED_NORMALIZED:36764,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,INVALID_INDEX:4294967295,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,SAMPLER_BINDING:35097,RGB10_A2UI:36975,INT_2_10_10_10_REV:36255,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_SRGB8_ETC2:37493,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37494,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37495,COMPRESSED_RGBA8_ETC2_EAC:37496,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37497,TEXTURE_IMMUTABLE_FORMAT:37167,MAX_ELEMENT_INDEX:36203,TEXTURE_IMMUTABLE_LEVELS:33503};return e(t)}),define("Core/ComponentDatatype",["../Renderer/WebGLConstants","./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject"],function(e,t,r,n,a,o){"use strict";if(!a.supportsTypedArrays())return{};var i={BYTE:e.BYTE,UNSIGNED_BYTE:e.UNSIGNED_BYTE,SHORT:e.SHORT,UNSIGNED_SHORT:e.UNSIGNED_SHORT,FLOAT:e.FLOAT,DOUBLE:e.DOUBLE};return i.getSizeInBytes=function(e){switch(e){case i.BYTE:return Int8Array.BYTES_PER_ELEMENT;case i.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case i.SHORT:return Int16Array.BYTES_PER_ELEMENT;case i.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case i.FLOAT:return Float32Array.BYTES_PER_ELEMENT;case i.DOUBLE:return Float64Array.BYTES_PER_ELEMENT;default:throw new n("componentDatatype is not a valid value.")}},i.fromTypedArray=function(e){return e instanceof Int8Array?i.BYTE:e instanceof Uint8Array?i.UNSIGNED_BYTE:e instanceof Int16Array?i.SHORT:e instanceof Uint16Array?i.UNSIGNED_SHORT:e instanceof Float32Array?i.FLOAT:e instanceof Float64Array?i.DOUBLE:void 0},i.validate=function(e){return r(e)&&(e===i.BYTE||e===i.UNSIGNED_BYTE||e===i.SHORT||e===i.UNSIGNED_SHORT||e===i.FLOAT||e===i.DOUBLE)},i.createTypedArray=function(e,t){switch(e){case i.BYTE:return new Int8Array(t);case i.UNSIGNED_BYTE:return new Uint8Array(t);case i.SHORT:return new Int16Array(t);case i.UNSIGNED_SHORT:return new Uint16Array(t);case i.FLOAT:return new Float32Array(t);case i.DOUBLE:return new Float64Array(t);default:throw new n("componentDatatype is not a valid value.")}},i.createArrayBufferView=function(e,r,a,o){switch(a=t(a,0),o=t(o,(r.byteLength-a)/i.getSizeInBytes(e)),e){case i.BYTE:return new Int8Array(r,a,o);case i.UNSIGNED_BYTE:return new Uint8Array(r,a,o);case i.SHORT:return new Int16Array(r,a,o);case i.UNSIGNED_SHORT:return new Uint16Array(r,a,o);case i.FLOAT:return new Float32Array(r,a,o);case i.DOUBLE:return new Float64Array(r,a,o);default:throw new n("componentDatatype is not a valid value.")}},o(i)}),define("Core/GeometryType",["./freezeObject"],function(e){"use strict";var t={NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3};return e(t)}),define("Core/PrimitiveType",["../Renderer/WebGLConstants","./freezeObject"],function(e,t){"use strict";var r={POINTS:e.POINTS,LINES:e.LINES,LINE_LOOP:e.LINE_LOOP,LINE_STRIP:e.LINE_STRIP,TRIANGLES:e.TRIANGLES,TRIANGLE_STRIP:e.TRIANGLE_STRIP,TRIANGLE_FAN:e.TRIANGLE_FAN,validate:function(e){return e===r.POINTS||e===r.LINES||e===r.LINE_LOOP||e===r.LINE_STRIP||e===r.TRIANGLES||e===r.TRIANGLE_STRIP||e===r.TRIANGLE_FAN}};return t(r)}),define("Core/Geometry",["./defaultValue","./defined","./DeveloperError","./GeometryType","./PrimitiveType"],function(e,t,r,n,a){"use strict";function o(t){t=e(t,e.EMPTY_OBJECT),this.attributes=t.attributes,this.indices=t.indices,this.primitiveType=e(t.primitiveType,a.TRIANGLES),this.boundingSphere=t.boundingSphere,this.geometryType=e(t.geometryType,n.NONE),this.boundingSphereCV=void 0}return o.computeNumberOfVertices=function(e){var n=-1;for(var a in e.attributes)if(e.attributes.hasOwnProperty(a)&&t(e.attributes[a])&&t(e.attributes[a].values)){var o=e.attributes[a],i=o.values.length/o.componentsPerAttribute;if(n!==i&&-1!==n)throw new r("All attribute lists must have the same number of attributes.");n=i}return n},o}),define("Core/GeometryAttribute",["./defaultValue","./defined","./DeveloperError"],function(e,t,r){"use strict";function n(t){t=e(t,e.EMPTY_OBJECT),this.componentDatatype=t.componentDatatype,this.componentsPerAttribute=t.componentsPerAttribute,this.normalize=e(t.normalize,!1),this.values=t.values}return n}),define("Core/GeometryAttributes",["./defaultValue"],function(e){"use strict";function t(t){t=e(t,e.EMPTY_OBJECT),this.position=t.position,this.normal=t.normal,this.st=t.st,this.binormal=t.binormal,this.tangent=t.tangent,this.color=t.color}return t}),define("Core/Cartesian2",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,a){"use strict";function o(t,r){this.x=e(t,0),this.y=e(r,0)}o.fromElements=function(e,r,n){return t(n)?(n.x=e,n.y=r,n):new o(e,r)},o.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r):new o(e.x,e.y):void 0},o.fromCartesian3=o.clone,o.fromCartesian4=o.clone,o.packedLength=2,o.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n]=t.y},o.unpack=function(r,n,a){return n=e(n,0),t(a)||(a=new o),a.x=r[n++],a.y=r[n],a},o.packArray=function(e,r){var n=e.length;t(r)?r.length=2*n:r=new Array(2*n);for(var a=0;n>a;++a)o.pack(e[a],r,2*a);return r},o.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/2:r=new Array(n/2);for(var a=0;n>a;a+=2){var i=a/2;r[i]=o.unpack(e,a,r[i])}return r},o.fromArray=o.unpack,o.maximumComponent=function(e){return Math.max(e.x,e.y)},o.minimumComponent=function(e){return Math.min(e.x,e.y)},o.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r},o.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r},o.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y},o.magnitude=function(e){return Math.sqrt(o.magnitudeSquared(e))};var i=new o;o.distance=function(e,t){return o.subtract(e,t,i),o.magnitude(i)},o.distanceSquared=function(e,t){return o.subtract(e,t,i),o.magnitudeSquared(i)},o.normalize=function(e,t){var r=o.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t},o.dot=function(e,t){return e.x*t.x+e.y*t.y},o.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r},o.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r},o.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r},o.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r},o.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r},o.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t},o.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t};var u=new o;o.lerp=function(e,t,r,n){return o.multiplyByScalar(t,r,u),n=o.multiplyByScalar(e,1-r,n),o.add(u,n,n)};var s=new o,c=new o;o.angleBetween=function(e,t){return o.normalize(e,s),o.normalize(t,c),a.acosClamped(o.dot(s,c))};var l=new o;return o.mostOrthogonalAxis=function(e,t){var r=o.normalize(e,l);return o.abs(r,r),t=r.x<=r.y?o.clone(o.UNIT_X,t):o.clone(o.UNIT_Y,t)},o.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y},o.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]},o.equalsEpsilon=function(e,r,n,o){return e===r||t(e)&&t(r)&&a.equalsEpsilon(e.x,r.x,n,o)&&a.equalsEpsilon(e.y,r.y,n,o)},o.ZERO=n(new o(0,0)),o.UNIT_X=n(new o(1,0)),o.UNIT_Y=n(new o(0,1)),o.prototype.clone=function(e){return o.clone(this,e)},o.prototype.equals=function(e){return o.equals(this,e)},o.prototype.equalsEpsilon=function(e,t,r){return o.equalsEpsilon(this,e,t,r)},o.prototype.toString=function(){return"("+this.x+", "+this.y+")"},o}),define("Core/AttributeCompression",["./Cartesian2","./Cartesian3","./defined","./DeveloperError","./Math"],function(e,t,r,n,a){"use strict";var o={};o.octEncode=function(e,t){if(t.x=e.x/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),t.y=e.y/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),e.z<0){var r=t.x,n=t.y;t.x=(1-Math.abs(n))*a.signNotZero(r),t.y=(1-Math.abs(r))*a.signNotZero(n)}return t.x=a.toSNorm(t.x),t.y=a.toSNorm(t.y),t},o.octDecode=function(e,r,n){if(n.x=a.fromSNorm(e),n.y=a.fromSNorm(r),n.z=1-(Math.abs(n.x)+Math.abs(n.y)),n.z<0){var o=n.x;n.x=(1-Math.abs(n.y))*a.signNotZero(o),n.y=(1-Math.abs(o))*a.signNotZero(n.y)}return t.normalize(n,n)},o.octPackFloat=function(e){return 256*e.x+e.y};var i=new e;return o.octEncodeFloat=function(e){return o.octEncode(e,i),o.octPackFloat(i)},o.octDecodeFloat=function(e,t){var r=e/256,n=Math.floor(r),a=256*(r-n);return o.octDecode(n,a,t)},o.octPack=function(e,t,r,n){var a=o.octEncodeFloat(e),u=o.octEncodeFloat(t),s=o.octEncode(r,i);return n.x=65536*s.x+a,n.y=65536*s.y+u,n},o.octUnpack=function(e,t,r,n){var a=e.x/65536,i=Math.floor(a),u=65536*(a-i);a=e.y/65536;var s=Math.floor(a),c=65536*(a-s);o.octDecodeFloat(u,t),o.octDecodeFloat(c,r),o.octDecode(i,s,n);
},o.compressTextureCoordinates=function(e){var t=1===e.x?4095:4096*e.x|0,r=1===e.y?4095:4096*e.y|0;return 4096*t+r},o.decompressTextureCoordinates=function(e,t){var r=e/4096;return t.x=Math.floor(r)/4096,t.y=r-Math.floor(r),t},o}),define("Core/barycentricCoordinates",["./Cartesian2","./Cartesian3","./defined","./DeveloperError"],function(e,t,r,n){"use strict";function a(n,a,s,c,l){r(l)||(l=new t);var E,f,h,m,d,p,A,T;r(a.z)?(E=t.subtract(s,a,o),f=t.subtract(c,a,i),h=t.subtract(n,a,u),m=t.dot(E,E),d=t.dot(E,f),p=t.dot(E,h),A=t.dot(f,f),T=t.dot(f,h)):(E=e.subtract(s,a,o),f=e.subtract(c,a,i),h=e.subtract(n,a,u),m=e.dot(E,E),d=e.dot(E,f),p=e.dot(E,h),A=e.dot(f,f),T=e.dot(f,h));var R=1/(m*A-d*d);return l.y=(A*p-d*T)*R,l.z=(m*T-d*p)*R,l.x=1-l.y-l.z,l}var o=new t,i=new t,u=new t;return a}),define("Core/EncodedCartesian3",["./Cartesian3","./defined","./DeveloperError"],function(e,t,r){"use strict";function n(){this.high=e.clone(e.ZERO),this.low=e.clone(e.ZERO)}n.encode=function(e,r){t(r)||(r={high:0,low:0});var n;return e>=0?(n=65536*Math.floor(e/65536),r.high=n,r.low=e-n):(n=65536*Math.floor(-e/65536),r.high=-n,r.low=e+n),r};var a={high:0,low:0};n.fromCartesian=function(e,r){t(r)||(r=new n);var o=r.high,i=r.low;return n.encode(e.x,a),o.x=a.high,i.x=a.low,n.encode(e.y,a),o.y=a.high,i.y=a.low,n.encode(e.z,a),o.z=a.high,i.z=a.low,r};var o=new n;return n.writeElements=function(e,t,r){n.fromCartesian(e,o);var a=o.high,i=o.low;t[r]=a.x,t[r+1]=a.y,t[r+2]=a.z,t[r+3]=i.x,t[r+4]=i.y,t[r+5]=i.z},n}),define("Core/GeometryInstance",["./defaultValue","./defined","./DeveloperError","./Matrix4"],function(e,t,r,n){"use strict";function a(t){t=e(t,e.EMPTY_OBJECT),this.geometry=t.geometry,this.modelMatrix=n.clone(e(t.modelMatrix,n.IDENTITY)),this.id=t.id,this.pickPrimitive=t.pickPrimitive,this.attributes=e(t.attributes,{}),this.westHemisphereGeometry=void 0,this.eastHemisphereGeometry=void 0}return a}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,a){"use strict";var o={UNSIGNED_BYTE:e.UNSIGNED_BYTE,UNSIGNED_SHORT:e.UNSIGNED_SHORT,UNSIGNED_INT:e.UNSIGNED_INT};return o.getSizeInBytes=function(e){switch(e){case o.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case o.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case o.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},o.validate=function(e){return t(e)&&(e===o.UNSIGNED_BYTE||e===o.UNSIGNED_SHORT||e===o.UNSIGNED_INT)},o.createTypedArray=function(e,t){return e>=a.SIXTY_FOUR_KILOBYTES?new Uint32Array(t):new Uint16Array(t)},o.createTypedArrayFromArrayBuffer=function(e,t,r,n){return e>=a.SIXTY_FOUR_KILOBYTES?new Uint32Array(t,r,n):new Uint16Array(t,r,n)},n(o)}),define("Core/QuadraticRealPolynomial",["./DeveloperError","./Math"],function(e,t){"use strict";function r(e,r,n){var a=e+r;return t.sign(e)!==t.sign(r)&&Math.abs(a/Math.max(Math.abs(e),Math.abs(r)))<n?0:a}var n={};return n.computeDiscriminant=function(e,t,r){var n=t*t-4*e*r;return n},n.computeRealRoots=function(e,n,a){var o;if(0===e)return 0===n?[]:[-a/n];if(0===n){if(0===a)return[0,0];var i=Math.abs(a),u=Math.abs(e);if(u>i&&i/u<t.EPSILON14)return[0,0];if(i>u&&u/i<t.EPSILON14)return[];if(o=-a/e,0>o)return[];var s=Math.sqrt(o);return[-s,s]}if(0===a)return o=-n/e,0>o?[o,0]:[0,o];var c=n*n,l=4*e*a,E=r(c,-l,t.EPSILON14);if(0>E)return[];var f=-.5*r(n,t.sign(n)*Math.sqrt(E),t.EPSILON14);return n>0?[f/e,a/f]:[a/f,f/e]},n}),define("Core/CubicRealPolynomial",["./DeveloperError","./QuadraticRealPolynomial"],function(e,t){"use strict";function r(e,t,r,n){var a,o,i=e,u=t/3,s=r/3,c=n,l=i*s,E=u*c,f=u*u,h=s*s,m=i*s-f,d=i*c-u*s,p=u*c-h,A=4*m*p-d*d;if(0>A){var T,R,y;f*E>=l*h?(T=i,R=m,y=-2*u*m+i*d):(T=c,R=p,y=-c*d+2*s*p);var _=0>y?-1:1,v=-_*Math.abs(T)*Math.sqrt(-A);o=-y+v;var S=o/2,g=0>S?-Math.pow(-S,1/3):Math.pow(S,1/3),C=o===v?-g:-R/g;return a=0>=R?g+C:-y/(g*g+C*C+R),f*E>=l*h?[(a-u)/i]:[-c/(a+s)]}var N=m,I=-2*u*m+i*d,M=p,O=-c*d+2*s*p,L=Math.sqrt(A),F=Math.sqrt(3)/2,P=Math.abs(Math.atan2(i*L,-I)/3);a=2*Math.sqrt(-N);var b=Math.cos(P);o=a*b;var w=a*(-b/2-F*Math.sin(P)),D=o+w>2*u?o-u:w-u,x=i,U=D/x;P=Math.abs(Math.atan2(c*L,-O)/3),a=2*Math.sqrt(-M),b=Math.cos(P),o=a*b,w=a*(-b/2-F*Math.sin(P));var B=-c,G=2*s>o+w?o+s:w+s,z=B/G,V=x*G,H=-D*G-x*B,W=D*B,q=(s*H-u*W)/(-u*H+s*V);return q>=U?z>=U?z>=q?[U,q,z]:[U,z,q]:[z,U,q]:z>=U?[q,U,z]:z>=q?[q,z,U]:[z,q,U]}var n={};return n.computeDiscriminant=function(e,t,r,n){var a=e*e,o=t*t,i=r*r,u=n*n,s=18*e*t*r*n+o*i-27*a*u-4*(e*i*r+o*t*n);return s},n.computeRealRoots=function(e,n,a,o){var i,u;if(0===e)return t.computeRealRoots(n,a,o);if(0===n){if(0===a){if(0===o)return[0,0,0];u=-o/e;var s=0>u?-Math.pow(-u,1/3):Math.pow(u,1/3);return[s,s,s]}return 0===o?(i=t.computeRealRoots(e,0,a),0===i.Length?[0]:[i[0],0,i[1]]):r(e,0,a,o)}return 0===a?0===o?(u=-n/e,0>u?[u,0,0]:[0,0,u]):r(e,n,0,o):0===o?(i=t.computeRealRoots(e,n,a),0===i.length?[0]:i[1]<=0?[i[0],i[1],0]:i[0]>=0?[0,i[0],i[1]]:[i[0],0,i[1]]):r(e,n,a,o)},n}),define("Core/QuarticRealPolynomial",["./CubicRealPolynomial","./DeveloperError","./Math","./QuadraticRealPolynomial"],function(e,t,r,n){"use strict";function a(t,a,o,i){var u=t*t,s=a-3*u/8,c=o-a*t/2+u*t/8,l=i-o*t/4+a*u/16-3*u*u/256,E=e.computeRealRoots(1,2*s,s*s-4*l,-c*c);if(E.length>0){var f=-t/4,h=E[E.length-1];if(Math.abs(h)<r.EPSILON14){var m=n.computeRealRoots(1,s,l);if(2===m.length){var d,p=m[0],A=m[1];if(p>=0&&A>=0){var T=Math.sqrt(p),R=Math.sqrt(A);return[f-R,f-T,f+T,f+R]}if(p>=0&&0>A)return d=Math.sqrt(p),[f-d,f+d];if(0>p&&A>=0)return d=Math.sqrt(A),[f-d,f+d]}return[]}if(h>0){var y=Math.sqrt(h),_=(s+h-c/y)/2,v=(s+h+c/y)/2,S=n.computeRealRoots(1,y,_),g=n.computeRealRoots(1,-y,v);return 0!==S.length?(S[0]+=f,S[1]+=f,0!==g.length?(g[0]+=f,g[1]+=f,S[1]<=g[0]?[S[0],S[1],g[0],g[1]]:g[1]<=S[0]?[g[0],g[1],S[0],S[1]]:S[0]>=g[0]&&S[1]<=g[1]?[g[0],S[0],S[1],g[1]]:g[0]>=S[0]&&g[1]<=S[1]?[S[0],g[0],g[1],S[1]]:S[0]>g[0]&&S[0]<g[1]?[g[0],S[0],g[1],S[1]]:[S[0],g[0],S[1],g[1]]):S):0!==g.length?(g[0]+=f,g[1]+=f,g):[]}}return[]}function o(t,a,o,i){var u=o*o,s=a*a,c=t*t,l=-2*a,E=o*t+s-4*i,f=c*i-o*a*t+u,h=e.computeRealRoots(1,l,E,f);if(h.length>0){var m,d,p=h[0],A=a-p,T=A*A,R=t/2,y=A/2,_=T-4*i,v=T+4*Math.abs(i),S=c-4*p,g=c+4*Math.abs(p);if(0>p||S*v>_*g){var C=Math.sqrt(S);m=C/2,d=0===C?0:(t*y-o)/C}else{var N=Math.sqrt(_);m=0===N?0:(t*y-o)/N,d=N/2}var I,M;0===R&&0===m?(I=0,M=0):r.sign(R)===r.sign(m)?(I=R+m,M=p/I):(M=R-m,I=p/M);var O,L;0===y&&0===d?(O=0,L=0):r.sign(y)===r.sign(d)?(O=y+d,L=i/O):(L=y-d,O=i/L);var F=n.computeRealRoots(1,I,O),P=n.computeRealRoots(1,M,L);if(0!==F.length)return 0!==P.length?F[1]<=P[0]?[F[0],F[1],P[0],P[1]]:P[1]<=F[0]?[P[0],P[1],F[0],F[1]]:F[0]>=P[0]&&F[1]<=P[1]?[P[0],F[0],F[1],P[1]]:P[0]>=F[0]&&P[1]<=F[1]?[F[0],P[0],P[1],F[1]]:F[0]>P[0]&&F[0]<P[1]?[P[0],F[0],P[1],F[1]]:[F[0],P[0],F[1],P[1]]:F;if(0!==P.length)return P}return[]}var i={};return i.computeDiscriminant=function(e,t,r,n,a){var o=e*e,i=o*e,u=t*t,s=u*t,c=r*r,l=c*r,E=n*n,f=E*n,h=a*a,m=h*a,d=u*c*E-4*s*f-4*e*l*E+18*e*t*r*f-27*o*E*E+256*i*m+a*(18*s*r*n-4*u*l+16*e*c*c-80*e*t*c*n-6*e*u*E+144*o*r*E)+h*(144*e*u*r-27*u*u-128*o*c-192*o*t*n);return d},i.computeRealRoots=function(t,n,i,u,s){if(Math.abs(t)<r.EPSILON15)return e.computeRealRoots(n,i,u,s);var c=n/t,l=i/t,E=u/t,f=s/t,h=0>c?1:0;switch(h+=0>l?h+1:h,h+=0>E?h+1:h,h+=0>f?h+1:h){case 0:return a(c,l,E,f);case 1:return o(c,l,E,f);case 2:return o(c,l,E,f);case 3:return a(c,l,E,f);case 4:return a(c,l,E,f);case 5:return o(c,l,E,f);case 6:return a(c,l,E,f);case 7:return a(c,l,E,f);case 8:return o(c,l,E,f);case 9:return a(c,l,E,f);case 10:return a(c,l,E,f);case 11:return o(c,l,E,f);case 12:return a(c,l,E,f);case 13:return a(c,l,E,f);case 14:return a(c,l,E,f);case 15:return a(c,l,E,f);default:return}},i}),define("Core/Ray",["./Cartesian3","./defaultValue","./defined","./DeveloperError"],function(e,t,r,n){"use strict";function a(r,n){n=e.clone(t(n,e.ZERO)),e.equals(n,e.ZERO)||e.normalize(n,n),this.origin=e.clone(t(r,e.ZERO)),this.direction=n}return a.getPoint=function(t,n,a){return r(a)||(a=new e),a=e.multiplyByScalar(t.direction,n,a),e.add(t.origin,a,a)},a}),define("Core/IntersectionTests",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Math","./Matrix3","./QuadraticRealPolynomial","./QuarticRealPolynomial","./Ray"],function(e,t,r,n,a,o,i,u,s,c){"use strict";function l(e,t,r,n){var a=t*t-4*e*r;if(!(0>a)){if(a>0){var o=1/(2*e),i=Math.sqrt(a),u=(-t+i)*o,s=(-t-i)*o;return s>u?(n.root0=u,n.root1=s):(n.root0=s,n.root1=u),n}var c=-t/(2*e);if(0!==c)return n.root0=n.root1=c,n}}function E(t,r,a){n(a)||(a={});var o=t.origin,i=t.direction,u=r.center,s=r.radius*r.radius,c=e.subtract(o,u,A),E=e.dot(i,i),f=2*e.dot(i,c),h=e.magnitudeSquared(c)-s,m=l(E,f,h,_);return n(m)?(a.start=m.root0,a.stop=m.root1,a):void 0}function f(e,t,r){var n=e+t;return o.sign(e)!==o.sign(t)&&Math.abs(n/Math.max(Math.abs(e),Math.abs(t)))<r?0:n}function h(t,r,n,a,c){var l,E=a*a,h=c*c,m=(t[i.COLUMN1ROW1]-t[i.COLUMN2ROW2])*h,d=c*(a*f(t[i.COLUMN1ROW0],t[i.COLUMN0ROW1],o.EPSILON15)+r.y),p=t[i.COLUMN0ROW0]*E+t[i.COLUMN2ROW2]*h+a*r.x+n,A=h*f(t[i.COLUMN2ROW1],t[i.COLUMN1ROW2],o.EPSILON15),T=c*(a*f(t[i.COLUMN2ROW0],t[i.COLUMN0ROW2])+r.z),R=[];if(0===T&&0===A){if(l=u.computeRealRoots(m,d,p),0===l.length)return R;var y=l[0],_=Math.sqrt(Math.max(1-y*y,0));if(R.push(new e(a,c*y,c*-_)),R.push(new e(a,c*y,c*_)),2===l.length){var v=l[1],S=Math.sqrt(Math.max(1-v*v,0));R.push(new e(a,c*v,c*-S)),R.push(new e(a,c*v,c*S))}return R}var g=T*T,C=A*A,N=m*m,I=T*A,M=N+C,O=2*(d*m+I),L=2*p*m+d*d-C+g,F=2*(p*d-I),P=p*p-g;if(0===M&&0===O&&0===L&&0===F)return R;l=s.computeRealRoots(M,O,L,F,P);var b=l.length;if(0===b)return R;for(var w=0;b>w;++w){var D,x=l[w],U=x*x,B=Math.max(1-U,0),G=Math.sqrt(B);D=o.sign(m)===o.sign(p)?f(m*U+p,d*x,o.EPSILON12):o.sign(p)===o.sign(d*x)?f(m*U,d*x+p,o.EPSILON12):f(m*U+d*x,p,o.EPSILON12);var z=f(A*x,T,o.EPSILON15),V=D*z;0>V?R.push(new e(a,c*x,c*G)):V>0?R.push(new e(a,c*x,c*-G)):0!==G?(R.push(new e(a,c*x,c*-G)),R.push(new e(a,c*x,c*G)),++w):R.push(new e(a,c*x,c*G))}return R}var m={};m.rayPlane=function(t,r,a){n(a)||(a=new e);var i=t.origin,u=t.direction,s=r.normal,c=e.dot(s,u);if(!(Math.abs(c)<o.EPSILON15)){var l=(-r.distance-e.dot(s,i))/c;if(!(0>l))return a=e.multiplyByScalar(u,l,a),e.add(i,a,a)}};var d=new e,p=new e,A=new e,T=new e,R=new e;m.rayTriangleParametric=function(t,n,a,i,u){u=r(u,!1);var s,c,l,E,f,h=t.origin,m=t.direction,y=e.subtract(a,n,d),_=e.subtract(i,n,p),v=e.cross(m,_,A),S=e.dot(y,v);if(u){if(S<o.EPSILON6)return;if(s=e.subtract(h,n,T),l=e.dot(s,v),0>l||l>S)return;if(c=e.cross(s,y,R),E=e.dot(m,c),0>E||l+E>S)return;f=e.dot(_,c)/S}else{if(Math.abs(S)<o.EPSILON6)return;var g=1/S;if(s=e.subtract(h,n,T),l=e.dot(s,v)*g,0>l||l>1)return;if(c=e.cross(s,y,R),E=e.dot(m,c)*g,0>E||l+E>1)return;f=e.dot(_,c)*g}return f},m.rayTriangle=function(t,r,a,o,i,u){var s=m.rayTriangleParametric(t,r,a,o,i);if(n(s)&&!(0>s))return n(u)||(u=new e),e.multiplyByScalar(t.direction,s,u),e.add(t.origin,u,u)};var y=new c;m.lineSegmentTriangle=function(t,r,a,o,i,u,s){var c=y;e.clone(t,c.origin),e.subtract(r,t,c.direction),e.normalize(c.direction,c.direction);var l=m.rayTriangleParametric(c,a,o,i,u);return!n(l)||0>l||l>e.distance(t,r)?void 0:(n(s)||(s=new e),e.multiplyByScalar(c.direction,l,s),e.add(c.origin,s,s))};var _={root0:0,root1:0};m.raySphere=function(e,t,r){return r=E(e,t,r),!n(r)||r.stop<0?void 0:(r.start=Math.max(r.start,0),r)};var v=new c;m.lineSegmentSphere=function(t,r,a,o){var i=v;e.clone(t,i.origin);var u=e.subtract(r,t,i.direction),s=e.magnitude(u);return e.normalize(u,u),o=E(i,a,o),!n(o)||o.stop<0||o.start>s?void 0:(o.start=Math.max(o.start,0),o.stop=Math.min(o.stop,s),o)};var S=new e,g=new e;m.rayEllipsoid=function(t,r){var n,a,o,i,u,s=r.oneOverRadii,c=e.multiplyComponents(s,t.origin,S),l=e.multiplyComponents(s,t.direction,g),E=e.magnitudeSquared(c),f=e.dot(c,l);if(E>1){if(f>=0)return;var h=f*f;if(n=E-1,a=e.magnitudeSquared(l),o=a*n,o>h)return;if(h>o){i=f*f-o,u=-f+Math.sqrt(i);var m=u/a,d=n/u;return d>m?{start:m,stop:d}:{start:d,stop:m}}var p=Math.sqrt(n/a);return{start:p,stop:p}}return 1>E?(n=E-1,a=e.magnitudeSquared(l),o=a*n,i=f*f-o,u=-f+Math.sqrt(i),{start:0,stop:u/a}):0>f?(a=e.magnitudeSquared(l),{start:0,stop:-f/a}):void 0};var C=new e,N=new e,I=new e,M=new e,O=new e,L=new i,F=new i,P=new i,b=new i,w=new i,D=new i,x=new i,U=new e,B=new e,G=new t;m.grazingAltitudeLocation=function(t,r){var a=t.origin,u=t.direction,s=r.geodeticSurfaceNormal(a,C);if(e.dot(u,s)>=0)return a;var c=n(this.rayEllipsoid(t,r)),l=r.transformPositionToScaledSpace(u,C),E=e.normalize(l,l),f=e.mostOrthogonalAxis(l,M),m=e.normalize(e.cross(f,E,N),N),d=e.normalize(e.cross(E,m,I),I),p=L;p[0]=E.x,p[1]=E.y,p[2]=E.z,p[3]=m.x,p[4]=m.y,p[5]=m.z,p[6]=d.x,p[7]=d.y,p[8]=d.z;var A=i.transpose(p,F),T=i.fromScale(r.radii,P),R=i.fromScale(r.oneOverRadii,b),y=w;y[0]=0,y[1]=-u.z,y[2]=u.y,y[3]=u.z,y[4]=0,y[5]=-u.x,y[6]=-u.y,y[7]=u.x,y[8]=0;var _,v,S=i.multiply(i.multiply(A,R,D),y,D),g=i.multiply(i.multiply(S,T,x),p,x),z=i.multiplyByVector(S,a,O),V=h(g,e.negate(z,C),0,0,1),H=V.length;if(H>0){for(var W=e.clone(e.ZERO,B),q=Number.NEGATIVE_INFINITY,X=0;H>X;++X){_=i.multiplyByVector(T,i.multiplyByVector(p,V[X],U),U);var Y=e.normalize(e.subtract(_,a,M),M),k=e.dot(Y,u);k>q&&(q=k,W=e.clone(_,W))}var K=r.cartesianToCartographic(W,G);return q=o.clamp(q,0,1),v=e.magnitude(e.subtract(W,a,M))*Math.sqrt(1-q*q),v=c?-v:v,K.height=v,r.cartographicToCartesian(K,new e)}};var z=new e;return m.lineSegmentPlane=function(t,r,a,i){n(i)||(i=new e);var u=e.subtract(r,t,z),s=a.normal,c=e.dot(s,u);if(!(Math.abs(c)<o.EPSILON6)){var l=e.dot(s,t),E=-(a.distance+l)/c;if(!(0>E||E>1))return e.multiplyByScalar(u,E,i),e.add(t,i,i),i}},m.trianglePlaneIntersection=function(t,r,n,a){var o=a.normal,i=a.distance,u=e.dot(o,t)+i<0,s=e.dot(o,r)+i<0,c=e.dot(o,n)+i<0,l=0;l+=u?1:0,l+=s?1:0,l+=c?1:0;var E,f;if((1===l||2===l)&&(E=new e,f=new e),1===l){if(u)return m.lineSegmentPlane(t,r,a,E),m.lineSegmentPlane(t,n,a,f),{positions:[t,r,n,E,f],indices:[0,3,4,1,2,4,1,4,3]};if(s)return m.lineSegmentPlane(r,n,a,E),m.lineSegmentPlane(r,t,a,f),{positions:[t,r,n,E,f],indices:[1,3,4,2,0,4,2,4,3]};if(c)return m.lineSegmentPlane(n,t,a,E),m.lineSegmentPlane(n,r,a,f),{positions:[t,r,n,E,f],indices:[2,3,4,0,1,4,0,4,3]}}else if(2===l){if(!u)return m.lineSegmentPlane(r,t,a,E),m.lineSegmentPlane(n,t,a,f),{positions:[t,r,n,E,f],indices:[1,2,4,1,4,3,0,3,4]};if(!s)return m.lineSegmentPlane(n,r,a,E),m.lineSegmentPlane(t,r,a,f),{positions:[t,r,n,E,f],indices:[2,0,4,2,4,3,1,3,4]};if(!c)return m.lineSegmentPlane(t,n,a,E),m.lineSegmentPlane(r,n,a,f),{positions:[t,r,n,E,f],indices:[0,1,4,0,4,3,2,3,4]}}},m}),define("Core/Tipsify",["./defaultValue","./defined","./DeveloperError"],function(e,t,r){"use strict";var n={};return n.calculateACMR=function(r){r=e(r,e.EMPTY_OBJECT);var n=r.indices,a=r.maximumIndex,o=e(r.cacheSize,24),i=n.length;if(!t(a)){a=0;for(var u=0,s=n[u];i>u;)s>a&&(a=s),++u,s=n[u]}for(var c=[],l=0;a+1>l;l++)c[l]=0;for(var E=o+1,f=0;i>f;++f)E-c[n[f]]>o&&(c[n[f]]=E,++E);return(E-o+1)/(i/3)},n.tipsify=function(r){function n(e,t,r,n){for(;t.length>=1;){var a=t[t.length-1];if(t.splice(t.length-1,1),e[a].numLiveTriangles>0)return a}for(;n>o;){if(e[o].numLiveTriangles>0)return++o,o-1;++o}return-1}function a(e,t,r,a,o,i,u){for(var s,c=-1,l=-1,E=0;E<r.length;){var f=r[E];a[f].numLiveTriangles&&(s=0,o-a[f].timeStamp+2*a[f].numLiveTriangles<=t&&(s=o-a[f].timeStamp),(s>l||-1===l)&&(l=s,c=f)),++E}return-1===c?n(a,i,e,u):c}r=e(r,e.EMPTY_OBJECT);var o,i=r.indices,u=r.maximumIndex,s=e(r.cacheSize,24),c=i.length,l=0,E=0,f=i[E],h=c;if(t(u))l=u+1;else{for(;h>E;)f>l&&(l=f),++E,f=i[E];if(-1===l)return 0;++l}for(var m=[],d=0;l>d;d++)m[d]={numLiveTriangles:0,timeStamp:0,vertexTriangles:[]};E=0;for(var p=0;h>E;)m[i[E]].vertexTriangles.push(p),++m[i[E]].numLiveTriangles,m[i[E+1]].vertexTriangles.push(p),++m[i[E+1]].numLiveTriangles,m[i[E+2]].vertexTriangles.push(p),++m[i[E+2]].numLiveTriangles,++p,E+=3;var A=0,T=s+1;o=1;var R,y,_=[],v=[],S=0,g=[],C=c/3,N=[];for(d=0;C>d;d++)N[d]=!1;for(var I,M;-1!==A;){_=[],y=m[A],M=y.vertexTriangles.length;for(var O=0;M>O;++O)if(p=y.vertexTriangles[O],!N[p]){N[p]=!0,E=p+p+p;for(var L=0;3>L;++L)I=i[E],_.push(I),v.push(I),g[S]=I,++S,R=m[I],--R.numLiveTriangles,T-R.timeStamp>s&&(R.timeStamp=T,++T),++E}A=a(i,s,_,m,T,v,l)}return g},n}),define("Core/GeometryPipeline",["./AttributeCompression","./barycentricCoordinates","./BoundingSphere","./Cartesian2","./Cartesian3","./Cartesian4","./Cartographic","./ComponentDatatype","./defaultValue","./defined","./DeveloperError","./EncodedCartesian3","./GeographicProjection","./Geometry","./GeometryAttribute","./GeometryInstance","./GeometryType","./IndexDatatype","./Intersect","./IntersectionTests","./Math","./Matrix3","./Matrix4","./Plane","./PrimitiveType","./Tipsify"],function(e,t,r,n,a,o,i,u,s,c,l,E,f,h,m,d,p,A,T,R,y,_,v,S,g,C){"use strict";function N(e,t,r,n,a){e[t++]=r,e[t++]=n,e[t++]=n,e[t++]=a,e[t++]=a,e[t]=r}function I(e){for(var t=e.length,r=t/3*6,n=A.createTypedArray(t,r),a=0,o=0;t>o;o+=3,a+=6)N(n,a,e[o],e[o+1],e[o+2]);return n}function M(e){var t=e.length;if(t>=3){var r=6*(t-2),n=A.createTypedArray(t,r);N(n,0,e[0],e[1],e[2]);for(var a=6,o=3;t>o;++o,a+=6)N(n,a,e[o-1],e[o],e[o-2]);return n}return new Uint16Array}function O(e){if(e.length>0){for(var t=e.length-1,r=6*(t-1),n=A.createTypedArray(t,r),a=e[0],o=0,i=1;t>i;++i,o+=6)N(n,o,a,e[i],e[i+1]);return n}return new Uint16Array}function L(e){var t={};for(var r in e)if(e.hasOwnProperty(r)&&c(e[r])&&c(e[r].values)){var n=e[r];t[r]=new m({componentDatatype:n.componentDatatype,componentsPerAttribute:n.componentsPerAttribute,normalize:n.normalize,values:[]})}return t}function F(e,t,r){for(var n in t)if(t.hasOwnProperty(n)&&c(t[n])&&c(t[n].values))for(var a=t[n],o=0;o<a.componentsPerAttribute;++o)e[n].values.push(a.values[r*a.componentsPerAttribute+o])}function P(e,t){if(c(t))for(var r=t.values,n=r.length,o=0;n>o;o+=3)a.unpack(r,o,ie),v.multiplyByPoint(e,ie,ie),a.pack(ie,r,o)}function b(e,t){if(c(t))for(var r=t.values,n=r.length,o=0;n>o;o+=3)a.unpack(r,o,ie),_.multiplyByVector(e,ie,ie),ie=a.normalize(ie,ie),a.pack(ie,r,o)}function w(e,t){var r,n=e.length,a={},o=e[0][t].attributes;for(r in o)if(o.hasOwnProperty(r)&&c(o[r])&&c(o[r].values)){for(var i=o[r],s=i.values.length,l=!0,E=1;n>E;++E){var f=e[E][t].attributes[r];if(!c(f)||i.componentDatatype!==f.componentDatatype||i.componentsPerAttribute!==f.componentsPerAttribute||i.normalize!==f.normalize){l=!1;break}s+=f.values.length}l&&(a[r]=new m({componentDatatype:i.componentDatatype,componentsPerAttribute:i.componentsPerAttribute,normalize:i.normalize,values:u.createTypedArray(i.componentDatatype,s)}))}return a}function D(e,t){var n,o,i,u,s,l,E,f=e.length,m=(e[0].modelMatrix,c(e[0][t].indices)),d=e[0][t].primitiveType,p=w(e,t);for(n in p)if(p.hasOwnProperty(n))for(s=p[n].values,u=0,o=0;f>o;++o)for(l=e[o][t].attributes[n].values,E=l.length,i=0;E>i;++i)s[u++]=l[i];var T;if(m){var R=0;for(o=0;f>o;++o)R+=e[o][t].indices.length;var y=h.computeNumberOfVertices(new h({attributes:p,primitiveType:g.POINTS})),_=A.createTypedArray(y,R),v=0,S=0;for(o=0;f>o;++o){var C=e[o][t].indices,N=C.length;for(u=0;N>u;++u)_[v++]=S+C[u];S+=h.computeNumberOfVertices(e[o][t])}T=_}var I,M=new a,O=0;for(o=0;f>o;++o){if(I=e[o][t].boundingSphere,!c(I)){M=void 0;break}a.add(I.center,M,M)}if(c(M))for(a.divideByScalar(M,f,M),o=0;f>o;++o){I=e[o][t].boundingSphere;var L=a.magnitude(a.subtract(I.center,M,ce))+I.radius;L>O&&(O=L)}return new h({attributes:p,indices:T,primitiveType:d,boundingSphere:c(M)?new r(M,O):void 0})}function x(e){if(c(e.indices))return e;for(var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,t),n=0;t>n;++n)r[n]=n;return e.indices=r,e}function U(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,3*(t-2));r[0]=1,r[1]=0,r[2]=2;for(var n=3,a=3;t>a;++a)r[n++]=a-1,r[n++]=0,r[n++]=a;return e.indices=r,e.primitiveType=g.TRIANGLES,e}function B(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,3*(t-2));r[0]=0,r[1]=1,r[2]=2,t>3&&(r[3]=0,r[4]=2,r[5]=3);for(var n=6,a=3;t-1>a;a+=2)r[n++]=a,r[n++]=a-1,r[n++]=a+1,t>a+2&&(r[n++]=a,r[n++]=a+1,r[n++]=a+2);return e.indices=r,e.primitiveType=g.TRIANGLES,e}function G(e){if(c(e.indices))return e;for(var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,t),n=0;t>n;++n)r[n]=n;return e.indices=r,e}function z(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,2*(t-1));r[0]=0,r[1]=1;for(var n=2,a=2;t>a;++a)r[n++]=a-1,r[n++]=a;return e.indices=r,e.primitiveType=g.LINES,e}function V(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,2*t);r[0]=0,r[1]=1;for(var n=2,a=2;t>a;++a)r[n++]=a-1,r[n++]=a;return r[n++]=t-1,r[n]=0,e.indices=r,e.primitiveType=g.LINES,e}function H(e){switch(e.primitiveType){case g.TRIANGLE_FAN:return U(e);case g.TRIANGLE_STRIP:return B(e);case g.TRIANGLES:return x(e);case g.LINE_STRIP:return z(e);case g.LINE_LOOP:return V(e);case g.LINES:return G(e)}return e}function W(e,t){Math.abs(e.y)<y.EPSILON6&&(t?e.y=-y.EPSILON6:e.y=y.EPSILON6)}function q(e,t,r){if(0!==e.y&&0!==t.y&&0!==r.y)return W(e,e.y<0),W(t,t.y<0),void W(r,r.y<0);var n,a=Math.abs(e.y),o=Math.abs(t.y),i=Math.abs(r.y);n=a>o?a>i?y.sign(e.y):y.sign(r.y):o>i?y.sign(t.y):y.sign(r.y);var u=0>n;W(e,u),W(t,u),W(r,u)}function X(e,t,r,n){a.add(e,a.multiplyByScalar(a.subtract(t,e,_e),e.y/(e.y-t.y),_e),r),a.clone(r,n),W(r,!0),W(n,!1)}function Y(e,t,r){if(!(e.x>=0||t.x>=0||r.x>=0)){q(e,t,r);var n=e.y<0,a=t.y<0,o=r.y<0,i=0;i+=n?1:0,i+=a?1:0,i+=o?1:0;var u=Ne.indices;1===i?(u[1]=3,u[2]=4,u[5]=6,u[7]=6,u[8]=5,n?(X(e,t,ve,ge),X(e,r,Se,Ce),u[0]=0,u[3]=1,u[4]=2,u[6]=1):a?(X(t,r,ve,ge),X(t,e,Se,Ce),u[0]=1,u[3]=2,u[4]=0,u[6]=2):o&&(X(r,e,ve,ge),X(r,t,Se,Ce),u[0]=2,u[3]=0,u[4]=1,u[6]=0)):2===i&&(u[2]=4,u[4]=4,u[5]=3,u[7]=5,u[8]=6,n?a?o||(X(r,e,ve,ge),X(r,t,Se,Ce),u[0]=0,u[1]=1,u[3]=0,u[6]=2):(X(t,r,ve,ge),X(t,e,Se,Ce),u[0]=2,u[1]=0,u[3]=2,u[6]=1):(X(e,t,ve,ge),X(e,r,Se,Ce),u[0]=1,u[1]=2,u[3]=1,u[6]=0));var s=Ne.positions;return s[0]=e,s[1]=t,s[2]=r,s.length=3,(1===i||2===i)&&(s[3]=ve,s[4]=Se,s[5]=ge,s[6]=Ce,s.length=7),Ne}}function k(e,t){var n=e.attributes;if(0!==n.position.values.length){for(var a in n)if(n.hasOwnProperty(a)&&c(n[a])&&c(n[a].values)){var o=n[a];o.values=u.createTypedArray(o.componentDatatype,o.values)}var i=h.computeNumberOfVertices(e);return e.indices=A.createTypedArray(i,e.indices),t&&(e.boundingSphere=r.fromVertices(n.position.values)),e}}function K(e){var t=e.attributes,r={};for(var n in t)if(t.hasOwnProperty(n)&&c(t[n])&&c(t[n].values)){var a=t[n];r[n]=new m({componentDatatype:a.componentDatatype,componentsPerAttribute:a.componentsPerAttribute,normalize:a.normalize,values:[]})}return new h({attributes:r,indices:[],primitiveType:e.primitiveType})}function Z(e,t,r){var n=c(e.geometry.boundingSphere);t=k(t,n),r=k(r,n),c(r)&&!c(t)?e.geometry=r:!c(r)&&c(t)?e.geometry=t:(e.westHemisphereGeometry=t,e.eastHemisphereGeometry=r,e.geometry=void 0)}function j(e,r,o,i,u,s,l,E,f,h,m){if(c(s)||c(l)||c(E)||c(f)){var d=a.fromArray(u,3*e,Ie),p=a.fromArray(u,3*r,Me),A=a.fromArray(u,3*o,Oe),T=t(i,d,p,A,Le);if(c(s)){var R=a.fromArray(s,3*e,Ie),y=a.fromArray(s,3*r,Me),_=a.fromArray(s,3*o,Oe);a.multiplyByScalar(R,T.x,R),a.multiplyByScalar(y,T.y,y),a.multiplyByScalar(_,T.z,_);var v=a.add(R,y,R);a.add(v,_,v),a.normalize(v,v),a.pack(v,h.normal.values,3*m)}if(c(l)){var S=a.fromArray(l,3*e,Ie),g=a.fromArray(l,3*r,Me),C=a.fromArray(l,3*o,Oe);a.multiplyByScalar(S,T.x,S),a.multiplyByScalar(g,T.y,g),a.multiplyByScalar(C,T.z,C);var N=a.add(S,g,S);a.add(N,C,N),a.normalize(N,N),a.pack(N,h.binormal.values,3*m)}if(c(E)){var I=a.fromArray(E,3*e,Ie),M=a.fromArray(E,3*r,Me),O=a.fromArray(E,3*o,Oe);a.multiplyByScalar(I,T.x,I),a.multiplyByScalar(M,T.y,M),a.multiplyByScalar(O,T.z,O);var L=a.add(I,M,I);a.add(L,O,L),a.normalize(L,L),a.pack(L,h.tangent.values,3*m)}if(c(f)){var F=n.fromArray(f,2*e,Fe),P=n.fromArray(f,2*r,Pe),b=n.fromArray(f,2*o,be);n.multiplyByScalar(F,T.x,F),n.multiplyByScalar(P,T.y,P),n.multiplyByScalar(b,T.z,b);var w=n.add(F,P,F);n.add(w,b,w),n.pack(w,h.st.values,2*m)}}}function Q(e,t,r,n,a,o){var i=e.position.values.length/3;if(-1!==a){var u=n[a],s=r[u];return-1===s?(r[u]=i,e.position.values.push(o.x,o.y,o.z),t.push(i),i):(t.push(s),s)}return e.position.values.push(o.x,o.y,o.z),t.push(i),i}function J(e){var t,r,n,o,i,u=e.geometry,s=u.attributes,l=s.position.values,E=c(s.normal)?s.normal.values:void 0,f=c(s.binormal)?s.binormal.values:void 0,h=c(s.tangent)?s.tangent.values:void 0,m=c(s.st)?s.st.values:void 0,d=u.indices,p=K(u),A=K(u),T=[];T.length=l.length/3;var R=[];for(R.length=l.length/3,i=0;i<T.length;++i)T[i]=-1,R[i]=-1;var y=d.length;for(i=0;y>i;i+=3){var _=d[i],v=d[i+1],S=d[i+2],g=a.fromArray(l,3*_),C=a.fromArray(l,3*v),N=a.fromArray(l,3*S),I=Y(g,C,N);if(c(I)&&I.positions.length>3)for(var M=I.positions,O=I.indices,L=O.length,F=0;L>F;++F){var P=O[F],b=M[P];b.y<0?(t=A.attributes,r=A.indices,n=T):(t=p.attributes,r=p.indices,n=R),o=Q(t,r,n,d,3>P?i+P:-1,b),j(_,v,S,b,l,E,f,h,m,t,o)}else c(I)&&(g=I.positions[0],C=I.positions[1],N=I.positions[2]),g.y<0?(t=A.attributes,r=A.indices,n=T):(t=p.attributes,r=p.indices,n=R),o=Q(t,r,n,d,i,g),j(_,v,S,g,l,E,f,h,m,t,o),o=Q(t,r,n,d,i+1,C),j(_,v,S,C,l,E,f,h,m,t,o),o=Q(t,r,n,d,i+2,N),j(_,v,S,N,l,E,f,h,m,t,o)}Z(e,A,p)}function $(e){var t,r=e.geometry,n=r.attributes,o=n.position.values,i=r.indices,u=K(r),s=K(r),l=i.length,E=[];E.length=o.length/3;var f=[];for(f.length=o.length/3,t=0;t<E.length;++t)E[t]=-1,f[t]=-1;for(t=0;l>t;t+=2){var h=i[t],m=i[t+1],d=a.fromArray(o,3*h,Ie),p=a.fromArray(o,3*m,Me);Math.abs(d.y)<y.EPSILON6&&(d.y<0?d.y=-y.EPSILON6:d.y=y.EPSILON6),Math.abs(p.y)<y.EPSILON6&&(p.y<0?p.y=-y.EPSILON6:p.y=y.EPSILON6);var A=u.attributes,T=u.indices,_=f,v=s.attributes,S=s.indices,g=E,C=R.lineSegmentPlane(d,p,we,Oe);if(c(C)){var N=a.multiplyByScalar(a.UNIT_Y,5*y.EPSILON9,De);d.y<0&&(a.negate(N,N),A=s.attributes,T=s.indices,_=E,v=u.attributes,S=u.indices,g=f);var I=a.add(C,N,xe);Q(A,T,_,i,t,d),Q(A,T,_,i,-1,I),a.negate(N,N),a.add(C,N,I),Q(v,S,g,i,-1,I),Q(v,S,g,i,t+1,p)}else{var M,O,L;d.y<0?(M=s.attributes,O=s.indices,L=E):(M=u.attributes,O=u.indices,L=f),Q(M,O,L,i,t,d),Q(M,O,L,i,t+1,p)}}Z(e,s,u)}function ee(e){for(var t=e.attributes,r=t.position.values,n=t.prevPosition.values,o=t.nextPosition.values,i=r.length,u=0;i>u;u+=3){var s=a.unpack(r,u,Ge);if(!(s.x>0)){var c=a.unpack(n,u,ze);(s.y<0&&c.y>0||s.y>0&&c.y<0)&&(u-3>0?(n[u]=r[u-3],n[u+1]=r[u-2],n[u+2]=r[u-1]):a.pack(s,n,u));var l=a.unpack(o,u,Ve);(s.y<0&&l.y>0||s.y>0&&l.y<0)&&(i>u+3?(o[u]=r[u+3],o[u+1]=r[u+4],o[u+2]=r[u+5]):a.pack(s,o,u))}}}function te(e){var t,r,i,u=e.geometry,s=u.attributes,l=s.position.values,E=s.prevPosition.values,f=s.nextPosition.values,h=s.expandAndWidth.values,m=c(s.st)?s.st.values:void 0,d=c(s.color)?s.color.values:void 0,p=K(u),A=K(u),T=!1,_=l.length/3;for(t=0;_>t;t+=4){var v=t,S=t+2,g=a.fromArray(l,3*v,Ge),C=a.fromArray(l,3*S,ze);if(Math.abs(g.y)<ke)for(g.y=ke*(C.y<0?-1:1),l[3*t+1]=g.y,l[3*(t+1)+1]=g.y,r=3*v;3*v+12>r;r+=3)E[r]=l[3*t],E[r+1]=l[3*t+1],E[r+2]=l[3*t+2];if(Math.abs(C.y)<ke)for(C.y=ke*(g.y<0?-1:1),l[3*(t+2)+1]=C.y,l[3*(t+3)+1]=C.y,r=3*v;3*v+12>r;r+=3)f[r]=l[3*(t+2)],f[r+1]=l[3*(t+2)+1],f[r+2]=l[3*(t+2)+2];var N=p.attributes,I=p.indices,M=A.attributes,O=A.indices,L=R.lineSegmentPlane(g,C,we,He);if(c(L)){T=!0;var F=a.multiplyByScalar(a.UNIT_Y,Ye,We);g.y<0&&(a.negate(F,F),N=A.attributes,I=A.indices,M=p.attributes,O=p.indices);var P=a.add(L,F,qe);N.position.values.push(g.x,g.y,g.z,g.x,g.y,g.z),N.position.values.push(P.x,P.y,P.z),N.position.values.push(P.x,P.y,P.z),N.prevPosition.values.push(E[3*v],E[3*v+1],E[3*v+2]),N.prevPosition.values.push(E[3*v+3],E[3*v+4],E[3*v+5]),N.prevPosition.values.push(g.x,g.y,g.z,g.x,g.y,g.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),a.negate(F,F),a.add(L,F,P),M.position.values.push(P.x,P.y,P.z),M.position.values.push(P.x,P.y,P.z),M.position.values.push(C.x,C.y,C.z,C.x,C.y,C.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.nextPosition.values.push(C.x,C.y,C.z,C.x,C.y,C.z),M.nextPosition.values.push(f[3*S],f[3*S+1],f[3*S+2]),M.nextPosition.values.push(f[3*S+3],f[3*S+4],f[3*S+5]);var b=n.fromArray(h,2*v,Ue),w=Math.abs(b.y);N.expandAndWidth.values.push(-1,w,1,w),N.expandAndWidth.values.push(-1,-w,1,-w),M.expandAndWidth.values.push(-1,w,1,w),M.expandAndWidth.values.push(-1,-w,1,-w);var D=a.magnitudeSquared(a.subtract(L,g,Ve));if(D/=a.magnitudeSquared(a.subtract(C,g,Ve)),c(d)){var x=o.fromArray(d,4*v,Xe),U=o.fromArray(d,4*S,Xe),B=y.lerp(x.x,U.x,D),G=y.lerp(x.y,U.y,D),z=y.lerp(x.z,U.z,D),V=y.lerp(x.w,U.w,D);for(r=4*v;4*v+8>r;++r)N.color.values.push(d[r]);for(N.color.values.push(B,G,z,V),N.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),r=4*S;4*S+8>r;++r)M.color.values.push(d[r])}if(c(m)){var H=n.fromArray(m,2*v,Ue),W=n.fromArray(m,2*(t+3),Be),q=y.lerp(H.x,W.x,D);for(r=2*v;2*v+4>r;++r)N.st.values.push(m[r]);for(N.st.values.push(q,H.y),N.st.values.push(q,W.y),M.st.values.push(q,H.y),M.st.values.push(q,W.y),r=2*S;2*S+4>r;++r)M.st.values.push(m[r])}i=N.position.values.length/3-4,I.push(i,i+2,i+1),I.push(i+1,i+2,i+3),i=M.position.values.length/3-4,O.push(i,i+2,i+1),O.push(i+1,i+2,i+3)}else{var X,Y;for(g.y<0?(X=A.attributes,Y=A.indices):(X=p.attributes,Y=p.indices),X.position.values.push(g.x,g.y,g.z),X.position.values.push(g.x,g.y,g.z),X.position.values.push(C.x,C.y,C.z),X.position.values.push(C.x,C.y,C.z),r=3*t;3*t+12>r;++r)X.prevPosition.values.push(E[r]),X.nextPosition.values.push(f[r]);for(r=2*t;2*t+8>r;++r)X.expandAndWidth.values.push(h[r]),c(m)&&X.st.values.push(m[r]);if(c(d))for(r=4*t;4*t+16>r;++r)X.color.values.push(d[r]);i=X.position.values.length/3-4,Y.push(i,i+2,i+1),Y.push(i+1,i+2,i+3)}}T&&(ee(A),ee(p)),Z(e,A,p)}var re={};re.toWireframe=function(e){var t=e.indices;if(c(t)){switch(e.primitiveType){case g.TRIANGLES:e.indices=I(t);break;case g.TRIANGLE_STRIP:e.indices=M(t);break;case g.TRIANGLE_FAN:e.indices=O(t);break;default:throw new l("geometry.primitiveType must be TRIANGLES, TRIANGLE_STRIP, or TRIANGLE_FAN.")}e.primitiveType=g.LINES}return e},re.createLineSegmentsForVectors=function(e,t,n){t=s(t,"normal"),n=s(n,1e4);for(var a=e.attributes.position.values,o=e.attributes[t].values,i=a.length,l=new Float64Array(2*i),E=0,f=0;i>f;f+=3)l[E++]=a[f],l[E++]=a[f+1],l[E++]=a[f+2],l[E++]=a[f]+o[f]*n,l[E++]=a[f+1]+o[f+1]*n,l[E++]=a[f+2]+o[f+2]*n;var d,p=e.boundingSphere;return c(p)&&(d=new r(p.center,p.radius+n)),new h({attributes:{position:new m({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:l})},primitiveType:g.LINES,boundingSphere:d})},re.createAttributeLocations=function(e){var t,r=["position","positionHigh","positionLow","position3DHigh","position3DLow","position2DHigh","position2DLow","pickColor","normal","st","binormal","tangent","compressedAttributes"],n=e.attributes,a={},o=0,i=r.length;for(t=0;i>t;++t){var u=r[t];c(n[u])&&(a[u]=o++)}for(var s in n)n.hasOwnProperty(s)&&!c(a[s])&&(a[s]=o++);return a},re.reorderForPreVertexCache=function(e){var t=h.computeNumberOfVertices(e),r=e.indices;if(c(r)){for(var n=new Int32Array(t),a=0;t>a;a++)n[a]=-1;for(var o,i=r,s=i.length,l=A.createTypedArray(t,s),E=0,f=0,m=0;s>E;)o=n[i[E]],-1!==o?l[f]=o:(o=i[E],n[o]=m,l[f]=m,++m),++E,++f;e.indices=l;var d=e.attributes;for(var p in d)if(d.hasOwnProperty(p)&&c(d[p])&&c(d[p].values)){for(var T=d[p],R=T.values,y=0,_=T.componentsPerAttribute,v=u.createTypedArray(T.componentDatatype,m*_);t>y;){var S=n[y];if(-1!==S)for(a=0;_>a;a++)v[_*S+a]=R[_*y+a];++y}T.values=v}}return e},re.reorderForPostVertexCache=function(e,t){var r=e.indices;if(e.primitiveType===g.TRIANGLES&&c(r)){for(var n=r.length,a=0,o=0;n>o;o++)r[o]>a&&(a=r[o]);e.indices=C.tipsify({indices:r,maximumIndex:a,cacheSize:t})}return e},re.fitToUnsignedShortIndices=function(e){var t=[],r=h.computeNumberOfVertices(e);
if(c(e.indices)&&r>=y.SIXTY_FOUR_KILOBYTES){var n,a=[],o=[],i=0,u=L(e.attributes),s=e.indices,l=s.length;e.primitiveType===g.TRIANGLES?n=3:e.primitiveType===g.LINES?n=2:e.primitiveType===g.POINTS&&(n=1);for(var E=0;l>E;E+=n){for(var f=0;n>f;++f){var m=s[E+f],d=a[m];c(d)||(d=i++,a[m]=d,F(u,e.attributes,m)),o.push(d)}i+n>=y.SIXTY_FOUR_KILOBYTES&&(t.push(new h({attributes:u,indices:o,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV})),a=[],o=[],i=0,u=L(e.attributes))}0!==o.length&&t.push(new h({attributes:u,indices:o,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV}))}else t.push(e);return t};var ne=new a,ae=new i;re.projectTo2D=function(e,t,r,n,o){var i=e.attributes[t];o=c(o)?o:new f;for(var s=o.ellipsoid,E=i.values,h=new Float64Array(E.length),d=0,p=0;p<E.length;p+=3){var A=a.fromArray(E,p,ne),T=s.cartesianToCartographic(A,ae);if(!c(T))throw new l("Could not project point ("+A.x+", "+A.y+", "+A.z+") to 2D.");var R=o.project(T,ne);h[d++]=R.x,h[d++]=R.y,h[d++]=R.z}return e.attributes[r]=i,e.attributes[n]=new m({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:h}),delete e.attributes[t],e};var oe={high:0,low:0};re.encodeAttribute=function(e,t,r,n){for(var a=e.attributes[t],o=a.values,i=o.length,s=new Float32Array(i),c=new Float32Array(i),l=0;i>l;++l)E.encode(o[l],oe),s[l]=oe.high,c[l]=oe.low;var f=a.componentsPerAttribute;return e.attributes[r]=new m({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:s}),e.attributes[n]=new m({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:c}),delete e.attributes[t],e};var ie=new a,ue=new v,se=new _;re.transformToWorldCoordinates=function(e){var t=e.modelMatrix;if(v.equals(t,v.IDENTITY))return e;var n=e.geometry.attributes;P(t,n.position),P(t,n.prevPosition),P(t,n.nextPosition),(c(n.normal)||c(n.binormal)||c(n.tangent))&&(v.inverse(t,ue),v.transpose(ue,ue),v.getRotation(ue,se),b(se,n.normal),b(se,n.binormal),b(se,n.tangent));var a=e.geometry.boundingSphere;return c(a)&&(e.geometry.boundingSphere=r.transform(a,t,a)),e.modelMatrix=v.clone(v.IDENTITY),e};var ce=new a;re.combineInstances=function(e){for(var t=[],r=[],n=e.length,a=0;n>a;++a){var o=e[a];c(o.geometry)?t.push(o):r.push(o)}var i=[];return t.length>0&&i.push(D(t,"geometry")),r.length>0&&(i.push(D(r,"westHemisphereGeometry")),i.push(D(r,"eastHemisphereGeometry"))),i};var le=new a,Ee=new a,fe=new a,he=new a;re.computeNormal=function(e){for(var t=e.indices,r=e.attributes,n=r.position.values,o=r.position.values.length/3,i=t.length,s=new Array(o),c=new Array(i/3),l=new Array(i),E=0;o>E;E++)s[E]={indexOffset:0,count:0,currentCount:0};var f=0;for(E=0;i>E;E+=3){var h=t[E],d=t[E+1],p=t[E+2],A=3*h,T=3*d,R=3*p;Ee.x=n[A],Ee.y=n[A+1],Ee.z=n[A+2],fe.x=n[T],fe.y=n[T+1],fe.z=n[T+2],he.x=n[R],he.y=n[R+1],he.z=n[R+2],s[h].count++,s[d].count++,s[p].count++,a.subtract(fe,Ee,fe),a.subtract(he,Ee,he),c[f]=a.cross(fe,he,new a),f++}var y=0;for(E=0;o>E;E++)s[E].indexOffset+=y,y+=s[E].count;f=0;var _;for(E=0;i>E;E+=3){_=s[t[E]];var v=_.indexOffset+_.currentCount;l[v]=f,_.currentCount++,_=s[t[E+1]],v=_.indexOffset+_.currentCount,l[v]=f,_.currentCount++,_=s[t[E+2]],v=_.indexOffset+_.currentCount,l[v]=f,_.currentCount++,f++}var S=new Float32Array(3*o);for(E=0;o>E;E++){var g=3*E;if(_=s[E],_.count>0){for(a.clone(a.ZERO,le),f=0;f<_.count;f++)a.add(le,c[l[_.indexOffset+f]],le);a.normalize(le,le),S[g]=le.x,S[g+1]=le.y,S[g+2]=le.z}else S[g]=0,S[g+1]=0,S[g+2]=1}return e.attributes.normal=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:S}),e};var me=new a,de=new a,pe=new a;re.computeBinormalAndTangent=function(e){for(var t=(e.attributes,e.indices),r=e.attributes.position.values,n=e.attributes.normal.values,o=e.attributes.st.values,i=e.attributes.position.values.length/3,s=t.length,c=new Array(3*i),l=0;l<c.length;l++)c[l]=0;var E,f,h;for(l=0;s>l;l+=3){var d=t[l],p=t[l+1],A=t[l+2];E=3*d,f=3*p,h=3*A;var T=2*d,R=2*p,y=2*A,_=r[E],v=r[E+1],S=r[E+2],g=o[T],C=o[T+1],N=o[R+1]-C,I=o[y+1]-C,M=1/((o[R]-g)*I-(o[y]-g)*N),O=(I*(r[f]-_)-N*(r[h]-_))*M,L=(I*(r[f+1]-v)-N*(r[h+1]-v))*M,F=(I*(r[f+2]-S)-N*(r[h+2]-S))*M;c[E]+=O,c[E+1]+=L,c[E+2]+=F,c[f]+=O,c[f+1]+=L,c[f+2]+=F,c[h]+=O,c[h+1]+=L,c[h+2]+=F}var P=new Float32Array(3*i),b=new Float32Array(3*i);for(l=0;i>l;l++){E=3*l,f=E+1,h=E+2;var w=a.fromArray(n,E,me),D=a.fromArray(c,E,pe),x=a.dot(w,D);a.multiplyByScalar(w,x,de),a.normalize(a.subtract(D,de,D),D),b[E]=D.x,b[f]=D.y,b[h]=D.z,a.normalize(a.cross(w,D,D),D),P[E]=D.x,P[f]=D.y,P[h]=D.z}return e.attributes.tangent=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:b}),e.attributes.binormal=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:P}),e};var Ae=new n,Te=new a,Re=new a,ye=new a;re.compressVertices=function(t){var r=t.attributes.normal,o=t.attributes.st;if(!c(r)&&!c(o))return t;var i,s,l,E,f=t.attributes.tangent,h=t.attributes.binormal;c(r)&&(i=r.values),c(o)&&(s=o.values),c(f)&&(l=f.values),h&&(E=h.values);var d=c(i)?i.length:s.length,p=c(i)?3:2,A=d/p,T=A,R=c(s)&&c(i)?2:1;R+=c(l)||c(E)?1:0,T*=R;for(var y=new Float32Array(T),_=0,v=0;A>v;++v){c(s)&&(n.fromArray(s,2*v,Ae),y[_++]=e.compressTextureCoordinates(Ae));var S=3*v;c(i)&&c(l)&&c(E)?(a.fromArray(i,S,Te),a.fromArray(l,S,Re),a.fromArray(E,S,ye),e.octPack(Te,Re,ye,Ae),y[_++]=Ae.x,y[_++]=Ae.y):(c(i)&&(a.fromArray(i,S,Te),y[_++]=e.octEncodeFloat(Te)),c(l)&&(a.fromArray(l,S,Te),y[_++]=e.octEncodeFloat(Te)),c(E)&&(a.fromArray(E,S,Te),y[_++]=e.octEncodeFloat(Te)))}return t.attributes.compressedAttributes=new m({componentDatatype:u.FLOAT,componentsPerAttribute:R,values:y}),c(i)&&delete t.attributes.normal,c(s)&&delete t.attributes.st,c(l)&&delete t.attributes.tangent,c(E)&&delete t.attributes.binormal,t};var _e=new a,ve=new a,Se=new a,ge=new a,Ce=new a,Ne={positions:new Array(7),indices:new Array(9)},Ie=new a,Me=new a,Oe=new a,Le=new a,Fe=new n,Pe=new n,be=new n,we=S.fromPointNormal(a.ZERO,a.UNIT_Y),De=new a,xe=new a,Ue=new n,Be=new n,Ge=new a,ze=new a,Ve=new a,He=new a,We=new a,qe=new a,Xe=new o,Ye=5*y.EPSILON9,ke=y.EPSILON6;return re.splitLongitude=function(e){var t=e.geometry,n=t.boundingSphere;if(c(n)){var a=n.center.x-n.radius;if(a>0||r.intersectPlane(n,S.ORIGIN_ZX_PLANE)!==T.INTERSECTING)return e}if(t.geometryType!==p.NONE)switch(t.geometryType){case p.POLYLINES:te(e);break;case p.TRIANGLES:J(e);break;case p.LINES:$(e)}else H(t),t.primitiveType===g.TRIANGLES?J(e):t.primitiveType===g.LINES&&$(e);return e},re}),define("Core/WebMercatorProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./Math"],function(e,t,r,n,a,o,i,u){"use strict";function s(e){this._ellipsoid=r(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return a(s.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),s.mercatorAngleToGeodeticLatitude=function(e){return u.PI_OVER_TWO-2*Math.atan(Math.exp(-e))},s.geodeticLatitudeToMercatorAngle=function(e){e>s.MaximumLatitude?e=s.MaximumLatitude:e<-s.MaximumLatitude&&(e=-s.MaximumLatitude);var t=Math.sin(e);return.5*Math.log((1+t)/(1-t))},s.MaximumLatitude=s.mercatorAngleToGeodeticLatitude(Math.PI),s.prototype.project=function(t,r){var a=this._semimajorAxis,o=t.longitude*a,i=s.geodeticLatitudeToMercatorAngle(t.latitude)*a,u=t.height;return n(r)?(r.x=o,r.y=i,r.z=u,r):new e(o,i,u)},s.prototype.unproject=function(e,r){var a=this._oneOverSemimajorAxis,o=e.x*a,i=s.mercatorAngleToGeodeticLatitude(e.y*a),u=e.z;return n(r)?(r.longitude=o,r.latitude=i,r.height=u,r):new t(o,i,u)},s}),define("Scene/PrimitivePipeline",["../Core/BoundingSphere","../Core/Color","../Core/ComponentDatatype","../Core/defaultValue","../Core/defined","../Core/DeveloperError","../Core/Ellipsoid","../Core/FeatureDetection","../Core/GeographicProjection","../Core/Geometry","../Core/GeometryAttribute","../Core/GeometryAttributes","../Core/GeometryPipeline","../Core/IndexDatatype","../Core/Matrix4","../Core/WebMercatorProjection"],function(e,t,r,n,a,o,i,u,s,c,l,E,f,h,m,d){"use strict";function p(e,t,r){var n,a=!r,o=e.length;if(!a&&o>1){var i=e[0].modelMatrix;for(n=1;o>n;++n)if(!m.equals(i,e[n].modelMatrix)){a=!0;break}}if(a)for(n=0;o>n;++n)f.transformToWorldCoordinates(e[n]);else m.multiplyTransformation(t,e[0].modelMatrix,t)}function A(e,n){var a=e.attributes,o=a.position,i=4*(o.values.length/o.componentsPerAttribute);a.pickColor=new l({componentDatatype:r.UNSIGNED_BYTE,componentsPerAttribute:4,normalize:!0,values:new Uint8Array(i)});for(var u=t.floatToByte(n.red),s=t.floatToByte(n.green),c=t.floatToByte(n.blue),E=t.floatToByte(n.alpha),f=a.pickColor.values,h=0;i>h;h+=4)f[h]=u,f[h+1]=s,f[h+2]=c,f[h+3]=E}function T(e,t){for(var r=e.length,n=0;r>n;++n){var o=e[n],i=t[n];a(o.geometry)?A(o.geometry,i):(A(o.westHemisphereGeometry,i),A(o.eastHemisphereGeometry,i))}}function R(e){var t,r=e.length,n=[],o=e[0].attributes;for(t in o)if(o.hasOwnProperty(t)){for(var i=o[t],u=!0,s=1;r>s;++s){var c=e[s].attributes[t];if(!a(c)||i.componentDatatype!==c.componentDatatype||i.componentsPerAttribute!==c.componentsPerAttribute||i.normalize!==c.normalize){u=!1;break}}u&&n.push(t)}return n}function y(e,t,n){for(var a=c.computeNumberOfVertices(t),o=n.length,i=0;o>i;++i){for(var u=n[i],s=e[u],E=s.componentDatatype,f=s.value,h=s.componentsPerAttribute,m=r.createTypedArray(E,a*h),d=0;a>d;++d)m.set(f,d*h);t.attributes[u]=new l({componentDatatype:E,componentsPerAttribute:h,normalize:s.normalize,values:m})}}function _(e,t){for(var r=e.length,n=0;r>n;++n){var o=e[n],i=o.attributes;a(o.geometry)?y(i,o.geometry,t):(y(i,o.westHemisphereGeometry,t),y(i,o.eastHemisphereGeometry,t))}}function v(t){var n,o,i=t.instances,u=t.pickIds,s=t.projection,c=t.elementIndexUintSupported,l=t.scene3DOnly,E=t.allowPicking,h=t.vertexCacheOptimize,m=t.compressVertices,d=t.modelMatrix,A=i.length;i[0].geometry.primitiveType;if(p(i,d,l),!l)for(n=0;A>n;++n)f.splitLongitude(i[n]);E&&T(i,u);var y=R(i);if(_(i,y),h)for(n=0;A>n;++n){var v=i[n];a(v.geometry)?(f.reorderForPostVertexCache(v.geometry),f.reorderForPreVertexCache(v.geometry)):(f.reorderForPostVertexCache(v.westHemisphereGeometry),f.reorderForPreVertexCache(v.westHemisphereGeometry),f.reorderForPostVertexCache(v.eastHemisphereGeometry),f.reorderForPreVertexCache(v.eastHemisphereGeometry))}var S=f.combineInstances(i);for(A=S.length,n=0;A>n;++n){o=S[n];var g,C=o.attributes;if(l)for(g in C)C.hasOwnProperty(g)&&C[g].componentDatatype===r.DOUBLE&&f.encodeAttribute(o,g,g+"3DHigh",g+"3DLow");else for(g in C)if(C.hasOwnProperty(g)&&C[g].componentDatatype===r.DOUBLE){var N=g+"3D",I=g+"2D";f.projectTo2D(o,g,N,I,s),a(o.boundingSphere)&&"position"===g&&(o.boundingSphereCV=e.fromVertices(o.attributes.position2D.values)),f.encodeAttribute(o,N,N+"High",N+"Low"),f.encodeAttribute(o,I,I+"High",I+"Low")}m&&f.compressVertices(o)}if(!c){var M=[];for(A=S.length,n=0;A>n;++n)o=S[n],M=M.concat(f.fitToUnsignedShortIndices(o));S=M}return S}function S(e,t,n){for(var a=[],o=e.attributes,i=n.length,u=0;i>u;++u){var s=n[u],c=o[s],l=c.componentDatatype;l===r.DOUBLE&&(l=r.FLOAT);var E=r.createTypedArray(l,c.values);a.push({index:t[s],componentDatatype:l,componentsPerAttribute:c.componentsPerAttribute,normalize:c.normalize,values:E}),delete o[s]}return a}function g(e,t,r,o,i,u,s,l,E){var f=c.computeNumberOfVertices(t);a(s[e])||(s[e]={boundingSphere:t.boundingSphere,boundingSphereCV:t.boundingSphereCV});for(var h=o.length,m=0;h>m;++m)for(var d=o[m],p=i[d],A=f;A>0;){for(var T,R=n(E[d],0),y=u[R],_=y.length,v=0;_>v&&(T=y[v],T.index!==p);++v);a(s[e][d])||(s[e][d]={dirty:!1,valid:!0,value:r[d].value,indices:[]});var S,g=T.values.length/T.componentsPerAttribute,C=n(l[d],0);g>C+A?(S=A,s[e][d].indices.push({attribute:T,offset:C,count:S}),l[d]=C+A):(S=g-C,s[e][d].indices.push({attribute:T,offset:C,count:S}),l[d]=0,E[d]=R+1),A-=S}}function C(e,t,r,n,o){var i,u,s,c=[],l=e.length,E={},f={};for(i=0;l>i;++i)u=e[i],s=u.attributes,a(u.geometry)&&g(i,u.geometry,s,o,n,r,c,E,f);for(i=0;l>i;++i)u=e[i],s=u.attributes,a(u.westHemisphereGeometry)&&g(i,u.westHemisphereGeometry,s,o,n,r,c,E,f);for(i=0;l>i;++i)u=e[i],s=u.attributes,a(u.eastHemisphereGeometry)&&g(i,u.eastHemisphereGeometry,s,o,n,r,c,E,f);for(l=t.length,i=0;l>i;++i){u=t[i],s=u.attributes;var h={};c.push(h);for(var m=o.length,d=0;m>d;++d){var p=o[d];h[p]={dirty:!1,valid:!1,value:s[p].value,indices:[]}}}return c}function N(e,t,r,n){var o,i,u,s=n.length-1;if(s>=0){var c=n[s];o=c.offset+c.count,u=c.index,i=r[u].indices.length}else o=0,u=0,i=r[u].indices.length;for(var l=e.length,E=0;l>E;++E){var f=e[E],h=f[t];if(a(h)){var m=h.indices.length;o+m>i&&(o=0,i=r[++u].indices.length),n.push({index:u,offset:o,count:m}),o+=m}}}function I(e,t){var r=[];return N(e,"geometry",t,r),N(e,"westHemisphereGeometry",t,r),N(e,"eastHemisphereGeometry",t,r),r}function M(e,t){var r=e.attributes;for(var n in r)if(r.hasOwnProperty(n)){var o=r[n];a(o)&&a(o.values)&&t.push(o.values.buffer)}a(e.indices)&&t.push(e.indices.buffer)}function O(e,t){for(var r=e.length,n=0;r>n;++n)M(e[n],t)}function L(e,t){for(var r=e.length,n=0;r>n;++n)for(var a=e[n],o=a.length,i=0;o>i;++i)t.push(a[i].values.buffer)}function F(t){for(var r=1,n=t.length,o=0;n>o;o++){var i=t[o];if(++r,a(i)){var u=i.attributes;r+=6+2*e.packedLength+(a(i.indices)?i.indices.length:0);for(var s in u)if(u.hasOwnProperty(s)&&a(u[s])){var c=u[s];r+=5+c.values.length}}}return r}function P(e,t){for(var r=e.length,n=new Uint32Array(e.length),a=0;r>a;++a)n[a]=e[a].toRgba();return t.push(n.buffer),n}function b(e){for(var r=e.length,n=new Array(r),a=0;r>a;a++)n[a]=t.fromRgba(e[a]);return n}function w(e){for(var t=e.length,r=1+17*t,n=0;t>n;n++){var o=e[n].attributes;for(var i in o)if(o.hasOwnProperty(i)&&a(o[i])){var u=o[i];r+=5+u.value.length}}return r}function D(e,t){var r=new Float64Array(w(e)),n={},o=[],i=e.length,u=0;r[u++]=i;for(var s=0;i>s;s++){var c=e[s];m.pack(c.modelMatrix,r,u),u+=m.packedLength;var l=c.attributes,E=[];for(var f in l)l.hasOwnProperty(f)&&a(l[f])&&(E.push(f),a(n[f])||(n[f]=o.length,o.push(f)));r[u++]=E.length;for(var h=0;h<E.length;h++){var d=E[h],p=l[d];r[u++]=n[d],r[u++]=p.componentDatatype,r[u++]=p.componentsPerAttribute,r[u++]=p.normalize,r[u++]=p.value.length,r.set(p.value,u),u+=p.value.length}}return t.push(r.buffer),{stringTable:o,packedData:r}}function x(e){for(var t=e.packedData,n=e.stringTable,a=new Array(t[0]),o=0,i=1;i<t.length;){var u=m.unpack(t,i);i+=m.packedLength;for(var s={},c=t[i++],l=0;c>l;l++){for(var E=n[t[i++]],f=t[i++],h=t[i++],d=0!==t[i++],p=t[i++],A=r.createTypedArray(f,p),T=0;p>T;T++)A[T]=t[i++];s[E]={componentDatatype:f,componentsPerAttribute:h,normalize:d,value:A}}a[o++]={attributes:s,modelMatrix:u}}return a}function U(t){for(var r=t.length,n=1+r,o=0;r>o;o++){var i=t[o];n+=2,n+=a(i.boundingSphere)?e.packedLength:0,n+=a(i.boundingSphereCV)?e.packedLength:0;for(var u in i)if(i.hasOwnProperty(u)&&a(i[u])&&"boundingSphere"!==u&&"boundingSphereCV"!==u){var s=i[u];n+=4+3*s.indices.length+s.value.length}}return n}function B(t,r){var n=new Float64Array(U(t)),o=[],i=[],u={},s=t.length,c=0;n[c++]=s;for(var l=0;s>l;l++){var E=t[l],f=E.boundingSphere,h=a(f);n[c++]=h?1:0,h&&(e.pack(f,n,c),c+=e.packedLength),f=E.boundingSphereCV,h=a(f),n[c++]=h?1:0,h&&(e.pack(f,n,c),c+=e.packedLength);var m=[];for(var d in E)E.hasOwnProperty(d)&&a(E[d])&&"boundingSphere"!==d&&"boundingSphereCV"!==d&&(m.push(d),a(u[d])||(u[d]=o.length,o.push(d)));n[c++]=m.length;for(var p=0;p<m.length;p++){var A=m[p],T=E[A];n[c++]=u[A],n[c++]=T.valid?1:0;var R=T.indices,y=R.length;n[c++]=y;for(var _=0;y>_;_++){var v=R[_];n[c++]=v.count,n[c++]=v.offset;var S=i.indexOf(v.attribute);-1===S&&(S=i.length,i.push(v.attribute)),n[c++]=S}n[c++]=T.value.length,n.set(T.value,c),c+=T.value.length}}return r.push(n.buffer),{stringTable:o,packedData:n,attributeTable:i}}function G(t,n){for(var a=t.stringTable,o=t.attributeTable,i=t.packedData,u=new Array(i[0]),s=0,c=1,l=i.length;l>c;){var E={},f=1===i[c++];f&&(E.boundingSphere=e.unpack(i,c),c+=e.packedLength),f=1===i[c++],f&&(E.boundingSphereCV=e.unpack(i,c),c+=e.packedLength);for(var h=i[c++],m=0;h>m;m++){for(var d=a[i[c++]],p=1===i[c++],A=i[c++],T=A>0?new Array(A):void 0,R=0;A>R;R++){var y={};y.count=i[c++],y.offset=i[c++],y.attribute=o[i[c++]],T[R]=y}for(var _=i[c++],v=p?r.createTypedArray(T[0].attribute.componentDatatype,_):new Array(_),S=0;_>S;S++)v[S]=i[c++];E[d]={dirty:!1,valid:p,indices:T,value:v}}u[s++]=E}return u}if(!u.supportsTypedArrays())return{};var z={};return z.combineGeometry=function(e){var t,r,n,o,i,u=e.instances,s=e.invalidInstances;if(u.length>0){t=v(e),r=f.createAttributeLocations(t[0]),o=R(u),n=[],i=t.length;for(var c=0;i>c;++c){var l=t[c];n.push(S(l,r,o))}}o=a(o)?o:R(s);var E,h=C(u,s,n,r,o);return e.createPickOffsets&&a(t)&&(E=I(u,t)),{geometries:t,modelMatrix:e.modelMatrix,attributeLocations:r,vaAttributes:n,vaAttributeLocations:h,validInstancesIndices:e.validInstancesIndices,invalidInstancesIndices:e.invalidInstancesIndices,pickOffsets:E}},z.packCreateGeometryResults=function(t,r){var n=new Float64Array(F(t)),o=[],i={},u=t.length,s=0;n[s++]=u;for(var c=0;u>c;c++){var l=t[c],E=a(l);if(n[s++]=E?1:0,E){n[s++]=l.primitiveType,n[s++]=l.geometryType;var f=a(l.boundingSphere)?1:0;n[s++]=f,f&&e.pack(l.boundingSphere,n,s),s+=e.packedLength;var h=a(l.boundingSphereCV)?1:0;n[s++]=h,h&&e.pack(l.boundingSphereCV,n,s),s+=e.packedLength;var m=l.attributes,d=[];for(var p in m)m.hasOwnProperty(p)&&a(m[p])&&(d.push(p),a(i[p])||(i[p]=o.length,o.push(p)));n[s++]=d.length;for(var A=0;A<d.length;A++){var T=d[A],R=m[T];n[s++]=i[T],n[s++]=R.componentDatatype,n[s++]=R.componentsPerAttribute,n[s++]=R.normalize?1:0,n[s++]=R.values.length,n.set(R.values,s),s+=R.values.length}var y=a(l.indices)?l.indices.length:0;n[s++]=y,y>0&&(n.set(l.indices,s),s+=y)}}return r.push(n.buffer),{stringTable:o,packedData:n}},z.unpackCreateGeometryResults=function(t){for(var n,a=t.stringTable,o=t.packedData,i=new Array(o[0]),u=0,s=1;s<o.length;){var f=1===o[s++];if(f){var m,d,p=o[s++],A=o[s++],T=1===o[s++];T&&(m=e.unpack(o,s)),s+=e.packedLength;var R=1===o[s++];R&&(d=e.unpack(o,s)),s+=e.packedLength;var y,_,v,S=new E,g=o[s++];for(n=0;g>n;n++){var C=a[o[s++]],N=o[s++];v=o[s++];var I=0!==o[s++];y=o[s++],_=r.createTypedArray(N,y);for(var M=0;y>M;M++)_[M]=o[s++];S[C]=new l({componentDatatype:N,componentsPerAttribute:v,normalize:I,values:_})}var O;if(y=o[s++],y>0){var L=_.length/v;for(O=h.createTypedArray(L,y),n=0;y>n;n++)O[n]=o[s++]}i[u++]=new c({primitiveType:p,geometryType:A,boundingSphere:m,indices:O,attributes:S})}else i[u++]=void 0}return i},z.packCombineGeometryParameters=function(e,t){for(var r=e.createGeometryResults,n=r.length,a=0;n>a;a++)t.push(r[a].packedData.buffer);var o;return e.allowPicking&&(o=P(e.pickIds,t)),{createGeometryResults:e.createGeometryResults,packedInstances:D(e.instances,t),packedPickIds:o,ellipsoid:e.ellipsoid,isGeographic:e.projection instanceof s,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,allowPicking:e.allowPicking,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:e.modelMatrix,createPickOffsets:e.createPickOffsets}},z.unpackCombineGeometryParameters=function(e){for(var t=x(e.packedInstances),r=e.allowPicking,n=r?b(e.packedPickIds):void 0,o=e.createGeometryResults,u=o.length,c=0,l=[],E=[],f=[],h=[],p=[],A=0;u>A;A++)for(var T=z.unpackCreateGeometryResults(o[A]),R=T.length,y=0;R>y;y++){var _=T[y],v=t[c];a(_)?(v.geometry=_,l.push(v),f.push(c),r&&p.push(n[c])):(E.push(v),h.push(c)),++c}var S=i.clone(e.ellipsoid),g=e.isGeographic?new s(S):new d(S);return{instances:l,invalidInstances:E,validInstancesIndices:f,invalidInstancesIndices:h,pickIds:p,ellipsoid:S,projection:g,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,allowPicking:e.allowPicking,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:m.clone(e.modelMatrix),createPickOffsets:e.createPickOffsets}},z.packCombineGeometryResults=function(e,t){return a(e.geometries)&&(O(e.geometries,t),L(e.vaAttributes,t)),{geometries:e.geometries,attributeLocations:e.attributeLocations,vaAttributes:e.vaAttributes,packedVaAttributeLocations:B(e.vaAttributeLocations,t),modelMatrix:e.modelMatrix,validInstancesIndices:e.validInstancesIndices,invalidInstancesIndices:e.invalidInstancesIndices,pickOffsets:e.pickOffsets}},z.unpackCombineGeometryResults=function(e){return{geometries:e.geometries,attributeLocations:e.attributeLocations,vaAttributes:e.vaAttributes,perInstanceAttributeLocations:G(e.packedVaAttributeLocations,e.vaAttributes),modelMatrix:e.modelMatrix,pickOffsets:e.pickOffsets}},z}),define("Core/formatError",["./defined"],function(e){"use strict";function t(t){var r,n=t.name,a=t.message;r=e(n)&&e(a)?n+": "+a:t.toString();var o=t.stack;return e(o)&&(r+="\n"+o),r}return t}),define("Workers/createTaskProcessorWorker",["../Core/defaultValue","../Core/defined","../Core/formatError"],function(e,t,r){"use strict";function n(n){var a,o=[],i={id:void 0,result:void 0,error:void 0};return function(u){var s=u.data;o.length=0,i.id=s.id,i.error=void 0,i.result=void 0;try{i.result=n(s.parameters,o)}catch(c){c instanceof Error?i.error={name:c.name,message:c.message,stack:c.stack}:i.error=c}t(a)||(a=e(self.webkitPostMessage,self.postMessage)),s.canTransferArrayBuffer||(o.length=0);try{a(i,o)}catch(c){i.result=void 0,i.error="postMessage failed with error: "+r(c)+"\n  with responseMessage: "+JSON.stringify(i),a(i)}}}return n}),define("Workers/combineGeometry",["../Scene/PrimitivePipeline","./createTaskProcessorWorker"],function(e,t){"use strict";function r(t,r){var n=e.unpackCombineGeometryParameters(t),a=e.combineGeometry(n);return e.packCombineGeometryResults(a,r)}return t(r)})}();