/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2015 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**
  @license
  when.js - https://github.com/cujojs/when

  MIT License (c) copyright B Cavalier & J Hann

 * A lightweight CommonJS Promises/A and when() implementation
 * when is part of the cujo.js family of libraries (http://cujojs.com/)
 *
 * Licensed under the MIT License at:
 * http://www.opensource.org/licenses/mit-license.php
 *
 * @version 1.7.1
 */

!function(){define("Core/defined",[],function(){"use strict";function e(e){return void 0!==e&&null!==e}return e}),define("Core/freezeObject",["./defined"],function(e){"use strict";var t=Object.freeze;return e(t)||(t=function(e){return e}),t}),define("Core/defaultValue",["./freezeObject"],function(e){"use strict";function t(e,t){return void 0!==e?e:t}return t.EMPTY_OBJECT=e({}),t}),define("Core/DeveloperError",["./defined"],function(e){"use strict";function t(e){this.name="DeveloperError",this.message=e;var t;try{throw new Error}catch(r){t=r.stack}this.stack=t}return e(Object.create)&&(t.prototype=Object.create(Error.prototype),t.prototype.constructor=t),t.prototype.toString=function(){var t=this.name+": "+this.message;return e(this.stack)&&(t+="\n"+this.stack.toString()),t},t.throwInstantiationError=function(){throw new t("This function defines an interface and should not be called directly.")},t}),define("ThirdParty/mersenne-twister",[],function(){var e=function(e){void 0==e&&(e=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(e)};return e.prototype.init_genrand=function(e){for(this.mt[0]=e>>>0,this.mti=1;this.mti<this.N;this.mti++){var e=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&e)>>>16)<<16)+1812433253*(65535&e)+this.mti,this.mt[this.mti]>>>=0}},e.prototype.genrand_int32=function(){var e,t=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var r;for(this.mti==this.N+1&&this.init_genrand(5489),r=0;r<this.N-this.M;r++)e=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+this.M]^e>>>1^t[1&e];for(;r<this.N-1;r++)e=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+(this.M-this.N)]^e>>>1^t[1&e];e=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^e>>>1^t[1&e],this.mti=0}return e=this.mt[this.mti++],e^=e>>>11,e^=e<<7&2636928640,e^=e<<15&4022730752,e^=e>>>18,e>>>0},e.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},e}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(e,t,r,n){"use strict";var o={};o.EPSILON1=.1,o.EPSILON2=.01,o.EPSILON3=.001,o.EPSILON4=1e-4,o.EPSILON5=1e-5,o.EPSILON6=1e-6,o.EPSILON7=1e-7,o.EPSILON8=1e-8,o.EPSILON9=1e-9,o.EPSILON10=1e-10,o.EPSILON11=1e-11,o.EPSILON12=1e-12,o.EPSILON13=1e-13,o.EPSILON14=1e-14,o.EPSILON15=1e-15,o.EPSILON16=1e-16,o.EPSILON17=1e-17,o.EPSILON18=1e-18,o.EPSILON19=1e-19,o.EPSILON20=1e-20,o.GRAVITATIONALPARAMETER=3986004418e5,o.SOLAR_RADIUS=6955e5,o.LUNAR_RADIUS=1737400,o.SIXTY_FOUR_KILOBYTES=65536,o.sign=function(e){return e>0?1:0>e?-1:0},o.signNotZero=function(e){return 0>e?-1:1},o.toSNorm=function(e){return Math.round(255*(.5*o.clamp(e,-1,1)+.5))},o.fromSNorm=function(e){return o.clamp(e,0,255)/255*2-1},o.sinh=function(e){var t=Math.pow(Math.E,e),r=Math.pow(Math.E,-1*e);return.5*(t-r)},o.cosh=function(e){var t=Math.pow(Math.E,e),r=Math.pow(Math.E,-1*e);return.5*(t+r)},o.lerp=function(e,t,r){return(1-r)*e+r*t},o.PI=Math.PI,o.ONE_OVER_PI=1/Math.PI,o.PI_OVER_TWO=.5*Math.PI,o.PI_OVER_THREE=Math.PI/3,o.PI_OVER_FOUR=Math.PI/4,o.PI_OVER_SIX=Math.PI/6,o.THREE_PI_OVER_TWO=3*Math.PI*.5,o.TWO_PI=2*Math.PI,o.ONE_OVER_TWO_PI=1/(2*Math.PI),o.RADIANS_PER_DEGREE=Math.PI/180,o.DEGREES_PER_RADIAN=180/Math.PI,o.RADIANS_PER_ARCSECOND=o.RADIANS_PER_DEGREE/3600,o.toRadians=function(e){return e*o.RADIANS_PER_DEGREE},o.toDegrees=function(e){return e*o.DEGREES_PER_RADIAN},o.convertLongitudeRange=function(e){var t=o.TWO_PI,r=e-Math.floor(e/t)*t;return r<-Math.PI?r+t:r>=Math.PI?r-t:r},o.negativePiToPi=function(e){return o.zeroToTwoPi(e+o.PI)-o.PI},o.zeroToTwoPi=function(e){var t=o.mod(e,o.TWO_PI);return Math.abs(t)<o.EPSILON14&&Math.abs(e)>o.EPSILON14?o.TWO_PI:t},o.mod=function(e,t){return(e%t+t)%t},o.equalsEpsilon=function(e,r,n,o){o=t(o,n);var a=Math.abs(e-r);return o>=a||a<=n*Math.max(Math.abs(e),Math.abs(r))};var a=[1];o.factorial=function(e){var t=a.length;if(e>=t)for(var r=a[t-1],n=t;e>=n;n++)a.push(r*n);return a[e]},o.incrementWrap=function(e,r,n){return n=t(n,0),++e,e>r&&(e=n),e},o.isPowerOfTwo=function(e){return 0!==e&&0===(e&e-1)},o.nextPowerOfTwo=function(e){return--e,e|=e>>1,e|=e>>2,e|=e>>4,e|=e>>8,e|=e>>16,++e,e},o.clamp=function(e,t,r){return t>e?t:e>r?r:e};var i=new e;return o.setRandomNumberSeed=function(t){i=new e(t)},o.nextRandomNumber=function(){return i.random()},o.acosClamped=function(e){return Math.acos(o.clamp(e,-1,1))},o.asinClamped=function(e){return Math.asin(o.clamp(e,-1,1))},o.chordLength=function(e,t){return 2*t*Math.sin(.5*e)},o.logBase=function(e,t){return Math.log(e)/Math.log(t)},o.fog=function(e,t){var r=e*t;return 1-Math.exp(-(r*r))},o}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,o){"use strict";function a(t,r,n){this.x=e(t,0),this.y=e(r,0),this.z=e(n,0)}a.fromSpherical=function(r,n){t(n)||(n=new a);var o=r.clock,i=r.cone,u=e(r.magnitude,1),s=u*Math.sin(i);return n.x=s*Math.cos(o),n.y=s*Math.sin(o),n.z=u*Math.cos(i),n},a.fromElements=function(e,r,n,o){return t(o)?(o.x=e,o.y=r,o.z=n,o):new a(e,r,n)},a.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r.z=e.z,r):new a(e.x,e.y,e.z):void 0},a.fromCartesian4=a.clone,a.packedLength=3,a.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n++]=t.y,r[n]=t.z},a.unpack=function(r,n,o){return n=e(n,0),t(o)||(o=new a),o.x=r[n++],o.y=r[n++],o.z=r[n],o},a.packArray=function(e,r){var n=e.length;t(r)?r.length=3*n:r=new Array(3*n);for(var o=0;n>o;++o)a.pack(e[o],r,3*o);return r},a.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/3:r=new Array(n/3);for(var o=0;n>o;o+=3){var i=o/3;r[i]=a.unpack(e,o,r[i])}return r},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y,e.z)},a.minimumComponent=function(e){return Math.min(e.x,e.y,e.z)},a.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r.z=Math.min(e.z,t.z),r},a.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r.z=Math.max(e.z,t.z),r},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,t){return a.subtract(e,t,i),a.magnitude(i)},a.distanceSquared=function(e,t){return a.subtract(e,t,i),a.magnitudeSquared(i)},a.normalize=function(e,t){var r=a.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t},a.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z},a.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r.z=e.z*t.z,r},a.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r.z=e.z+t.z,r},a.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r.z=e.z-t.z,r},a.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r.z=e.z*t,r},a.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r},a.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t},a.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t.z=Math.abs(e.z),t};var u=new a;a.lerp=function(e,t,r,n){return a.multiplyByScalar(t,r,u),n=a.multiplyByScalar(e,1-r,n),a.add(u,n,n)};var s=new a,c=new a;a.angleBetween=function(e,t){a.normalize(e,s),a.normalize(t,c);var r=a.dot(s,c),n=a.magnitude(a.cross(s,c,s));return Math.atan2(n,r)};var l=new a;a.mostOrthogonalAxis=function(e,t){var r=a.normalize(e,l);return a.abs(r,r),t=r.x<=r.y?r.x<=r.z?a.clone(a.UNIT_X,t):a.clone(a.UNIT_Z,t):r.y<=r.z?a.clone(a.UNIT_Y,t):a.clone(a.UNIT_Z,t)},a.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y&&e.z===r.z},a.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]&&e.z===t[r+2]},a.equalsEpsilon=function(e,r,n,a){return e===r||t(e)&&t(r)&&o.equalsEpsilon(e.x,r.x,n,a)&&o.equalsEpsilon(e.y,r.y,n,a)&&o.equalsEpsilon(e.z,r.z,n,a)},a.cross=function(e,t,r){var n=e.x,o=e.y,a=e.z,i=t.x,u=t.y,s=t.z,c=o*s-a*u,l=a*i-n*s,E=n*u-o*i;return r.x=c,r.y=l,r.z=E,r},a.fromDegrees=function(e,t,r,n,i){return e=o.toRadians(e),t=o.toRadians(t),a.fromRadians(e,t,r,n,i)};var E=new a,f=new a,h=new a(40680631590769,40680631590769,40408299984661.445);return a.fromRadians=function(r,n,o,i,u){o=e(o,0);var s=t(i)?i.radiiSquared:h,c=Math.cos(n);E.x=c*Math.cos(r),E.y=c*Math.sin(r),E.z=Math.sin(n),E=a.normalize(E,E),a.multiplyComponents(s,E,f);var l=Math.sqrt(a.dot(E,f));return f=a.divideByScalar(f,l,f),E=a.multiplyByScalar(E,o,E),t(u)||(u=new a),a.add(f,E,u)},a.fromDegreesArray=function(e,r,n){var o=e.length;t(n)?n.length=o/2:n=new Array(o/2);for(var i=0;o>i;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=a.fromDegrees(u,s,0,r,n[c])}return n},a.fromRadiansArray=function(e,r,n){var o=e.length;t(n)?n.length=o/2:n=new Array(o/2);for(var i=0;o>i;i+=2){var u=e[i],s=e[i+1],c=i/2;n[c]=a.fromRadians(u,s,0,r,n[c])}return n},a.fromDegreesArrayHeights=function(e,r,n){var o=e.length;t(n)?n.length=o/3:n=new Array(o/3);for(var i=0;o>i;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=a.fromDegrees(u,s,c,r,n[l])}return n},a.fromRadiansArrayHeights=function(e,r,n){var o=e.length;t(n)?n.length=o/3:n=new Array(o/3);for(var i=0;o>i;i+=3){var u=e[i],s=e[i+1],c=e[i+2],l=i/3;n[l]=a.fromRadians(u,s,c,r,n[l])}return n},a.ZERO=n(new a(0,0,0)),a.UNIT_X=n(new a(1,0,0)),a.UNIT_Y=n(new a(0,1,0)),a.UNIT_Z=n(new a(0,0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,t,r){return a.equalsEpsilon(this,e,t,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},a}),define("Core/scaleToGeodeticSurface",["./Cartesian3","./defined","./DeveloperError","./Math"],function(e,t,r,n){"use strict";function o(r,o,u,s,c){var l=r.x,E=r.y,f=r.z,h=o.x,m=o.y,d=o.z,p=l*l*h*h,A=E*E*m*m,T=f*f*d*d,R=p+A+T,y=Math.sqrt(1/R),_=e.multiplyByScalar(r,y,a);if(s>R)return isFinite(y)?e.clone(_,c):void 0;var v=u.x,S=u.y,g=u.z,C=i;C.x=_.x*v*2,C.y=_.y*S*2,C.z=_.z*g*2;var N,I,M,O,L,F,P,w,b,D,x,U=(1-y)*e.magnitude(r)/(.5*e.magnitude(C)),B=0;do{U-=B,M=1/(1+U*v),O=1/(1+U*S),L=1/(1+U*g),F=M*M,P=O*O,w=L*L,b=F*M,D=P*O,x=w*L,N=p*F+A*P+T*w-1,I=p*b*v+A*D*S+T*x*g;var G=-2*I;B=N/G}while(Math.abs(N)>n.EPSILON12);return t(c)?(c.x=l*M,c.y=E*O,c.z=f*L,c):new e(l*M,E*O,f*L)}var a=new e,i=new e;return o}),define("Core/Cartographic",["./Cartesian3","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,t,r,n,o,a,i){"use strict";function u(e,r,n){this.longitude=t(e,0),this.latitude=t(r,0),this.height=t(n,0)}u.fromRadians=function(e,n,o,a){return o=t(o,0),r(a)?(a.longitude=e,a.latitude=n,a.height=o,a):new u(e,n,o)},u.fromDegrees=function(e,t,r,n){return e=a.toRadians(e),t=a.toRadians(t),u.fromRadians(e,t,r,n)};var s=new e,c=new e,l=new e,E=new e(1/6378137,1/6378137,1/6356752.314245179),f=new e(1/40680631590769,1/40680631590769,1/40408299984661.445),h=a.EPSILON1;return u.fromCartesian=function(t,n,o){var m=r(n)?n.oneOverRadii:E,d=r(n)?n.oneOverRadiiSquared:f,p=r(n)?n._centerToleranceSquared:h,A=i(t,m,d,p,c);if(r(A)){var T=e.multiplyComponents(t,d,s);T=e.normalize(T,T);var R=e.subtract(t,A,l),y=Math.atan2(T.y,T.x),_=Math.asin(T.z),v=a.sign(e.dot(R,t))*e.magnitude(R);return r(o)?(o.longitude=y,o.latitude=_,o.height=v,o):new u(y,_,v)}},u.clone=function(e,t){return r(e)?r(t)?(t.longitude=e.longitude,t.latitude=e.latitude,t.height=e.height,t):new u(e.longitude,e.latitude,e.height):void 0},u.equals=function(e,t){return e===t||r(e)&&r(t)&&e.longitude===t.longitude&&e.latitude===t.latitude&&e.height===t.height},u.equalsEpsilon=function(e,t,n){return e===t||r(e)&&r(t)&&Math.abs(e.longitude-t.longitude)<=n&&Math.abs(e.latitude-t.latitude)<=n&&Math.abs(e.height-t.height)<=n},u.ZERO=o(new u(0,0,0)),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,t){return u.equalsEpsilon(this,e,t)},u.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},u}),define("Core/defineProperties",["./defined"],function(e){"use strict";var t=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(e){return!1}}(),r=Object.defineProperties;return t&&e(r)||(r=function(e){return e}),r}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(e,t,r,n,o,a,i,u,s){"use strict";function c(t,n,o,a){n=r(n,0),o=r(o,0),a=r(a,0),t._radii=new e(n,o,a),t._radiiSquared=new e(n*n,o*o,a*a),t._radiiToTheFourth=new e(n*n*n*n,o*o*o*o,a*a*a*a),t._oneOverRadii=new e(0===n?0:1/n,0===o?0:1/o,0===a?0:1/a),t._oneOverRadiiSquared=new e(0===n?0:1/(n*n),0===o?0:1/(o*o),0===a?0:1/(a*a)),t._minimumRadius=Math.min(n,o,a),t._maximumRadius=Math.max(n,o,a),t._centerToleranceSquared=u.EPSILON1}function l(e,t,r){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,c(this,e,t,r)}o(l.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),l.clone=function(t,r){if(n(t)){var o=t._radii;return n(r)?(e.clone(o,r._radii),e.clone(t._radiiSquared,r._radiiSquared),e.clone(t._radiiToTheFourth,r._radiiToTheFourth),e.clone(t._oneOverRadii,r._oneOverRadii),e.clone(t._oneOverRadiiSquared,r._oneOverRadiiSquared),r._minimumRadius=t._minimumRadius,r._maximumRadius=t._maximumRadius,r._centerToleranceSquared=t._centerToleranceSquared,r):new l(o.x,o.y,o.z)}},l.fromCartesian3=function(e,t){return n(t)||(t=new l),n(e)?(c(t,e.x,e.y,e.z),t):t},l.WGS84=i(new l(6378137,6378137,6356752.314245179)),l.UNIT_SPHERE=i(new l(1,1,1)),l.MOON=i(new l(u.LUNAR_RADIUS,u.LUNAR_RADIUS,u.LUNAR_RADIUS)),l.prototype.clone=function(e){return l.clone(this,e)},l.packedLength=e.packedLength,l.pack=function(t,n,o){o=r(o,0),e.pack(t._radii,n,o)},l.unpack=function(t,n,o){n=r(n,0);var a=e.unpack(t,n);return l.fromCartesian3(a,o)},l.prototype.geocentricSurfaceNormal=e.normalize,l.prototype.geodeticSurfaceNormalCartographic=function(t,r){var o=t.longitude,a=t.latitude,i=Math.cos(a),u=i*Math.cos(o),s=i*Math.sin(o),c=Math.sin(a);return n(r)||(r=new e),r.x=u,r.y=s,r.z=c,e.normalize(r,r)},l.prototype.geodeticSurfaceNormal=function(t,r){return n(r)||(r=new e),r=e.multiplyComponents(t,this._oneOverRadiiSquared,r),e.normalize(r,r)};var E=new e,f=new e;l.prototype.cartographicToCartesian=function(t,r){var o=E,a=f;this.geodeticSurfaceNormalCartographic(t,o),e.multiplyComponents(this._radiiSquared,o,a);var i=Math.sqrt(e.dot(o,a));return e.divideByScalar(a,i,a),e.multiplyByScalar(o,t.height,o),n(r)||(r=new e),e.add(a,o,r)},l.prototype.cartographicArrayToCartesianArray=function(e,t){var r=e.length;n(t)?t.length=r:t=new Array(r);for(var o=0;r>o;o++)t[o]=this.cartographicToCartesian(e[o],t[o]);return t};var h=new e,m=new e,d=new e;return l.prototype.cartesianToCartographic=function(r,o){var a=this.scaleToGeodeticSurface(r,m);if(n(a)){var i=this.geodeticSurfaceNormal(a,h),s=e.subtract(r,a,d),c=Math.atan2(i.y,i.x),l=Math.asin(i.z),E=u.sign(e.dot(s,r))*e.magnitude(s);return n(o)?(o.longitude=c,o.latitude=l,o.height=E,o):new t(c,l,E)}},l.prototype.cartesianArrayToCartographicArray=function(e,t){var r=e.length;n(t)?t.length=r:t=new Array(r);for(var o=0;r>o;++o)t[o]=this.cartesianToCartographic(e[o],t[o]);return t},l.prototype.scaleToGeodeticSurface=function(e,t){return s(e,this._oneOverRadii,this._oneOverRadiiSquared,this._centerToleranceSquared,t)},l.prototype.scaleToGeocentricSurface=function(t,r){n(r)||(r=new e);var o=t.x,a=t.y,i=t.z,u=this._oneOverRadiiSquared,s=1/Math.sqrt(o*o*u.x+a*a*u.y+i*i*u.z);return e.multiplyByScalar(t,s,r)},l.prototype.transformPositionToScaledSpace=function(t,r){return n(r)||(r=new e),e.multiplyComponents(t,this._oneOverRadii,r)},l.prototype.transformPositionFromScaledSpace=function(t,r){return n(r)||(r=new e),e.multiplyComponents(t,this._radii,r)},l.prototype.equals=function(t){return this===t||n(t)&&e.equals(this._radii,t._radii)},l.prototype.toString=function(){return this._radii.toString()},l}),define("Core/GeographicProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid"],function(e,t,r,n,o,a,i){"use strict";function u(e){this._ellipsoid=r(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return o(u.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),u.prototype.project=function(t,r){var o=this._semimajorAxis,a=t.longitude*o,i=t.latitude*o,u=t.height;return n(r)?(r.x=a,r.y=i,r.z=u,r):new e(a,i,u)},u.prototype.unproject=function(e,r){var o=this._oneOverSemimajorAxis,a=e.x*o,i=e.y*o,u=e.z;return n(r)?(r.longitude=a,r.latitude=i,r.height=u,r):new t(a,i,u)},u}),define("Core/Intersect",["./freezeObject"],function(e){"use strict";var t={OUTSIDE:-1,INTERSECTING:0,INSIDE:1};return e(t)}),define("Core/Interval",["./defaultValue"],function(e){"use strict";function t(t,r){this.start=e(t,0),this.stop=e(r,0)}return t}),define("Core/Matrix3",["./Cartesian3","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,o,a,i){"use strict";function u(e,r,n,o,a,i,u,s,c){this[0]=t(e,0),this[1]=t(o,0),this[2]=t(u,0),this[3]=t(r,0),this[4]=t(a,0),this[5]=t(s,0),this[6]=t(n,0),this[7]=t(i,0),this[8]=t(c,0)}function s(e){for(var t=0,r=0;9>r;++r){var n=e[r];t+=n*n}return Math.sqrt(t)}function c(e){for(var t=0,r=0;3>r;++r){var n=e[u.getElementIndex(m[r],h[r])];t+=2*n*n}return Math.sqrt(t)}function l(e,t){for(var r=i.EPSILON15,n=0,o=1,a=0;3>a;++a){var s=Math.abs(e[u.getElementIndex(m[a],h[a])]);s>n&&(o=a,n=s)}var c=1,l=0,E=h[o],f=m[o];if(Math.abs(e[u.getElementIndex(f,E)])>r){var d,p=e[u.getElementIndex(f,f)],A=e[u.getElementIndex(E,E)],T=e[u.getElementIndex(f,E)],R=(p-A)/2/T;d=0>R?-1/(-R+Math.sqrt(1+R*R)):1/(R+Math.sqrt(1+R*R)),c=1/Math.sqrt(1+d*d),l=d*c}return t=u.clone(u.IDENTITY,t),t[u.getElementIndex(E,E)]=t[u.getElementIndex(f,f)]=c,t[u.getElementIndex(f,E)]=l,t[u.getElementIndex(E,f)]=-l,t}u.packedLength=9,u.pack=function(e,r,n){n=t(n,0),r[n++]=e[0],r[n++]=e[1],r[n++]=e[2],r[n++]=e[3],r[n++]=e[4],r[n++]=e[5],r[n++]=e[6],r[n++]=e[7],r[n++]=e[8]},u.unpack=function(e,n,o){return n=t(n,0),r(o)||(o=new u),o[0]=e[n++],o[1]=e[n++],o[2]=e[n++],o[3]=e[n++],o[4]=e[n++],o[5]=e[n++],o[6]=e[n++],o[7]=e[n++],o[8]=e[n++],o},u.clone=function(e,t){return r(e)?r(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):new u(e[0],e[3],e[6],e[1],e[4],e[7],e[2],e[5],e[8]):void 0},u.fromArray=function(e,n,o){return n=t(n,0),r(o)||(o=new u),o[0]=e[n],o[1]=e[n+1],o[2]=e[n+2],o[3]=e[n+3],o[4]=e[n+4],o[5]=e[n+5],o[6]=e[n+6],o[7]=e[n+7],o[8]=e[n+8],o},u.fromColumnMajorArray=function(e,t){return u.clone(e,t)},u.fromRowMajorArray=function(e,t){return r(t)?(t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8],t):new u(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8])},u.fromQuaternion=function(e,t){var n=e.x*e.x,o=e.x*e.y,a=e.x*e.z,i=e.x*e.w,s=e.y*e.y,c=e.y*e.z,l=e.y*e.w,E=e.z*e.z,f=e.z*e.w,h=e.w*e.w,m=n-s-E+h,d=2*(o-f),p=2*(a+l),A=2*(o+f),T=-n+s-E+h,R=2*(c-i),y=2*(a-l),_=2*(c+i),v=-n-s+E+h;return r(t)?(t[0]=m,t[1]=A,t[2]=y,t[3]=d,t[4]=T,t[5]=_,t[6]=p,t[7]=R,t[8]=v,t):new u(m,d,p,A,T,R,y,_,v)},u.fromScale=function(e,t){return r(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=e.y,t[5]=0,t[6]=0,t[7]=0,t[8]=e.z,t):new u(e.x,0,0,0,e.y,0,0,0,e.z)},u.fromUniformScale=function(e,t){return r(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=e,t[5]=0,t[6]=0,t[7]=0,t[8]=e,t):new u(e,0,0,0,e,0,0,0,e)},u.fromCrossProduct=function(e,t){return r(t)?(t[0]=0,t[1]=e.z,t[2]=-e.y,t[3]=-e.z,t[4]=0,t[5]=e.x,t[6]=e.y,t[7]=-e.x,t[8]=0,t):new u(0,-e.z,e.y,e.z,0,-e.x,-e.y,e.x,0)},u.fromRotationX=function(e,t){var n=Math.cos(e),o=Math.sin(e);return r(t)?(t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=n,t[5]=o,t[6]=0,t[7]=-o,t[8]=n,t):new u(1,0,0,0,n,-o,0,o,n)},u.fromRotationY=function(e,t){var n=Math.cos(e),o=Math.sin(e);return r(t)?(t[0]=n,t[1]=0,t[2]=-o,t[3]=0,t[4]=1,t[5]=0,t[6]=o,t[7]=0,t[8]=n,t):new u(n,0,o,0,1,0,-o,0,n)},u.fromRotationZ=function(e,t){var n=Math.cos(e),o=Math.sin(e);return r(t)?(t[0]=n,t[1]=o,t[2]=0,t[3]=-o,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t):new u(n,-o,0,o,n,0,0,0,1)},u.toArray=function(e,t){return r(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8]]},u.getElementIndex=function(e,t){return 3*e+t},u.getColumn=function(e,t,r){var n=3*t,o=e[n],a=e[n+1],i=e[n+2];return r.x=o,r.y=a,r.z=i,r},u.setColumn=function(e,t,r,n){n=u.clone(e,n);var o=3*t;return n[o]=r.x,n[o+1]=r.y,n[o+2]=r.z,n},u.getRow=function(e,t,r){var n=e[t],o=e[t+3],a=e[t+6];return r.x=n,r.y=o,r.z=a,r},u.setRow=function(e,t,r,n){return n=u.clone(e,n),n[t]=r.x,n[t+3]=r.y,n[t+6]=r.z,n};var E=new e;u.getScale=function(t,r){return r.x=e.magnitude(e.fromElements(t[0],t[1],t[2],E)),r.y=e.magnitude(e.fromElements(t[3],t[4],t[5],E)),r.z=e.magnitude(e.fromElements(t[6],t[7],t[8],E)),r};var f=new e;u.getMaximumScale=function(t){return u.getScale(t,f),e.maximumComponent(f)},u.multiply=function(e,t,r){var n=e[0]*t[0]+e[3]*t[1]+e[6]*t[2],o=e[1]*t[0]+e[4]*t[1]+e[7]*t[2],a=e[2]*t[0]+e[5]*t[1]+e[8]*t[2],i=e[0]*t[3]+e[3]*t[4]+e[6]*t[5],u=e[1]*t[3]+e[4]*t[4]+e[7]*t[5],s=e[2]*t[3]+e[5]*t[4]+e[8]*t[5],c=e[0]*t[6]+e[3]*t[7]+e[6]*t[8],l=e[1]*t[6]+e[4]*t[7]+e[7]*t[8],E=e[2]*t[6]+e[5]*t[7]+e[8]*t[8];return r[0]=n,r[1]=o,r[2]=a,r[3]=i,r[4]=u,r[5]=s,r[6]=c,r[7]=l,r[8]=E,r},u.add=function(e,t,r){return r[0]=e[0]+t[0],r[1]=e[1]+t[1],r[2]=e[2]+t[2],r[3]=e[3]+t[3],r[4]=e[4]+t[4],r[5]=e[5]+t[5],r[6]=e[6]+t[6],r[7]=e[7]+t[7],r[8]=e[8]+t[8],r},u.subtract=function(e,t,r){return r[0]=e[0]-t[0],r[1]=e[1]-t[1],r[2]=e[2]-t[2],r[3]=e[3]-t[3],r[4]=e[4]-t[4],r[5]=e[5]-t[5],r[6]=e[6]-t[6],r[7]=e[7]-t[7],r[8]=e[8]-t[8],r},u.multiplyByVector=function(e,t,r){var n=t.x,o=t.y,a=t.z,i=e[0]*n+e[3]*o+e[6]*a,u=e[1]*n+e[4]*o+e[7]*a,s=e[2]*n+e[5]*o+e[8]*a;return r.x=i,r.y=u,r.z=s,r},u.multiplyByScalar=function(e,t,r){return r[0]=e[0]*t,r[1]=e[1]*t,r[2]=e[2]*t,r[3]=e[3]*t,r[4]=e[4]*t,r[5]=e[5]*t,r[6]=e[6]*t,r[7]=e[7]*t,r[8]=e[8]*t,r},u.multiplyByScale=function(e,t,r){return r[0]=e[0]*t.x,r[1]=e[1]*t.x,r[2]=e[2]*t.x,r[3]=e[3]*t.y,r[4]=e[4]*t.y,r[5]=e[5]*t.y,r[6]=e[6]*t.z,r[7]=e[7]*t.z,r[8]=e[8]*t.z,r},u.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t},u.transpose=function(e,t){var r=e[0],n=e[3],o=e[6],a=e[1],i=e[4],u=e[7],s=e[2],c=e[5],l=e[8];return t[0]=r,t[1]=n,t[2]=o,t[3]=a,t[4]=i,t[5]=u,t[6]=s,t[7]=c,t[8]=l,t};var h=[1,0,0],m=[2,2,1],d=new u,p=new u;return u.computeEigenDecomposition=function(e,t){var n=i.EPSILON20,o=10,a=0,E=0;r(t)||(t={});for(var f=t.unitary=u.clone(u.IDENTITY,t.unitary),h=t.diagonal=u.clone(e,t.diagonal),m=n*s(h);o>E&&c(h)>m;)l(h,d),u.transpose(d,p),u.multiply(h,d,h),u.multiply(p,h,h),u.multiply(f,d,f),++a>2&&(++E,a=0);return t},u.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t},u.determinant=function(e){var t=e[0],r=e[3],n=e[6],o=e[1],a=e[4],i=e[7],u=e[2],s=e[5],c=e[8];return t*(a*c-s*i)+o*(s*n-r*c)+u*(r*i-a*n)},u.inverse=function(e,t){var r=e[0],n=e[1],a=e[2],s=e[3],c=e[4],l=e[5],E=e[6],f=e[7],h=e[8],m=u.determinant(e);if(Math.abs(m)<=i.EPSILON15)throw new o("matrix is not invertible");t[0]=c*h-f*l,t[1]=f*a-n*h,t[2]=n*l-c*a,t[3]=E*l-s*h,t[4]=r*h-E*a,t[5]=s*a-r*l,t[6]=s*f-E*c,t[7]=E*n-r*f,t[8]=r*c-s*n;var d=1/m;return u.multiplyByScalar(t,d,t)},u.equals=function(e,t){return e===t||r(e)&&r(t)&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[7]===t[7]&&e[8]===t[8]},u.equalsEpsilon=function(e,t,n){return e===t||r(e)&&r(t)&&Math.abs(e[0]-t[0])<=n&&Math.abs(e[1]-t[1])<=n&&Math.abs(e[2]-t[2])<=n&&Math.abs(e[3]-t[3])<=n&&Math.abs(e[4]-t[4])<=n&&Math.abs(e[5]-t[5])<=n&&Math.abs(e[6]-t[6])<=n&&Math.abs(e[7]-t[7])<=n&&Math.abs(e[8]-t[8])<=n},u.IDENTITY=a(new u(1,0,0,0,1,0,0,0,1)),u.ZERO=a(new u(0,0,0,0,0,0,0,0,0)),u.COLUMN0ROW0=0,u.COLUMN0ROW1=1,u.COLUMN0ROW2=2,u.COLUMN1ROW0=3,u.COLUMN1ROW1=4,u.COLUMN1ROW2=5,u.COLUMN2ROW0=6,u.COLUMN2ROW1=7,u.COLUMN2ROW2=8,n(u.prototype,{length:{get:function(){return u.packedLength}}}),u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.equalsArray=function(e,t,r){return e[0]===t[r]&&e[1]===t[r+1]&&e[2]===t[r+2]&&e[3]===t[r+3]&&e[4]===t[r+4]&&e[5]===t[r+5]&&e[6]===t[r+6]&&e[7]===t[r+7]&&e[8]===t[r+8]},u.prototype.equalsEpsilon=function(e,t){return u.equalsEpsilon(this,e,t)},u.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n("+this[1]+", "+this[4]+", "+this[7]+")\n("+this[2]+", "+this[5]+", "+this[8]+")"},u}),define("Core/Cartesian4",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,o){"use strict";function a(t,r,n,o){this.x=e(t,0),this.y=e(r,0),this.z=e(n,0),this.w=e(o,0)}a.fromElements=function(e,r,n,o,i){return t(i)?(i.x=e,i.y=r,i.z=n,i.w=o,i):new a(e,r,n,o)},a.fromColor=function(e,r){return t(r)?(r.x=e.red,r.y=e.green,r.z=e.blue,r.w=e.alpha,r):new a(e.red,e.green,e.blue,e.alpha)},a.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r.z=e.z,r.w=e.w,r):new a(e.x,e.y,e.z,e.w):void 0},a.packedLength=4,a.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n++]=t.y,r[n++]=t.z,r[n]=t.w},a.unpack=function(r,n,o){return n=e(n,0),t(o)||(o=new a),o.x=r[n++],o.y=r[n++],o.z=r[n++],o.w=r[n],o},a.packArray=function(e,r){var n=e.length;t(r)?r.length=4*n:r=new Array(4*n);for(var o=0;n>o;++o)a.pack(e[o],r,4*o);return r},a.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/4:r=new Array(n/4);for(var o=0;n>o;o+=4){var i=o/4;r[i]=a.unpack(e,o,r[i])}return r},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y,e.z,e.w)},a.minimumComponent=function(e){return Math.min(e.x,e.y,e.z,e.w)},a.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r.z=Math.min(e.z,t.z),r.w=Math.min(e.w,t.w),r},a.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r.z=Math.max(e.z,t.z),r.w=Math.max(e.w,t.w),r},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y+e.z*e.z+e.w*e.w},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,t){return a.subtract(e,t,i),a.magnitude(i)},a.distanceSquared=function(e,t){return a.subtract(e,t,i),a.magnitudeSquared(i)},a.normalize=function(e,t){var r=a.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t.z=e.z/r,t.w=e.w/r,t},a.dot=function(e,t){return e.x*t.x+e.y*t.y+e.z*t.z+e.w*t.w},a.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r.z=e.z*t.z,r.w=e.w*t.w,r},a.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r.z=e.z+t.z,r.w=e.w+t.w,r},a.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r.z=e.z-t.z,r.w=e.w-t.w,r},a.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r.z=e.z*t,r.w=e.w*t,r},a.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r.z=e.z/t,r.w=e.w/t,r},a.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t.z=-e.z,t.w=-e.w,t},a.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t.z=Math.abs(e.z),t.w=Math.abs(e.w),t};var u=new a;a.lerp=function(e,t,r,n){return a.multiplyByScalar(t,r,u),n=a.multiplyByScalar(e,1-r,n),a.add(u,n,n)};var s=new a;return a.mostOrthogonalAxis=function(e,t){var r=a.normalize(e,s);return a.abs(r,r),t=r.x<=r.y?r.x<=r.z?r.x<=r.w?a.clone(a.UNIT_X,t):a.clone(a.UNIT_W,t):r.z<=r.w?a.clone(a.UNIT_Z,t):a.clone(a.UNIT_W,t):r.y<=r.z?r.y<=r.w?a.clone(a.UNIT_Y,t):a.clone(a.UNIT_W,t):r.z<=r.w?a.clone(a.UNIT_Z,t):a.clone(a.UNIT_W,t)},a.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y&&e.z===r.z&&e.w===r.w},a.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]&&e.z===t[r+2]&&e.w===t[r+3]},a.equalsEpsilon=function(e,r,n,a){return e===r||t(e)&&t(r)&&o.equalsEpsilon(e.x,r.x,n,a)&&o.equalsEpsilon(e.y,r.y,n,a)&&o.equalsEpsilon(e.z,r.z,n,a)&&o.equalsEpsilon(e.w,r.w,n,a)},a.ZERO=n(new a(0,0,0,0)),a.UNIT_X=n(new a(1,0,0,0)),a.UNIT_Y=n(new a(0,1,0,0)),a.UNIT_Z=n(new a(0,0,1,0)),a.UNIT_W=n(new a(0,0,0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,t,r){return a.equalsEpsilon(this,e,t,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"},a}),define("Core/RuntimeError",["./defined"],function(e){"use strict";function t(e){this.name="RuntimeError",this.message=e;var t;try{throw new Error}catch(r){t=r.stack}this.stack=t}return e(Object.create)&&(t.prototype=Object.create(Error.prototype),t.prototype.constructor=t),t.prototype.toString=function(){var t=this.name+": "+this.message;return e(this.stack)&&(t+="\n"+this.stack.toString()),t},t}),define("Core/Matrix4",["./Cartesian3","./Cartesian4","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./Matrix3","./RuntimeError"],function(e,t,r,n,o,a,i,u,s,c){"use strict";function l(e,t,n,o,a,i,u,s,c,l,E,f,h,m,d,p){this[0]=r(e,0),this[1]=r(a,0),this[2]=r(c,0),this[3]=r(h,0),this[4]=r(t,0),this[5]=r(i,0),this[6]=r(l,0),this[7]=r(m,0),this[8]=r(n,0),this[9]=r(u,0),this[10]=r(E,0),this[11]=r(d,0),this[12]=r(o,0),this[13]=r(s,0),this[14]=r(f,0),this[15]=r(p,0)}l.packedLength=16,l.pack=function(e,t,n){n=r(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t[n++]=e[4],t[n++]=e[5],t[n++]=e[6],t[n++]=e[7],t[n++]=e[8],t[n++]=e[9],t[n++]=e[10],t[n++]=e[11],t[n++]=e[12],t[n++]=e[13],t[n++]=e[14],t[n]=e[15]},l.unpack=function(e,t,o){return t=r(t,0),n(o)||(o=new l),o[0]=e[t++],o[1]=e[t++],o[2]=e[t++],o[3]=e[t++],o[4]=e[t++],o[5]=e[t++],o[6]=e[t++],o[7]=e[t++],o[8]=e[t++],o[9]=e[t++],o[10]=e[t++],o[11]=e[t++],o[12]=e[t++],o[13]=e[t++],o[14]=e[t++],o[15]=e[t],o},l.clone=function(e,t){return n(e)?n(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):new l(e[0],e[4],e[8],e[12],e[1],e[5],e[9],e[13],e[2],e[6],e[10],e[14],e[3],e[7],e[11],e[15]):void 0},l.fromArray=l.unpack,l.fromColumnMajorArray=function(e,t){return l.clone(e,t)},l.fromRowMajorArray=function(e,t){return n(t)?(t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15],t):new l(e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15])},l.fromRotationTranslation=function(t,o,a){return o=r(o,e.ZERO),n(a)?(a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=0,a[4]=t[3],a[5]=t[4],a[6]=t[5],a[7]=0,a[8]=t[6],a[9]=t[7],a[10]=t[8],a[11]=0,a[12]=o.x,a[13]=o.y,a[14]=o.z,a[15]=1,a):new l(t[0],t[3],t[6],o.x,t[1],t[4],t[7],o.y,t[2],t[5],t[8],o.z,0,0,0,1)},l.fromTranslationQuaternionRotationScale=function(e,t,r,o){n(o)||(o=new l);var a=r.x,i=r.y,u=r.z,s=t.x*t.x,c=t.x*t.y,E=t.x*t.z,f=t.x*t.w,h=t.y*t.y,m=t.y*t.z,d=t.y*t.w,p=t.z*t.z,A=t.z*t.w,T=t.w*t.w,R=s-h-p+T,y=2*(c-A),_=2*(E+d),v=2*(c+A),S=-s+h-p+T,g=2*(m-f),C=2*(E-d),N=2*(m+f),I=-s-h+p+T;return o[0]=R*a,o[1]=v*a,o[2]=C*a,o[3]=0,o[4]=y*i,o[5]=S*i,o[6]=N*i,o[7]=0,o[8]=_*u,o[9]=g*u,o[10]=I*u,o[11]=0,o[12]=e.x,o[13]=e.y,o[14]=e.z,
o[15]=1,o},l.fromTranslationRotationScale=function(e,t){return l.fromTranslationQuaternionRotationScale(e.translation,e.rotation,e.scale,t)},l.fromTranslation=function(e,t){return l.fromRotationTranslation(s.IDENTITY,e,t)},l.fromScale=function(e,t){return n(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e.y,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e.z,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new l(e.x,0,0,0,0,e.y,0,0,0,0,e.z,0,0,0,0,1)},l.fromUniformScale=function(e,t){return n(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t):new l(e,0,0,0,0,e,0,0,0,0,e,0,0,0,0,1)};var E=new e,f=new e,h=new e;l.fromCamera=function(t,r){var o=t.position,a=t.direction,i=t.up;e.normalize(a,E),e.normalize(e.cross(E,i,f),f),e.normalize(e.cross(f,E,h),h);var u=f.x,s=f.y,c=f.z,m=E.x,d=E.y,p=E.z,A=h.x,T=h.y,R=h.z,y=o.x,_=o.y,v=o.z,S=u*-y+s*-_+c*-v,g=A*-y+T*-_+R*-v,C=m*y+d*_+p*v;return n(r)?(r[0]=u,r[1]=A,r[2]=-m,r[3]=0,r[4]=s,r[5]=T,r[6]=-d,r[7]=0,r[8]=c,r[9]=R,r[10]=-p,r[11]=0,r[12]=S,r[13]=g,r[14]=C,r[15]=1,r):new l(u,s,c,S,A,T,R,g,-m,-d,-p,C,0,0,0,1)},l.computePerspectiveFieldOfView=function(e,t,r,n,o){var a=Math.tan(.5*e),i=1/a,u=i/t,s=(n+r)/(r-n),c=2*n*r/(r-n);return o[0]=u,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=i,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=s,o[11]=-1,o[12]=0,o[13]=0,o[14]=c,o[15]=0,o},l.computeOrthographicOffCenter=function(e,t,r,n,o,a,i){var u=1/(t-e),s=1/(n-r),c=1/(a-o),l=-(t+e)*u,E=-(n+r)*s,f=-(a+o)*c;return u*=2,s*=2,c*=-2,i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=0,i[9]=0,i[10]=c,i[11]=0,i[12]=l,i[13]=E,i[14]=f,i[15]=1,i},l.computePerspectiveOffCenter=function(e,t,r,n,o,a,i){var u=2*o/(t-e),s=2*o/(n-r),c=(t+e)/(t-e),l=(n+r)/(n-r),E=-(a+o)/(a-o),f=-1,h=-2*a*o/(a-o);return i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=c,i[9]=l,i[10]=E,i[11]=f,i[12]=0,i[13]=0,i[14]=h,i[15]=0,i},l.computeInfinitePerspectiveOffCenter=function(e,t,r,n,o,a){var i=2*o/(t-e),u=2*o/(n-r),s=(t+e)/(t-e),c=(n+r)/(n-r),l=-1,E=-1,f=-2*o;return a[0]=i,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=u,a[6]=0,a[7]=0,a[8]=s,a[9]=c,a[10]=l,a[11]=E,a[12]=0,a[13]=0,a[14]=f,a[15]=0,a},l.computeViewportTransformation=function(e,t,n,o){e=r(e,r.EMPTY_OBJECT);var a=r(e.x,0),i=r(e.y,0),u=r(e.width,0),s=r(e.height,0);t=r(t,0),n=r(n,1);var c=.5*u,l=.5*s,E=.5*(n-t),f=c,h=l,m=E,d=a+c,p=i+l,A=t+E,T=1;return o[0]=f,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=h,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=m,o[11]=0,o[12]=d,o[13]=p,o[14]=A,o[15]=T,o},l.computeView=function(t,r,n,o,a){return a[0]=o.x,a[1]=n.x,a[2]=-r.x,a[3]=0,a[4]=o.y,a[5]=n.y,a[6]=-r.y,a[7]=0,a[8]=o.z,a[9]=n.z,a[10]=-r.z,a[11]=0,a[12]=-e.dot(o,t),a[13]=-e.dot(n,t),a[14]=e.dot(r,t),a[15]=1,a},l.toArray=function(e,t){return n(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t):[e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14],e[15]]},l.getElementIndex=function(e,t){return 4*e+t},l.getColumn=function(e,t,r){var n=4*t,o=e[n],a=e[n+1],i=e[n+2],u=e[n+3];return r.x=o,r.y=a,r.z=i,r.w=u,r},l.setColumn=function(e,t,r,n){n=l.clone(e,n);var o=4*t;return n[o]=r.x,n[o+1]=r.y,n[o+2]=r.z,n[o+3]=r.w,n},l.setTranslation=function(e,t,r){return r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=t.x,r[13]=t.y,r[14]=t.z,r[15]=e[15],r},l.getRow=function(e,t,r){var n=e[t],o=e[t+4],a=e[t+8],i=e[t+12];return r.x=n,r.y=o,r.z=a,r.w=i,r},l.setRow=function(e,t,r,n){return n=l.clone(e,n),n[t]=r.x,n[t+4]=r.y,n[t+8]=r.z,n[t+12]=r.w,n};var m=new e;l.getScale=function(t,r){return r.x=e.magnitude(e.fromElements(t[0],t[1],t[2],m)),r.y=e.magnitude(e.fromElements(t[4],t[5],t[6],m)),r.z=e.magnitude(e.fromElements(t[8],t[9],t[10],m)),r};var d=new e;l.getMaximumScale=function(t){return l.getScale(t,d),e.maximumComponent(d)},l.multiply=function(e,t,r){var n=e[0],o=e[1],a=e[2],i=e[3],u=e[4],s=e[5],c=e[6],l=e[7],E=e[8],f=e[9],h=e[10],m=e[11],d=e[12],p=e[13],A=e[14],T=e[15],R=t[0],y=t[1],_=t[2],v=t[3],S=t[4],g=t[5],C=t[6],N=t[7],I=t[8],M=t[9],O=t[10],L=t[11],F=t[12],P=t[13],w=t[14],b=t[15],D=n*R+u*y+E*_+d*v,x=o*R+s*y+f*_+p*v,U=a*R+c*y+h*_+A*v,B=i*R+l*y+m*_+T*v,G=n*S+u*g+E*C+d*N,z=o*S+s*g+f*C+p*N,V=a*S+c*g+h*C+A*N,H=i*S+l*g+m*C+T*N,W=n*I+u*M+E*O+d*L,q=o*I+s*M+f*O+p*L,X=a*I+c*M+h*O+A*L,Y=i*I+l*M+m*O+T*L,k=n*F+u*P+E*w+d*b,K=o*F+s*P+f*w+p*b,j=a*F+c*P+h*w+A*b,Z=i*F+l*P+m*w+T*b;return r[0]=D,r[1]=x,r[2]=U,r[3]=B,r[4]=G,r[5]=z,r[6]=V,r[7]=H,r[8]=W,r[9]=q,r[10]=X,r[11]=Y,r[12]=k,r[13]=K,r[14]=j,r[15]=Z,r},l.add=function(e,t,r){return r[0]=e[0]+t[0],r[1]=e[1]+t[1],r[2]=e[2]+t[2],r[3]=e[3]+t[3],r[4]=e[4]+t[4],r[5]=e[5]+t[5],r[6]=e[6]+t[6],r[7]=e[7]+t[7],r[8]=e[8]+t[8],r[9]=e[9]+t[9],r[10]=e[10]+t[10],r[11]=e[11]+t[11],r[12]=e[12]+t[12],r[13]=e[13]+t[13],r[14]=e[14]+t[14],r[15]=e[15]+t[15],r},l.subtract=function(e,t,r){return r[0]=e[0]-t[0],r[1]=e[1]-t[1],r[2]=e[2]-t[2],r[3]=e[3]-t[3],r[4]=e[4]-t[4],r[5]=e[5]-t[5],r[6]=e[6]-t[6],r[7]=e[7]-t[7],r[8]=e[8]-t[8],r[9]=e[9]-t[9],r[10]=e[10]-t[10],r[11]=e[11]-t[11],r[12]=e[12]-t[12],r[13]=e[13]-t[13],r[14]=e[14]-t[14],r[15]=e[15]-t[15],r},l.multiplyTransformation=function(e,t,r){var n=e[0],o=e[1],a=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=e[12],h=e[13],m=e[14],d=t[0],p=t[1],A=t[2],T=t[4],R=t[5],y=t[6],_=t[8],v=t[9],S=t[10],g=t[12],C=t[13],N=t[14],I=n*d+i*p+c*A,M=o*d+u*p+l*A,O=a*d+s*p+E*A,L=n*T+i*R+c*y,F=o*T+u*R+l*y,P=a*T+s*R+E*y,w=n*_+i*v+c*S,b=o*_+u*v+l*S,D=a*_+s*v+E*S,x=n*g+i*C+c*N+f,U=o*g+u*C+l*N+h,B=a*g+s*C+E*N+m;return r[0]=I,r[1]=M,r[2]=O,r[3]=0,r[4]=L,r[5]=F,r[6]=P,r[7]=0,r[8]=w,r[9]=b,r[10]=D,r[11]=0,r[12]=x,r[13]=U,r[14]=B,r[15]=1,r},l.multiplyByMatrix3=function(e,t,r){var n=e[0],o=e[1],a=e[2],i=e[4],u=e[5],s=e[6],c=e[8],l=e[9],E=e[10],f=t[0],h=t[1],m=t[2],d=t[3],p=t[4],A=t[5],T=t[6],R=t[7],y=t[8],_=n*f+i*h+c*m,v=o*f+u*h+l*m,S=a*f+s*h+E*m,g=n*d+i*p+c*A,C=o*d+u*p+l*A,N=a*d+s*p+E*A,I=n*T+i*R+c*y,M=o*T+u*R+l*y,O=a*T+s*R+E*y;return r[0]=_,r[1]=v,r[2]=S,r[3]=0,r[4]=g,r[5]=C,r[6]=N,r[7]=0,r[8]=I,r[9]=M,r[10]=O,r[11]=0,r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=e[15],r},l.multiplyByTranslation=function(e,t,r){var n=t.x,o=t.y,a=t.z,i=n*e[0]+o*e[4]+a*e[8]+e[12],u=n*e[1]+o*e[5]+a*e[9]+e[13],s=n*e[2]+o*e[6]+a*e[10]+e[14];return r[0]=e[0],r[1]=e[1],r[2]=e[2],r[3]=e[3],r[4]=e[4],r[5]=e[5],r[6]=e[6],r[7]=e[7],r[8]=e[8],r[9]=e[9],r[10]=e[10],r[11]=e[11],r[12]=i,r[13]=u,r[14]=s,r[15]=e[15],r};var p=new e;l.multiplyByUniformScale=function(e,t,r){return p.x=t,p.y=t,p.z=t,l.multiplyByScale(e,p,r)},l.multiplyByScale=function(e,t,r){var n=t.x,o=t.y,a=t.z;return 1===n&&1===o&&1===a?l.clone(e,r):(r[0]=n*e[0],r[1]=n*e[1],r[2]=n*e[2],r[3]=0,r[4]=o*e[4],r[5]=o*e[5],r[6]=o*e[6],r[7]=0,r[8]=a*e[8],r[9]=a*e[9],r[10]=a*e[10],r[11]=0,r[12]=e[12],r[13]=e[13],r[14]=e[14],r[15]=1,r)},l.multiplyByVector=function(e,t,r){var n=t.x,o=t.y,a=t.z,i=t.w,u=e[0]*n+e[4]*o+e[8]*a+e[12]*i,s=e[1]*n+e[5]*o+e[9]*a+e[13]*i,c=e[2]*n+e[6]*o+e[10]*a+e[14]*i,l=e[3]*n+e[7]*o+e[11]*a+e[15]*i;return r.x=u,r.y=s,r.z=c,r.w=l,r},l.multiplyByPointAsVector=function(e,t,r){var n=t.x,o=t.y,a=t.z,i=e[0]*n+e[4]*o+e[8]*a,u=e[1]*n+e[5]*o+e[9]*a,s=e[2]*n+e[6]*o+e[10]*a;return r.x=i,r.y=u,r.z=s,r},l.multiplyByPoint=function(e,t,r){var n=t.x,o=t.y,a=t.z,i=e[0]*n+e[4]*o+e[8]*a+e[12],u=e[1]*n+e[5]*o+e[9]*a+e[13],s=e[2]*n+e[6]*o+e[10]*a+e[14];return r.x=i,r.y=u,r.z=s,r},l.multiplyByScalar=function(e,t,r){return r[0]=e[0]*t,r[1]=e[1]*t,r[2]=e[2]*t,r[3]=e[3]*t,r[4]=e[4]*t,r[5]=e[5]*t,r[6]=e[6]*t,r[7]=e[7]*t,r[8]=e[8]*t,r[9]=e[9]*t,r[10]=e[10]*t,r[11]=e[11]*t,r[12]=e[12]*t,r[13]=e[13]*t,r[14]=e[14]*t,r[15]=e[15]*t,r},l.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t[4]=-e[4],t[5]=-e[5],t[6]=-e[6],t[7]=-e[7],t[8]=-e[8],t[9]=-e[9],t[10]=-e[10],t[11]=-e[11],t[12]=-e[12],t[13]=-e[13],t[14]=-e[14],t[15]=-e[15],t},l.transpose=function(e,t){var r=e[1],n=e[2],o=e[3],a=e[6],i=e[7],u=e[11];return t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=a,t[10]=e[10],t[11]=e[14],t[12]=o,t[13]=i,t[14]=u,t[15]=e[15],t},l.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t[4]=Math.abs(e[4]),t[5]=Math.abs(e[5]),t[6]=Math.abs(e[6]),t[7]=Math.abs(e[7]),t[8]=Math.abs(e[8]),t[9]=Math.abs(e[9]),t[10]=Math.abs(e[10]),t[11]=Math.abs(e[11]),t[12]=Math.abs(e[12]),t[13]=Math.abs(e[13]),t[14]=Math.abs(e[14]),t[15]=Math.abs(e[15]),t},l.equals=function(e,t){return e===t||n(e)&&n(t)&&e[12]===t[12]&&e[13]===t[13]&&e[14]===t[14]&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[4]===t[4]&&e[5]===t[5]&&e[6]===t[6]&&e[8]===t[8]&&e[9]===t[9]&&e[10]===t[10]&&e[3]===t[3]&&e[7]===t[7]&&e[11]===t[11]&&e[15]===t[15]},l.equalsEpsilon=function(e,t,r){return e===t||n(e)&&n(t)&&Math.abs(e[0]-t[0])<=r&&Math.abs(e[1]-t[1])<=r&&Math.abs(e[2]-t[2])<=r&&Math.abs(e[3]-t[3])<=r&&Math.abs(e[4]-t[4])<=r&&Math.abs(e[5]-t[5])<=r&&Math.abs(e[6]-t[6])<=r&&Math.abs(e[7]-t[7])<=r&&Math.abs(e[8]-t[8])<=r&&Math.abs(e[9]-t[9])<=r&&Math.abs(e[10]-t[10])<=r&&Math.abs(e[11]-t[11])<=r&&Math.abs(e[12]-t[12])<=r&&Math.abs(e[13]-t[13])<=r&&Math.abs(e[14]-t[14])<=r&&Math.abs(e[15]-t[15])<=r},l.getTranslation=function(e,t){return t.x=e[12],t.y=e[13],t.z=e[14],t},l.getRotation=function(e,t){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t};var A=new s,T=new s,R=new t,y=new t(0,0,0,1);return l.inverse=function(e,r){if(s.equalsEpsilon(l.getRotation(e,A),T,u.EPSILON7)&&t.equals(l.getRow(e,3,R),y))return r[0]=0,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=0,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=0,r[11]=0,r[12]=-e[12],r[13]=-e[13],r[14]=-e[14],r[15]=1,r;var n=e[0],o=e[4],a=e[8],i=e[12],E=e[1],f=e[5],h=e[9],m=e[13],d=e[2],p=e[6],_=e[10],v=e[14],S=e[3],g=e[7],C=e[11],N=e[15],I=_*N,M=v*C,O=p*N,L=v*g,F=p*C,P=_*g,w=d*N,b=v*S,D=d*C,x=_*S,U=d*g,B=p*S,G=I*f+L*h+F*m-(M*f+O*h+P*m),z=M*E+w*h+x*m-(I*E+b*h+D*m),V=O*E+b*f+U*m-(L*E+w*f+B*m),H=P*E+D*f+B*h-(F*E+x*f+U*h),W=M*o+O*a+P*i-(I*o+L*a+F*i),q=I*n+b*a+D*i-(M*n+w*a+x*i),X=L*n+w*o+B*i-(O*n+b*o+U*i),Y=F*n+x*o+U*a-(P*n+D*o+B*a);I=a*m,M=i*h,O=o*m,L=i*f,F=o*h,P=a*f,w=n*m,b=i*E,D=n*h,x=a*E,U=n*f,B=o*E;var k=I*g+L*C+F*N-(M*g+O*C+P*N),K=M*S+w*C+x*N-(I*S+b*C+D*N),j=O*S+b*g+U*N-(L*S+w*g+B*N),Z=P*S+D*g+B*C-(F*S+x*g+U*C),Q=O*_+P*v+M*p-(F*v+I*p+L*_),J=D*v+I*d+b*_-(w*_+x*v+M*d),$=w*p+B*v+L*d-(U*v+O*d+b*p),ee=U*_+F*d+x*p-(D*p+B*_+P*d),te=n*G+o*z+a*V+i*H;if(Math.abs(te)<u.EPSILON20)throw new c("matrix is not invertible because its determinate is zero.");return te=1/te,r[0]=G*te,r[1]=z*te,r[2]=V*te,r[3]=H*te,r[4]=W*te,r[5]=q*te,r[6]=X*te,r[7]=Y*te,r[8]=k*te,r[9]=K*te,r[10]=j*te,r[11]=Z*te,r[12]=Q*te,r[13]=J*te,r[14]=$*te,r[15]=ee*te,r},l.inverseTransformation=function(e,t){var r=e[0],n=e[1],o=e[2],a=e[4],i=e[5],u=e[6],s=e[8],c=e[9],l=e[10],E=e[12],f=e[13],h=e[14],m=-r*E-n*f-o*h,d=-a*E-i*f-u*h,p=-s*E-c*f-l*h;return t[0]=r,t[1]=a,t[2]=s,t[3]=0,t[4]=n,t[5]=i,t[6]=c,t[7]=0,t[8]=o,t[9]=u,t[10]=l,t[11]=0,t[12]=m,t[13]=d,t[14]=p,t[15]=1,t},l.IDENTITY=i(new l(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),l.ZERO=i(new l(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN0ROW3=3,l.COLUMN1ROW0=4,l.COLUMN1ROW1=5,l.COLUMN1ROW2=6,l.COLUMN1ROW3=7,l.COLUMN2ROW0=8,l.COLUMN2ROW1=9,l.COLUMN2ROW2=10,l.COLUMN2ROW3=11,l.COLUMN3ROW0=12,l.COLUMN3ROW1=13,l.COLUMN3ROW2=14,l.COLUMN3ROW3=15,o(l.prototype,{length:{get:function(){return l.packedLength}}}),l.prototype.clone=function(e){return l.clone(this,e)},l.prototype.equals=function(e){return l.equals(this,e)},l.equalsArray=function(e,t,r){return e[0]===t[r]&&e[1]===t[r+1]&&e[2]===t[r+2]&&e[3]===t[r+3]&&e[4]===t[r+4]&&e[5]===t[r+5]&&e[6]===t[r+6]&&e[7]===t[r+7]&&e[8]===t[r+8]&&e[9]===t[r+9]&&e[10]===t[r+10]&&e[11]===t[r+11]&&e[12]===t[r+12]&&e[13]===t[r+13]&&e[14]===t[r+14]&&e[15]===t[r+15]},l.prototype.equalsEpsilon=function(e,t){return l.equalsEpsilon(this,e,t)},l.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"},l}),define("Core/Plane",["./Cartesian3","./defined","./DeveloperError","./freezeObject"],function(e,t,r,n){"use strict";function o(t,r){this.normal=e.clone(t),this.distance=r}o.fromPointNormal=function(r,n,a){var i=-e.dot(n,r);return t(a)?(e.clone(n,a.normal),a.distance=i,a):new o(n,i)};var a=new e;return o.fromCartesian4=function(r,n){var i=e.fromCartesian4(r,a),u=r.w;return t(n)?(e.clone(i,n.normal),n.distance=u,n):new o(i,u)},o.getPointDistance=function(t,r){return e.dot(t.normal,r)+t.distance},o.ORIGIN_XY_PLANE=n(new o(e.UNIT_Z,0)),o.ORIGIN_YZ_PLANE=n(new o(e.UNIT_X,0)),o.ORIGIN_ZX_PLANE=n(new o(e.UNIT_Y,0)),o}),define("Core/Rectangle",["./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./freezeObject","./Math"],function(e,t,r,n,o,a,i,u){"use strict";function s(e,r,n,o){this.west=t(e,0),this.south=t(r,0),this.east=t(n,0),this.north=t(o,0)}n(s.prototype,{width:{get:function(){return s.computeWidth(this)}},height:{get:function(){return s.computeHeight(this)}}}),s.packedLength=4,s.pack=function(e,r,n){n=t(n,0),r[n++]=e.west,r[n++]=e.south,r[n++]=e.east,r[n]=e.north},s.unpack=function(e,n,o){return n=t(n,0),r(o)||(o=new s),o.west=e[n++],o.south=e[n++],o.east=e[n++],o.north=e[n],o},s.computeWidth=function(e){var t=e.east,r=e.west;return r>t&&(t+=u.TWO_PI),t-r},s.computeHeight=function(e){return e.north-e.south},s.fromDegrees=function(e,n,o,a,i){return e=u.toRadians(t(e,0)),n=u.toRadians(t(n,0)),o=u.toRadians(t(o,0)),a=u.toRadians(t(a,0)),r(i)?(i.west=e,i.south=n,i.east=o,i.north=a,i):new s(e,n,o,a)},s.fromCartographicArray=function(e,t){for(var n=Number.MAX_VALUE,o=-Number.MAX_VALUE,a=Number.MAX_VALUE,i=-Number.MAX_VALUE,c=Number.MAX_VALUE,l=-Number.MAX_VALUE,E=0,f=e.length;f>E;E++){var h=e[E];n=Math.min(n,h.longitude),o=Math.max(o,h.longitude),c=Math.min(c,h.latitude),l=Math.max(l,h.latitude);var m=h.longitude>=0?h.longitude:h.longitude+u.TWO_PI;a=Math.min(a,m),i=Math.max(i,m)}return o-n>i-a&&(n=a,o=i,o>u.PI&&(o-=u.TWO_PI),n>u.PI&&(n-=u.TWO_PI)),r(t)?(t.west=n,t.south=c,t.east=o,t.north=l,t):new s(n,c,o,l)},s.fromCartesianArray=function(e,t,n){for(var o=Number.MAX_VALUE,a=-Number.MAX_VALUE,i=Number.MAX_VALUE,c=-Number.MAX_VALUE,l=Number.MAX_VALUE,E=-Number.MAX_VALUE,f=0,h=e.length;h>f;f++){var m=t.cartesianToCartographic(e[f]);o=Math.min(o,m.longitude),a=Math.max(a,m.longitude),l=Math.min(l,m.latitude),E=Math.max(E,m.latitude);var d=m.longitude>=0?m.longitude:m.longitude+u.TWO_PI;i=Math.min(i,d),c=Math.max(c,d)}return a-o>c-i&&(o=i,a=c,a>u.PI&&(a-=u.TWO_PI),o>u.PI&&(o-=u.TWO_PI)),r(n)?(n.west=o,n.south=l,n.east=a,n.north=E,n):new s(o,l,a,E)},s.clone=function(e,t){return r(e)?r(t)?(t.west=e.west,t.south=e.south,t.east=e.east,t.north=e.north,t):new s(e.west,e.south,e.east,e.north):void 0},s.prototype.clone=function(e){return s.clone(this,e)},s.prototype.equals=function(e){return s.equals(this,e)},s.equals=function(e,t){return e===t||r(e)&&r(t)&&e.west===t.west&&e.south===t.south&&e.east===t.east&&e.north===t.north},s.prototype.equalsEpsilon=function(e,t){return r(e)&&Math.abs(this.west-e.west)<=t&&Math.abs(this.south-e.south)<=t&&Math.abs(this.east-e.east)<=t&&Math.abs(this.north-e.north)<=t},s.validate=function(e){},s.southwest=function(t,n){return r(n)?(n.longitude=t.west,n.latitude=t.south,n.height=0,n):new e(t.west,t.south)},s.northwest=function(t,n){return r(n)?(n.longitude=t.west,n.latitude=t.north,n.height=0,n):new e(t.west,t.north)},s.northeast=function(t,n){return r(n)?(n.longitude=t.east,n.latitude=t.north,n.height=0,n):new e(t.east,t.north)},s.southeast=function(t,n){return r(n)?(n.longitude=t.east,n.latitude=t.south,n.height=0,n):new e(t.east,t.south)},s.center=function(t,n){var o=t.east,a=t.west;a>o&&(o+=u.TWO_PI);var i=u.negativePiToPi(.5*(a+o)),s=.5*(t.south+t.north);return r(n)?(n.longitude=i,n.latitude=s,n.height=0,n):new e(i,s)},s.intersection=function(e,t,n){var o=e.east,a=e.west,i=t.east,c=t.west;a>o&&i>0?o+=u.TWO_PI:c>i&&o>0&&(i+=u.TWO_PI),a>o&&0>c?c+=u.TWO_PI:c>i&&0>a&&(a+=u.TWO_PI);var l=u.negativePiToPi(Math.max(a,c)),E=u.negativePiToPi(Math.min(o,i));if(!((e.west<e.east||t.west<t.east)&&l>=E)){var f=Math.max(e.south,t.south),h=Math.min(e.north,t.north);if(!(f>=h))return r(n)?(n.west=l,n.south=f,n.east=E,n.north=h,n):new s(l,f,E,h)}},s.union=function(e,t,n){return r(n)||(n=new s),n.west=Math.min(e.west,t.west),n.south=Math.min(e.south,t.south),n.east=Math.max(e.east,t.east),n.north=Math.max(e.north,t.north),n},s.expand=function(e,t,n){return r(n)||(n=new s),n.west=Math.min(e.west,t.longitude),n.south=Math.min(e.south,t.latitude),n.east=Math.max(e.east,t.longitude),n.north=Math.max(e.north,t.latitude),n},s.contains=function(e,t){var r=t.longitude,n=t.latitude,o=e.west,a=e.east;return o>a&&(a+=u.TWO_PI,0>r&&(r+=u.TWO_PI)),(r>o||u.equalsEpsilon(r,o,u.EPSILON14))&&(a>r||u.equalsEpsilon(r,a,u.EPSILON14))&&n>=e.south&&n<=e.north};var c=new e;return s.subsample=function(e,n,o,i){n=t(n,a.WGS84),o=t(o,0),r(i)||(i=[]);var l=0,E=e.north,f=e.south,h=e.east,m=e.west,d=c;d.height=o,d.longitude=m,d.latitude=E,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.latitude=f,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++,0>E?d.latitude=E:f>0?d.latitude=f:d.latitude=0;for(var p=1;8>p;++p)d.longitude=-Math.PI+p*u.PI_OVER_TWO,s.contains(e,d)&&(i[l]=n.cartographicToCartesian(d,i[l]),l++);return 0===d.latitude&&(d.longitude=m,i[l]=n.cartographicToCartesian(d,i[l]),l++,d.longitude=h,i[l]=n.cartographicToCartesian(d,i[l]),l++),i.length=l,i},s.MAX_VALUE=i(new s(-Math.PI,-u.PI_OVER_TWO,Math.PI,u.PI_OVER_TWO)),s}),define("Core/BoundingSphere",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./GeographicProjection","./Intersect","./Interval","./Matrix3","./Matrix4","./Plane","./Rectangle"],function(e,t,r,n,o,a,i,u,s,c,l,E,f){"use strict";function h(t,n){this.center=e.clone(r(t,e.ZERO)),this.radius=r(n,0)}var m=new e,d=new e,p=new e,A=new e,T=new e,R=new e,y=new e,_=new e,v=new e,S=new e,g=new e,C=new e;h.fromPoints=function(t,r){if(n(r)||(r=new h),!n(t)||0===t.length)return r.center=e.clone(e.ZERO,r.center),r.radius=0,r;for(var o=e.clone(t[0],y),a=e.clone(o,m),i=e.clone(o,d),u=e.clone(o,p),s=e.clone(o,A),c=e.clone(o,T),l=e.clone(o,R),E=t.length,f=1;E>f;f++){e.clone(t[f],o);var N=o.x,I=o.y,M=o.z;N<a.x&&e.clone(o,a),N>s.x&&e.clone(o,s),I<i.y&&e.clone(o,i),I>c.y&&e.clone(o,c),M<u.z&&e.clone(o,u),M>l.z&&e.clone(o,l)}var O=e.magnitudeSquared(e.subtract(s,a,_)),L=e.magnitudeSquared(e.subtract(c,i,_)),F=e.magnitudeSquared(e.subtract(l,u,_)),P=a,w=s,b=O;L>b&&(b=L,P=i,w=c),F>b&&(b=F,P=u,w=l);var D=v;D.x=.5*(P.x+w.x),D.y=.5*(P.y+w.y),D.z=.5*(P.z+w.z);var x=e.magnitudeSquared(e.subtract(w,D,_)),U=Math.sqrt(x),B=S;B.x=a.x,B.y=i.y,B.z=u.z;var G=g;G.x=s.x,G.y=c.y,G.z=l.z;var z=e.multiplyByScalar(e.add(B,G,_),.5,C),V=0;for(f=0;E>f;f++){e.clone(t[f],o);var H=e.magnitude(e.subtract(o,z,_));H>V&&(V=H);var W=e.magnitudeSquared(e.subtract(o,D,_));if(W>x){var q=Math.sqrt(W);U=.5*(U+q),x=U*U;var X=q-U;D.x=(U*D.x+X*o.x)/q,D.y=(U*D.y+X*o.y)/q,D.z=(U*D.z+X*o.z)/q}}return V>U?(e.clone(D,r.center),r.radius=U):(e.clone(z,r.center),r.radius=V),r};var N=new i,I=new e,M=new e,O=new t,L=new t;h.fromRectangle2D=function(e,t,r){return h.fromRectangleWithHeights2D(e,t,0,0,r)},h.fromRectangleWithHeights2D=function(t,o,a,i,u){if(n(u)||(u=new h),!n(t))return u.center=e.clone(e.ZERO,u.center),u.radius=0,u;o=r(o,N),f.southwest(t,O),O.height=a,f.northeast(t,L),L.height=i;var s=o.project(O,I),c=o.project(L,M),l=c.x-s.x,E=c.y-s.y,m=c.z-s.z;u.radius=.5*Math.sqrt(l*l+E*E+m*m);var d=u.center;return d.x=s.x+.5*l,d.y=s.y+.5*E,d.z=s.z+.5*m,u};var F=[];h.fromRectangle3D=function(e,t,o,i){t=r(t,a.WGS84),o=r(o,0);var u;return n(e)&&(u=f.subsample(e,t,o,F)),h.fromPoints(u,i)},h.fromVertices=function(t,o,a,i){if(n(i)||(i=new h),!n(t)||0===t.length)return i.center=e.clone(e.ZERO,i.center),i.radius=0,i;o=r(o,e.ZERO),a=r(a,3);var u=y;u.x=t[0]+o.x,u.y=t[1]+o.y,u.z=t[2]+o.z;for(var s=e.clone(u,m),c=e.clone(u,d),l=e.clone(u,p),E=e.clone(u,A),f=e.clone(u,T),N=e.clone(u,R),I=t.length,M=0;I>M;M+=a){var O=t[M]+o.x,L=t[M+1]+o.y,F=t[M+2]+o.z;u.x=O,u.y=L,u.z=F,O<s.x&&e.clone(u,s),O>E.x&&e.clone(u,E),L<c.y&&e.clone(u,c),L>f.y&&e.clone(u,f),F<l.z&&e.clone(u,l),F>N.z&&e.clone(u,N)}var P=e.magnitudeSquared(e.subtract(E,s,_)),w=e.magnitudeSquared(e.subtract(f,c,_)),b=e.magnitudeSquared(e.subtract(N,l,_)),D=s,x=E,U=P;w>U&&(U=w,D=c,x=f),b>U&&(U=b,D=l,x=N);var B=v;B.x=.5*(D.x+x.x),B.y=.5*(D.y+x.y),B.z=.5*(D.z+x.z);var G=e.magnitudeSquared(e.subtract(x,B,_)),z=Math.sqrt(G),V=S;V.x=s.x,V.y=c.y,V.z=l.z;var H=g;H.x=E.x,H.y=f.y,H.z=N.z;var W=e.multiplyByScalar(e.add(V,H,_),.5,C),q=0;for(M=0;I>M;M+=a){u.x=t[M]+o.x,u.y=t[M+1]+o.y,u.z=t[M+2]+o.z;var X=e.magnitude(e.subtract(u,W,_));X>q&&(q=X);var Y=e.magnitudeSquared(e.subtract(u,B,_));if(Y>G){var k=Math.sqrt(Y);z=.5*(z+k),G=z*z;var K=k-z;B.x=(z*B.x+K*u.x)/k,B.y=(z*B.y+K*u.y)/k,B.z=(z*B.z+K*u.z)/k}}return q>z?(e.clone(B,i.center),i.radius=z):(e.clone(W,i.center),i.radius=q),i},h.fromEncodedCartesianVertices=function(t,r,o){if(n(o)||(o=new h),!n(t)||!n(r)||t.length!==r.length||0===t.length)return o.center=e.clone(e.ZERO,o.center),o.radius=0,o;var a=y;a.x=t[0]+r[0],a.y=t[1]+r[1],a.z=t[2]+r[2];for(var i=e.clone(a,m),u=e.clone(a,d),s=e.clone(a,p),c=e.clone(a,A),l=e.clone(a,T),E=e.clone(a,R),f=t.length,N=0;f>N;N+=3){var I=t[N]+r[N],M=t[N+1]+r[N+1],O=t[N+2]+r[N+2];a.x=I,a.y=M,a.z=O,I<i.x&&e.clone(a,i),I>c.x&&e.clone(a,c),M<u.y&&e.clone(a,u),M>l.y&&e.clone(a,l),O<s.z&&e.clone(a,s),O>E.z&&e.clone(a,E)}var L=e.magnitudeSquared(e.subtract(c,i,_)),F=e.magnitudeSquared(e.subtract(l,u,_)),P=e.magnitudeSquared(e.subtract(E,s,_)),w=i,b=c,D=L;F>D&&(D=F,w=u,b=l),P>D&&(D=P,w=s,b=E);var x=v;x.x=.5*(w.x+b.x),x.y=.5*(w.y+b.y),x.z=.5*(w.z+b.z);var U=e.magnitudeSquared(e.subtract(b,x,_)),B=Math.sqrt(U),G=S;G.x=i.x,G.y=u.y,G.z=s.z;var z=g;z.x=c.x,z.y=l.y,z.z=E.z;var V=e.multiplyByScalar(e.add(G,z,_),.5,C),H=0;for(N=0;f>N;N+=3){a.x=t[N]+r[N],a.y=t[N+1]+r[N+1],a.z=t[N+2]+r[N+2];var W=e.magnitude(e.subtract(a,V,_));W>H&&(H=W);var q=e.magnitudeSquared(e.subtract(a,x,_));if(q>U){var X=Math.sqrt(q);B=.5*(B+X),U=B*B;var Y=X-B;x.x=(B*x.x+Y*a.x)/X,x.y=(B*x.y+Y*a.y)/X,x.z=(B*x.z+Y*a.z)/X}}return H>B?(e.clone(x,o.center),o.radius=B):(e.clone(V,o.center),o.radius=H),o},h.fromCornerPoints=function(t,r,o){n(o)||(o=new h);var a=o.center;return e.add(t,r,a),e.multiplyByScalar(a,.5,a),o.radius=e.distance(a,r),o},h.fromEllipsoid=function(t,r){return n(r)||(r=new h),e.clone(e.ZERO,r.center),r.radius=t.maximumRadius,r};var P=new e;h.fromBoundingSpheres=function(t,r){if(n(r)||(r=new h),!n(t)||0===t.length)return r.center=e.clone(e.ZERO,r.center),r.radius=0,r;var o=t.length;if(1===o)return h.clone(t[0],r);if(2===o)return h.union(t[0],t[1],r);for(var a=[],i=0;o>i;i++)a.push(t[i].center);r=h.fromPoints(a,r);var u=r.center,s=r.radius;for(i=0;o>i;i++){var c=t[i];s=Math.max(s,e.distance(u,c.center,P)+c.radius)}return r.radius=s,r};var w=new e,b=new e,D=new e;h.fromOrientedBoundingBox=function(t,r){n(r)||(r=new h);var o=t.halfAxes,a=c.getColumn(o,0,w),i=c.getColumn(o,1,b),u=c.getColumn(o,2,D),s=e.magnitude(a),l=e.magnitude(i),E=e.magnitude(u);return r.center=e.clone(t.center,r.center),r.radius=Math.max(s,l,E),r},h.clone=function(t,r){return n(t)?n(r)?(r.center=e.clone(t.center,r.center),r.radius=t.radius,r):new h(t.center,t.radius):void 0},h.packedLength=4,h.pack=function(e,t,n){n=r(n,0);var o=e.center;t[n++]=o.x,t[n++]=o.y,t[n++]=o.z,t[n]=e.radius},h.unpack=function(e,t,o){t=r(t,0),n(o)||(o=new h);var a=o.center;return a.x=e[t++],a.y=e[t++],a.z=e[t++],o.radius=e[t],o};var x=new e,U=new e;h.union=function(t,r,o){n(o)||(o=new h);var a=t.center,i=t.radius,u=r.center,s=r.radius,c=e.subtract(u,a,x),l=e.magnitude(c);if(i>=l+s)return t.clone(o),o;if(s>=l+i)return r.clone(o),o;var E=.5*(i+l+s),f=e.multiplyByScalar(c,(-i+E)/l,U);return e.add(f,a,f),e.clone(f,o.center),o.radius=E,o};var B=new e;h.expand=function(t,r,n){n=h.clone(t,n);var o=e.magnitude(e.subtract(r,n.center,B));return o>n.radius&&(n.radius=o),n},h.intersectPlane=function(t,r){var n=t.center,o=t.radius,a=r.normal,i=e.dot(a,n)+r.distance;return-o>i?u.OUTSIDE:o>i?u.INTERSECTING:u.INSIDE},h.transform=function(e,t,r){return n(r)||(r=new h),r.center=l.multiplyByPoint(t,e.center,r.center),r.radius=l.getMaximumScale(t)*e.radius,r};var G=new e;h.distanceSquaredTo=function(t,r){var n=e.subtract(t.center,r,G);return e.magnitudeSquared(n)-t.radius*t.radius},h.transformWithoutScale=function(e,t,r){return n(r)||(r=new h),r.center=l.multiplyByPoint(t,e.center,r.center),r.radius=e.radius,r};var z=new e;h.computePlaneDistances=function(t,r,o,a){n(a)||(a=new s);var i=e.subtract(t.center,r,z),u=e.dot(o,i);return a.start=u-t.radius,a.stop=u+t.radius,a};for(var V=new e,H=new e,W=new e,q=new e,X=new e,Y=new t,k=new Array(8),K=0;8>K;++K)k[K]=new e;var j=new i;return h.projectTo2D=function(t,n,o){n=r(n,j);var a=n.ellipsoid,i=t.center,u=t.radius,s=a.geodeticSurfaceNormal(i,V),c=e.cross(e.UNIT_Z,s,H);e.normalize(c,c);var l=e.cross(s,c,W);e.normalize(l,l),e.multiplyByScalar(s,u,s),e.multiplyByScalar(l,u,l),e.multiplyByScalar(c,u,c);var E=e.negate(l,X),f=e.negate(c,q),m=k,d=m[0];e.add(s,l,d),e.add(d,c,d),d=m[1],e.add(s,l,d),e.add(d,f,d),d=m[2],e.add(s,E,d),e.add(d,f,d),d=m[3],e.add(s,E,d),e.add(d,c,d),e.negate(s,s),d=m[4],e.add(s,l,d),e.add(d,c,d),d=m[5],e.add(s,l,d),e.add(d,f,d),d=m[6],e.add(s,E,d),e.add(d,f,d),d=m[7],e.add(s,E,d),e.add(d,c,d);for(var p=m.length,A=0;p>A;++A){var T=m[A];e.add(i,T,T);var R=a.cartesianToCartographic(T,Y);n.project(R,T)}o=h.fromPoints(m,o),i=o.center;var y=i.x,_=i.y,v=i.z;return i.x=v,i.y=y,i.z=_,o},h.isOccluded=function(e,t){return!t.isBoundingSphereVisible(e)},h.equals=function(t,r){return t===r||n(t)&&n(r)&&e.equals(t.center,r.center)&&t.radius===r.radius},h.prototype.intersectPlane=function(e){return h.intersectPlane(this,e)},h.prototype.distanceSquaredTo=function(e){return h.distanceSquaredTo(this,e)},h.prototype.computePlaneDistances=function(e,t,r){return h.computePlaneDistances(this,e,t,r)},h.prototype.isOccluded=function(e){return h.isOccluded(this,e)},h.prototype.equals=function(e){return h.equals(this,e)},h.prototype.clone=function(e){return h.clone(this,e)},h}),define("Core/Fullscreen",["./defined","./defineProperties"],function(e,t){"use strict";var r,n={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},o={};return t(o,{element:{get:function(){return o.supportsFullscreen()?document[n.fullscreenElement]:void 0}},changeEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenchange:void 0}},errorEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenerror:void 0}},enabled:{get:function(){return o.supportsFullscreen()?document[n.fullscreenEnabled]:void 0}},fullscreen:{get:function(){return o.supportsFullscreen()?null!==o.element:void 0}}}),o.supportsFullscreen=function(){if(e(r))return r;r=!1;var t=document.body;if("function"==typeof t.requestFullscreen)return n.requestFullscreen="requestFullscreen",n.exitFullscreen="exitFullscreen",n.fullscreenEnabled="fullscreenEnabled",n.fullscreenElement="fullscreenElement",n.fullscreenchange="fullscreenchange",n.fullscreenerror="fullscreenerror",r=!0;for(var o,a=["webkit","moz","o","ms","khtml"],i=0,u=a.length;u>i;++i){var s=a[i];o=s+"RequestFullscreen","function"==typeof t[o]?(n.requestFullscreen=o,r=!0):(o=s+"RequestFullScreen","function"==typeof t[o]&&(n.requestFullscreen=o,r=!0)),o=s+"ExitFullscreen","function"==typeof document[o]?n.exitFullscreen=o:(o=s+"CancelFullScreen","function"==typeof document[o]&&(n.exitFullscreen=o)),o=s+"FullscreenEnabled",void 0!==document[o]?n.fullscreenEnabled=o:(o=s+"FullScreenEnabled",void 0!==document[o]&&(n.fullscreenEnabled=o)),o=s+"FullscreenElement",void 0!==document[o]?n.fullscreenElement=o:(o=s+"FullScreenElement",void 0!==document[o]&&(n.fullscreenElement=o)),o=s+"fullscreenchange",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenChange"),n.fullscreenchange=o),o=s+"fullscreenerror",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenError"),n.fullscreenerror=o)}return r},o.requestFullscreen=function(e,t){o.supportsFullscreen()&&e[n.requestFullscreen]({vrDisplay:t})},o.exitFullscreen=function(){o.supportsFullscreen()&&document[n.exitFullscreen]()},o}),define("Core/FeatureDetection",["./defaultValue","./defined","./Fullscreen"],function(e,t,r){"use strict";function n(e){for(var t=e.split("."),r=0,n=t.length;n>r;++r)t[r]=parseInt(t[r],10);return t}function o(){if(!t(R)){R=!1;var e=/ Chrome\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(R=!0,y=n(e[1]))}return R}function a(){return o()&&y}function i(){if(!t(_)&&(_=!1,!o()&&/ Safari\/[\.0-9]+/.test(T.userAgent))){var e=/ Version\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(_=!0,v=n(e[1]))}return _}function u(){return i()&&v}function s(){if(!t(S)){S=!1;var e=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(T.userAgent);null!==e&&(S=!0,g=n(e[1]),g.isNightly=!!e[2])}return S}function c(){return s()&&g}function l(){if(!t(C)){C=!1;var e;"Microsoft Internet Explorer"===T.appName?(e=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(T.userAgent),null!==e&&(C=!0,N=n(e[1]))):"Netscape"===T.appName&&(e=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(T.userAgent),null!==e&&(C=!0,N=n(e[1])))}return C}function E(){return l()&&N}function f(){if(!t(I)){I=!1;var e=/Firefox\/([\.0-9]+)/.exec(T.userAgent);null!==e&&(I=!0,M=n(e[1]))}return I}function h(){return t(O)||(O=/Windows/i.test(T.appVersion)),O}function m(){return f()&&M}function d(){return t(L)||(L="undefined"!=typeof PointerEvent&&(!t(T.pointerEnabled)||T.pointerEnabled)),L}function p(){if(!t(P)){var e=document.createElement("canvas");e.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");var r=e.style.imageRendering;P=t(r)&&""!==r,P&&(F=r)}return P}function A(){return p()?F:void 0}var T;T="undefined"!=typeof navigator?navigator:{};var R,y,_,v,S,g,C,N,I,M,O,L,F,P,w={isChrome:o,chromeVersion:a,isSafari:i,safariVersion:u,isWebkit:s,webkitVersion:c,isInternetExplorer:l,internetExplorerVersion:E,isFirefox:f,firefoxVersion:m,isWindows:h,hardwareConcurrency:e(T.hardwareConcurrency,3),supportsPointerEvents:d,supportsImageRenderingPixelated:p,imageRenderingValue:A};return w.supportsFullscreen=function(){return r.supportsFullscreen()},w.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},w.supportsWebWorkers=function(){return"undefined"!=typeof Worker},w}),define("Core/Color",["./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject","./Math"],function(e,t,r,n,o,a){"use strict";function i(e,t,r){return 0>r&&(r+=1),r>1&&(r-=1),1>6*r?e+6*(t-e)*r:1>2*r?t:2>3*r?e+(t-e)*(2/3-r)*6:e}function u(t,r,n,o){this.red=e(t,1),this.green=e(r,1),this.blue=e(n,1),this.alpha=e(o,1)}u.fromCartesian4=function(e,r){return t(r)?(r.red=e.x,r.green=e.y,r.blue=e.z,r.alpha=e.w,r):new u(e.x,e.y,e.z,e.w)},u.fromBytes=function(r,n,o,a,i){return r=u.byteToFloat(e(r,255)),n=u.byteToFloat(e(n,255)),o=u.byteToFloat(e(o,255)),a=u.byteToFloat(e(a,255)),t(i)?(i.red=r,i.green=n,i.blue=o,i.alpha=a,i):new u(r,n,o,a)},u.fromAlpha=function(e,r,n){return t(n)?(n.red=e.red,n.green=e.green,n.blue=e.blue,n.alpha=r,n):new u(e.red,e.green,e.blue,r)};var s,c,l;n.supportsTypedArrays()&&(s=new ArrayBuffer(4),c=new Uint32Array(s),l=new Uint8Array(s)),u.fromRgba=function(e,t){return c[0]=e,u.fromBytes(l[0],l[1],l[2],l[3],t)},u.fromHsl=function(r,n,o,a,s){r=e(r,0)%1,n=e(n,0),o=e(o,0),a=e(a,1);var c=o,l=o,E=o;if(0!==n){var f;f=.5>o?o*(1+n):o+n-o*n;var h=2*o-f;c=i(h,f,r+1/3),l=i(h,f,r),E=i(h,f,r-1/3)}return t(s)?(s.red=c,s.green=l,s.blue=E,s.alpha=a,s):new u(c,l,E,a);
},u.fromRandom=function(r,n){r=e(r,e.EMPTY_OBJECT);var o=r.red;if(!t(o)){var i=e(r.minimumRed,0),s=e(r.maximumRed,1);o=i+a.nextRandomNumber()*(s-i)}var c=r.green;if(!t(c)){var l=e(r.minimumGreen,0),E=e(r.maximumGreen,1);c=l+a.nextRandomNumber()*(E-l)}var f=r.blue;if(!t(f)){var h=e(r.minimumBlue,0),m=e(r.maximumBlue,1);f=h+a.nextRandomNumber()*(m-h)}var d=r.alpha;if(!t(d)){var p=e(r.minimumAlpha,0),A=e(r.maximumAlpha,1);d=p+a.nextRandomNumber()*(A-p)}return t(n)?(n.red=o,n.green=c,n.blue=f,n.alpha=d,n):new u(o,c,f,d)};var E=/^#([0-9a-f])([0-9a-f])([0-9a-f])$/i,f=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i,h=/^rgba?\(\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)(?:\s*,\s*([0-9.]+))?\s*\)$/i,m=/^hsla?\(\s*([0-9.]+)\s*,\s*([0-9.]+%)\s*,\s*([0-9.]+%)(?:\s*,\s*([0-9.]+))?\s*\)$/i;return u.fromCssColorString=function(r,n){t(n)||(n=new u);var o=u[r.toUpperCase()];if(t(o))return u.clone(o,n),n;var a=E.exec(r);return null!==a?(n.red=parseInt(a[1],16)/15,n.green=parseInt(a[2],16)/15,n.blue=parseInt(a[3],16)/15,n.alpha=1,n):(a=f.exec(r),null!==a?(n.red=parseInt(a[1],16)/255,n.green=parseInt(a[2],16)/255,n.blue=parseInt(a[3],16)/255,n.alpha=1,n):(a=h.exec(r),null!==a?(n.red=parseFloat(a[1])/("%"===a[1].substr(-1)?100:255),n.green=parseFloat(a[2])/("%"===a[2].substr(-1)?100:255),n.blue=parseFloat(a[3])/("%"===a[3].substr(-1)?100:255),n.alpha=parseFloat(e(a[4],"1.0")),n):(a=m.exec(r),null!==a?u.fromHsl(parseFloat(a[1])/360,parseFloat(a[2])/100,parseFloat(a[3])/100,parseFloat(e(a[4],"1.0")),n):n=void 0)))},u.packedLength=4,u.pack=function(t,r,n){n=e(n,0),r[n++]=t.red,r[n++]=t.green,r[n++]=t.blue,r[n]=t.alpha},u.unpack=function(r,n,o){return n=e(n,0),t(o)||(o=new u),o.red=r[n++],o.green=r[n++],o.blue=r[n++],o.alpha=r[n],o},u.byteToFloat=function(e){return e/255},u.floatToByte=function(e){return 1===e?255:256*e|0},u.clone=function(e,r){return t(e)?t(r)?(r.red=e.red,r.green=e.green,r.blue=e.blue,r.alpha=e.alpha,r):new u(e.red,e.green,e.blue,e.alpha):void 0},u.equals=function(e,r){return e===r||t(e)&&t(r)&&e.red===r.red&&e.green===r.green&&e.blue===r.blue&&e.alpha===r.alpha},u.equalsArray=function(e,t,r){return e.red===t[r]&&e.green===t[r+1]&&e.blue===t[r+2]&&e.alpha===t[r+3]},u.prototype.clone=function(e){return u.clone(this,e)},u.prototype.equals=function(e){return u.equals(this,e)},u.prototype.equalsEpsilon=function(e,r){return this===e||t(e)&&Math.abs(this.red-e.red)<=r&&Math.abs(this.green-e.green)<=r&&Math.abs(this.blue-e.blue)<=r&&Math.abs(this.alpha-e.alpha)<=r},u.prototype.toString=function(){return"("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},u.prototype.toCssColorString=function(){var e=u.floatToByte(this.red),t=u.floatToByte(this.green),r=u.floatToByte(this.blue);return 1===this.alpha?"rgb("+e+","+t+","+r+")":"rgba("+e+","+t+","+r+","+this.alpha+")"},u.prototype.toBytes=function(e){var r=u.floatToByte(this.red),n=u.floatToByte(this.green),o=u.floatToByte(this.blue),a=u.floatToByte(this.alpha);return t(e)?(e[0]=r,e[1]=n,e[2]=o,e[3]=a,e):[r,n,o,a]},u.prototype.toRgba=function(){return l[0]=u.floatToByte(this.red),l[1]=u.floatToByte(this.green),l[2]=u.floatToByte(this.blue),l[3]=u.floatToByte(this.alpha),c[0]},u.prototype.brighten=function(e,t){return e=1-e,t.red=1-(1-this.red)*e,t.green=1-(1-this.green)*e,t.blue=1-(1-this.blue)*e,t.alpha=this.alpha,t},u.prototype.darken=function(e,t){return e=1-e,t.red=this.red*e,t.green=this.green*e,t.blue=this.blue*e,t.alpha=this.alpha,t},u.prototype.withAlpha=function(e,t){return u.fromAlpha(this,e,t)},u.add=function(e,t,r){return r.red=e.red+t.red,r.green=e.green+t.green,r.blue=e.blue+t.blue,r.alpha=e.alpha+t.alpha,r},u.subtract=function(e,t,r){return r.red=e.red-t.red,r.green=e.green-t.green,r.blue=e.blue-t.blue,r.alpha=e.alpha-t.alpha,r},u.multiply=function(e,t,r){return r.red=e.red*t.red,r.green=e.green*t.green,r.blue=e.blue*t.blue,r.alpha=e.alpha*t.alpha,r},u.divide=function(e,t,r){return r.red=e.red/t.red,r.green=e.green/t.green,r.blue=e.blue/t.blue,r.alpha=e.alpha/t.alpha,r},u.mod=function(e,t,r){return r.red=e.red%t.red,r.green=e.green%t.green,r.blue=e.blue%t.blue,r.alpha=e.alpha%t.alpha,r},u.multiplyByScalar=function(e,t,r){return r.red=e.red*t,r.green=e.green*t,r.blue=e.blue*t,r.alpha=e.alpha*t,r},u.divideByScalar=function(e,t,r){return r.red=e.red/t,r.green=e.green/t,r.blue=e.blue/t,r.alpha=e.alpha/t,r},u.ALICEBLUE=o(u.fromCssColorString("#F0F8FF")),u.ANTIQUEWHITE=o(u.fromCssColorString("#FAEBD7")),u.AQUA=o(u.fromCssColorString("#00FFFF")),u.AQUAMARINE=o(u.fromCssColorString("#7FFFD4")),u.AZURE=o(u.fromCssColorString("#F0FFFF")),u.BEIGE=o(u.fromCssColorString("#F5F5DC")),u.BISQUE=o(u.fromCssColorString("#FFE4C4")),u.BLACK=o(u.fromCssColorString("#000000")),u.BLANCHEDALMOND=o(u.fromCssColorString("#FFEBCD")),u.BLUE=o(u.fromCssColorString("#0000FF")),u.BLUEVIOLET=o(u.fromCssColorString("#8A2BE2")),u.BROWN=o(u.fromCssColorString("#A52A2A")),u.BURLYWOOD=o(u.fromCssColorString("#DEB887")),u.CADETBLUE=o(u.fromCssColorString("#5F9EA0")),u.CHARTREUSE=o(u.fromCssColorString("#7FFF00")),u.CHOCOLATE=o(u.fromCssColorString("#D2691E")),u.CORAL=o(u.fromCssColorString("#FF7F50")),u.CORNFLOWERBLUE=o(u.fromCssColorString("#6495ED")),u.CORNSILK=o(u.fromCssColorString("#FFF8DC")),u.CRIMSON=o(u.fromCssColorString("#DC143C")),u.CYAN=o(u.fromCssColorString("#00FFFF")),u.DARKBLUE=o(u.fromCssColorString("#00008B")),u.DARKCYAN=o(u.fromCssColorString("#008B8B")),u.DARKGOLDENROD=o(u.fromCssColorString("#B8860B")),u.DARKGRAY=o(u.fromCssColorString("#A9A9A9")),u.DARKGREEN=o(u.fromCssColorString("#006400")),u.DARKGREY=u.DARKGRAY,u.DARKKHAKI=o(u.fromCssColorString("#BDB76B")),u.DARKMAGENTA=o(u.fromCssColorString("#8B008B")),u.DARKOLIVEGREEN=o(u.fromCssColorString("#556B2F")),u.DARKORANGE=o(u.fromCssColorString("#FF8C00")),u.DARKORCHID=o(u.fromCssColorString("#9932CC")),u.DARKRED=o(u.fromCssColorString("#8B0000")),u.DARKSALMON=o(u.fromCssColorString("#E9967A")),u.DARKSEAGREEN=o(u.fromCssColorString("#8FBC8F")),u.DARKSLATEBLUE=o(u.fromCssColorString("#483D8B")),u.DARKSLATEGRAY=o(u.fromCssColorString("#2F4F4F")),u.DARKSLATEGREY=u.DARKSLATEGRAY,u.DARKTURQUOISE=o(u.fromCssColorString("#00CED1")),u.DARKVIOLET=o(u.fromCssColorString("#9400D3")),u.DEEPPINK=o(u.fromCssColorString("#FF1493")),u.DEEPSKYBLUE=o(u.fromCssColorString("#00BFFF")),u.DIMGRAY=o(u.fromCssColorString("#696969")),u.DIMGREY=u.DIMGRAY,u.DODGERBLUE=o(u.fromCssColorString("#1E90FF")),u.FIREBRICK=o(u.fromCssColorString("#B22222")),u.FLORALWHITE=o(u.fromCssColorString("#FFFAF0")),u.FORESTGREEN=o(u.fromCssColorString("#228B22")),u.FUSCHIA=o(u.fromCssColorString("#FF00FF")),u.GAINSBORO=o(u.fromCssColorString("#DCDCDC")),u.GHOSTWHITE=o(u.fromCssColorString("#F8F8FF")),u.GOLD=o(u.fromCssColorString("#FFD700")),u.GOLDENROD=o(u.fromCssColorString("#DAA520")),u.GRAY=o(u.fromCssColorString("#808080")),u.GREEN=o(u.fromCssColorString("#008000")),u.GREENYELLOW=o(u.fromCssColorString("#ADFF2F")),u.GREY=u.GRAY,u.HONEYDEW=o(u.fromCssColorString("#F0FFF0")),u.HOTPINK=o(u.fromCssColorString("#FF69B4")),u.INDIANRED=o(u.fromCssColorString("#CD5C5C")),u.INDIGO=o(u.fromCssColorString("#4B0082")),u.IVORY=o(u.fromCssColorString("#FFFFF0")),u.KHAKI=o(u.fromCssColorString("#F0E68C")),u.LAVENDER=o(u.fromCssColorString("#E6E6FA")),u.LAVENDAR_BLUSH=o(u.fromCssColorString("#FFF0F5")),u.LAWNGREEN=o(u.fromCssColorString("#7CFC00")),u.LEMONCHIFFON=o(u.fromCssColorString("#FFFACD")),u.LIGHTBLUE=o(u.fromCssColorString("#ADD8E6")),u.LIGHTCORAL=o(u.fromCssColorString("#F08080")),u.LIGHTCYAN=o(u.fromCssColorString("#E0FFFF")),u.LIGHTGOLDENRODYELLOW=o(u.fromCssColorString("#FAFAD2")),u.LIGHTGRAY=o(u.fromCssColorString("#D3D3D3")),u.LIGHTGREEN=o(u.fromCssColorString("#90EE90")),u.LIGHTGREY=u.LIGHTGRAY,u.LIGHTPINK=o(u.fromCssColorString("#FFB6C1")),u.LIGHTSEAGREEN=o(u.fromCssColorString("#20B2AA")),u.LIGHTSKYBLUE=o(u.fromCssColorString("#87CEFA")),u.LIGHTSLATEGRAY=o(u.fromCssColorString("#778899")),u.LIGHTSLATEGREY=u.LIGHTSLATEGRAY,u.LIGHTSTEELBLUE=o(u.fromCssColorString("#B0C4DE")),u.LIGHTYELLOW=o(u.fromCssColorString("#FFFFE0")),u.LIME=o(u.fromCssColorString("#00FF00")),u.LIMEGREEN=o(u.fromCssColorString("#32CD32")),u.LINEN=o(u.fromCssColorString("#FAF0E6")),u.MAGENTA=o(u.fromCssColorString("#FF00FF")),u.MAROON=o(u.fromCssColorString("#800000")),u.MEDIUMAQUAMARINE=o(u.fromCssColorString("#66CDAA")),u.MEDIUMBLUE=o(u.fromCssColorString("#0000CD")),u.MEDIUMORCHID=o(u.fromCssColorString("#BA55D3")),u.MEDIUMPURPLE=o(u.fromCssColorString("#9370DB")),u.MEDIUMSEAGREEN=o(u.fromCssColorString("#3CB371")),u.MEDIUMSLATEBLUE=o(u.fromCssColorString("#7B68EE")),u.MEDIUMSPRINGGREEN=o(u.fromCssColorString("#00FA9A")),u.MEDIUMTURQUOISE=o(u.fromCssColorString("#48D1CC")),u.MEDIUMVIOLETRED=o(u.fromCssColorString("#C71585")),u.MIDNIGHTBLUE=o(u.fromCssColorString("#191970")),u.MINTCREAM=o(u.fromCssColorString("#F5FFFA")),u.MISTYROSE=o(u.fromCssColorString("#FFE4E1")),u.MOCCASIN=o(u.fromCssColorString("#FFE4B5")),u.NAVAJOWHITE=o(u.fromCssColorString("#FFDEAD")),u.NAVY=o(u.fromCssColorString("#000080")),u.OLDLACE=o(u.fromCssColorString("#FDF5E6")),u.OLIVE=o(u.fromCssColorString("#808000")),u.OLIVEDRAB=o(u.fromCssColorString("#6B8E23")),u.ORANGE=o(u.fromCssColorString("#FFA500")),u.ORANGERED=o(u.fromCssColorString("#FF4500")),u.ORCHID=o(u.fromCssColorString("#DA70D6")),u.PALEGOLDENROD=o(u.fromCssColorString("#EEE8AA")),u.PALEGREEN=o(u.fromCssColorString("#98FB98")),u.PALETURQUOISE=o(u.fromCssColorString("#AFEEEE")),u.PALEVIOLETRED=o(u.fromCssColorString("#DB7093")),u.PAPAYAWHIP=o(u.fromCssColorString("#FFEFD5")),u.PEACHPUFF=o(u.fromCssColorString("#FFDAB9")),u.PERU=o(u.fromCssColorString("#CD853F")),u.PINK=o(u.fromCssColorString("#FFC0CB")),u.PLUM=o(u.fromCssColorString("#DDA0DD")),u.POWDERBLUE=o(u.fromCssColorString("#B0E0E6")),u.PURPLE=o(u.fromCssColorString("#800080")),u.RED=o(u.fromCssColorString("#FF0000")),u.ROSYBROWN=o(u.fromCssColorString("#BC8F8F")),u.ROYALBLUE=o(u.fromCssColorString("#4169E1")),u.SADDLEBROWN=o(u.fromCssColorString("#8B4513")),u.SALMON=o(u.fromCssColorString("#FA8072")),u.SANDYBROWN=o(u.fromCssColorString("#F4A460")),u.SEAGREEN=o(u.fromCssColorString("#2E8B57")),u.SEASHELL=o(u.fromCssColorString("#FFF5EE")),u.SIENNA=o(u.fromCssColorString("#A0522D")),u.SILVER=o(u.fromCssColorString("#C0C0C0")),u.SKYBLUE=o(u.fromCssColorString("#87CEEB")),u.SLATEBLUE=o(u.fromCssColorString("#6A5ACD")),u.SLATEGRAY=o(u.fromCssColorString("#708090")),u.SLATEGREY=u.SLATEGRAY,u.SNOW=o(u.fromCssColorString("#FFFAFA")),u.SPRINGGREEN=o(u.fromCssColorString("#00FF7F")),u.STEELBLUE=o(u.fromCssColorString("#4682B4")),u.TAN=o(u.fromCssColorString("#D2B48C")),u.TEAL=o(u.fromCssColorString("#008080")),u.THISTLE=o(u.fromCssColorString("#D8BFD8")),u.TOMATO=o(u.fromCssColorString("#FF6347")),u.TURQUOISE=o(u.fromCssColorString("#40E0D0")),u.VIOLET=o(u.fromCssColorString("#EE82EE")),u.WHEAT=o(u.fromCssColorString("#F5DEB3")),u.WHITE=o(u.fromCssColorString("#FFFFFF")),u.WHITESMOKE=o(u.fromCssColorString("#F5F5F5")),u.YELLOW=o(u.fromCssColorString("#FFFF00")),u.YELLOWGREEN=o(u.fromCssColorString("#9ACD32")),u.TRANSPARENT=o(new u(0,0,0,0)),u}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(e){"use strict";var t={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,DOUBLE:5130,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,COLOR:6144,DEPTH:6145,STENCIL:6146,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,MAX_3D_TEXTURE_SIZE:32883,UNSIGNED_INT_2_10_10_10_REV:33640,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,MAX_TEXTURE_LOD_BIAS:34045,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,VERTEX_ATTRIB_ARRAY_INTEGER:35069,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,UNSIGNED_INT_10F_11F_11F_REV:35899,RGB9_E5:35901,UNSIGNED_INT_5_9_9_9_REV:35902,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,RASTERIZER_DISCARD:35977,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,UNSIGNED_INT_24_8:34042,DEPTH24_STENCIL8:35056,UNSIGNED_NORMALIZED:35863,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,MAX_SAMPLES:36183,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,VERTEX_ARRAY_BINDING:34229,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,SIGNED_NORMALIZED:36764,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,INVALID_INDEX:4294967295,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,SAMPLER_BINDING:35097,RGB10_A2UI:36975,INT_2_10_10_10_REV:36255,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_SRGB8_ETC2:37493,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37494,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37495,COMPRESSED_RGBA8_ETC2_EAC:37496,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37497,TEXTURE_IMMUTABLE_FORMAT:37167,MAX_ELEMENT_INDEX:36203,TEXTURE_IMMUTABLE_LEVELS:33503};return e(t)}),define("Core/ComponentDatatype",["../Renderer/WebGLConstants","./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject"],function(e,t,r,n,o,a){"use strict";if(!o.supportsTypedArrays())return{};var i={BYTE:e.BYTE,UNSIGNED_BYTE:e.UNSIGNED_BYTE,SHORT:e.SHORT,UNSIGNED_SHORT:e.UNSIGNED_SHORT,FLOAT:e.FLOAT,DOUBLE:e.DOUBLE};return i.getSizeInBytes=function(e){switch(e){case i.BYTE:return Int8Array.BYTES_PER_ELEMENT;case i.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case i.SHORT:return Int16Array.BYTES_PER_ELEMENT;case i.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case i.FLOAT:return Float32Array.BYTES_PER_ELEMENT;case i.DOUBLE:return Float64Array.BYTES_PER_ELEMENT;default:throw new n("componentDatatype is not a valid value.")}},i.fromTypedArray=function(e){return e instanceof Int8Array?i.BYTE:e instanceof Uint8Array?i.UNSIGNED_BYTE:e instanceof Int16Array?i.SHORT:e instanceof Uint16Array?i.UNSIGNED_SHORT:e instanceof Float32Array?i.FLOAT:e instanceof Float64Array?i.DOUBLE:void 0},i.validate=function(e){return r(e)&&(e===i.BYTE||e===i.UNSIGNED_BYTE||e===i.SHORT||e===i.UNSIGNED_SHORT||e===i.FLOAT||e===i.DOUBLE)},i.createTypedArray=function(e,t){switch(e){case i.BYTE:return new Int8Array(t);case i.UNSIGNED_BYTE:return new Uint8Array(t);case i.SHORT:return new Int16Array(t);case i.UNSIGNED_SHORT:return new Uint16Array(t);case i.FLOAT:return new Float32Array(t);case i.DOUBLE:return new Float64Array(t);default:throw new n("componentDatatype is not a valid value.")}},i.createArrayBufferView=function(e,r,o,a){switch(o=t(o,0),a=t(a,(r.byteLength-o)/i.getSizeInBytes(e)),e){case i.BYTE:return new Int8Array(r,o,a);case i.UNSIGNED_BYTE:return new Uint8Array(r,o,a);case i.SHORT:return new Int16Array(r,o,a);case i.UNSIGNED_SHORT:return new Uint16Array(r,o,a);case i.FLOAT:return new Float32Array(r,o,a);case i.DOUBLE:return new Float64Array(r,o,a);default:throw new n("componentDatatype is not a valid value.")}},a(i)}),define("Core/GeometryType",["./freezeObject"],function(e){"use strict";var t={NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3};return e(t)}),define("Core/PrimitiveType",["../Renderer/WebGLConstants","./freezeObject"],function(e,t){"use strict";var r={POINTS:e.POINTS,LINES:e.LINES,LINE_LOOP:e.LINE_LOOP,LINE_STRIP:e.LINE_STRIP,TRIANGLES:e.TRIANGLES,TRIANGLE_STRIP:e.TRIANGLE_STRIP,TRIANGLE_FAN:e.TRIANGLE_FAN,validate:function(e){return e===r.POINTS||e===r.LINES||e===r.LINE_LOOP||e===r.LINE_STRIP||e===r.TRIANGLES||e===r.TRIANGLE_STRIP||e===r.TRIANGLE_FAN}};return t(r)}),define("Core/Geometry",["./defaultValue","./defined","./DeveloperError","./GeometryType","./PrimitiveType"],function(e,t,r,n,o){"use strict";function a(t){t=e(t,e.EMPTY_OBJECT),this.attributes=t.attributes,this.indices=t.indices,this.primitiveType=e(t.primitiveType,o.TRIANGLES),this.boundingSphere=t.boundingSphere,this.geometryType=e(t.geometryType,n.NONE),this.boundingSphereCV=void 0}return a.computeNumberOfVertices=function(e){var n=-1;for(var o in e.attributes)if(e.attributes.hasOwnProperty(o)&&t(e.attributes[o])&&t(e.attributes[o].values)){var a=e.attributes[o],i=a.values.length/a.componentsPerAttribute;if(n!==i&&-1!==n)throw new r("All attribute lists must have the same number of attributes.");n=i}return n},a}),define("Core/GeometryAttribute",["./defaultValue","./defined","./DeveloperError"],function(e,t,r){"use strict";function n(t){t=e(t,e.EMPTY_OBJECT),this.componentDatatype=t.componentDatatype,this.componentsPerAttribute=t.componentsPerAttribute,this.normalize=e(t.normalize,!1),this.values=t.values}return n}),define("Core/GeometryAttributes",["./defaultValue"],function(e){"use strict";function t(t){t=e(t,e.EMPTY_OBJECT),this.position=t.position,this.normal=t.normal,this.st=t.st,this.binormal=t.binormal,this.tangent=t.tangent,this.color=t.color}return t}),define("Core/Cartesian2",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,o){"use strict";function a(t,r){this.x=e(t,0),this.y=e(r,0)}a.fromElements=function(e,r,n){return t(n)?(n.x=e,n.y=r,n):new a(e,r)},a.clone=function(e,r){return t(e)?t(r)?(r.x=e.x,r.y=e.y,r):new a(e.x,e.y):void 0},a.fromCartesian3=a.clone,a.fromCartesian4=a.clone,a.packedLength=2,a.pack=function(t,r,n){n=e(n,0),r[n++]=t.x,r[n]=t.y},a.unpack=function(r,n,o){return n=e(n,0),t(o)||(o=new a),o.x=r[n++],o.y=r[n],o},a.packArray=function(e,r){var n=e.length;t(r)?r.length=2*n:r=new Array(2*n);for(var o=0;n>o;++o)a.pack(e[o],r,2*o);return r},a.unpackArray=function(e,r){var n=e.length;t(r)?r.length=n/2:r=new Array(n/2);for(var o=0;n>o;o+=2){var i=o/2;r[i]=a.unpack(e,o,r[i])}return r},a.fromArray=a.unpack,a.maximumComponent=function(e){return Math.max(e.x,e.y)},a.minimumComponent=function(e){return Math.min(e.x,e.y)},a.minimumByComponent=function(e,t,r){return r.x=Math.min(e.x,t.x),r.y=Math.min(e.y,t.y),r},a.maximumByComponent=function(e,t,r){return r.x=Math.max(e.x,t.x),r.y=Math.max(e.y,t.y),r},a.magnitudeSquared=function(e){return e.x*e.x+e.y*e.y},a.magnitude=function(e){return Math.sqrt(a.magnitudeSquared(e))};var i=new a;a.distance=function(e,t){return a.subtract(e,t,i),a.magnitude(i)},a.distanceSquared=function(e,t){return a.subtract(e,t,i),a.magnitudeSquared(i)},a.normalize=function(e,t){var r=a.magnitude(e);return t.x=e.x/r,t.y=e.y/r,t},a.dot=function(e,t){return e.x*t.x+e.y*t.y},a.multiplyComponents=function(e,t,r){return r.x=e.x*t.x,r.y=e.y*t.y,r},a.add=function(e,t,r){return r.x=e.x+t.x,r.y=e.y+t.y,r},a.subtract=function(e,t,r){return r.x=e.x-t.x,r.y=e.y-t.y,r},a.multiplyByScalar=function(e,t,r){return r.x=e.x*t,r.y=e.y*t,r},a.divideByScalar=function(e,t,r){return r.x=e.x/t,r.y=e.y/t,r},a.negate=function(e,t){return t.x=-e.x,t.y=-e.y,t},a.abs=function(e,t){return t.x=Math.abs(e.x),t.y=Math.abs(e.y),t};var u=new a;a.lerp=function(e,t,r,n){return a.multiplyByScalar(t,r,u),n=a.multiplyByScalar(e,1-r,n),a.add(u,n,n)};var s=new a,c=new a;a.angleBetween=function(e,t){return a.normalize(e,s),a.normalize(t,c),o.acosClamped(a.dot(s,c))};var l=new a;return a.mostOrthogonalAxis=function(e,t){var r=a.normalize(e,l);return a.abs(r,r),t=r.x<=r.y?a.clone(a.UNIT_X,t):a.clone(a.UNIT_Y,t)},a.equals=function(e,r){return e===r||t(e)&&t(r)&&e.x===r.x&&e.y===r.y},a.equalsArray=function(e,t,r){return e.x===t[r]&&e.y===t[r+1]},a.equalsEpsilon=function(e,r,n,a){return e===r||t(e)&&t(r)&&o.equalsEpsilon(e.x,r.x,n,a)&&o.equalsEpsilon(e.y,r.y,n,a)},a.ZERO=n(new a(0,0)),a.UNIT_X=n(new a(1,0)),a.UNIT_Y=n(new a(0,1)),a.prototype.clone=function(e){return a.clone(this,e)},a.prototype.equals=function(e){return a.equals(this,e)},a.prototype.equalsEpsilon=function(e,t,r){return a.equalsEpsilon(this,e,t,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+")"},a}),define("Core/AttributeCompression",["./Cartesian2","./Cartesian3","./defined","./DeveloperError","./Math"],function(e,t,r,n,o){"use strict";var a={};a.octEncode=function(e,t){if(t.x=e.x/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),t.y=e.y/(Math.abs(e.x)+Math.abs(e.y)+Math.abs(e.z)),e.z<0){var r=t.x,n=t.y;t.x=(1-Math.abs(n))*o.signNotZero(r),t.y=(1-Math.abs(r))*o.signNotZero(n)}return t.x=o.toSNorm(t.x),t.y=o.toSNorm(t.y),t},a.octDecode=function(e,r,n){if(n.x=o.fromSNorm(e),n.y=o.fromSNorm(r),n.z=1-(Math.abs(n.x)+Math.abs(n.y)),n.z<0){var a=n.x;n.x=(1-Math.abs(n.y))*o.signNotZero(a),n.y=(1-Math.abs(a))*o.signNotZero(n.y)}return t.normalize(n,n)},a.octPackFloat=function(e){return 256*e.x+e.y};var i=new e;return a.octEncodeFloat=function(e){return a.octEncode(e,i),a.octPackFloat(i)},a.octDecodeFloat=function(e,t){var r=e/256,n=Math.floor(r),o=256*(r-n);return a.octDecode(n,o,t)},a.octPack=function(e,t,r,n){var o=a.octEncodeFloat(e),u=a.octEncodeFloat(t),s=a.octEncode(r,i);return n.x=65536*s.x+o,n.y=65536*s.y+u,n},a.octUnpack=function(e,t,r,n){var o=e.x/65536,i=Math.floor(o),u=65536*(o-i);o=e.y/65536;var s=Math.floor(o),c=65536*(o-s);a.octDecodeFloat(u,t),a.octDecodeFloat(c,r),a.octDecode(i,s,n);
},a.compressTextureCoordinates=function(e){var t=1===e.x?4095:4096*e.x|0,r=1===e.y?4095:4096*e.y|0;return 4096*t+r},a.decompressTextureCoordinates=function(e,t){var r=e/4096;return t.x=Math.floor(r)/4096,t.y=r-Math.floor(r),t},a}),define("Core/barycentricCoordinates",["./Cartesian2","./Cartesian3","./defined","./DeveloperError"],function(e,t,r,n){"use strict";function o(n,o,s,c,l){r(l)||(l=new t);var E,f,h,m,d,p,A,T;r(o.z)?(E=t.subtract(s,o,a),f=t.subtract(c,o,i),h=t.subtract(n,o,u),m=t.dot(E,E),d=t.dot(E,f),p=t.dot(E,h),A=t.dot(f,f),T=t.dot(f,h)):(E=e.subtract(s,o,a),f=e.subtract(c,o,i),h=e.subtract(n,o,u),m=e.dot(E,E),d=e.dot(E,f),p=e.dot(E,h),A=e.dot(f,f),T=e.dot(f,h));var R=1/(m*A-d*d);return l.y=(A*p-d*T)*R,l.z=(m*T-d*p)*R,l.x=1-l.y-l.z,l}var a=new t,i=new t,u=new t;return o}),define("Core/EncodedCartesian3",["./Cartesian3","./defined","./DeveloperError"],function(e,t,r){"use strict";function n(){this.high=e.clone(e.ZERO),this.low=e.clone(e.ZERO)}n.encode=function(e,r){t(r)||(r={high:0,low:0});var n;return e>=0?(n=65536*Math.floor(e/65536),r.high=n,r.low=e-n):(n=65536*Math.floor(-e/65536),r.high=-n,r.low=e+n),r};var o={high:0,low:0};n.fromCartesian=function(e,r){t(r)||(r=new n);var a=r.high,i=r.low;return n.encode(e.x,o),a.x=o.high,i.x=o.low,n.encode(e.y,o),a.y=o.high,i.y=o.low,n.encode(e.z,o),a.z=o.high,i.z=o.low,r};var a=new n;return n.writeElements=function(e,t,r){n.fromCartesian(e,a);var o=a.high,i=a.low;t[r]=o.x,t[r+1]=o.y,t[r+2]=o.z,t[r+3]=i.x,t[r+4]=i.y,t[r+5]=i.z},n}),define("Core/GeometryInstance",["./defaultValue","./defined","./DeveloperError","./Matrix4"],function(e,t,r,n){"use strict";function o(t){t=e(t,e.EMPTY_OBJECT),this.geometry=t.geometry,this.modelMatrix=n.clone(e(t.modelMatrix,n.IDENTITY)),this.id=t.id,this.pickPrimitive=t.pickPrimitive,this.attributes=e(t.attributes,{}),this.westHemisphereGeometry=void 0,this.eastHemisphereGeometry=void 0}return o}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(e,t,r,n,o){"use strict";var a={UNSIGNED_BYTE:e.UNSIGNED_BYTE,UNSIGNED_SHORT:e.UNSIGNED_SHORT,UNSIGNED_INT:e.UNSIGNED_INT};return a.getSizeInBytes=function(e){switch(e){case a.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case a.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case a.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},a.validate=function(e){return t(e)&&(e===a.UNSIGNED_BYTE||e===a.UNSIGNED_SHORT||e===a.UNSIGNED_INT)},a.createTypedArray=function(e,t){return e>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(t):new Uint16Array(t)},a.createTypedArrayFromArrayBuffer=function(e,t,r,n){return e>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(t,r,n):new Uint16Array(t,r,n)},n(a)}),define("Core/QuadraticRealPolynomial",["./DeveloperError","./Math"],function(e,t){"use strict";function r(e,r,n){var o=e+r;return t.sign(e)!==t.sign(r)&&Math.abs(o/Math.max(Math.abs(e),Math.abs(r)))<n?0:o}var n={};return n.computeDiscriminant=function(e,t,r){var n=t*t-4*e*r;return n},n.computeRealRoots=function(e,n,o){var a;if(0===e)return 0===n?[]:[-o/n];if(0===n){if(0===o)return[0,0];var i=Math.abs(o),u=Math.abs(e);if(u>i&&i/u<t.EPSILON14)return[0,0];if(i>u&&u/i<t.EPSILON14)return[];if(a=-o/e,0>a)return[];var s=Math.sqrt(a);return[-s,s]}if(0===o)return a=-n/e,0>a?[a,0]:[0,a];var c=n*n,l=4*e*o,E=r(c,-l,t.EPSILON14);if(0>E)return[];var f=-.5*r(n,t.sign(n)*Math.sqrt(E),t.EPSILON14);return n>0?[f/e,o/f]:[o/f,f/e]},n}),define("Core/CubicRealPolynomial",["./DeveloperError","./QuadraticRealPolynomial"],function(e,t){"use strict";function r(e,t,r,n){var o,a,i=e,u=t/3,s=r/3,c=n,l=i*s,E=u*c,f=u*u,h=s*s,m=i*s-f,d=i*c-u*s,p=u*c-h,A=4*m*p-d*d;if(0>A){var T,R,y;f*E>=l*h?(T=i,R=m,y=-2*u*m+i*d):(T=c,R=p,y=-c*d+2*s*p);var _=0>y?-1:1,v=-_*Math.abs(T)*Math.sqrt(-A);a=-y+v;var S=a/2,g=0>S?-Math.pow(-S,1/3):Math.pow(S,1/3),C=a===v?-g:-R/g;return o=0>=R?g+C:-y/(g*g+C*C+R),f*E>=l*h?[(o-u)/i]:[-c/(o+s)]}var N=m,I=-2*u*m+i*d,M=p,O=-c*d+2*s*p,L=Math.sqrt(A),F=Math.sqrt(3)/2,P=Math.abs(Math.atan2(i*L,-I)/3);o=2*Math.sqrt(-N);var w=Math.cos(P);a=o*w;var b=o*(-w/2-F*Math.sin(P)),D=a+b>2*u?a-u:b-u,x=i,U=D/x;P=Math.abs(Math.atan2(c*L,-O)/3),o=2*Math.sqrt(-M),w=Math.cos(P),a=o*w,b=o*(-w/2-F*Math.sin(P));var B=-c,G=2*s>a+b?a+s:b+s,z=B/G,V=x*G,H=-D*G-x*B,W=D*B,q=(s*H-u*W)/(-u*H+s*V);return q>=U?z>=U?z>=q?[U,q,z]:[U,z,q]:[z,U,q]:z>=U?[q,U,z]:z>=q?[q,z,U]:[z,q,U]}var n={};return n.computeDiscriminant=function(e,t,r,n){var o=e*e,a=t*t,i=r*r,u=n*n,s=18*e*t*r*n+a*i-27*o*u-4*(e*i*r+a*t*n);return s},n.computeRealRoots=function(e,n,o,a){var i,u;if(0===e)return t.computeRealRoots(n,o,a);if(0===n){if(0===o){if(0===a)return[0,0,0];u=-a/e;var s=0>u?-Math.pow(-u,1/3):Math.pow(u,1/3);return[s,s,s]}return 0===a?(i=t.computeRealRoots(e,0,o),0===i.Length?[0]:[i[0],0,i[1]]):r(e,0,o,a)}return 0===o?0===a?(u=-n/e,0>u?[u,0,0]:[0,0,u]):r(e,n,0,a):0===a?(i=t.computeRealRoots(e,n,o),0===i.length?[0]:i[1]<=0?[i[0],i[1],0]:i[0]>=0?[0,i[0],i[1]]:[i[0],0,i[1]]):r(e,n,o,a)},n}),define("Core/QuarticRealPolynomial",["./CubicRealPolynomial","./DeveloperError","./Math","./QuadraticRealPolynomial"],function(e,t,r,n){"use strict";function o(t,o,a,i){var u=t*t,s=o-3*u/8,c=a-o*t/2+u*t/8,l=i-a*t/4+o*u/16-3*u*u/256,E=e.computeRealRoots(1,2*s,s*s-4*l,-c*c);if(E.length>0){var f=-t/4,h=E[E.length-1];if(Math.abs(h)<r.EPSILON14){var m=n.computeRealRoots(1,s,l);if(2===m.length){var d,p=m[0],A=m[1];if(p>=0&&A>=0){var T=Math.sqrt(p),R=Math.sqrt(A);return[f-R,f-T,f+T,f+R]}if(p>=0&&0>A)return d=Math.sqrt(p),[f-d,f+d];if(0>p&&A>=0)return d=Math.sqrt(A),[f-d,f+d]}return[]}if(h>0){var y=Math.sqrt(h),_=(s+h-c/y)/2,v=(s+h+c/y)/2,S=n.computeRealRoots(1,y,_),g=n.computeRealRoots(1,-y,v);return 0!==S.length?(S[0]+=f,S[1]+=f,0!==g.length?(g[0]+=f,g[1]+=f,S[1]<=g[0]?[S[0],S[1],g[0],g[1]]:g[1]<=S[0]?[g[0],g[1],S[0],S[1]]:S[0]>=g[0]&&S[1]<=g[1]?[g[0],S[0],S[1],g[1]]:g[0]>=S[0]&&g[1]<=S[1]?[S[0],g[0],g[1],S[1]]:S[0]>g[0]&&S[0]<g[1]?[g[0],S[0],g[1],S[1]]:[S[0],g[0],S[1],g[1]]):S):0!==g.length?(g[0]+=f,g[1]+=f,g):[]}}return[]}function a(t,o,a,i){var u=a*a,s=o*o,c=t*t,l=-2*o,E=a*t+s-4*i,f=c*i-a*o*t+u,h=e.computeRealRoots(1,l,E,f);if(h.length>0){var m,d,p=h[0],A=o-p,T=A*A,R=t/2,y=A/2,_=T-4*i,v=T+4*Math.abs(i),S=c-4*p,g=c+4*Math.abs(p);if(0>p||S*v>_*g){var C=Math.sqrt(S);m=C/2,d=0===C?0:(t*y-a)/C}else{var N=Math.sqrt(_);m=0===N?0:(t*y-a)/N,d=N/2}var I,M;0===R&&0===m?(I=0,M=0):r.sign(R)===r.sign(m)?(I=R+m,M=p/I):(M=R-m,I=p/M);var O,L;0===y&&0===d?(O=0,L=0):r.sign(y)===r.sign(d)?(O=y+d,L=i/O):(L=y-d,O=i/L);var F=n.computeRealRoots(1,I,O),P=n.computeRealRoots(1,M,L);if(0!==F.length)return 0!==P.length?F[1]<=P[0]?[F[0],F[1],P[0],P[1]]:P[1]<=F[0]?[P[0],P[1],F[0],F[1]]:F[0]>=P[0]&&F[1]<=P[1]?[P[0],F[0],F[1],P[1]]:P[0]>=F[0]&&P[1]<=F[1]?[F[0],P[0],P[1],F[1]]:F[0]>P[0]&&F[0]<P[1]?[P[0],F[0],P[1],F[1]]:[F[0],P[0],F[1],P[1]]:F;if(0!==P.length)return P}return[]}var i={};return i.computeDiscriminant=function(e,t,r,n,o){var a=e*e,i=a*e,u=t*t,s=u*t,c=r*r,l=c*r,E=n*n,f=E*n,h=o*o,m=h*o,d=u*c*E-4*s*f-4*e*l*E+18*e*t*r*f-27*a*E*E+256*i*m+o*(18*s*r*n-4*u*l+16*e*c*c-80*e*t*c*n-6*e*u*E+144*a*r*E)+h*(144*e*u*r-27*u*u-128*a*c-192*a*t*n);return d},i.computeRealRoots=function(t,n,i,u,s){if(Math.abs(t)<r.EPSILON15)return e.computeRealRoots(n,i,u,s);var c=n/t,l=i/t,E=u/t,f=s/t,h=0>c?1:0;switch(h+=0>l?h+1:h,h+=0>E?h+1:h,h+=0>f?h+1:h){case 0:return o(c,l,E,f);case 1:return a(c,l,E,f);case 2:return a(c,l,E,f);case 3:return o(c,l,E,f);case 4:return o(c,l,E,f);case 5:return a(c,l,E,f);case 6:return o(c,l,E,f);case 7:return o(c,l,E,f);case 8:return a(c,l,E,f);case 9:return o(c,l,E,f);case 10:return o(c,l,E,f);case 11:return a(c,l,E,f);case 12:return o(c,l,E,f);case 13:return o(c,l,E,f);case 14:return o(c,l,E,f);case 15:return o(c,l,E,f);default:return}},i}),define("Core/Ray",["./Cartesian3","./defaultValue","./defined","./DeveloperError"],function(e,t,r,n){"use strict";function o(r,n){n=e.clone(t(n,e.ZERO)),e.equals(n,e.ZERO)||e.normalize(n,n),this.origin=e.clone(t(r,e.ZERO)),this.direction=n}return o.getPoint=function(t,n,o){return r(o)||(o=new e),o=e.multiplyByScalar(t.direction,n,o),e.add(t.origin,o,o)},o}),define("Core/IntersectionTests",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Math","./Matrix3","./QuadraticRealPolynomial","./QuarticRealPolynomial","./Ray"],function(e,t,r,n,o,a,i,u,s,c){"use strict";function l(e,t,r,n){var o=t*t-4*e*r;if(!(0>o)){if(o>0){var a=1/(2*e),i=Math.sqrt(o),u=(-t+i)*a,s=(-t-i)*a;return s>u?(n.root0=u,n.root1=s):(n.root0=s,n.root1=u),n}var c=-t/(2*e);if(0!==c)return n.root0=n.root1=c,n}}function E(t,r,o){n(o)||(o={});var a=t.origin,i=t.direction,u=r.center,s=r.radius*r.radius,c=e.subtract(a,u,A),E=e.dot(i,i),f=2*e.dot(i,c),h=e.magnitudeSquared(c)-s,m=l(E,f,h,_);return n(m)?(o.start=m.root0,o.stop=m.root1,o):void 0}function f(e,t,r){var n=e+t;return a.sign(e)!==a.sign(t)&&Math.abs(n/Math.max(Math.abs(e),Math.abs(t)))<r?0:n}function h(t,r,n,o,c){var l,E=o*o,h=c*c,m=(t[i.COLUMN1ROW1]-t[i.COLUMN2ROW2])*h,d=c*(o*f(t[i.COLUMN1ROW0],t[i.COLUMN0ROW1],a.EPSILON15)+r.y),p=t[i.COLUMN0ROW0]*E+t[i.COLUMN2ROW2]*h+o*r.x+n,A=h*f(t[i.COLUMN2ROW1],t[i.COLUMN1ROW2],a.EPSILON15),T=c*(o*f(t[i.COLUMN2ROW0],t[i.COLUMN0ROW2])+r.z),R=[];if(0===T&&0===A){if(l=u.computeRealRoots(m,d,p),0===l.length)return R;var y=l[0],_=Math.sqrt(Math.max(1-y*y,0));if(R.push(new e(o,c*y,c*-_)),R.push(new e(o,c*y,c*_)),2===l.length){var v=l[1],S=Math.sqrt(Math.max(1-v*v,0));R.push(new e(o,c*v,c*-S)),R.push(new e(o,c*v,c*S))}return R}var g=T*T,C=A*A,N=m*m,I=T*A,M=N+C,O=2*(d*m+I),L=2*p*m+d*d-C+g,F=2*(p*d-I),P=p*p-g;if(0===M&&0===O&&0===L&&0===F)return R;l=s.computeRealRoots(M,O,L,F,P);var w=l.length;if(0===w)return R;for(var b=0;w>b;++b){var D,x=l[b],U=x*x,B=Math.max(1-U,0),G=Math.sqrt(B);D=a.sign(m)===a.sign(p)?f(m*U+p,d*x,a.EPSILON12):a.sign(p)===a.sign(d*x)?f(m*U,d*x+p,a.EPSILON12):f(m*U+d*x,p,a.EPSILON12);var z=f(A*x,T,a.EPSILON15),V=D*z;0>V?R.push(new e(o,c*x,c*G)):V>0?R.push(new e(o,c*x,c*-G)):0!==G?(R.push(new e(o,c*x,c*-G)),R.push(new e(o,c*x,c*G)),++b):R.push(new e(o,c*x,c*G))}return R}var m={};m.rayPlane=function(t,r,o){n(o)||(o=new e);var i=t.origin,u=t.direction,s=r.normal,c=e.dot(s,u);if(!(Math.abs(c)<a.EPSILON15)){var l=(-r.distance-e.dot(s,i))/c;if(!(0>l))return o=e.multiplyByScalar(u,l,o),e.add(i,o,o)}};var d=new e,p=new e,A=new e,T=new e,R=new e;m.rayTriangleParametric=function(t,n,o,i,u){u=r(u,!1);var s,c,l,E,f,h=t.origin,m=t.direction,y=e.subtract(o,n,d),_=e.subtract(i,n,p),v=e.cross(m,_,A),S=e.dot(y,v);if(u){if(S<a.EPSILON6)return;if(s=e.subtract(h,n,T),l=e.dot(s,v),0>l||l>S)return;if(c=e.cross(s,y,R),E=e.dot(m,c),0>E||l+E>S)return;f=e.dot(_,c)/S}else{if(Math.abs(S)<a.EPSILON6)return;var g=1/S;if(s=e.subtract(h,n,T),l=e.dot(s,v)*g,0>l||l>1)return;if(c=e.cross(s,y,R),E=e.dot(m,c)*g,0>E||l+E>1)return;f=e.dot(_,c)*g}return f},m.rayTriangle=function(t,r,o,a,i,u){var s=m.rayTriangleParametric(t,r,o,a,i);if(n(s)&&!(0>s))return n(u)||(u=new e),e.multiplyByScalar(t.direction,s,u),e.add(t.origin,u,u)};var y=new c;m.lineSegmentTriangle=function(t,r,o,a,i,u,s){var c=y;e.clone(t,c.origin),e.subtract(r,t,c.direction),e.normalize(c.direction,c.direction);var l=m.rayTriangleParametric(c,o,a,i,u);return!n(l)||0>l||l>e.distance(t,r)?void 0:(n(s)||(s=new e),e.multiplyByScalar(c.direction,l,s),e.add(c.origin,s,s))};var _={root0:0,root1:0};m.raySphere=function(e,t,r){return r=E(e,t,r),!n(r)||r.stop<0?void 0:(r.start=Math.max(r.start,0),r)};var v=new c;m.lineSegmentSphere=function(t,r,o,a){var i=v;e.clone(t,i.origin);var u=e.subtract(r,t,i.direction),s=e.magnitude(u);return e.normalize(u,u),a=E(i,o,a),!n(a)||a.stop<0||a.start>s?void 0:(a.start=Math.max(a.start,0),a.stop=Math.min(a.stop,s),a)};var S=new e,g=new e;m.rayEllipsoid=function(t,r){var n,o,a,i,u,s=r.oneOverRadii,c=e.multiplyComponents(s,t.origin,S),l=e.multiplyComponents(s,t.direction,g),E=e.magnitudeSquared(c),f=e.dot(c,l);if(E>1){if(f>=0)return;var h=f*f;if(n=E-1,o=e.magnitudeSquared(l),a=o*n,a>h)return;if(h>a){i=f*f-a,u=-f+Math.sqrt(i);var m=u/o,d=n/u;return d>m?{start:m,stop:d}:{start:d,stop:m}}var p=Math.sqrt(n/o);return{start:p,stop:p}}return 1>E?(n=E-1,o=e.magnitudeSquared(l),a=o*n,i=f*f-a,u=-f+Math.sqrt(i),{start:0,stop:u/o}):0>f?(o=e.magnitudeSquared(l),{start:0,stop:-f/o}):void 0};var C=new e,N=new e,I=new e,M=new e,O=new e,L=new i,F=new i,P=new i,w=new i,b=new i,D=new i,x=new i,U=new e,B=new e,G=new t;m.grazingAltitudeLocation=function(t,r){var o=t.origin,u=t.direction,s=r.geodeticSurfaceNormal(o,C);if(e.dot(u,s)>=0)return o;var c=n(this.rayEllipsoid(t,r)),l=r.transformPositionToScaledSpace(u,C),E=e.normalize(l,l),f=e.mostOrthogonalAxis(l,M),m=e.normalize(e.cross(f,E,N),N),d=e.normalize(e.cross(E,m,I),I),p=L;p[0]=E.x,p[1]=E.y,p[2]=E.z,p[3]=m.x,p[4]=m.y,p[5]=m.z,p[6]=d.x,p[7]=d.y,p[8]=d.z;var A=i.transpose(p,F),T=i.fromScale(r.radii,P),R=i.fromScale(r.oneOverRadii,w),y=b;y[0]=0,y[1]=-u.z,y[2]=u.y,y[3]=u.z,y[4]=0,y[5]=-u.x,y[6]=-u.y,y[7]=u.x,y[8]=0;var _,v,S=i.multiply(i.multiply(A,R,D),y,D),g=i.multiply(i.multiply(S,T,x),p,x),z=i.multiplyByVector(S,o,O),V=h(g,e.negate(z,C),0,0,1),H=V.length;if(H>0){for(var W=e.clone(e.ZERO,B),q=Number.NEGATIVE_INFINITY,X=0;H>X;++X){_=i.multiplyByVector(T,i.multiplyByVector(p,V[X],U),U);var Y=e.normalize(e.subtract(_,o,M),M),k=e.dot(Y,u);k>q&&(q=k,W=e.clone(_,W))}var K=r.cartesianToCartographic(W,G);return q=a.clamp(q,0,1),v=e.magnitude(e.subtract(W,o,M))*Math.sqrt(1-q*q),v=c?-v:v,K.height=v,r.cartographicToCartesian(K,new e)}};var z=new e;return m.lineSegmentPlane=function(t,r,o,i){n(i)||(i=new e);var u=e.subtract(r,t,z),s=o.normal,c=e.dot(s,u);if(!(Math.abs(c)<a.EPSILON6)){var l=e.dot(s,t),E=-(o.distance+l)/c;if(!(0>E||E>1))return e.multiplyByScalar(u,E,i),e.add(t,i,i),i}},m.trianglePlaneIntersection=function(t,r,n,o){var a=o.normal,i=o.distance,u=e.dot(a,t)+i<0,s=e.dot(a,r)+i<0,c=e.dot(a,n)+i<0,l=0;l+=u?1:0,l+=s?1:0,l+=c?1:0;var E,f;if((1===l||2===l)&&(E=new e,f=new e),1===l){if(u)return m.lineSegmentPlane(t,r,o,E),m.lineSegmentPlane(t,n,o,f),{positions:[t,r,n,E,f],indices:[0,3,4,1,2,4,1,4,3]};if(s)return m.lineSegmentPlane(r,n,o,E),m.lineSegmentPlane(r,t,o,f),{positions:[t,r,n,E,f],indices:[1,3,4,2,0,4,2,4,3]};if(c)return m.lineSegmentPlane(n,t,o,E),m.lineSegmentPlane(n,r,o,f),{positions:[t,r,n,E,f],indices:[2,3,4,0,1,4,0,4,3]}}else if(2===l){if(!u)return m.lineSegmentPlane(r,t,o,E),m.lineSegmentPlane(n,t,o,f),{positions:[t,r,n,E,f],indices:[1,2,4,1,4,3,0,3,4]};if(!s)return m.lineSegmentPlane(n,r,o,E),m.lineSegmentPlane(t,r,o,f),{positions:[t,r,n,E,f],indices:[2,0,4,2,4,3,1,3,4]};if(!c)return m.lineSegmentPlane(t,n,o,E),m.lineSegmentPlane(r,n,o,f),{positions:[t,r,n,E,f],indices:[0,1,4,0,4,3,2,3,4]}}},m}),define("Core/Tipsify",["./defaultValue","./defined","./DeveloperError"],function(e,t,r){"use strict";var n={};return n.calculateACMR=function(r){r=e(r,e.EMPTY_OBJECT);var n=r.indices,o=r.maximumIndex,a=e(r.cacheSize,24),i=n.length;if(!t(o)){o=0;for(var u=0,s=n[u];i>u;)s>o&&(o=s),++u,s=n[u]}for(var c=[],l=0;o+1>l;l++)c[l]=0;for(var E=a+1,f=0;i>f;++f)E-c[n[f]]>a&&(c[n[f]]=E,++E);return(E-a+1)/(i/3)},n.tipsify=function(r){function n(e,t,r,n){for(;t.length>=1;){var o=t[t.length-1];if(t.splice(t.length-1,1),e[o].numLiveTriangles>0)return o}for(;n>a;){if(e[a].numLiveTriangles>0)return++a,a-1;++a}return-1}function o(e,t,r,o,a,i,u){for(var s,c=-1,l=-1,E=0;E<r.length;){var f=r[E];o[f].numLiveTriangles&&(s=0,a-o[f].timeStamp+2*o[f].numLiveTriangles<=t&&(s=a-o[f].timeStamp),(s>l||-1===l)&&(l=s,c=f)),++E}return-1===c?n(o,i,e,u):c}r=e(r,e.EMPTY_OBJECT);var a,i=r.indices,u=r.maximumIndex,s=e(r.cacheSize,24),c=i.length,l=0,E=0,f=i[E],h=c;if(t(u))l=u+1;else{for(;h>E;)f>l&&(l=f),++E,f=i[E];if(-1===l)return 0;++l}for(var m=[],d=0;l>d;d++)m[d]={numLiveTriangles:0,timeStamp:0,vertexTriangles:[]};E=0;for(var p=0;h>E;)m[i[E]].vertexTriangles.push(p),++m[i[E]].numLiveTriangles,m[i[E+1]].vertexTriangles.push(p),++m[i[E+1]].numLiveTriangles,m[i[E+2]].vertexTriangles.push(p),++m[i[E+2]].numLiveTriangles,++p,E+=3;var A=0,T=s+1;a=1;var R,y,_=[],v=[],S=0,g=[],C=c/3,N=[];for(d=0;C>d;d++)N[d]=!1;for(var I,M;-1!==A;){_=[],y=m[A],M=y.vertexTriangles.length;for(var O=0;M>O;++O)if(p=y.vertexTriangles[O],!N[p]){N[p]=!0,E=p+p+p;for(var L=0;3>L;++L)I=i[E],_.push(I),v.push(I),g[S]=I,++S,R=m[I],--R.numLiveTriangles,T-R.timeStamp>s&&(R.timeStamp=T,++T),++E}A=o(i,s,_,m,T,v,l)}return g},n}),define("Core/GeometryPipeline",["./AttributeCompression","./barycentricCoordinates","./BoundingSphere","./Cartesian2","./Cartesian3","./Cartesian4","./Cartographic","./ComponentDatatype","./defaultValue","./defined","./DeveloperError","./EncodedCartesian3","./GeographicProjection","./Geometry","./GeometryAttribute","./GeometryInstance","./GeometryType","./IndexDatatype","./Intersect","./IntersectionTests","./Math","./Matrix3","./Matrix4","./Plane","./PrimitiveType","./Tipsify"],function(e,t,r,n,o,a,i,u,s,c,l,E,f,h,m,d,p,A,T,R,y,_,v,S,g,C){"use strict";function N(e,t,r,n,o){e[t++]=r,e[t++]=n,e[t++]=n,e[t++]=o,e[t++]=o,e[t]=r}function I(e){for(var t=e.length,r=t/3*6,n=A.createTypedArray(t,r),o=0,a=0;t>a;a+=3,o+=6)N(n,o,e[a],e[a+1],e[a+2]);return n}function M(e){var t=e.length;if(t>=3){var r=6*(t-2),n=A.createTypedArray(t,r);N(n,0,e[0],e[1],e[2]);for(var o=6,a=3;t>a;++a,o+=6)N(n,o,e[a-1],e[a],e[a-2]);return n}return new Uint16Array}function O(e){if(e.length>0){for(var t=e.length-1,r=6*(t-1),n=A.createTypedArray(t,r),o=e[0],a=0,i=1;t>i;++i,a+=6)N(n,a,o,e[i],e[i+1]);return n}return new Uint16Array}function L(e){var t={};for(var r in e)if(e.hasOwnProperty(r)&&c(e[r])&&c(e[r].values)){var n=e[r];t[r]=new m({componentDatatype:n.componentDatatype,componentsPerAttribute:n.componentsPerAttribute,normalize:n.normalize,values:[]})}return t}function F(e,t,r){for(var n in t)if(t.hasOwnProperty(n)&&c(t[n])&&c(t[n].values))for(var o=t[n],a=0;a<o.componentsPerAttribute;++a)e[n].values.push(o.values[r*o.componentsPerAttribute+a])}function P(e,t){if(c(t))for(var r=t.values,n=r.length,a=0;n>a;a+=3)o.unpack(r,a,ie),v.multiplyByPoint(e,ie,ie),o.pack(ie,r,a)}function w(e,t){if(c(t))for(var r=t.values,n=r.length,a=0;n>a;a+=3)o.unpack(r,a,ie),_.multiplyByVector(e,ie,ie),ie=o.normalize(ie,ie),o.pack(ie,r,a)}function b(e,t){var r,n=e.length,o={},a=e[0][t].attributes;for(r in a)if(a.hasOwnProperty(r)&&c(a[r])&&c(a[r].values)){for(var i=a[r],s=i.values.length,l=!0,E=1;n>E;++E){var f=e[E][t].attributes[r];if(!c(f)||i.componentDatatype!==f.componentDatatype||i.componentsPerAttribute!==f.componentsPerAttribute||i.normalize!==f.normalize){l=!1;break}s+=f.values.length}l&&(o[r]=new m({componentDatatype:i.componentDatatype,componentsPerAttribute:i.componentsPerAttribute,normalize:i.normalize,values:u.createTypedArray(i.componentDatatype,s)}))}return o}function D(e,t){var n,a,i,u,s,l,E,f=e.length,m=(e[0].modelMatrix,c(e[0][t].indices)),d=e[0][t].primitiveType,p=b(e,t);for(n in p)if(p.hasOwnProperty(n))for(s=p[n].values,u=0,a=0;f>a;++a)for(l=e[a][t].attributes[n].values,E=l.length,i=0;E>i;++i)s[u++]=l[i];var T;if(m){var R=0;for(a=0;f>a;++a)R+=e[a][t].indices.length;var y=h.computeNumberOfVertices(new h({attributes:p,primitiveType:g.POINTS})),_=A.createTypedArray(y,R),v=0,S=0;for(a=0;f>a;++a){var C=e[a][t].indices,N=C.length;for(u=0;N>u;++u)_[v++]=S+C[u];S+=h.computeNumberOfVertices(e[a][t])}T=_}var I,M=new o,O=0;for(a=0;f>a;++a){if(I=e[a][t].boundingSphere,!c(I)){M=void 0;break}o.add(I.center,M,M)}if(c(M))for(o.divideByScalar(M,f,M),a=0;f>a;++a){I=e[a][t].boundingSphere;var L=o.magnitude(o.subtract(I.center,M,ce))+I.radius;L>O&&(O=L)}return new h({attributes:p,indices:T,primitiveType:d,boundingSphere:c(M)?new r(M,O):void 0})}function x(e){if(c(e.indices))return e;for(var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,t),n=0;t>n;++n)r[n]=n;return e.indices=r,e}function U(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,3*(t-2));r[0]=1,r[1]=0,r[2]=2;for(var n=3,o=3;t>o;++o)r[n++]=o-1,r[n++]=0,r[n++]=o;return e.indices=r,e.primitiveType=g.TRIANGLES,e}function B(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,3*(t-2));r[0]=0,r[1]=1,r[2]=2,t>3&&(r[3]=0,r[4]=2,r[5]=3);for(var n=6,o=3;t-1>o;o+=2)r[n++]=o,r[n++]=o-1,r[n++]=o+1,t>o+2&&(r[n++]=o,r[n++]=o+1,r[n++]=o+2);return e.indices=r,e.primitiveType=g.TRIANGLES,e}function G(e){if(c(e.indices))return e;for(var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,t),n=0;t>n;++n)r[n]=n;return e.indices=r,e}function z(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,2*(t-1));r[0]=0,r[1]=1;for(var n=2,o=2;t>o;++o)r[n++]=o-1,r[n++]=o;return e.indices=r,e.primitiveType=g.LINES,e}function V(e){var t=h.computeNumberOfVertices(e),r=A.createTypedArray(t,2*t);r[0]=0,r[1]=1;for(var n=2,o=2;t>o;++o)r[n++]=o-1,r[n++]=o;return r[n++]=t-1,r[n]=0,e.indices=r,e.primitiveType=g.LINES,e}function H(e){switch(e.primitiveType){case g.TRIANGLE_FAN:return U(e);case g.TRIANGLE_STRIP:return B(e);case g.TRIANGLES:return x(e);case g.LINE_STRIP:return z(e);case g.LINE_LOOP:return V(e);case g.LINES:return G(e)}return e}function W(e,t){Math.abs(e.y)<y.EPSILON6&&(t?e.y=-y.EPSILON6:e.y=y.EPSILON6)}function q(e,t,r){if(0!==e.y&&0!==t.y&&0!==r.y)return W(e,e.y<0),W(t,t.y<0),void W(r,r.y<0);var n,o=Math.abs(e.y),a=Math.abs(t.y),i=Math.abs(r.y);n=o>a?o>i?y.sign(e.y):y.sign(r.y):a>i?y.sign(t.y):y.sign(r.y);var u=0>n;W(e,u),W(t,u),W(r,u)}function X(e,t,r,n){o.add(e,o.multiplyByScalar(o.subtract(t,e,_e),e.y/(e.y-t.y),_e),r),o.clone(r,n),W(r,!0),W(n,!1)}function Y(e,t,r){if(!(e.x>=0||t.x>=0||r.x>=0)){q(e,t,r);var n=e.y<0,o=t.y<0,a=r.y<0,i=0;i+=n?1:0,i+=o?1:0,i+=a?1:0;var u=Ne.indices;1===i?(u[1]=3,u[2]=4,u[5]=6,u[7]=6,u[8]=5,n?(X(e,t,ve,ge),X(e,r,Se,Ce),u[0]=0,u[3]=1,u[4]=2,u[6]=1):o?(X(t,r,ve,ge),X(t,e,Se,Ce),u[0]=1,u[3]=2,u[4]=0,u[6]=2):a&&(X(r,e,ve,ge),X(r,t,Se,Ce),u[0]=2,u[3]=0,u[4]=1,u[6]=0)):2===i&&(u[2]=4,u[4]=4,u[5]=3,u[7]=5,u[8]=6,n?o?a||(X(r,e,ve,ge),X(r,t,Se,Ce),u[0]=0,u[1]=1,u[3]=0,u[6]=2):(X(t,r,ve,ge),X(t,e,Se,Ce),u[0]=2,u[1]=0,u[3]=2,u[6]=1):(X(e,t,ve,ge),X(e,r,Se,Ce),u[0]=1,u[1]=2,u[3]=1,u[6]=0));var s=Ne.positions;return s[0]=e,s[1]=t,s[2]=r,s.length=3,(1===i||2===i)&&(s[3]=ve,s[4]=Se,s[5]=ge,s[6]=Ce,s.length=7),Ne}}function k(e,t){var n=e.attributes;if(0!==n.position.values.length){for(var o in n)if(n.hasOwnProperty(o)&&c(n[o])&&c(n[o].values)){var a=n[o];a.values=u.createTypedArray(a.componentDatatype,a.values)}var i=h.computeNumberOfVertices(e);return e.indices=A.createTypedArray(i,e.indices),t&&(e.boundingSphere=r.fromVertices(n.position.values)),e}}function K(e){var t=e.attributes,r={};for(var n in t)if(t.hasOwnProperty(n)&&c(t[n])&&c(t[n].values)){var o=t[n];r[n]=new m({componentDatatype:o.componentDatatype,componentsPerAttribute:o.componentsPerAttribute,normalize:o.normalize,values:[]})}return new h({attributes:r,indices:[],primitiveType:e.primitiveType})}function j(e,t,r){var n=c(e.geometry.boundingSphere);t=k(t,n),r=k(r,n),c(r)&&!c(t)?e.geometry=r:!c(r)&&c(t)?e.geometry=t:(e.westHemisphereGeometry=t,e.eastHemisphereGeometry=r,e.geometry=void 0)}function Z(e,r,a,i,u,s,l,E,f,h,m){if(c(s)||c(l)||c(E)||c(f)){var d=o.fromArray(u,3*e,Ie),p=o.fromArray(u,3*r,Me),A=o.fromArray(u,3*a,Oe),T=t(i,d,p,A,Le);if(c(s)){var R=o.fromArray(s,3*e,Ie),y=o.fromArray(s,3*r,Me),_=o.fromArray(s,3*a,Oe);o.multiplyByScalar(R,T.x,R),o.multiplyByScalar(y,T.y,y),o.multiplyByScalar(_,T.z,_);var v=o.add(R,y,R);o.add(v,_,v),o.normalize(v,v),o.pack(v,h.normal.values,3*m)}if(c(l)){var S=o.fromArray(l,3*e,Ie),g=o.fromArray(l,3*r,Me),C=o.fromArray(l,3*a,Oe);o.multiplyByScalar(S,T.x,S),o.multiplyByScalar(g,T.y,g),o.multiplyByScalar(C,T.z,C);var N=o.add(S,g,S);o.add(N,C,N),o.normalize(N,N),o.pack(N,h.binormal.values,3*m)}if(c(E)){var I=o.fromArray(E,3*e,Ie),M=o.fromArray(E,3*r,Me),O=o.fromArray(E,3*a,Oe);o.multiplyByScalar(I,T.x,I),o.multiplyByScalar(M,T.y,M),o.multiplyByScalar(O,T.z,O);var L=o.add(I,M,I);o.add(L,O,L),o.normalize(L,L),o.pack(L,h.tangent.values,3*m)}if(c(f)){var F=n.fromArray(f,2*e,Fe),P=n.fromArray(f,2*r,Pe),w=n.fromArray(f,2*a,we);n.multiplyByScalar(F,T.x,F),n.multiplyByScalar(P,T.y,P),n.multiplyByScalar(w,T.z,w);var b=n.add(F,P,F);n.add(b,w,b),n.pack(b,h.st.values,2*m)}}}function Q(e,t,r,n,o,a){var i=e.position.values.length/3;if(-1!==o){var u=n[o],s=r[u];return-1===s?(r[u]=i,e.position.values.push(a.x,a.y,a.z),t.push(i),i):(t.push(s),s)}return e.position.values.push(a.x,a.y,a.z),t.push(i),i}function J(e){var t,r,n,a,i,u=e.geometry,s=u.attributes,l=s.position.values,E=c(s.normal)?s.normal.values:void 0,f=c(s.binormal)?s.binormal.values:void 0,h=c(s.tangent)?s.tangent.values:void 0,m=c(s.st)?s.st.values:void 0,d=u.indices,p=K(u),A=K(u),T=[];T.length=l.length/3;var R=[];for(R.length=l.length/3,i=0;i<T.length;++i)T[i]=-1,R[i]=-1;var y=d.length;for(i=0;y>i;i+=3){var _=d[i],v=d[i+1],S=d[i+2],g=o.fromArray(l,3*_),C=o.fromArray(l,3*v),N=o.fromArray(l,3*S),I=Y(g,C,N);if(c(I)&&I.positions.length>3)for(var M=I.positions,O=I.indices,L=O.length,F=0;L>F;++F){var P=O[F],w=M[P];w.y<0?(t=A.attributes,r=A.indices,n=T):(t=p.attributes,r=p.indices,n=R),a=Q(t,r,n,d,3>P?i+P:-1,w),Z(_,v,S,w,l,E,f,h,m,t,a)}else c(I)&&(g=I.positions[0],C=I.positions[1],N=I.positions[2]),g.y<0?(t=A.attributes,r=A.indices,n=T):(t=p.attributes,r=p.indices,n=R),a=Q(t,r,n,d,i,g),Z(_,v,S,g,l,E,f,h,m,t,a),a=Q(t,r,n,d,i+1,C),Z(_,v,S,C,l,E,f,h,m,t,a),a=Q(t,r,n,d,i+2,N),Z(_,v,S,N,l,E,f,h,m,t,a)}j(e,A,p)}function $(e){var t,r=e.geometry,n=r.attributes,a=n.position.values,i=r.indices,u=K(r),s=K(r),l=i.length,E=[];E.length=a.length/3;var f=[];for(f.length=a.length/3,t=0;t<E.length;++t)E[t]=-1,f[t]=-1;for(t=0;l>t;t+=2){var h=i[t],m=i[t+1],d=o.fromArray(a,3*h,Ie),p=o.fromArray(a,3*m,Me);Math.abs(d.y)<y.EPSILON6&&(d.y<0?d.y=-y.EPSILON6:d.y=y.EPSILON6),Math.abs(p.y)<y.EPSILON6&&(p.y<0?p.y=-y.EPSILON6:p.y=y.EPSILON6);var A=u.attributes,T=u.indices,_=f,v=s.attributes,S=s.indices,g=E,C=R.lineSegmentPlane(d,p,be,Oe);if(c(C)){var N=o.multiplyByScalar(o.UNIT_Y,5*y.EPSILON9,De);d.y<0&&(o.negate(N,N),A=s.attributes,T=s.indices,_=E,v=u.attributes,S=u.indices,g=f);var I=o.add(C,N,xe);Q(A,T,_,i,t,d),Q(A,T,_,i,-1,I),o.negate(N,N),o.add(C,N,I),Q(v,S,g,i,-1,I),Q(v,S,g,i,t+1,p)}else{var M,O,L;d.y<0?(M=s.attributes,O=s.indices,L=E):(M=u.attributes,O=u.indices,L=f),Q(M,O,L,i,t,d),Q(M,O,L,i,t+1,p)}}j(e,s,u)}function ee(e){for(var t=e.attributes,r=t.position.values,n=t.prevPosition.values,a=t.nextPosition.values,i=r.length,u=0;i>u;u+=3){var s=o.unpack(r,u,Ge);if(!(s.x>0)){var c=o.unpack(n,u,ze);(s.y<0&&c.y>0||s.y>0&&c.y<0)&&(u-3>0?(n[u]=r[u-3],n[u+1]=r[u-2],n[u+2]=r[u-1]):o.pack(s,n,u));var l=o.unpack(a,u,Ve);(s.y<0&&l.y>0||s.y>0&&l.y<0)&&(i>u+3?(a[u]=r[u+3],a[u+1]=r[u+4],a[u+2]=r[u+5]):o.pack(s,a,u))}}}function te(e){var t,r,i,u=e.geometry,s=u.attributes,l=s.position.values,E=s.prevPosition.values,f=s.nextPosition.values,h=s.expandAndWidth.values,m=c(s.st)?s.st.values:void 0,d=c(s.color)?s.color.values:void 0,p=K(u),A=K(u),T=!1,_=l.length/3;for(t=0;_>t;t+=4){var v=t,S=t+2,g=o.fromArray(l,3*v,Ge),C=o.fromArray(l,3*S,ze);if(Math.abs(g.y)<ke)for(g.y=ke*(C.y<0?-1:1),l[3*t+1]=g.y,l[3*(t+1)+1]=g.y,r=3*v;3*v+12>r;r+=3)E[r]=l[3*t],E[r+1]=l[3*t+1],E[r+2]=l[3*t+2];if(Math.abs(C.y)<ke)for(C.y=ke*(g.y<0?-1:1),l[3*(t+2)+1]=C.y,l[3*(t+3)+1]=C.y,r=3*v;3*v+12>r;r+=3)f[r]=l[3*(t+2)],f[r+1]=l[3*(t+2)+1],f[r+2]=l[3*(t+2)+2];var N=p.attributes,I=p.indices,M=A.attributes,O=A.indices,L=R.lineSegmentPlane(g,C,be,He);if(c(L)){T=!0;var F=o.multiplyByScalar(o.UNIT_Y,Ye,We);g.y<0&&(o.negate(F,F),N=A.attributes,I=A.indices,M=p.attributes,O=p.indices);var P=o.add(L,F,qe);N.position.values.push(g.x,g.y,g.z,g.x,g.y,g.z),N.position.values.push(P.x,P.y,P.z),N.position.values.push(P.x,P.y,P.z),N.prevPosition.values.push(E[3*v],E[3*v+1],E[3*v+2]),N.prevPosition.values.push(E[3*v+3],E[3*v+4],E[3*v+5]),N.prevPosition.values.push(g.x,g.y,g.z,g.x,g.y,g.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),N.nextPosition.values.push(P.x,P.y,P.z),o.negate(F,F),o.add(L,F,P),M.position.values.push(P.x,P.y,P.z),M.position.values.push(P.x,P.y,P.z),M.position.values.push(C.x,C.y,C.z,C.x,C.y,C.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.prevPosition.values.push(P.x,P.y,P.z),M.nextPosition.values.push(C.x,C.y,C.z,C.x,C.y,C.z),M.nextPosition.values.push(f[3*S],f[3*S+1],f[3*S+2]),M.nextPosition.values.push(f[3*S+3],f[3*S+4],f[3*S+5]);var w=n.fromArray(h,2*v,Ue),b=Math.abs(w.y);N.expandAndWidth.values.push(-1,b,1,b),N.expandAndWidth.values.push(-1,-b,1,-b),M.expandAndWidth.values.push(-1,b,1,b),M.expandAndWidth.values.push(-1,-b,1,-b);var D=o.magnitudeSquared(o.subtract(L,g,Ve));if(D/=o.magnitudeSquared(o.subtract(C,g,Ve)),c(d)){var x=a.fromArray(d,4*v,Xe),U=a.fromArray(d,4*S,Xe),B=y.lerp(x.x,U.x,D),G=y.lerp(x.y,U.y,D),z=y.lerp(x.z,U.z,D),V=y.lerp(x.w,U.w,D);for(r=4*v;4*v+8>r;++r)N.color.values.push(d[r]);for(N.color.values.push(B,G,z,V),N.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),M.color.values.push(B,G,z,V),r=4*S;4*S+8>r;++r)M.color.values.push(d[r])}if(c(m)){var H=n.fromArray(m,2*v,Ue),W=n.fromArray(m,2*(t+3),Be),q=y.lerp(H.x,W.x,D);for(r=2*v;2*v+4>r;++r)N.st.values.push(m[r]);for(N.st.values.push(q,H.y),N.st.values.push(q,W.y),M.st.values.push(q,H.y),M.st.values.push(q,W.y),r=2*S;2*S+4>r;++r)M.st.values.push(m[r])}i=N.position.values.length/3-4,I.push(i,i+2,i+1),I.push(i+1,i+2,i+3),i=M.position.values.length/3-4,O.push(i,i+2,i+1),O.push(i+1,i+2,i+3)}else{var X,Y;for(g.y<0?(X=A.attributes,Y=A.indices):(X=p.attributes,Y=p.indices),X.position.values.push(g.x,g.y,g.z),X.position.values.push(g.x,g.y,g.z),X.position.values.push(C.x,C.y,C.z),X.position.values.push(C.x,C.y,C.z),r=3*t;3*t+12>r;++r)X.prevPosition.values.push(E[r]),X.nextPosition.values.push(f[r]);for(r=2*t;2*t+8>r;++r)X.expandAndWidth.values.push(h[r]),c(m)&&X.st.values.push(m[r]);if(c(d))for(r=4*t;4*t+16>r;++r)X.color.values.push(d[r]);i=X.position.values.length/3-4,Y.push(i,i+2,i+1),Y.push(i+1,i+2,i+3)}}T&&(ee(A),ee(p)),j(e,A,p)}var re={};re.toWireframe=function(e){var t=e.indices;if(c(t)){switch(e.primitiveType){case g.TRIANGLES:e.indices=I(t);break;case g.TRIANGLE_STRIP:e.indices=M(t);break;case g.TRIANGLE_FAN:e.indices=O(t);break;default:throw new l("geometry.primitiveType must be TRIANGLES, TRIANGLE_STRIP, or TRIANGLE_FAN.")}e.primitiveType=g.LINES}return e},re.createLineSegmentsForVectors=function(e,t,n){t=s(t,"normal"),n=s(n,1e4);for(var o=e.attributes.position.values,a=e.attributes[t].values,i=o.length,l=new Float64Array(2*i),E=0,f=0;i>f;f+=3)l[E++]=o[f],l[E++]=o[f+1],l[E++]=o[f+2],l[E++]=o[f]+a[f]*n,l[E++]=o[f+1]+a[f+1]*n,l[E++]=o[f+2]+a[f+2]*n;var d,p=e.boundingSphere;return c(p)&&(d=new r(p.center,p.radius+n)),new h({attributes:{position:new m({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:l})},primitiveType:g.LINES,boundingSphere:d})},re.createAttributeLocations=function(e){var t,r=["position","positionHigh","positionLow","position3DHigh","position3DLow","position2DHigh","position2DLow","pickColor","normal","st","binormal","tangent","compressedAttributes"],n=e.attributes,o={},a=0,i=r.length;for(t=0;i>t;++t){var u=r[t];c(n[u])&&(o[u]=a++)}for(var s in n)n.hasOwnProperty(s)&&!c(o[s])&&(o[s]=a++);return o},re.reorderForPreVertexCache=function(e){var t=h.computeNumberOfVertices(e),r=e.indices;if(c(r)){for(var n=new Int32Array(t),o=0;t>o;o++)n[o]=-1;for(var a,i=r,s=i.length,l=A.createTypedArray(t,s),E=0,f=0,m=0;s>E;)a=n[i[E]],-1!==a?l[f]=a:(a=i[E],n[a]=m,l[f]=m,++m),++E,++f;e.indices=l;var d=e.attributes;for(var p in d)if(d.hasOwnProperty(p)&&c(d[p])&&c(d[p].values)){for(var T=d[p],R=T.values,y=0,_=T.componentsPerAttribute,v=u.createTypedArray(T.componentDatatype,m*_);t>y;){var S=n[y];if(-1!==S)for(o=0;_>o;o++)v[_*S+o]=R[_*y+o];++y}T.values=v}}return e},re.reorderForPostVertexCache=function(e,t){var r=e.indices;if(e.primitiveType===g.TRIANGLES&&c(r)){for(var n=r.length,o=0,a=0;n>a;a++)r[a]>o&&(o=r[a]);e.indices=C.tipsify({indices:r,maximumIndex:o,cacheSize:t})}return e},re.fitToUnsignedShortIndices=function(e){var t=[],r=h.computeNumberOfVertices(e);
if(c(e.indices)&&r>=y.SIXTY_FOUR_KILOBYTES){var n,o=[],a=[],i=0,u=L(e.attributes),s=e.indices,l=s.length;e.primitiveType===g.TRIANGLES?n=3:e.primitiveType===g.LINES?n=2:e.primitiveType===g.POINTS&&(n=1);for(var E=0;l>E;E+=n){for(var f=0;n>f;++f){var m=s[E+f],d=o[m];c(d)||(d=i++,o[m]=d,F(u,e.attributes,m)),a.push(d)}i+n>=y.SIXTY_FOUR_KILOBYTES&&(t.push(new h({attributes:u,indices:a,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV})),o=[],a=[],i=0,u=L(e.attributes))}0!==a.length&&t.push(new h({attributes:u,indices:a,primitiveType:e.primitiveType,boundingSphere:e.boundingSphere,boundingSphereCV:e.boundingSphereCV}))}else t.push(e);return t};var ne=new o,oe=new i;re.projectTo2D=function(e,t,r,n,a){var i=e.attributes[t];a=c(a)?a:new f;for(var s=a.ellipsoid,E=i.values,h=new Float64Array(E.length),d=0,p=0;p<E.length;p+=3){var A=o.fromArray(E,p,ne),T=s.cartesianToCartographic(A,oe);if(!c(T))throw new l("Could not project point ("+A.x+", "+A.y+", "+A.z+") to 2D.");var R=a.project(T,ne);h[d++]=R.x,h[d++]=R.y,h[d++]=R.z}return e.attributes[r]=i,e.attributes[n]=new m({componentDatatype:u.DOUBLE,componentsPerAttribute:3,values:h}),delete e.attributes[t],e};var ae={high:0,low:0};re.encodeAttribute=function(e,t,r,n){for(var o=e.attributes[t],a=o.values,i=a.length,s=new Float32Array(i),c=new Float32Array(i),l=0;i>l;++l)E.encode(a[l],ae),s[l]=ae.high,c[l]=ae.low;var f=o.componentsPerAttribute;return e.attributes[r]=new m({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:s}),e.attributes[n]=new m({componentDatatype:u.FLOAT,componentsPerAttribute:f,values:c}),delete e.attributes[t],e};var ie=new o,ue=new v,se=new _;re.transformToWorldCoordinates=function(e){var t=e.modelMatrix;if(v.equals(t,v.IDENTITY))return e;var n=e.geometry.attributes;P(t,n.position),P(t,n.prevPosition),P(t,n.nextPosition),(c(n.normal)||c(n.binormal)||c(n.tangent))&&(v.inverse(t,ue),v.transpose(ue,ue),v.getRotation(ue,se),w(se,n.normal),w(se,n.binormal),w(se,n.tangent));var o=e.geometry.boundingSphere;return c(o)&&(e.geometry.boundingSphere=r.transform(o,t,o)),e.modelMatrix=v.clone(v.IDENTITY),e};var ce=new o;re.combineInstances=function(e){for(var t=[],r=[],n=e.length,o=0;n>o;++o){var a=e[o];c(a.geometry)?t.push(a):r.push(a)}var i=[];return t.length>0&&i.push(D(t,"geometry")),r.length>0&&(i.push(D(r,"westHemisphereGeometry")),i.push(D(r,"eastHemisphereGeometry"))),i};var le=new o,Ee=new o,fe=new o,he=new o;re.computeNormal=function(e){for(var t=e.indices,r=e.attributes,n=r.position.values,a=r.position.values.length/3,i=t.length,s=new Array(a),c=new Array(i/3),l=new Array(i),E=0;a>E;E++)s[E]={indexOffset:0,count:0,currentCount:0};var f=0;for(E=0;i>E;E+=3){var h=t[E],d=t[E+1],p=t[E+2],A=3*h,T=3*d,R=3*p;Ee.x=n[A],Ee.y=n[A+1],Ee.z=n[A+2],fe.x=n[T],fe.y=n[T+1],fe.z=n[T+2],he.x=n[R],he.y=n[R+1],he.z=n[R+2],s[h].count++,s[d].count++,s[p].count++,o.subtract(fe,Ee,fe),o.subtract(he,Ee,he),c[f]=o.cross(fe,he,new o),f++}var y=0;for(E=0;a>E;E++)s[E].indexOffset+=y,y+=s[E].count;f=0;var _;for(E=0;i>E;E+=3){_=s[t[E]];var v=_.indexOffset+_.currentCount;l[v]=f,_.currentCount++,_=s[t[E+1]],v=_.indexOffset+_.currentCount,l[v]=f,_.currentCount++,_=s[t[E+2]],v=_.indexOffset+_.currentCount,l[v]=f,_.currentCount++,f++}var S=new Float32Array(3*a);for(E=0;a>E;E++){var g=3*E;if(_=s[E],_.count>0){for(o.clone(o.ZERO,le),f=0;f<_.count;f++)o.add(le,c[l[_.indexOffset+f]],le);o.normalize(le,le),S[g]=le.x,S[g+1]=le.y,S[g+2]=le.z}else S[g]=0,S[g+1]=0,S[g+2]=1}return e.attributes.normal=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:S}),e};var me=new o,de=new o,pe=new o;re.computeBinormalAndTangent=function(e){for(var t=(e.attributes,e.indices),r=e.attributes.position.values,n=e.attributes.normal.values,a=e.attributes.st.values,i=e.attributes.position.values.length/3,s=t.length,c=new Array(3*i),l=0;l<c.length;l++)c[l]=0;var E,f,h;for(l=0;s>l;l+=3){var d=t[l],p=t[l+1],A=t[l+2];E=3*d,f=3*p,h=3*A;var T=2*d,R=2*p,y=2*A,_=r[E],v=r[E+1],S=r[E+2],g=a[T],C=a[T+1],N=a[R+1]-C,I=a[y+1]-C,M=1/((a[R]-g)*I-(a[y]-g)*N),O=(I*(r[f]-_)-N*(r[h]-_))*M,L=(I*(r[f+1]-v)-N*(r[h+1]-v))*M,F=(I*(r[f+2]-S)-N*(r[h+2]-S))*M;c[E]+=O,c[E+1]+=L,c[E+2]+=F,c[f]+=O,c[f+1]+=L,c[f+2]+=F,c[h]+=O,c[h+1]+=L,c[h+2]+=F}var P=new Float32Array(3*i),w=new Float32Array(3*i);for(l=0;i>l;l++){E=3*l,f=E+1,h=E+2;var b=o.fromArray(n,E,me),D=o.fromArray(c,E,pe),x=o.dot(b,D);o.multiplyByScalar(b,x,de),o.normalize(o.subtract(D,de,D),D),w[E]=D.x,w[f]=D.y,w[h]=D.z,o.normalize(o.cross(b,D,D),D),P[E]=D.x,P[f]=D.y,P[h]=D.z}return e.attributes.tangent=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:w}),e.attributes.binormal=new m({componentDatatype:u.FLOAT,componentsPerAttribute:3,values:P}),e};var Ae=new n,Te=new o,Re=new o,ye=new o;re.compressVertices=function(t){var r=t.attributes.normal,a=t.attributes.st;if(!c(r)&&!c(a))return t;var i,s,l,E,f=t.attributes.tangent,h=t.attributes.binormal;c(r)&&(i=r.values),c(a)&&(s=a.values),c(f)&&(l=f.values),h&&(E=h.values);var d=c(i)?i.length:s.length,p=c(i)?3:2,A=d/p,T=A,R=c(s)&&c(i)?2:1;R+=c(l)||c(E)?1:0,T*=R;for(var y=new Float32Array(T),_=0,v=0;A>v;++v){c(s)&&(n.fromArray(s,2*v,Ae),y[_++]=e.compressTextureCoordinates(Ae));var S=3*v;c(i)&&c(l)&&c(E)?(o.fromArray(i,S,Te),o.fromArray(l,S,Re),o.fromArray(E,S,ye),e.octPack(Te,Re,ye,Ae),y[_++]=Ae.x,y[_++]=Ae.y):(c(i)&&(o.fromArray(i,S,Te),y[_++]=e.octEncodeFloat(Te)),c(l)&&(o.fromArray(l,S,Te),y[_++]=e.octEncodeFloat(Te)),c(E)&&(o.fromArray(E,S,Te),y[_++]=e.octEncodeFloat(Te)))}return t.attributes.compressedAttributes=new m({componentDatatype:u.FLOAT,componentsPerAttribute:R,values:y}),c(i)&&delete t.attributes.normal,c(s)&&delete t.attributes.st,c(l)&&delete t.attributes.tangent,c(E)&&delete t.attributes.binormal,t};var _e=new o,ve=new o,Se=new o,ge=new o,Ce=new o,Ne={positions:new Array(7),indices:new Array(9)},Ie=new o,Me=new o,Oe=new o,Le=new o,Fe=new n,Pe=new n,we=new n,be=S.fromPointNormal(o.ZERO,o.UNIT_Y),De=new o,xe=new o,Ue=new n,Be=new n,Ge=new o,ze=new o,Ve=new o,He=new o,We=new o,qe=new o,Xe=new a,Ye=5*y.EPSILON9,ke=y.EPSILON6;return re.splitLongitude=function(e){var t=e.geometry,n=t.boundingSphere;if(c(n)){var o=n.center.x-n.radius;if(o>0||r.intersectPlane(n,S.ORIGIN_ZX_PLANE)!==T.INTERSECTING)return e}if(t.geometryType!==p.NONE)switch(t.geometryType){case p.POLYLINES:te(e);break;case p.TRIANGLES:J(e);break;case p.LINES:$(e)}else H(t),t.primitiveType===g.TRIANGLES?J(e):t.primitiveType===g.LINES&&$(e);return e},re}),define("Core/WebMercatorProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./Math"],function(e,t,r,n,o,a,i,u){"use strict";function s(e){this._ellipsoid=r(e,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return o(s.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),s.mercatorAngleToGeodeticLatitude=function(e){return u.PI_OVER_TWO-2*Math.atan(Math.exp(-e))},s.geodeticLatitudeToMercatorAngle=function(e){e>s.MaximumLatitude?e=s.MaximumLatitude:e<-s.MaximumLatitude&&(e=-s.MaximumLatitude);var t=Math.sin(e);return.5*Math.log((1+t)/(1-t))},s.MaximumLatitude=s.mercatorAngleToGeodeticLatitude(Math.PI),s.prototype.project=function(t,r){var o=this._semimajorAxis,a=t.longitude*o,i=s.geodeticLatitudeToMercatorAngle(t.latitude)*o,u=t.height;return n(r)?(r.x=a,r.y=i,r.z=u,r):new e(a,i,u)},s.prototype.unproject=function(e,r){var o=this._oneOverSemimajorAxis,a=e.x*o,i=s.mercatorAngleToGeodeticLatitude(e.y*o),u=e.z;return n(r)?(r.longitude=a,r.latitude=i,r.height=u,r):new t(a,i,u)},s}),define("Scene/PrimitivePipeline",["../Core/BoundingSphere","../Core/Color","../Core/ComponentDatatype","../Core/defaultValue","../Core/defined","../Core/DeveloperError","../Core/Ellipsoid","../Core/FeatureDetection","../Core/GeographicProjection","../Core/Geometry","../Core/GeometryAttribute","../Core/GeometryAttributes","../Core/GeometryPipeline","../Core/IndexDatatype","../Core/Matrix4","../Core/WebMercatorProjection"],function(e,t,r,n,o,a,i,u,s,c,l,E,f,h,m,d){"use strict";function p(e,t,r){var n,o=!r,a=e.length;if(!o&&a>1){var i=e[0].modelMatrix;for(n=1;a>n;++n)if(!m.equals(i,e[n].modelMatrix)){o=!0;break}}if(o)for(n=0;a>n;++n)f.transformToWorldCoordinates(e[n]);else m.multiplyTransformation(t,e[0].modelMatrix,t)}function A(e,n){var o=e.attributes,a=o.position,i=4*(a.values.length/a.componentsPerAttribute);o.pickColor=new l({componentDatatype:r.UNSIGNED_BYTE,componentsPerAttribute:4,normalize:!0,values:new Uint8Array(i)});for(var u=t.floatToByte(n.red),s=t.floatToByte(n.green),c=t.floatToByte(n.blue),E=t.floatToByte(n.alpha),f=o.pickColor.values,h=0;i>h;h+=4)f[h]=u,f[h+1]=s,f[h+2]=c,f[h+3]=E}function T(e,t){for(var r=e.length,n=0;r>n;++n){var a=e[n],i=t[n];o(a.geometry)?A(a.geometry,i):(A(a.westHemisphereGeometry,i),A(a.eastHemisphereGeometry,i))}}function R(e){var t,r=e.length,n=[],a=e[0].attributes;for(t in a)if(a.hasOwnProperty(t)){for(var i=a[t],u=!0,s=1;r>s;++s){var c=e[s].attributes[t];if(!o(c)||i.componentDatatype!==c.componentDatatype||i.componentsPerAttribute!==c.componentsPerAttribute||i.normalize!==c.normalize){u=!1;break}}u&&n.push(t)}return n}function y(e,t,n){for(var o=c.computeNumberOfVertices(t),a=n.length,i=0;a>i;++i){for(var u=n[i],s=e[u],E=s.componentDatatype,f=s.value,h=s.componentsPerAttribute,m=r.createTypedArray(E,o*h),d=0;o>d;++d)m.set(f,d*h);t.attributes[u]=new l({componentDatatype:E,componentsPerAttribute:h,normalize:s.normalize,values:m})}}function _(e,t){for(var r=e.length,n=0;r>n;++n){var a=e[n],i=a.attributes;o(a.geometry)?y(i,a.geometry,t):(y(i,a.westHemisphereGeometry,t),y(i,a.eastHemisphereGeometry,t))}}function v(t){var n,a,i=t.instances,u=t.pickIds,s=t.projection,c=t.elementIndexUintSupported,l=t.scene3DOnly,E=t.allowPicking,h=t.vertexCacheOptimize,m=t.compressVertices,d=t.modelMatrix,A=i.length;i[0].geometry.primitiveType;if(p(i,d,l),!l)for(n=0;A>n;++n)f.splitLongitude(i[n]);E&&T(i,u);var y=R(i);if(_(i,y),h)for(n=0;A>n;++n){var v=i[n];o(v.geometry)?(f.reorderForPostVertexCache(v.geometry),f.reorderForPreVertexCache(v.geometry)):(f.reorderForPostVertexCache(v.westHemisphereGeometry),f.reorderForPreVertexCache(v.westHemisphereGeometry),f.reorderForPostVertexCache(v.eastHemisphereGeometry),f.reorderForPreVertexCache(v.eastHemisphereGeometry))}var S=f.combineInstances(i);for(A=S.length,n=0;A>n;++n){a=S[n];var g,C=a.attributes;if(l)for(g in C)C.hasOwnProperty(g)&&C[g].componentDatatype===r.DOUBLE&&f.encodeAttribute(a,g,g+"3DHigh",g+"3DLow");else for(g in C)if(C.hasOwnProperty(g)&&C[g].componentDatatype===r.DOUBLE){var N=g+"3D",I=g+"2D";f.projectTo2D(a,g,N,I,s),o(a.boundingSphere)&&"position"===g&&(a.boundingSphereCV=e.fromVertices(a.attributes.position2D.values)),f.encodeAttribute(a,N,N+"High",N+"Low"),f.encodeAttribute(a,I,I+"High",I+"Low")}m&&f.compressVertices(a)}if(!c){var M=[];for(A=S.length,n=0;A>n;++n)a=S[n],M=M.concat(f.fitToUnsignedShortIndices(a));S=M}return S}function S(e,t,n){for(var o=[],a=e.attributes,i=n.length,u=0;i>u;++u){var s=n[u],c=a[s],l=c.componentDatatype;l===r.DOUBLE&&(l=r.FLOAT);var E=r.createTypedArray(l,c.values);o.push({index:t[s],componentDatatype:l,componentsPerAttribute:c.componentsPerAttribute,normalize:c.normalize,values:E}),delete a[s]}return o}function g(e,t,r,a,i,u,s,l,E){var f=c.computeNumberOfVertices(t);o(s[e])||(s[e]={boundingSphere:t.boundingSphere,boundingSphereCV:t.boundingSphereCV});for(var h=a.length,m=0;h>m;++m)for(var d=a[m],p=i[d],A=f;A>0;){for(var T,R=n(E[d],0),y=u[R],_=y.length,v=0;_>v&&(T=y[v],T.index!==p);++v);o(s[e][d])||(s[e][d]={dirty:!1,valid:!0,value:r[d].value,indices:[]});var S,g=T.values.length/T.componentsPerAttribute,C=n(l[d],0);g>C+A?(S=A,s[e][d].indices.push({attribute:T,offset:C,count:S}),l[d]=C+A):(S=g-C,s[e][d].indices.push({attribute:T,offset:C,count:S}),l[d]=0,E[d]=R+1),A-=S}}function C(e,t,r,n,a){var i,u,s,c=[],l=e.length,E={},f={};for(i=0;l>i;++i)u=e[i],s=u.attributes,o(u.geometry)&&g(i,u.geometry,s,a,n,r,c,E,f);for(i=0;l>i;++i)u=e[i],s=u.attributes,o(u.westHemisphereGeometry)&&g(i,u.westHemisphereGeometry,s,a,n,r,c,E,f);for(i=0;l>i;++i)u=e[i],s=u.attributes,o(u.eastHemisphereGeometry)&&g(i,u.eastHemisphereGeometry,s,a,n,r,c,E,f);for(l=t.length,i=0;l>i;++i){u=t[i],s=u.attributes;var h={};c.push(h);for(var m=a.length,d=0;m>d;++d){var p=a[d];h[p]={dirty:!1,valid:!1,value:s[p].value,indices:[]}}}return c}function N(e,t,r,n){var a,i,u,s=n.length-1;if(s>=0){var c=n[s];a=c.offset+c.count,u=c.index,i=r[u].indices.length}else a=0,u=0,i=r[u].indices.length;for(var l=e.length,E=0;l>E;++E){var f=e[E],h=f[t];if(o(h)){var m=h.indices.length;a+m>i&&(a=0,i=r[++u].indices.length),n.push({index:u,offset:a,count:m}),a+=m}}}function I(e,t){var r=[];return N(e,"geometry",t,r),N(e,"westHemisphereGeometry",t,r),N(e,"eastHemisphereGeometry",t,r),r}function M(e,t){var r=e.attributes;for(var n in r)if(r.hasOwnProperty(n)){var a=r[n];o(a)&&o(a.values)&&t.push(a.values.buffer)}o(e.indices)&&t.push(e.indices.buffer)}function O(e,t){for(var r=e.length,n=0;r>n;++n)M(e[n],t)}function L(e,t){for(var r=e.length,n=0;r>n;++n)for(var o=e[n],a=o.length,i=0;a>i;++i)t.push(o[i].values.buffer)}function F(t){for(var r=1,n=t.length,a=0;n>a;a++){var i=t[a];if(++r,o(i)){var u=i.attributes;r+=6+2*e.packedLength+(o(i.indices)?i.indices.length:0);for(var s in u)if(u.hasOwnProperty(s)&&o(u[s])){var c=u[s];r+=5+c.values.length}}}return r}function P(e,t){for(var r=e.length,n=new Uint32Array(e.length),o=0;r>o;++o)n[o]=e[o].toRgba();return t.push(n.buffer),n}function w(e){for(var r=e.length,n=new Array(r),o=0;r>o;o++)n[o]=t.fromRgba(e[o]);return n}function b(e){for(var t=e.length,r=1+17*t,n=0;t>n;n++){var a=e[n].attributes;for(var i in a)if(a.hasOwnProperty(i)&&o(a[i])){var u=a[i];r+=5+u.value.length}}return r}function D(e,t){var r=new Float64Array(b(e)),n={},a=[],i=e.length,u=0;r[u++]=i;for(var s=0;i>s;s++){var c=e[s];m.pack(c.modelMatrix,r,u),u+=m.packedLength;var l=c.attributes,E=[];for(var f in l)l.hasOwnProperty(f)&&o(l[f])&&(E.push(f),o(n[f])||(n[f]=a.length,a.push(f)));r[u++]=E.length;for(var h=0;h<E.length;h++){var d=E[h],p=l[d];r[u++]=n[d],r[u++]=p.componentDatatype,r[u++]=p.componentsPerAttribute,r[u++]=p.normalize,r[u++]=p.value.length,r.set(p.value,u),u+=p.value.length}}return t.push(r.buffer),{stringTable:a,packedData:r}}function x(e){for(var t=e.packedData,n=e.stringTable,o=new Array(t[0]),a=0,i=1;i<t.length;){var u=m.unpack(t,i);i+=m.packedLength;for(var s={},c=t[i++],l=0;c>l;l++){for(var E=n[t[i++]],f=t[i++],h=t[i++],d=0!==t[i++],p=t[i++],A=r.createTypedArray(f,p),T=0;p>T;T++)A[T]=t[i++];s[E]={componentDatatype:f,componentsPerAttribute:h,normalize:d,value:A}}o[a++]={attributes:s,modelMatrix:u}}return o}function U(t){for(var r=t.length,n=1+r,a=0;r>a;a++){var i=t[a];n+=2,n+=o(i.boundingSphere)?e.packedLength:0,n+=o(i.boundingSphereCV)?e.packedLength:0;for(var u in i)if(i.hasOwnProperty(u)&&o(i[u])&&"boundingSphere"!==u&&"boundingSphereCV"!==u){var s=i[u];n+=4+3*s.indices.length+s.value.length}}return n}function B(t,r){var n=new Float64Array(U(t)),a=[],i=[],u={},s=t.length,c=0;n[c++]=s;for(var l=0;s>l;l++){var E=t[l],f=E.boundingSphere,h=o(f);n[c++]=h?1:0,h&&(e.pack(f,n,c),c+=e.packedLength),f=E.boundingSphereCV,h=o(f),n[c++]=h?1:0,h&&(e.pack(f,n,c),c+=e.packedLength);var m=[];for(var d in E)E.hasOwnProperty(d)&&o(E[d])&&"boundingSphere"!==d&&"boundingSphereCV"!==d&&(m.push(d),o(u[d])||(u[d]=a.length,a.push(d)));n[c++]=m.length;for(var p=0;p<m.length;p++){var A=m[p],T=E[A];n[c++]=u[A],n[c++]=T.valid?1:0;var R=T.indices,y=R.length;n[c++]=y;for(var _=0;y>_;_++){var v=R[_];n[c++]=v.count,n[c++]=v.offset;var S=i.indexOf(v.attribute);-1===S&&(S=i.length,i.push(v.attribute)),n[c++]=S}n[c++]=T.value.length,n.set(T.value,c),c+=T.value.length}}return r.push(n.buffer),{stringTable:a,packedData:n,attributeTable:i}}function G(t,n){for(var o=t.stringTable,a=t.attributeTable,i=t.packedData,u=new Array(i[0]),s=0,c=1,l=i.length;l>c;){var E={},f=1===i[c++];f&&(E.boundingSphere=e.unpack(i,c),c+=e.packedLength),f=1===i[c++],f&&(E.boundingSphereCV=e.unpack(i,c),c+=e.packedLength);for(var h=i[c++],m=0;h>m;m++){for(var d=o[i[c++]],p=1===i[c++],A=i[c++],T=A>0?new Array(A):void 0,R=0;A>R;R++){var y={};y.count=i[c++],y.offset=i[c++],y.attribute=a[i[c++]],T[R]=y}for(var _=i[c++],v=p?r.createTypedArray(T[0].attribute.componentDatatype,_):new Array(_),S=0;_>S;S++)v[S]=i[c++];E[d]={dirty:!1,valid:p,indices:T,value:v}}u[s++]=E}return u}if(!u.supportsTypedArrays())return{};var z={};return z.combineGeometry=function(e){var t,r,n,a,i,u=e.instances,s=e.invalidInstances;if(u.length>0){t=v(e),r=f.createAttributeLocations(t[0]),a=R(u),n=[],i=t.length;for(var c=0;i>c;++c){var l=t[c];n.push(S(l,r,a))}}a=o(a)?a:R(s);var E,h=C(u,s,n,r,a);return e.createPickOffsets&&o(t)&&(E=I(u,t)),{geometries:t,modelMatrix:e.modelMatrix,attributeLocations:r,vaAttributes:n,vaAttributeLocations:h,validInstancesIndices:e.validInstancesIndices,invalidInstancesIndices:e.invalidInstancesIndices,pickOffsets:E}},z.packCreateGeometryResults=function(t,r){var n=new Float64Array(F(t)),a=[],i={},u=t.length,s=0;n[s++]=u;for(var c=0;u>c;c++){var l=t[c],E=o(l);if(n[s++]=E?1:0,E){n[s++]=l.primitiveType,n[s++]=l.geometryType;var f=o(l.boundingSphere)?1:0;n[s++]=f,f&&e.pack(l.boundingSphere,n,s),s+=e.packedLength;var h=o(l.boundingSphereCV)?1:0;n[s++]=h,h&&e.pack(l.boundingSphereCV,n,s),s+=e.packedLength;var m=l.attributes,d=[];for(var p in m)m.hasOwnProperty(p)&&o(m[p])&&(d.push(p),o(i[p])||(i[p]=a.length,a.push(p)));n[s++]=d.length;for(var A=0;A<d.length;A++){var T=d[A],R=m[T];n[s++]=i[T],n[s++]=R.componentDatatype,n[s++]=R.componentsPerAttribute,n[s++]=R.normalize?1:0,n[s++]=R.values.length,n.set(R.values,s),s+=R.values.length}var y=o(l.indices)?l.indices.length:0;n[s++]=y,y>0&&(n.set(l.indices,s),s+=y)}}return r.push(n.buffer),{stringTable:a,packedData:n}},z.unpackCreateGeometryResults=function(t){for(var n,o=t.stringTable,a=t.packedData,i=new Array(a[0]),u=0,s=1;s<a.length;){var f=1===a[s++];if(f){var m,d,p=a[s++],A=a[s++],T=1===a[s++];T&&(m=e.unpack(a,s)),s+=e.packedLength;var R=1===a[s++];R&&(d=e.unpack(a,s)),s+=e.packedLength;var y,_,v,S=new E,g=a[s++];for(n=0;g>n;n++){var C=o[a[s++]],N=a[s++];v=a[s++];var I=0!==a[s++];y=a[s++],_=r.createTypedArray(N,y);for(var M=0;y>M;M++)_[M]=a[s++];S[C]=new l({componentDatatype:N,componentsPerAttribute:v,normalize:I,values:_})}var O;if(y=a[s++],y>0){var L=_.length/v;for(O=h.createTypedArray(L,y),n=0;y>n;n++)O[n]=a[s++]}i[u++]=new c({primitiveType:p,geometryType:A,boundingSphere:m,indices:O,attributes:S})}else i[u++]=void 0}return i},z.packCombineGeometryParameters=function(e,t){for(var r=e.createGeometryResults,n=r.length,o=0;n>o;o++)t.push(r[o].packedData.buffer);var a;return e.allowPicking&&(a=P(e.pickIds,t)),{createGeometryResults:e.createGeometryResults,packedInstances:D(e.instances,t),packedPickIds:a,ellipsoid:e.ellipsoid,isGeographic:e.projection instanceof s,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,allowPicking:e.allowPicking,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:e.modelMatrix,createPickOffsets:e.createPickOffsets}},z.unpackCombineGeometryParameters=function(e){for(var t=x(e.packedInstances),r=e.allowPicking,n=r?w(e.packedPickIds):void 0,a=e.createGeometryResults,u=a.length,c=0,l=[],E=[],f=[],h=[],p=[],A=0;u>A;A++)for(var T=z.unpackCreateGeometryResults(a[A]),R=T.length,y=0;R>y;y++){var _=T[y],v=t[c];o(_)?(v.geometry=_,l.push(v),f.push(c),r&&p.push(n[c])):(E.push(v),h.push(c)),++c}var S=i.clone(e.ellipsoid),g=e.isGeographic?new s(S):new d(S);return{instances:l,invalidInstances:E,validInstancesIndices:f,invalidInstancesIndices:h,pickIds:p,ellipsoid:S,projection:g,elementIndexUintSupported:e.elementIndexUintSupported,scene3DOnly:e.scene3DOnly,allowPicking:e.allowPicking,vertexCacheOptimize:e.vertexCacheOptimize,compressVertices:e.compressVertices,modelMatrix:m.clone(e.modelMatrix),createPickOffsets:e.createPickOffsets}},z.packCombineGeometryResults=function(e,t){return o(e.geometries)&&(O(e.geometries,t),L(e.vaAttributes,t)),{geometries:e.geometries,attributeLocations:e.attributeLocations,vaAttributes:e.vaAttributes,packedVaAttributeLocations:B(e.vaAttributeLocations,t),modelMatrix:e.modelMatrix,validInstancesIndices:e.validInstancesIndices,invalidInstancesIndices:e.invalidInstancesIndices,pickOffsets:e.pickOffsets}},z.unpackCombineGeometryResults=function(e){return{geometries:e.geometries,attributeLocations:e.attributeLocations,vaAttributes:e.vaAttributes,perInstanceAttributeLocations:G(e.packedVaAttributeLocations,e.vaAttributes),modelMatrix:e.modelMatrix,pickOffsets:e.pickOffsets}},z}),function(e){"use strict";e("ThirdParty/when",[],function(){function e(e,r,n,o){return t(e).then(r,n,o)}function t(e){var t,r;return e instanceof n?t=e:u(e)?(r=i(),e.then(function(e){r.resolve(e)},function(e){r.reject(e)},function(e){r.progress(e)}),t=r.promise):t=o(e),t}function r(t){return e(t,a)}function n(e){this.then=e}function o(e){var r=new n(function(r){try{return t(r?r(e):e)}catch(n){return a(n)}});return r}function a(e){var r=new n(function(r,n){try{return n?t(n(e)):a(e)}catch(o){return a(o)}});return r}function i(){function e(e,t,r){return f(e,t,r)}function r(e){return m(e)}function o(e){return m(a(e))}function u(e){return h(e)}var s,c,l,E,f,h,m;return c=new n(e),s={then:e,resolve:r,reject:o,progress:u,promise:c,resolver:{resolve:r,reject:o,progress:u}},l=[],E=[],f=function(e,t,r){var n,o;return n=i(),o="function"==typeof r?function(e){try{n.progress(r(e))}catch(t){n.progress(t)}}:function(e){n.progress(e)},l.push(function(r){r.then(e,t).then(n.resolve,n.reject,o)}),E.push(o),n.promise},h=function(e){return d(E,e),e},m=function(e){return e=t(e),f=e.then,m=t,h=A,d(l,e),E=l=_,e},s}function u(e){return e&&"function"==typeof e.then}function s(t,r,n,o,a){return p(2,arguments),e(t,function(t){function u(e){d(e)}function s(e){m(e)}var c,l,E,f,h,m,d,p,T,R;if(T=t.length>>>0,c=Math.max(0,Math.min(r,T)),E=[],l=T-c+1,f=[],h=i(),c)for(p=h.progress,d=function(e){f.push(e),--l||(m=d=A,h.reject(f))},m=function(e){E.push(e),--c||(m=d=A,h.resolve(E))},R=0;T>R;++R)R in t&&e(t[R],s,u,p);else h.resolve(E);return h.then(n,o,a)})}function c(e,t,r,n){function o(e){return t?t(e[0]):e[0]}return s(e,1,o,r,n)}function l(e,t,r,n){return p(1,arguments),f(e,T).then(t,r,n)}function E(){return f(arguments,T)}function f(t,r){return e(t,function(t){var n,o,a,u,s,c;if(a=o=t.length>>>0,n=[],c=i(),a)for(u=function(t,o){e(t,r).then(function(e){n[o]=e,--a||c.resolve(n)},c.reject)},s=0;o>s;s++)s in t?u(t[s],s):--a;else c.resolve(n);return c.promise})}function h(t,r){var n=y.call(arguments,1);return e(t,function(t){var o;return o=t.length,n[0]=function(t,n,a){return e(t,function(t){return e(n,function(e){return r(t,e,a,o)})})},R.apply(t,n)})}function m(t,r,n){var o=arguments.length>2;return e(t,function(e){return e=o?n:e,r.resolve(e),e},function(e){return r.reject(e),a(e)},r.progress)}function d(e,t){for(var r,n=0;r=e[n++];)r(t)}function p(e,t){for(var r,n=t.length;n>e;)if(r=t[--n],null!=r&&"function"!=typeof r)throw new Error("arg "+n+" must be a function")}function A(){}function T(e){return e}var R,y,_;return e.defer=i,e.resolve=t,e.reject=r,e.join=E,e.all=l,e.map=f,e.reduce=h,e.any=c,e.some=s,e.chain=m,e.isPromise=u,n.prototype={always:function(e,t){return this.then(e,e,t)},otherwise:function(e){return this.then(_,e)},"yield":function(e){return this.then(function(){return e})},spread:function(e){return this.then(function(t){return l(t,function(t){return e.apply(_,t)})})}},y=[].slice,R=[].reduce||function(e){var t,r,n,o,a;if(a=0,t=Object(this),o=t.length>>>0,r=arguments,r.length<=1)for(;;){if(a in t){n=t[a++];break}if(++a>=o)throw new TypeError}else n=r[1];for(;o>a;++a)a in t&&(n=e(n,t[a],a,t));return n},e})}("function"==typeof define&&define.amd?define:function(e){"object"==typeof exports?module.exports=e():this.when=e()}),define("Core/formatError",["./defined"],function(e){"use strict";function t(t){var r,n=t.name,o=t.message;r=e(n)&&e(o)?n+": "+o:t.toString();var a=t.stack;return e(a)&&(r+="\n"+a),r}return t}),define("Workers/createTaskProcessorWorker",["../Core/defaultValue","../Core/defined","../Core/formatError"],function(e,t,r){"use strict";function n(n){var o,a=[],i={id:void 0,result:void 0,error:void 0};return function(u){var s=u.data;a.length=0,i.id=s.id,i.error=void 0,i.result=void 0;try{i.result=n(s.parameters,a)}catch(c){c instanceof Error?i.error={name:c.name,message:c.message,stack:c.stack}:i.error=c}t(o)||(o=e(self.webkitPostMessage,self.postMessage)),s.canTransferArrayBuffer||(a.length=0);try{o(i,a)}catch(c){i.result=void 0,i.error="postMessage failed with error: "+r(c)+"\n  with responseMessage: "+JSON.stringify(i),o(i)}}}return n}),define("Workers/createGeometry",["../Core/defined","../Scene/PrimitivePipeline","../ThirdParty/when","./createTaskProcessorWorker","require"],function(e,t,r,n,o){"use strict";function a(t){var r=u[t];return e(r)||("object"==typeof exports?u[r]=r=o("Workers/"+t):o(["./"+t],function(e){r=e,u[r]=e})),r}function i(r,n){for(var o=r.subTasks,i=o.length,u=new Array(i),s=0;i>s;s++){var c=o[s],l=c.geometry,E=c.moduleName;if(e(E)){var f=a(E);u[s]=f(l,c.offset)}else u[s]=l}return t.packCreateGeometryResults(u,n)}var u={};return n(i)})}();