/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2015 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

!function(){define("Core/defined",[],function(){"use strict";function t(t){return void 0!==t&&null!==t}return t}),define("Core/freezeObject",["./defined"],function(t){"use strict";var e=Object.freeze;return t(e)||(e=function(t){return t}),e}),define("Core/defaultValue",["./freezeObject"],function(t){"use strict";function e(t,e){return void 0!==t?t:e}return e.EMPTY_OBJECT=t({}),e}),define("Core/DeveloperError",["./defined"],function(t){"use strict";function e(t){this.name="DeveloperError",this.message=t;var e;try{throw new Error}catch(r){e=r.stack}this.stack=e}return t(Object.create)&&(e.prototype=Object.create(Error.prototype),e.prototype.constructor=e),e.prototype.toString=function(){var e=this.name+": "+this.message;return t(this.stack)&&(e+="\n"+this.stack.toString()),e},e.throwInstantiationError=function(){throw new e("This function defines an interface and should not be called directly.")},e}),define("ThirdParty/mersenne-twister",[],function(){var t=function(t){void 0==t&&(t=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(t)};return t.prototype.init_genrand=function(t){for(this.mt[0]=t>>>0,this.mti=1;this.mti<this.N;this.mti++){var t=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&t)>>>16)<<16)+1812433253*(65535&t)+this.mti,this.mt[this.mti]>>>=0}},t.prototype.genrand_int32=function(){var t,e=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var r;for(this.mti==this.N+1&&this.init_genrand(5489),r=0;r<this.N-this.M;r++)t=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+this.M]^t>>>1^e[1&t];for(;r<this.N-1;r++)t=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+(this.M-this.N)]^t>>>1^e[1&t];t=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^t>>>1^e[1&t],this.mti=0}return t=this.mt[this.mti++],t^=t>>>11,t^=t<<7&2636928640,t^=t<<15&4022730752,t^=t>>>18,t>>>0},t.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},t}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(t,e,r,n){"use strict";var o={};o.EPSILON1=.1,o.EPSILON2=.01,o.EPSILON3=.001,o.EPSILON4=1e-4,o.EPSILON5=1e-5,o.EPSILON6=1e-6,o.EPSILON7=1e-7,o.EPSILON8=1e-8,o.EPSILON9=1e-9,o.EPSILON10=1e-10,o.EPSILON11=1e-11,o.EPSILON12=1e-12,o.EPSILON13=1e-13,o.EPSILON14=1e-14,o.EPSILON15=1e-15,o.EPSILON16=1e-16,o.EPSILON17=1e-17,o.EPSILON18=1e-18,o.EPSILON19=1e-19,o.EPSILON20=1e-20,o.GRAVITATIONALPARAMETER=3986004418e5,o.SOLAR_RADIUS=6955e5,o.LUNAR_RADIUS=1737400,o.SIXTY_FOUR_KILOBYTES=65536,o.sign=function(t){return t>0?1:0>t?-1:0},o.signNotZero=function(t){return 0>t?-1:1},o.toSNorm=function(t){return Math.round(255*(.5*o.clamp(t,-1,1)+.5))},o.fromSNorm=function(t){return o.clamp(t,0,255)/255*2-1},o.sinh=function(t){var e=Math.pow(Math.E,t),r=Math.pow(Math.E,-1*t);return.5*(e-r)},o.cosh=function(t){var e=Math.pow(Math.E,t),r=Math.pow(Math.E,-1*t);return.5*(e+r)},o.lerp=function(t,e,r){return(1-r)*t+r*e},o.PI=Math.PI,o.ONE_OVER_PI=1/Math.PI,o.PI_OVER_TWO=.5*Math.PI,o.PI_OVER_THREE=Math.PI/3,o.PI_OVER_FOUR=Math.PI/4,o.PI_OVER_SIX=Math.PI/6,o.THREE_PI_OVER_TWO=3*Math.PI*.5,o.TWO_PI=2*Math.PI,o.ONE_OVER_TWO_PI=1/(2*Math.PI),o.RADIANS_PER_DEGREE=Math.PI/180,o.DEGREES_PER_RADIAN=180/Math.PI,o.RADIANS_PER_ARCSECOND=o.RADIANS_PER_DEGREE/3600,o.toRadians=function(t){return t*o.RADIANS_PER_DEGREE},o.toDegrees=function(t){return t*o.DEGREES_PER_RADIAN},o.convertLongitudeRange=function(t){var e=o.TWO_PI,r=t-Math.floor(t/e)*e;return r<-Math.PI?r+e:r>=Math.PI?r-e:r},o.negativePiToPi=function(t){return o.zeroToTwoPi(t+o.PI)-o.PI},o.zeroToTwoPi=function(t){var e=o.mod(t,o.TWO_PI);return Math.abs(e)<o.EPSILON14&&Math.abs(t)>o.EPSILON14?o.TWO_PI:e},o.mod=function(t,e){return(t%e+e)%e},o.equalsEpsilon=function(t,r,n,o){o=e(o,n);var a=Math.abs(t-r);return o>=a||a<=n*Math.max(Math.abs(t),Math.abs(r))};var a=[1];o.factorial=function(t){var e=a.length;if(t>=e)for(var r=a[e-1],n=e;t>=n;n++)a.push(r*n);return a[t]},o.incrementWrap=function(t,r,n){return n=e(n,0),++t,t>r&&(t=n),t},o.isPowerOfTwo=function(t){return 0!==t&&0===(t&t-1)},o.nextPowerOfTwo=function(t){return--t,t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,t|=t>>16,++t,t},o.clamp=function(t,e,r){return e>t?e:t>r?r:t};var i=new t;return o.setRandomNumberSeed=function(e){i=new t(e)},o.nextRandomNumber=function(){return i.random()},o.acosClamped=function(t){return Math.acos(o.clamp(t,-1,1))},o.asinClamped=function(t){return Math.asin(o.clamp(t,-1,1))},o.chordLength=function(t,e){return 2*e*Math.sin(.5*t)},o.logBase=function(t,e){return Math.log(t)/Math.log(e)},o.fog=function(t,e){var r=t*e;return 1-Math.exp(-(r*r))},o}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,o){"use strict";function a(e,r,n){this.x=t(e,0),this.y=t(r,0),this.z=t(n,0)}a.fromSpherical=function(r,n){e(n)||(n=new a);var o=r.clock,i=r.cone,u=t(r.magnitude,1),s=u*Math.sin(i);return n.x=s*Math.cos(o),n.y=s*Math.sin(o),n.z=u*Math.cos(i),n},a.fromElements=function(t,r,n,o){return e(o)?(o.x=t,o.y=r,o.z=n,o):new a(t,r,n)},a.clone=function(t,r){return e(t)?e(r)?(r.x=t.x,r.y=t.y,r.z=t.z,r):new a(t.x,t.y,t.z):void 0},a.fromCartesian4=a.clone,a.packedLength=3,a.pack=function(e,r,n){n=t(n,0),r[n++]=e.x,r[n++]=e.y,r[n]=e.z},a.unpack=function(r,n,o){return n=t(n,0),e(o)||(o=new a),o.x=r[n++],o.y=r[n++],o.z=r[n],o},a.packArray=function(t,r){var n=t.length;e(r)?r.length=3*n:r=new Array(3*n);for(var o=0;n>o;++o)a.pack(t[o],r,3*o);return r},a.unpackArray=function(t,r){var n=t.length;e(r)?r.length=n/3:r=new Array(n/3);for(var o=0;n>o;o+=3){var i=o/3;r[i]=a.unpack(t,o,r[i])}return r},a.fromArray=a.unpack,a.maximumComponent=function(t){return Math.max(t.x,t.y,t.z)},a.minimumComponent=function(t){return Math.min(t.x,t.y,t.z)},a.minimumByComponent=function(t,e,r){return r.x=Math.min(t.x,e.x),r.y=Math.min(t.y,e.y),r.z=Math.min(t.z,e.z),r},a.maximumByComponent=function(t,e,r){return r.x=Math.max(t.x,e.x),r.y=Math.max(t.y,e.y),r.z=Math.max(t.z,e.z),r},a.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y+t.z*t.z},a.magnitude=function(t){return Math.sqrt(a.magnitudeSquared(t))};var i=new a;a.distance=function(t,e){return a.subtract(t,e,i),a.magnitude(i)},a.distanceSquared=function(t,e){return a.subtract(t,e,i),a.magnitudeSquared(i)},a.normalize=function(t,e){var r=a.magnitude(t);return e.x=t.x/r,e.y=t.y/r,e.z=t.z/r,e},a.dot=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},a.multiplyComponents=function(t,e,r){return r.x=t.x*e.x,r.y=t.y*e.y,r.z=t.z*e.z,r},a.add=function(t,e,r){return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},a.subtract=function(t,e,r){return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},a.multiplyByScalar=function(t,e,r){return r.x=t.x*e,r.y=t.y*e,r.z=t.z*e,r},a.divideByScalar=function(t,e,r){return r.x=t.x/e,r.y=t.y/e,r.z=t.z/e,r},a.negate=function(t,e){return e.x=-t.x,e.y=-t.y,e.z=-t.z,e},a.abs=function(t,e){return e.x=Math.abs(t.x),e.y=Math.abs(t.y),e.z=Math.abs(t.z),e};var u=new a;a.lerp=function(t,e,r,n){return a.multiplyByScalar(e,r,u),n=a.multiplyByScalar(t,1-r,n),a.add(u,n,n)};var s=new a,E=new a;a.angleBetween=function(t,e){a.normalize(t,s),a.normalize(e,E);var r=a.dot(s,E),n=a.magnitude(a.cross(s,E,s));return Math.atan2(n,r)};var l=new a;a.mostOrthogonalAxis=function(t,e){var r=a.normalize(t,l);return a.abs(r,r),e=r.x<=r.y?r.x<=r.z?a.clone(a.UNIT_X,e):a.clone(a.UNIT_Z,e):r.y<=r.z?a.clone(a.UNIT_Y,e):a.clone(a.UNIT_Z,e)},a.equals=function(t,r){return t===r||e(t)&&e(r)&&t.x===r.x&&t.y===r.y&&t.z===r.z},a.equalsArray=function(t,e,r){return t.x===e[r]&&t.y===e[r+1]&&t.z===e[r+2]},a.equalsEpsilon=function(t,r,n,a){return t===r||e(t)&&e(r)&&o.equalsEpsilon(t.x,r.x,n,a)&&o.equalsEpsilon(t.y,r.y,n,a)&&o.equalsEpsilon(t.z,r.z,n,a)},a.cross=function(t,e,r){var n=t.x,o=t.y,a=t.z,i=e.x,u=e.y,s=e.z,E=o*s-a*u,l=a*i-n*s,c=n*u-o*i;return r.x=E,r.y=l,r.z=c,r},a.fromDegrees=function(t,e,r,n,i){return t=o.toRadians(t),e=o.toRadians(e),a.fromRadians(t,e,r,n,i)};var c=new a,f=new a,_=new a(40680631590769,40680631590769,40408299984661.445);return a.fromRadians=function(r,n,o,i,u){o=t(o,0);var s=e(i)?i.radiiSquared:_,E=Math.cos(n);c.x=E*Math.cos(r),c.y=E*Math.sin(r),c.z=Math.sin(n),c=a.normalize(c,c),a.multiplyComponents(s,c,f);var l=Math.sqrt(a.dot(c,f));return f=a.divideByScalar(f,l,f),c=a.multiplyByScalar(c,o,c),e(u)||(u=new a),a.add(f,c,u)},a.fromDegreesArray=function(t,r,n){var o=t.length;e(n)?n.length=o/2:n=new Array(o/2);for(var i=0;o>i;i+=2){var u=t[i],s=t[i+1],E=i/2;n[E]=a.fromDegrees(u,s,0,r,n[E])}return n},a.fromRadiansArray=function(t,r,n){var o=t.length;e(n)?n.length=o/2:n=new Array(o/2);for(var i=0;o>i;i+=2){var u=t[i],s=t[i+1],E=i/2;n[E]=a.fromRadians(u,s,0,r,n[E])}return n},a.fromDegreesArrayHeights=function(t,r,n){var o=t.length;e(n)?n.length=o/3:n=new Array(o/3);for(var i=0;o>i;i+=3){var u=t[i],s=t[i+1],E=t[i+2],l=i/3;n[l]=a.fromDegrees(u,s,E,r,n[l])}return n},a.fromRadiansArrayHeights=function(t,r,n){var o=t.length;e(n)?n.length=o/3:n=new Array(o/3);for(var i=0;o>i;i+=3){var u=t[i],s=t[i+1],E=t[i+2],l=i/3;n[l]=a.fromRadians(u,s,E,r,n[l])}return n},a.ZERO=n(new a(0,0,0)),a.UNIT_X=n(new a(1,0,0)),a.UNIT_Y=n(new a(0,1,0)),a.UNIT_Z=n(new a(0,0,1)),a.prototype.clone=function(t){return a.clone(this,t)},a.prototype.equals=function(t){return a.equals(this,t)},a.prototype.equalsEpsilon=function(t,e,r){return a.equalsEpsilon(this,t,e,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},a}),define("Core/scaleToGeodeticSurface",["./Cartesian3","./defined","./DeveloperError","./Math"],function(t,e,r,n){"use strict";function o(r,o,u,s,E){var l=r.x,c=r.y,f=r.z,_=o.x,R=o.y,h=o.z,T=l*l*_*_,A=c*c*R*R,d=f*f*h*h,S=T+A+d,m=Math.sqrt(1/S),C=t.multiplyByScalar(r,m,a);if(s>S)return isFinite(m)?t.clone(C,E):void 0;var N=u.x,I=u.y,p=u.z,M=i;M.x=C.x*N*2,M.y=C.y*I*2,M.z=C.z*p*2;var O,g,y,F,L,v,D,U,P,w,B,x=(1-m)*t.magnitude(r)/(.5*t.magnitude(M)),G=0;do{x-=G,y=1/(1+x*N),F=1/(1+x*I),L=1/(1+x*p),v=y*y,D=F*F,U=L*L,P=v*y,w=D*F,B=U*L,O=T*v+A*D+d*U-1,g=T*P*N+A*w*I+d*B*p;var b=-2*g;G=O/b}while(Math.abs(O)>n.EPSILON12);return e(E)?(E.x=l*y,E.y=c*F,E.z=f*L,E):new t(l*y,c*F,f*L)}var a=new t,i=new t;return o}),define("Core/Cartographic",["./Cartesian3","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(t,e,r,n,o,a,i){"use strict";function u(t,r,n){this.longitude=e(t,0),this.latitude=e(r,0),this.height=e(n,0)}u.fromRadians=function(t,n,o,a){return o=e(o,0),r(a)?(a.longitude=t,a.latitude=n,a.height=o,a):new u(t,n,o)},u.fromDegrees=function(t,e,r,n){return t=a.toRadians(t),e=a.toRadians(e),u.fromRadians(t,e,r,n)};var s=new t,E=new t,l=new t,c=new t(1/6378137,1/6378137,1/6356752.314245179),f=new t(1/40680631590769,1/40680631590769,1/40408299984661.445),_=a.EPSILON1;return u.fromCartesian=function(e,n,o){var R=r(n)?n.oneOverRadii:c,h=r(n)?n.oneOverRadiiSquared:f,T=r(n)?n._centerToleranceSquared:_,A=i(e,R,h,T,E);if(r(A)){var d=t.multiplyComponents(e,h,s);d=t.normalize(d,d);var S=t.subtract(e,A,l),m=Math.atan2(d.y,d.x),C=Math.asin(d.z),N=a.sign(t.dot(S,e))*t.magnitude(S);return r(o)?(o.longitude=m,o.latitude=C,o.height=N,o):new u(m,C,N)}},u.clone=function(t,e){return r(t)?r(e)?(e.longitude=t.longitude,e.latitude=t.latitude,e.height=t.height,e):new u(t.longitude,t.latitude,t.height):void 0},u.equals=function(t,e){return t===e||r(t)&&r(e)&&t.longitude===e.longitude&&t.latitude===e.latitude&&t.height===e.height},u.equalsEpsilon=function(t,e,n){return t===e||r(t)&&r(e)&&Math.abs(t.longitude-e.longitude)<=n&&Math.abs(t.latitude-e.latitude)<=n&&Math.abs(t.height-e.height)<=n},u.ZERO=o(new u(0,0,0)),u.prototype.clone=function(t){return u.clone(this,t)},u.prototype.equals=function(t){return u.equals(this,t)},u.prototype.equalsEpsilon=function(t,e){return u.equalsEpsilon(this,t,e)},u.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},u}),define("Core/defineProperties",["./defined"],function(t){"use strict";var e=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(t){return!1}}(),r=Object.defineProperties;return e&&t(r)||(r=function(t){return t}),r}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./scaleToGeodeticSurface"],function(t,e,r,n,o,a,i,u,s){"use strict";function E(e,n,o,a){n=r(n,0),o=r(o,0),a=r(a,0),e._radii=new t(n,o,a),e._radiiSquared=new t(n*n,o*o,a*a),e._radiiToTheFourth=new t(n*n*n*n,o*o*o*o,a*a*a*a),e._oneOverRadii=new t(0===n?0:1/n,0===o?0:1/o,0===a?0:1/a),e._oneOverRadiiSquared=new t(0===n?0:1/(n*n),0===o?0:1/(o*o),0===a?0:1/(a*a)),e._minimumRadius=Math.min(n,o,a),e._maximumRadius=Math.max(n,o,a),e._centerToleranceSquared=u.EPSILON1}function l(t,e,r){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,E(this,t,e,r)}o(l.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),l.clone=function(e,r){if(n(e)){var o=e._radii;return n(r)?(t.clone(o,r._radii),t.clone(e._radiiSquared,r._radiiSquared),t.clone(e._radiiToTheFourth,r._radiiToTheFourth),t.clone(e._oneOverRadii,r._oneOverRadii),t.clone(e._oneOverRadiiSquared,r._oneOverRadiiSquared),r._minimumRadius=e._minimumRadius,r._maximumRadius=e._maximumRadius,r._centerToleranceSquared=e._centerToleranceSquared,r):new l(o.x,o.y,o.z)}},l.fromCartesian3=function(t,e){return n(e)||(e=new l),n(t)?(E(e,t.x,t.y,t.z),e):e},l.WGS84=i(new l(6378137,6378137,6356752.314245179)),l.UNIT_SPHERE=i(new l(1,1,1)),l.MOON=i(new l(u.LUNAR_RADIUS,u.LUNAR_RADIUS,u.LUNAR_RADIUS)),l.prototype.clone=function(t){return l.clone(this,t)},l.packedLength=t.packedLength,l.pack=function(e,n,o){o=r(o,0),t.pack(e._radii,n,o)},l.unpack=function(e,n,o){n=r(n,0);var a=t.unpack(e,n);return l.fromCartesian3(a,o)},l.prototype.geocentricSurfaceNormal=t.normalize,l.prototype.geodeticSurfaceNormalCartographic=function(e,r){var o=e.longitude,a=e.latitude,i=Math.cos(a),u=i*Math.cos(o),s=i*Math.sin(o),E=Math.sin(a);return n(r)||(r=new t),r.x=u,r.y=s,r.z=E,t.normalize(r,r)},l.prototype.geodeticSurfaceNormal=function(e,r){return n(r)||(r=new t),r=t.multiplyComponents(e,this._oneOverRadiiSquared,r),t.normalize(r,r)};var c=new t,f=new t;l.prototype.cartographicToCartesian=function(e,r){var o=c,a=f;this.geodeticSurfaceNormalCartographic(e,o),t.multiplyComponents(this._radiiSquared,o,a);var i=Math.sqrt(t.dot(o,a));return t.divideByScalar(a,i,a),t.multiplyByScalar(o,e.height,o),n(r)||(r=new t),t.add(a,o,r)},l.prototype.cartographicArrayToCartesianArray=function(t,e){var r=t.length;n(e)?e.length=r:e=new Array(r);for(var o=0;r>o;o++)e[o]=this.cartographicToCartesian(t[o],e[o]);return e};var _=new t,R=new t,h=new t;return l.prototype.cartesianToCartographic=function(r,o){var a=this.scaleToGeodeticSurface(r,R);if(n(a)){var i=this.geodeticSurfaceNormal(a,_),s=t.subtract(r,a,h),E=Math.atan2(i.y,i.x),l=Math.asin(i.z),c=u.sign(t.dot(s,r))*t.magnitude(s);return n(o)?(o.longitude=E,o.latitude=l,o.height=c,o):new e(E,l,c)}},l.prototype.cartesianArrayToCartographicArray=function(t,e){var r=t.length;n(e)?e.length=r:e=new Array(r);for(var o=0;r>o;++o)e[o]=this.cartesianToCartographic(t[o],e[o]);return e},l.prototype.scaleToGeodeticSurface=function(t,e){return s(t,this._oneOverRadii,this._oneOverRadiiSquared,this._centerToleranceSquared,e)},l.prototype.scaleToGeocentricSurface=function(e,r){n(r)||(r=new t);var o=e.x,a=e.y,i=e.z,u=this._oneOverRadiiSquared,s=1/Math.sqrt(o*o*u.x+a*a*u.y+i*i*u.z);return t.multiplyByScalar(e,s,r)},l.prototype.transformPositionToScaledSpace=function(e,r){return n(r)||(r=new t),t.multiplyComponents(e,this._oneOverRadii,r)},l.prototype.transformPositionFromScaledSpace=function(e,r){return n(r)||(r=new t),t.multiplyComponents(e,this._radii,r)},l.prototype.equals=function(e){return this===e||n(e)&&t.equals(this._radii,e._radii)},l.prototype.toString=function(){return this._radii.toString()},l}),define("Core/arrayRemoveDuplicates",["./defaultValue","./defined","./DeveloperError","./Math"],function(t,e,r,n){"use strict";function o(r,n,o){if(e(r)){o=t(o,!1);var i=r.length;if(2>i)return r;var u,s,E;for(u=1;i>u&&(s=r[u-1],E=r[u],!n(s,E,a));++u);if(u===i)return o&&n(r[0],r[r.length-1],a)?r.slice(1):r;for(var l=r.slice(0,u);i>u;++u)E=r[u],n(s,E,a)||(l.push(E),s=E);return o&&l.length>1&&n(l[0],l[l.length-1],a)&&l.shift(),l}}var a=n.EPSILON10;return o}),define("Core/GeographicProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid"],function(t,e,r,n,o,a,i){"use strict";function u(t){this._ellipsoid=r(t,i.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis}return o(u.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),u.prototype.project=function(e,r){var o=this._semimajorAxis,a=e.longitude*o,i=e.latitude*o,u=e.height;return n(r)?(r.x=a,r.y=i,r.z=u,r):new t(a,i,u)},u.prototype.unproject=function(t,r){var o=this._oneOverSemimajorAxis,a=t.x*o,i=t.y*o,u=t.z;return n(r)?(r.longitude=a,r.latitude=i,r.height=u,r):new e(a,i,u)},u}),define("Core/Intersect",["./freezeObject"],function(t){"use strict";var e={OUTSIDE:-1,INTERSECTING:0,INSIDE:1};return t(e)}),define("Core/Interval",["./defaultValue"],function(t){"use strict";function e(e,r){this.start=t(e,0),this.stop=t(r,0)}return e}),define("Core/Matrix3",["./Cartesian3","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,o,a,i){"use strict";function u(t,r,n,o,a,i,u,s,E){this[0]=e(t,0),this[1]=e(o,0),this[2]=e(u,0),this[3]=e(r,0),this[4]=e(a,0),this[5]=e(s,0),this[6]=e(n,0),this[7]=e(i,0),this[8]=e(E,0)}function s(t){for(var e=0,r=0;9>r;++r){var n=t[r];e+=n*n}return Math.sqrt(e)}function E(t){for(var e=0,r=0;3>r;++r){var n=t[u.getElementIndex(R[r],_[r])];e+=2*n*n}return Math.sqrt(e)}function l(t,e){for(var r=i.EPSILON15,n=0,o=1,a=0;3>a;++a){var s=Math.abs(t[u.getElementIndex(R[a],_[a])]);s>n&&(o=a,n=s)}var E=1,l=0,c=_[o],f=R[o];if(Math.abs(t[u.getElementIndex(f,c)])>r){var h,T=t[u.getElementIndex(f,f)],A=t[u.getElementIndex(c,c)],d=t[u.getElementIndex(f,c)],S=(T-A)/2/d;h=0>S?-1/(-S+Math.sqrt(1+S*S)):1/(S+Math.sqrt(1+S*S)),E=1/Math.sqrt(1+h*h),l=h*E}return e=u.clone(u.IDENTITY,e),e[u.getElementIndex(c,c)]=e[u.getElementIndex(f,f)]=E,e[u.getElementIndex(f,c)]=l,e[u.getElementIndex(c,f)]=-l,e}u.packedLength=9,u.pack=function(t,r,n){n=e(n,0),r[n++]=t[0],r[n++]=t[1],r[n++]=t[2],r[n++]=t[3],r[n++]=t[4],r[n++]=t[5],r[n++]=t[6],r[n++]=t[7],r[n++]=t[8]},u.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new u),o[0]=t[n++],o[1]=t[n++],o[2]=t[n++],o[3]=t[n++],o[4]=t[n++],o[5]=t[n++],o[6]=t[n++],o[7]=t[n++],o[8]=t[n++],o},u.clone=function(t,e){return r(t)?r(e)?(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e):new u(t[0],t[3],t[6],t[1],t[4],t[7],t[2],t[5],t[8]):void 0},u.fromArray=function(t,n,o){return n=e(n,0),r(o)||(o=new u),o[0]=t[n],o[1]=t[n+1],o[2]=t[n+2],o[3]=t[n+3],o[4]=t[n+4],o[5]=t[n+5],o[6]=t[n+6],o[7]=t[n+7],o[8]=t[n+8],o},u.fromColumnMajorArray=function(t,e){return u.clone(t,e)},u.fromRowMajorArray=function(t,e){return r(e)?(e[0]=t[0],e[1]=t[3],e[2]=t[6],e[3]=t[1],e[4]=t[4],e[5]=t[7],e[6]=t[2],e[7]=t[5],e[8]=t[8],e):new u(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},u.fromQuaternion=function(t,e){var n=t.x*t.x,o=t.x*t.y,a=t.x*t.z,i=t.x*t.w,s=t.y*t.y,E=t.y*t.z,l=t.y*t.w,c=t.z*t.z,f=t.z*t.w,_=t.w*t.w,R=n-s-c+_,h=2*(o-f),T=2*(a+l),A=2*(o+f),d=-n+s-c+_,S=2*(E-i),m=2*(a-l),C=2*(E+i),N=-n-s+c+_;return r(e)?(e[0]=R,e[1]=A,e[2]=m,e[3]=h,e[4]=d,e[5]=C,e[6]=T,e[7]=S,e[8]=N,e):new u(R,h,T,A,d,S,m,C,N)},u.fromScale=function(t,e){return r(e)?(e[0]=t.x,e[1]=0,e[2]=0,e[3]=0,e[4]=t.y,e[5]=0,e[6]=0,e[7]=0,e[8]=t.z,e):new u(t.x,0,0,0,t.y,0,0,0,t.z)},u.fromUniformScale=function(t,e){return r(e)?(e[0]=t,e[1]=0,e[2]=0,e[3]=0,e[4]=t,e[5]=0,e[6]=0,e[7]=0,e[8]=t,e):new u(t,0,0,0,t,0,0,0,t)},u.fromCrossProduct=function(t,e){return r(e)?(e[0]=0,e[1]=t.z,e[2]=-t.y,e[3]=-t.z,e[4]=0,e[5]=t.x,e[6]=t.y,e[7]=-t.x,e[8]=0,e):new u(0,-t.z,t.y,t.z,0,-t.x,-t.y,t.x,0)},u.fromRotationX=function(t,e){var n=Math.cos(t),o=Math.sin(t);return r(e)?(e[0]=1,e[1]=0,e[2]=0,e[3]=0,e[4]=n,e[5]=o,e[6]=0,e[7]=-o,e[8]=n,e):new u(1,0,0,0,n,-o,0,o,n)},u.fromRotationY=function(t,e){var n=Math.cos(t),o=Math.sin(t);return r(e)?(e[0]=n,e[1]=0,e[2]=-o,e[3]=0,e[4]=1,e[5]=0,e[6]=o,e[7]=0,e[8]=n,e):new u(n,0,o,0,1,0,-o,0,n)},u.fromRotationZ=function(t,e){var n=Math.cos(t),o=Math.sin(t);return r(e)?(e[0]=n,e[1]=o,e[2]=0,e[3]=-o,e[4]=n,e[5]=0,e[6]=0,e[7]=0,e[8]=1,e):new u(n,-o,0,o,n,0,0,0,1)},u.toArray=function(t,e){return r(e)?(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e):[t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8]]},u.getElementIndex=function(t,e){return 3*t+e},u.getColumn=function(t,e,r){var n=3*e,o=t[n],a=t[n+1],i=t[n+2];return r.x=o,r.y=a,r.z=i,r},u.setColumn=function(t,e,r,n){n=u.clone(t,n);var o=3*e;return n[o]=r.x,n[o+1]=r.y,n[o+2]=r.z,n},u.getRow=function(t,e,r){var n=t[e],o=t[e+3],a=t[e+6];return r.x=n,r.y=o,r.z=a,r},u.setRow=function(t,e,r,n){return n=u.clone(t,n),n[e]=r.x,n[e+3]=r.y,n[e+6]=r.z,n};var c=new t;u.getScale=function(e,r){return r.x=t.magnitude(t.fromElements(e[0],e[1],e[2],c)),r.y=t.magnitude(t.fromElements(e[3],e[4],e[5],c)),r.z=t.magnitude(t.fromElements(e[6],e[7],e[8],c)),r};var f=new t;u.getMaximumScale=function(e){return u.getScale(e,f),t.maximumComponent(f)},u.multiply=function(t,e,r){var n=t[0]*e[0]+t[3]*e[1]+t[6]*e[2],o=t[1]*e[0]+t[4]*e[1]+t[7]*e[2],a=t[2]*e[0]+t[5]*e[1]+t[8]*e[2],i=t[0]*e[3]+t[3]*e[4]+t[6]*e[5],u=t[1]*e[3]+t[4]*e[4]+t[7]*e[5],s=t[2]*e[3]+t[5]*e[4]+t[8]*e[5],E=t[0]*e[6]+t[3]*e[7]+t[6]*e[8],l=t[1]*e[6]+t[4]*e[7]+t[7]*e[8],c=t[2]*e[6]+t[5]*e[7]+t[8]*e[8];return r[0]=n,r[1]=o,r[2]=a,r[3]=i,r[4]=u,r[5]=s,r[6]=E,r[7]=l,r[8]=c,r},u.add=function(t,e,r){return r[0]=t[0]+e[0],r[1]=t[1]+e[1],r[2]=t[2]+e[2],r[3]=t[3]+e[3],r[4]=t[4]+e[4],r[5]=t[5]+e[5],r[6]=t[6]+e[6],r[7]=t[7]+e[7],r[8]=t[8]+e[8],r},u.subtract=function(t,e,r){return r[0]=t[0]-e[0],r[1]=t[1]-e[1],r[2]=t[2]-e[2],r[3]=t[3]-e[3],r[4]=t[4]-e[4],r[5]=t[5]-e[5],r[6]=t[6]-e[6],r[7]=t[7]-e[7],r[8]=t[8]-e[8],r},u.multiplyByVector=function(t,e,r){var n=e.x,o=e.y,a=e.z,i=t[0]*n+t[3]*o+t[6]*a,u=t[1]*n+t[4]*o+t[7]*a,s=t[2]*n+t[5]*o+t[8]*a;return r.x=i,r.y=u,r.z=s,r},u.multiplyByScalar=function(t,e,r){return r[0]=t[0]*e,r[1]=t[1]*e,r[2]=t[2]*e,r[3]=t[3]*e,r[4]=t[4]*e,r[5]=t[5]*e,r[6]=t[6]*e,r[7]=t[7]*e,r[8]=t[8]*e,r},u.multiplyByScale=function(t,e,r){return r[0]=t[0]*e.x,r[1]=t[1]*e.x,r[2]=t[2]*e.x,r[3]=t[3]*e.y,r[4]=t[4]*e.y,r[5]=t[5]*e.y,r[6]=t[6]*e.z,r[7]=t[7]*e.z,r[8]=t[8]*e.z,r},u.negate=function(t,e){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e[4]=-t[4],e[5]=-t[5],e[6]=-t[6],e[7]=-t[7],e[8]=-t[8],e},u.transpose=function(t,e){var r=t[0],n=t[3],o=t[6],a=t[1],i=t[4],u=t[7],s=t[2],E=t[5],l=t[8];return e[0]=r,e[1]=n,e[2]=o,e[3]=a,e[4]=i,e[5]=u,e[6]=s,e[7]=E,e[8]=l,e};var _=[1,0,0],R=[2,2,1],h=new u,T=new u;return u.computeEigenDecomposition=function(t,e){var n=i.EPSILON20,o=10,a=0,c=0;r(e)||(e={});for(var f=e.unitary=u.clone(u.IDENTITY,e.unitary),_=e.diagonal=u.clone(t,e.diagonal),R=n*s(_);o>c&&E(_)>R;)l(_,h),u.transpose(h,T),u.multiply(_,h,_),u.multiply(T,_,_),u.multiply(f,h,f),++a>2&&(++c,a=0);return e},u.abs=function(t,e){return e[0]=Math.abs(t[0]),e[1]=Math.abs(t[1]),e[2]=Math.abs(t[2]),e[3]=Math.abs(t[3]),e[4]=Math.abs(t[4]),e[5]=Math.abs(t[5]),e[6]=Math.abs(t[6]),e[7]=Math.abs(t[7]),e[8]=Math.abs(t[8]),e},u.determinant=function(t){var e=t[0],r=t[3],n=t[6],o=t[1],a=t[4],i=t[7],u=t[2],s=t[5],E=t[8];return e*(a*E-s*i)+o*(s*n-r*E)+u*(r*i-a*n)},u.inverse=function(t,e){var r=t[0],n=t[1],a=t[2],s=t[3],E=t[4],l=t[5],c=t[6],f=t[7],_=t[8],R=u.determinant(t);if(Math.abs(R)<=i.EPSILON15)throw new o("matrix is not invertible");e[0]=E*_-f*l,e[1]=f*a-n*_,e[2]=n*l-E*a,e[3]=c*l-s*_,e[4]=r*_-c*a,e[5]=s*a-r*l,e[6]=s*f-c*E,e[7]=c*n-r*f,e[8]=r*E-s*n;var h=1/R;return u.multiplyByScalar(e,h,e)},u.equals=function(t,e){return t===e||r(t)&&r(e)&&t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]},u.equalsEpsilon=function(t,e,n){return t===e||r(t)&&r(e)&&Math.abs(t[0]-e[0])<=n&&Math.abs(t[1]-e[1])<=n&&Math.abs(t[2]-e[2])<=n&&Math.abs(t[3]-e[3])<=n&&Math.abs(t[4]-e[4])<=n&&Math.abs(t[5]-e[5])<=n&&Math.abs(t[6]-e[6])<=n&&Math.abs(t[7]-e[7])<=n&&Math.abs(t[8]-e[8])<=n},u.IDENTITY=a(new u(1,0,0,0,1,0,0,0,1)),u.ZERO=a(new u(0,0,0,0,0,0,0,0,0)),u.COLUMN0ROW0=0,u.COLUMN0ROW1=1,u.COLUMN0ROW2=2,u.COLUMN1ROW0=3,u.COLUMN1ROW1=4,u.COLUMN1ROW2=5,u.COLUMN2ROW0=6,u.COLUMN2ROW1=7,u.COLUMN2ROW2=8,n(u.prototype,{length:{get:function(){return u.packedLength}}}),u.prototype.clone=function(t){return u.clone(this,t)},u.prototype.equals=function(t){return u.equals(this,t)},u.equalsArray=function(t,e,r){return t[0]===e[r]&&t[1]===e[r+1]&&t[2]===e[r+2]&&t[3]===e[r+3]&&t[4]===e[r+4]&&t[5]===e[r+5]&&t[6]===e[r+6]&&t[7]===e[r+7]&&t[8]===e[r+8]},u.prototype.equalsEpsilon=function(t,e){return u.equalsEpsilon(this,t,e)},u.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n("+this[1]+", "+this[4]+", "+this[7]+")\n("+this[2]+", "+this[5]+", "+this[8]+")"},u}),define("Core/Cartesian4",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,o){"use strict";function a(e,r,n,o){this.x=t(e,0),this.y=t(r,0),this.z=t(n,0),this.w=t(o,0)}a.fromElements=function(t,r,n,o,i){return e(i)?(i.x=t,i.y=r,i.z=n,i.w=o,i):new a(t,r,n,o)},a.fromColor=function(t,r){return e(r)?(r.x=t.red,r.y=t.green,r.z=t.blue,r.w=t.alpha,r):new a(t.red,t.green,t.blue,t.alpha)},a.clone=function(t,r){return e(t)?e(r)?(r.x=t.x,r.y=t.y,r.z=t.z,r.w=t.w,r):new a(t.x,t.y,t.z,t.w):void 0},a.packedLength=4,a.pack=function(e,r,n){n=t(n,0),r[n++]=e.x,r[n++]=e.y,r[n++]=e.z,r[n]=e.w},a.unpack=function(r,n,o){return n=t(n,0),e(o)||(o=new a),o.x=r[n++],o.y=r[n++],o.z=r[n++],o.w=r[n],o},a.packArray=function(t,r){var n=t.length;e(r)?r.length=4*n:r=new Array(4*n);for(var o=0;n>o;++o)a.pack(t[o],r,4*o);return r},a.unpackArray=function(t,r){var n=t.length;e(r)?r.length=n/4:r=new Array(n/4);for(var o=0;n>o;o+=4){var i=o/4;r[i]=a.unpack(t,o,r[i])}return r},a.fromArray=a.unpack,a.maximumComponent=function(t){return Math.max(t.x,t.y,t.z,t.w)},a.minimumComponent=function(t){return Math.min(t.x,t.y,t.z,t.w)},a.minimumByComponent=function(t,e,r){return r.x=Math.min(t.x,e.x),r.y=Math.min(t.y,e.y),r.z=Math.min(t.z,e.z),r.w=Math.min(t.w,e.w),r},a.maximumByComponent=function(t,e,r){return r.x=Math.max(t.x,e.x),r.y=Math.max(t.y,e.y),r.z=Math.max(t.z,e.z),r.w=Math.max(t.w,e.w),r},a.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y+t.z*t.z+t.w*t.w},a.magnitude=function(t){return Math.sqrt(a.magnitudeSquared(t))};var i=new a;a.distance=function(t,e){return a.subtract(t,e,i),a.magnitude(i)},a.distanceSquared=function(t,e){return a.subtract(t,e,i),a.magnitudeSquared(i)},a.normalize=function(t,e){var r=a.magnitude(t);return e.x=t.x/r,e.y=t.y/r,e.z=t.z/r,e.w=t.w/r,e},a.dot=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z+t.w*e.w},a.multiplyComponents=function(t,e,r){return r.x=t.x*e.x,r.y=t.y*e.y,r.z=t.z*e.z,r.w=t.w*e.w,r},a.add=function(t,e,r){return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r.w=t.w+e.w,r},a.subtract=function(t,e,r){return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r.w=t.w-e.w,r},a.multiplyByScalar=function(t,e,r){return r.x=t.x*e,r.y=t.y*e,r.z=t.z*e,r.w=t.w*e,r},a.divideByScalar=function(t,e,r){return r.x=t.x/e,r.y=t.y/e,r.z=t.z/e,r.w=t.w/e,r},a.negate=function(t,e){return e.x=-t.x,e.y=-t.y,e.z=-t.z,e.w=-t.w,e},a.abs=function(t,e){return e.x=Math.abs(t.x),e.y=Math.abs(t.y),e.z=Math.abs(t.z),e.w=Math.abs(t.w),e};var u=new a;a.lerp=function(t,e,r,n){return a.multiplyByScalar(e,r,u),n=a.multiplyByScalar(t,1-r,n),a.add(u,n,n)};var s=new a;return a.mostOrthogonalAxis=function(t,e){var r=a.normalize(t,s);return a.abs(r,r),e=r.x<=r.y?r.x<=r.z?r.x<=r.w?a.clone(a.UNIT_X,e):a.clone(a.UNIT_W,e):r.z<=r.w?a.clone(a.UNIT_Z,e):a.clone(a.UNIT_W,e):r.y<=r.z?r.y<=r.w?a.clone(a.UNIT_Y,e):a.clone(a.UNIT_W,e):r.z<=r.w?a.clone(a.UNIT_Z,e):a.clone(a.UNIT_W,e)},a.equals=function(t,r){return t===r||e(t)&&e(r)&&t.x===r.x&&t.y===r.y&&t.z===r.z&&t.w===r.w},a.equalsArray=function(t,e,r){return t.x===e[r]&&t.y===e[r+1]&&t.z===e[r+2]&&t.w===e[r+3]},a.equalsEpsilon=function(t,r,n,a){return t===r||e(t)&&e(r)&&o.equalsEpsilon(t.x,r.x,n,a)&&o.equalsEpsilon(t.y,r.y,n,a)&&o.equalsEpsilon(t.z,r.z,n,a)&&o.equalsEpsilon(t.w,r.w,n,a)},a.ZERO=n(new a(0,0,0,0)),a.UNIT_X=n(new a(1,0,0,0)),a.UNIT_Y=n(new a(0,1,0,0)),a.UNIT_Z=n(new a(0,0,1,0)),a.UNIT_W=n(new a(0,0,0,1)),a.prototype.clone=function(t){return a.clone(this,t)},a.prototype.equals=function(t){return a.equals(this,t)},a.prototype.equalsEpsilon=function(t,e,r){return a.equalsEpsilon(this,t,e,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"},a}),define("Core/RuntimeError",["./defined"],function(t){"use strict";function e(t){this.name="RuntimeError",this.message=t;var e;try{throw new Error}catch(r){e=r.stack}this.stack=e}return t(Object.create)&&(e.prototype=Object.create(Error.prototype),e.prototype.constructor=e),e.prototype.toString=function(){var e=this.name+": "+this.message;return t(this.stack)&&(e+="\n"+this.stack.toString()),e},e}),define("Core/Matrix4",["./Cartesian3","./Cartesian4","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math","./Matrix3","./RuntimeError"],function(t,e,r,n,o,a,i,u,s,E){"use strict";function l(t,e,n,o,a,i,u,s,E,l,c,f,_,R,h,T){this[0]=r(t,0),this[1]=r(a,0),this[2]=r(E,0),this[3]=r(_,0),this[4]=r(e,0),this[5]=r(i,0),this[6]=r(l,0),this[7]=r(R,0),this[8]=r(n,0),this[9]=r(u,0),this[10]=r(c,0),this[11]=r(h,0),this[12]=r(o,0),this[13]=r(s,0),this[14]=r(f,0),this[15]=r(T,0)}l.packedLength=16,l.pack=function(t,e,n){n=r(n,0),e[n++]=t[0],e[n++]=t[1],e[n++]=t[2],e[n++]=t[3],e[n++]=t[4],e[n++]=t[5],e[n++]=t[6],e[n++]=t[7],e[n++]=t[8],e[n++]=t[9],e[n++]=t[10],e[n++]=t[11],e[n++]=t[12],e[n++]=t[13],e[n++]=t[14],e[n]=t[15]},l.unpack=function(t,e,o){return e=r(e,0),n(o)||(o=new l),o[0]=t[e++],o[1]=t[e++],o[2]=t[e++],o[3]=t[e++],o[4]=t[e++],o[5]=t[e++],o[6]=t[e++],o[7]=t[e++],o[8]=t[e++],o[9]=t[e++],o[10]=t[e++],o[11]=t[e++],o[12]=t[e++],o[13]=t[e++],o[14]=t[e++],o[15]=t[e],o},l.clone=function(t,e){return n(t)?n(e)?(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e):new l(t[0],t[4],t[8],t[12],t[1],t[5],t[9],t[13],t[2],t[6],t[10],t[14],t[3],t[7],t[11],t[15]):void 0},l.fromArray=l.unpack,l.fromColumnMajorArray=function(t,e){return l.clone(t,e)},l.fromRowMajorArray=function(t,e){return n(e)?(e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=t[1],e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=t[2],e[9]=t[6],e[10]=t[10],e[11]=t[14],e[12]=t[3],e[13]=t[7],e[14]=t[11],e[15]=t[15],e):new l(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},l.fromRotationTranslation=function(e,o,a){return o=r(o,t.ZERO),n(a)?(a[0]=e[0],a[1]=e[1],a[2]=e[2],a[3]=0,a[4]=e[3],a[5]=e[4],a[6]=e[5],a[7]=0,a[8]=e[6],a[9]=e[7],a[10]=e[8],a[11]=0,a[12]=o.x,a[13]=o.y,a[14]=o.z,a[15]=1,a):new l(e[0],e[3],e[6],o.x,e[1],e[4],e[7],o.y,e[2],e[5],e[8],o.z,0,0,0,1);
},l.fromTranslationQuaternionRotationScale=function(t,e,r,o){n(o)||(o=new l);var a=r.x,i=r.y,u=r.z,s=e.x*e.x,E=e.x*e.y,c=e.x*e.z,f=e.x*e.w,_=e.y*e.y,R=e.y*e.z,h=e.y*e.w,T=e.z*e.z,A=e.z*e.w,d=e.w*e.w,S=s-_-T+d,m=2*(E-A),C=2*(c+h),N=2*(E+A),I=-s+_-T+d,p=2*(R-f),M=2*(c-h),O=2*(R+f),g=-s-_+T+d;return o[0]=S*a,o[1]=N*a,o[2]=M*a,o[3]=0,o[4]=m*i,o[5]=I*i,o[6]=O*i,o[7]=0,o[8]=C*u,o[9]=p*u,o[10]=g*u,o[11]=0,o[12]=t.x,o[13]=t.y,o[14]=t.z,o[15]=1,o},l.fromTranslationRotationScale=function(t,e){return l.fromTranslationQuaternionRotationScale(t.translation,t.rotation,t.scale,e)},l.fromTranslation=function(t,e){return l.fromRotationTranslation(s.IDENTITY,t,e)},l.fromScale=function(t,e){return n(e)?(e[0]=t.x,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t.y,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t.z,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e):new l(t.x,0,0,0,0,t.y,0,0,0,0,t.z,0,0,0,0,1)},l.fromUniformScale=function(t,e){return n(e)?(e[0]=t,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=t,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=t,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,e):new l(t,0,0,0,0,t,0,0,0,0,t,0,0,0,0,1)};var c=new t,f=new t,_=new t;l.fromCamera=function(e,r){var o=e.position,a=e.direction,i=e.up;t.normalize(a,c),t.normalize(t.cross(c,i,f),f),t.normalize(t.cross(f,c,_),_);var u=f.x,s=f.y,E=f.z,R=c.x,h=c.y,T=c.z,A=_.x,d=_.y,S=_.z,m=o.x,C=o.y,N=o.z,I=u*-m+s*-C+E*-N,p=A*-m+d*-C+S*-N,M=R*m+h*C+T*N;return n(r)?(r[0]=u,r[1]=A,r[2]=-R,r[3]=0,r[4]=s,r[5]=d,r[6]=-h,r[7]=0,r[8]=E,r[9]=S,r[10]=-T,r[11]=0,r[12]=I,r[13]=p,r[14]=M,r[15]=1,r):new l(u,s,E,I,A,d,S,p,-R,-h,-T,M,0,0,0,1)},l.computePerspectiveFieldOfView=function(t,e,r,n,o){var a=Math.tan(.5*t),i=1/a,u=i/e,s=(n+r)/(r-n),E=2*n*r/(r-n);return o[0]=u,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=i,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=s,o[11]=-1,o[12]=0,o[13]=0,o[14]=E,o[15]=0,o},l.computeOrthographicOffCenter=function(t,e,r,n,o,a,i){var u=1/(e-t),s=1/(n-r),E=1/(a-o),l=-(e+t)*u,c=-(n+r)*s,f=-(a+o)*E;return u*=2,s*=2,E*=-2,i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=0,i[9]=0,i[10]=E,i[11]=0,i[12]=l,i[13]=c,i[14]=f,i[15]=1,i},l.computePerspectiveOffCenter=function(t,e,r,n,o,a,i){var u=2*o/(e-t),s=2*o/(n-r),E=(e+t)/(e-t),l=(n+r)/(n-r),c=-(a+o)/(a-o),f=-1,_=-2*a*o/(a-o);return i[0]=u,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=E,i[9]=l,i[10]=c,i[11]=f,i[12]=0,i[13]=0,i[14]=_,i[15]=0,i},l.computeInfinitePerspectiveOffCenter=function(t,e,r,n,o,a){var i=2*o/(e-t),u=2*o/(n-r),s=(e+t)/(e-t),E=(n+r)/(n-r),l=-1,c=-1,f=-2*o;return a[0]=i,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=u,a[6]=0,a[7]=0,a[8]=s,a[9]=E,a[10]=l,a[11]=c,a[12]=0,a[13]=0,a[14]=f,a[15]=0,a},l.computeViewportTransformation=function(t,e,n,o){t=r(t,r.EMPTY_OBJECT);var a=r(t.x,0),i=r(t.y,0),u=r(t.width,0),s=r(t.height,0);e=r(e,0),n=r(n,1);var E=.5*u,l=.5*s,c=.5*(n-e),f=E,_=l,R=c,h=a+E,T=i+l,A=e+c,d=1;return o[0]=f,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=_,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=R,o[11]=0,o[12]=h,o[13]=T,o[14]=A,o[15]=d,o},l.computeView=function(e,r,n,o,a){return a[0]=o.x,a[1]=n.x,a[2]=-r.x,a[3]=0,a[4]=o.y,a[5]=n.y,a[6]=-r.y,a[7]=0,a[8]=o.z,a[9]=n.z,a[10]=-r.z,a[11]=0,a[12]=-t.dot(o,e),a[13]=-t.dot(n,e),a[14]=t.dot(r,e),a[15]=1,a},l.toArray=function(t,e){return n(e)?(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e):[t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15]]},l.getElementIndex=function(t,e){return 4*t+e},l.getColumn=function(t,e,r){var n=4*e,o=t[n],a=t[n+1],i=t[n+2],u=t[n+3];return r.x=o,r.y=a,r.z=i,r.w=u,r},l.setColumn=function(t,e,r,n){n=l.clone(t,n);var o=4*e;return n[o]=r.x,n[o+1]=r.y,n[o+2]=r.z,n[o+3]=r.w,n},l.setTranslation=function(t,e,r){return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r[9]=t[9],r[10]=t[10],r[11]=t[11],r[12]=e.x,r[13]=e.y,r[14]=e.z,r[15]=t[15],r},l.getRow=function(t,e,r){var n=t[e],o=t[e+4],a=t[e+8],i=t[e+12];return r.x=n,r.y=o,r.z=a,r.w=i,r},l.setRow=function(t,e,r,n){return n=l.clone(t,n),n[e]=r.x,n[e+4]=r.y,n[e+8]=r.z,n[e+12]=r.w,n};var R=new t;l.getScale=function(e,r){return r.x=t.magnitude(t.fromElements(e[0],e[1],e[2],R)),r.y=t.magnitude(t.fromElements(e[4],e[5],e[6],R)),r.z=t.magnitude(t.fromElements(e[8],e[9],e[10],R)),r};var h=new t;l.getMaximumScale=function(e){return l.getScale(e,h),t.maximumComponent(h)},l.multiply=function(t,e,r){var n=t[0],o=t[1],a=t[2],i=t[3],u=t[4],s=t[5],E=t[6],l=t[7],c=t[8],f=t[9],_=t[10],R=t[11],h=t[12],T=t[13],A=t[14],d=t[15],S=e[0],m=e[1],C=e[2],N=e[3],I=e[4],p=e[5],M=e[6],O=e[7],g=e[8],y=e[9],F=e[10],L=e[11],v=e[12],D=e[13],U=e[14],P=e[15],w=n*S+u*m+c*C+h*N,B=o*S+s*m+f*C+T*N,x=a*S+E*m+_*C+A*N,G=i*S+l*m+R*C+d*N,b=n*I+u*p+c*M+h*O,z=o*I+s*p+f*M+T*O,H=a*I+E*p+_*M+A*O,V=i*I+l*p+R*M+d*O,X=n*g+u*y+c*F+h*L,q=o*g+s*y+f*F+T*L,W=a*g+E*y+_*F+A*L,Y=i*g+l*y+R*F+d*L,K=n*v+u*D+c*U+h*P,k=o*v+s*D+f*U+T*P,Z=a*v+E*D+_*U+A*P,j=i*v+l*D+R*U+d*P;return r[0]=w,r[1]=B,r[2]=x,r[3]=G,r[4]=b,r[5]=z,r[6]=H,r[7]=V,r[8]=X,r[9]=q,r[10]=W,r[11]=Y,r[12]=K,r[13]=k,r[14]=Z,r[15]=j,r},l.add=function(t,e,r){return r[0]=t[0]+e[0],r[1]=t[1]+e[1],r[2]=t[2]+e[2],r[3]=t[3]+e[3],r[4]=t[4]+e[4],r[5]=t[5]+e[5],r[6]=t[6]+e[6],r[7]=t[7]+e[7],r[8]=t[8]+e[8],r[9]=t[9]+e[9],r[10]=t[10]+e[10],r[11]=t[11]+e[11],r[12]=t[12]+e[12],r[13]=t[13]+e[13],r[14]=t[14]+e[14],r[15]=t[15]+e[15],r},l.subtract=function(t,e,r){return r[0]=t[0]-e[0],r[1]=t[1]-e[1],r[2]=t[2]-e[2],r[3]=t[3]-e[3],r[4]=t[4]-e[4],r[5]=t[5]-e[5],r[6]=t[6]-e[6],r[7]=t[7]-e[7],r[8]=t[8]-e[8],r[9]=t[9]-e[9],r[10]=t[10]-e[10],r[11]=t[11]-e[11],r[12]=t[12]-e[12],r[13]=t[13]-e[13],r[14]=t[14]-e[14],r[15]=t[15]-e[15],r},l.multiplyTransformation=function(t,e,r){var n=t[0],o=t[1],a=t[2],i=t[4],u=t[5],s=t[6],E=t[8],l=t[9],c=t[10],f=t[12],_=t[13],R=t[14],h=e[0],T=e[1],A=e[2],d=e[4],S=e[5],m=e[6],C=e[8],N=e[9],I=e[10],p=e[12],M=e[13],O=e[14],g=n*h+i*T+E*A,y=o*h+u*T+l*A,F=a*h+s*T+c*A,L=n*d+i*S+E*m,v=o*d+u*S+l*m,D=a*d+s*S+c*m,U=n*C+i*N+E*I,P=o*C+u*N+l*I,w=a*C+s*N+c*I,B=n*p+i*M+E*O+f,x=o*p+u*M+l*O+_,G=a*p+s*M+c*O+R;return r[0]=g,r[1]=y,r[2]=F,r[3]=0,r[4]=L,r[5]=v,r[6]=D,r[7]=0,r[8]=U,r[9]=P,r[10]=w,r[11]=0,r[12]=B,r[13]=x,r[14]=G,r[15]=1,r},l.multiplyByMatrix3=function(t,e,r){var n=t[0],o=t[1],a=t[2],i=t[4],u=t[5],s=t[6],E=t[8],l=t[9],c=t[10],f=e[0],_=e[1],R=e[2],h=e[3],T=e[4],A=e[5],d=e[6],S=e[7],m=e[8],C=n*f+i*_+E*R,N=o*f+u*_+l*R,I=a*f+s*_+c*R,p=n*h+i*T+E*A,M=o*h+u*T+l*A,O=a*h+s*T+c*A,g=n*d+i*S+E*m,y=o*d+u*S+l*m,F=a*d+s*S+c*m;return r[0]=C,r[1]=N,r[2]=I,r[3]=0,r[4]=p,r[5]=M,r[6]=O,r[7]=0,r[8]=g,r[9]=y,r[10]=F,r[11]=0,r[12]=t[12],r[13]=t[13],r[14]=t[14],r[15]=t[15],r},l.multiplyByTranslation=function(t,e,r){var n=e.x,o=e.y,a=e.z,i=n*t[0]+o*t[4]+a*t[8]+t[12],u=n*t[1]+o*t[5]+a*t[9]+t[13],s=n*t[2]+o*t[6]+a*t[10]+t[14];return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r[9]=t[9],r[10]=t[10],r[11]=t[11],r[12]=i,r[13]=u,r[14]=s,r[15]=t[15],r};var T=new t;l.multiplyByUniformScale=function(t,e,r){return T.x=e,T.y=e,T.z=e,l.multiplyByScale(t,T,r)},l.multiplyByScale=function(t,e,r){var n=e.x,o=e.y,a=e.z;return 1===n&&1===o&&1===a?l.clone(t,r):(r[0]=n*t[0],r[1]=n*t[1],r[2]=n*t[2],r[3]=0,r[4]=o*t[4],r[5]=o*t[5],r[6]=o*t[6],r[7]=0,r[8]=a*t[8],r[9]=a*t[9],r[10]=a*t[10],r[11]=0,r[12]=t[12],r[13]=t[13],r[14]=t[14],r[15]=1,r)},l.multiplyByVector=function(t,e,r){var n=e.x,o=e.y,a=e.z,i=e.w,u=t[0]*n+t[4]*o+t[8]*a+t[12]*i,s=t[1]*n+t[5]*o+t[9]*a+t[13]*i,E=t[2]*n+t[6]*o+t[10]*a+t[14]*i,l=t[3]*n+t[7]*o+t[11]*a+t[15]*i;return r.x=u,r.y=s,r.z=E,r.w=l,r},l.multiplyByPointAsVector=function(t,e,r){var n=e.x,o=e.y,a=e.z,i=t[0]*n+t[4]*o+t[8]*a,u=t[1]*n+t[5]*o+t[9]*a,s=t[2]*n+t[6]*o+t[10]*a;return r.x=i,r.y=u,r.z=s,r},l.multiplyByPoint=function(t,e,r){var n=e.x,o=e.y,a=e.z,i=t[0]*n+t[4]*o+t[8]*a+t[12],u=t[1]*n+t[5]*o+t[9]*a+t[13],s=t[2]*n+t[6]*o+t[10]*a+t[14];return r.x=i,r.y=u,r.z=s,r},l.multiplyByScalar=function(t,e,r){return r[0]=t[0]*e,r[1]=t[1]*e,r[2]=t[2]*e,r[3]=t[3]*e,r[4]=t[4]*e,r[5]=t[5]*e,r[6]=t[6]*e,r[7]=t[7]*e,r[8]=t[8]*e,r[9]=t[9]*e,r[10]=t[10]*e,r[11]=t[11]*e,r[12]=t[12]*e,r[13]=t[13]*e,r[14]=t[14]*e,r[15]=t[15]*e,r},l.negate=function(t,e){return e[0]=-t[0],e[1]=-t[1],e[2]=-t[2],e[3]=-t[3],e[4]=-t[4],e[5]=-t[5],e[6]=-t[6],e[7]=-t[7],e[8]=-t[8],e[9]=-t[9],e[10]=-t[10],e[11]=-t[11],e[12]=-t[12],e[13]=-t[13],e[14]=-t[14],e[15]=-t[15],e},l.transpose=function(t,e){var r=t[1],n=t[2],o=t[3],a=t[6],i=t[7],u=t[11];return e[0]=t[0],e[1]=t[4],e[2]=t[8],e[3]=t[12],e[4]=r,e[5]=t[5],e[6]=t[9],e[7]=t[13],e[8]=n,e[9]=a,e[10]=t[10],e[11]=t[14],e[12]=o,e[13]=i,e[14]=u,e[15]=t[15],e},l.abs=function(t,e){return e[0]=Math.abs(t[0]),e[1]=Math.abs(t[1]),e[2]=Math.abs(t[2]),e[3]=Math.abs(t[3]),e[4]=Math.abs(t[4]),e[5]=Math.abs(t[5]),e[6]=Math.abs(t[6]),e[7]=Math.abs(t[7]),e[8]=Math.abs(t[8]),e[9]=Math.abs(t[9]),e[10]=Math.abs(t[10]),e[11]=Math.abs(t[11]),e[12]=Math.abs(t[12]),e[13]=Math.abs(t[13]),e[14]=Math.abs(t[14]),e[15]=Math.abs(t[15]),e},l.equals=function(t,e){return t===e||n(t)&&n(e)&&t[12]===e[12]&&t[13]===e[13]&&t[14]===e[14]&&t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[8]===e[8]&&t[9]===e[9]&&t[10]===e[10]&&t[3]===e[3]&&t[7]===e[7]&&t[11]===e[11]&&t[15]===e[15]},l.equalsEpsilon=function(t,e,r){return t===e||n(t)&&n(e)&&Math.abs(t[0]-e[0])<=r&&Math.abs(t[1]-e[1])<=r&&Math.abs(t[2]-e[2])<=r&&Math.abs(t[3]-e[3])<=r&&Math.abs(t[4]-e[4])<=r&&Math.abs(t[5]-e[5])<=r&&Math.abs(t[6]-e[6])<=r&&Math.abs(t[7]-e[7])<=r&&Math.abs(t[8]-e[8])<=r&&Math.abs(t[9]-e[9])<=r&&Math.abs(t[10]-e[10])<=r&&Math.abs(t[11]-e[11])<=r&&Math.abs(t[12]-e[12])<=r&&Math.abs(t[13]-e[13])<=r&&Math.abs(t[14]-e[14])<=r&&Math.abs(t[15]-e[15])<=r},l.getTranslation=function(t,e){return e.x=t[12],e.y=t[13],e.z=t[14],e},l.getRotation=function(t,e){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[4],e[4]=t[5],e[5]=t[6],e[6]=t[8],e[7]=t[9],e[8]=t[10],e};var A=new s,d=new s,S=new e,m=new e(0,0,0,1);return l.inverse=function(t,r){if(s.equalsEpsilon(l.getRotation(t,A),d,u.EPSILON7)&&e.equals(l.getRow(t,3,S),m))return r[0]=0,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=0,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=0,r[11]=0,r[12]=-t[12],r[13]=-t[13],r[14]=-t[14],r[15]=1,r;var n=t[0],o=t[4],a=t[8],i=t[12],c=t[1],f=t[5],_=t[9],R=t[13],h=t[2],T=t[6],C=t[10],N=t[14],I=t[3],p=t[7],M=t[11],O=t[15],g=C*O,y=N*M,F=T*O,L=N*p,v=T*M,D=C*p,U=h*O,P=N*I,w=h*M,B=C*I,x=h*p,G=T*I,b=g*f+L*_+v*R-(y*f+F*_+D*R),z=y*c+U*_+B*R-(g*c+P*_+w*R),H=F*c+P*f+x*R-(L*c+U*f+G*R),V=D*c+w*f+G*_-(v*c+B*f+x*_),X=y*o+F*a+D*i-(g*o+L*a+v*i),q=g*n+P*a+w*i-(y*n+U*a+B*i),W=L*n+U*o+G*i-(F*n+P*o+x*i),Y=v*n+B*o+x*a-(D*n+w*o+G*a);g=a*R,y=i*_,F=o*R,L=i*f,v=o*_,D=a*f,U=n*R,P=i*c,w=n*_,B=a*c,x=n*f,G=o*c;var K=g*p+L*M+v*O-(y*p+F*M+D*O),k=y*I+U*M+B*O-(g*I+P*M+w*O),Z=F*I+P*p+x*O-(L*I+U*p+G*O),j=D*I+w*p+G*M-(v*I+B*p+x*M),Q=F*C+D*N+y*T-(v*N+g*T+L*C),J=w*N+g*h+P*C-(U*C+B*N+y*h),$=U*T+G*N+L*h-(x*N+F*h+P*T),tt=x*C+v*h+B*T-(w*T+G*C+D*h),et=n*b+o*z+a*H+i*V;if(Math.abs(et)<u.EPSILON20)throw new E("matrix is not invertible because its determinate is zero.");return et=1/et,r[0]=b*et,r[1]=z*et,r[2]=H*et,r[3]=V*et,r[4]=X*et,r[5]=q*et,r[6]=W*et,r[7]=Y*et,r[8]=K*et,r[9]=k*et,r[10]=Z*et,r[11]=j*et,r[12]=Q*et,r[13]=J*et,r[14]=$*et,r[15]=tt*et,r},l.inverseTransformation=function(t,e){var r=t[0],n=t[1],o=t[2],a=t[4],i=t[5],u=t[6],s=t[8],E=t[9],l=t[10],c=t[12],f=t[13],_=t[14],R=-r*c-n*f-o*_,h=-a*c-i*f-u*_,T=-s*c-E*f-l*_;return e[0]=r,e[1]=a,e[2]=s,e[3]=0,e[4]=n,e[5]=i,e[6]=E,e[7]=0,e[8]=o,e[9]=u,e[10]=l,e[11]=0,e[12]=R,e[13]=h,e[14]=T,e[15]=1,e},l.IDENTITY=i(new l(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),l.ZERO=i(new l(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN0ROW3=3,l.COLUMN1ROW0=4,l.COLUMN1ROW1=5,l.COLUMN1ROW2=6,l.COLUMN1ROW3=7,l.COLUMN2ROW0=8,l.COLUMN2ROW1=9,l.COLUMN2ROW2=10,l.COLUMN2ROW3=11,l.COLUMN3ROW0=12,l.COLUMN3ROW1=13,l.COLUMN3ROW2=14,l.COLUMN3ROW3=15,o(l.prototype,{length:{get:function(){return l.packedLength}}}),l.prototype.clone=function(t){return l.clone(this,t)},l.prototype.equals=function(t){return l.equals(this,t)},l.equalsArray=function(t,e,r){return t[0]===e[r]&&t[1]===e[r+1]&&t[2]===e[r+2]&&t[3]===e[r+3]&&t[4]===e[r+4]&&t[5]===e[r+5]&&t[6]===e[r+6]&&t[7]===e[r+7]&&t[8]===e[r+8]&&t[9]===e[r+9]&&t[10]===e[r+10]&&t[11]===e[r+11]&&t[12]===e[r+12]&&t[13]===e[r+13]&&t[14]===e[r+14]&&t[15]===e[r+15]},l.prototype.equalsEpsilon=function(t,e){return l.equalsEpsilon(this,t,e)},l.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"},l}),define("Core/Plane",["./Cartesian3","./defined","./DeveloperError","./freezeObject"],function(t,e,r,n){"use strict";function o(e,r){this.normal=t.clone(e),this.distance=r}o.fromPointNormal=function(r,n,a){var i=-t.dot(n,r);return e(a)?(t.clone(n,a.normal),a.distance=i,a):new o(n,i)};var a=new t;return o.fromCartesian4=function(r,n){var i=t.fromCartesian4(r,a),u=r.w;return e(n)?(t.clone(i,n.normal),n.distance=u,n):new o(i,u)},o.getPointDistance=function(e,r){return t.dot(e.normal,r)+e.distance},o.ORIGIN_XY_PLANE=n(new o(t.UNIT_Z,0)),o.ORIGIN_YZ_PLANE=n(new o(t.UNIT_X,0)),o.ORIGIN_ZX_PLANE=n(new o(t.UNIT_Y,0)),o}),define("Core/Rectangle",["./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./freezeObject","./Math"],function(t,e,r,n,o,a,i,u){"use strict";function s(t,r,n,o){this.west=e(t,0),this.south=e(r,0),this.east=e(n,0),this.north=e(o,0)}n(s.prototype,{width:{get:function(){return s.computeWidth(this)}},height:{get:function(){return s.computeHeight(this)}}}),s.packedLength=4,s.pack=function(t,r,n){n=e(n,0),r[n++]=t.west,r[n++]=t.south,r[n++]=t.east,r[n]=t.north},s.unpack=function(t,n,o){return n=e(n,0),r(o)||(o=new s),o.west=t[n++],o.south=t[n++],o.east=t[n++],o.north=t[n],o},s.computeWidth=function(t){var e=t.east,r=t.west;return r>e&&(e+=u.TWO_PI),e-r},s.computeHeight=function(t){return t.north-t.south},s.fromDegrees=function(t,n,o,a,i){return t=u.toRadians(e(t,0)),n=u.toRadians(e(n,0)),o=u.toRadians(e(o,0)),a=u.toRadians(e(a,0)),r(i)?(i.west=t,i.south=n,i.east=o,i.north=a,i):new s(t,n,o,a)},s.fromCartographicArray=function(t,e){for(var n=Number.MAX_VALUE,o=-Number.MAX_VALUE,a=Number.MAX_VALUE,i=-Number.MAX_VALUE,E=Number.MAX_VALUE,l=-Number.MAX_VALUE,c=0,f=t.length;f>c;c++){var _=t[c];n=Math.min(n,_.longitude),o=Math.max(o,_.longitude),E=Math.min(E,_.latitude),l=Math.max(l,_.latitude);var R=_.longitude>=0?_.longitude:_.longitude+u.TWO_PI;a=Math.min(a,R),i=Math.max(i,R)}return o-n>i-a&&(n=a,o=i,o>u.PI&&(o-=u.TWO_PI),n>u.PI&&(n-=u.TWO_PI)),r(e)?(e.west=n,e.south=E,e.east=o,e.north=l,e):new s(n,E,o,l)},s.fromCartesianArray=function(t,e,n){for(var o=Number.MAX_VALUE,a=-Number.MAX_VALUE,i=Number.MAX_VALUE,E=-Number.MAX_VALUE,l=Number.MAX_VALUE,c=-Number.MAX_VALUE,f=0,_=t.length;_>f;f++){var R=e.cartesianToCartographic(t[f]);o=Math.min(o,R.longitude),a=Math.max(a,R.longitude),l=Math.min(l,R.latitude),c=Math.max(c,R.latitude);var h=R.longitude>=0?R.longitude:R.longitude+u.TWO_PI;i=Math.min(i,h),E=Math.max(E,h)}return a-o>E-i&&(o=i,a=E,a>u.PI&&(a-=u.TWO_PI),o>u.PI&&(o-=u.TWO_PI)),r(n)?(n.west=o,n.south=l,n.east=a,n.north=c,n):new s(o,l,a,c)},s.clone=function(t,e){return r(t)?r(e)?(e.west=t.west,e.south=t.south,e.east=t.east,e.north=t.north,e):new s(t.west,t.south,t.east,t.north):void 0},s.prototype.clone=function(t){return s.clone(this,t)},s.prototype.equals=function(t){return s.equals(this,t)},s.equals=function(t,e){return t===e||r(t)&&r(e)&&t.west===e.west&&t.south===e.south&&t.east===e.east&&t.north===e.north},s.prototype.equalsEpsilon=function(t,e){return r(t)&&Math.abs(this.west-t.west)<=e&&Math.abs(this.south-t.south)<=e&&Math.abs(this.east-t.east)<=e&&Math.abs(this.north-t.north)<=e},s.validate=function(t){},s.southwest=function(e,n){return r(n)?(n.longitude=e.west,n.latitude=e.south,n.height=0,n):new t(e.west,e.south)},s.northwest=function(e,n){return r(n)?(n.longitude=e.west,n.latitude=e.north,n.height=0,n):new t(e.west,e.north)},s.northeast=function(e,n){return r(n)?(n.longitude=e.east,n.latitude=e.north,n.height=0,n):new t(e.east,e.north)},s.southeast=function(e,n){return r(n)?(n.longitude=e.east,n.latitude=e.south,n.height=0,n):new t(e.east,e.south)},s.center=function(e,n){var o=e.east,a=e.west;a>o&&(o+=u.TWO_PI);var i=u.negativePiToPi(.5*(a+o)),s=.5*(e.south+e.north);return r(n)?(n.longitude=i,n.latitude=s,n.height=0,n):new t(i,s)},s.intersection=function(t,e,n){var o=t.east,a=t.west,i=e.east,E=e.west;a>o&&i>0?o+=u.TWO_PI:E>i&&o>0&&(i+=u.TWO_PI),a>o&&0>E?E+=u.TWO_PI:E>i&&0>a&&(a+=u.TWO_PI);var l=u.negativePiToPi(Math.max(a,E)),c=u.negativePiToPi(Math.min(o,i));if(!((t.west<t.east||e.west<e.east)&&l>=c)){var f=Math.max(t.south,e.south),_=Math.min(t.north,e.north);if(!(f>=_))return r(n)?(n.west=l,n.south=f,n.east=c,n.north=_,n):new s(l,f,c,_)}},s.union=function(t,e,n){return r(n)||(n=new s),n.west=Math.min(t.west,e.west),n.south=Math.min(t.south,e.south),n.east=Math.max(t.east,e.east),n.north=Math.max(t.north,e.north),n},s.expand=function(t,e,n){return r(n)||(n=new s),n.west=Math.min(t.west,e.longitude),n.south=Math.min(t.south,e.latitude),n.east=Math.max(t.east,e.longitude),n.north=Math.max(t.north,e.latitude),n},s.contains=function(t,e){var r=e.longitude,n=e.latitude,o=t.west,a=t.east;return o>a&&(a+=u.TWO_PI,0>r&&(r+=u.TWO_PI)),(r>o||u.equalsEpsilon(r,o,u.EPSILON14))&&(a>r||u.equalsEpsilon(r,a,u.EPSILON14))&&n>=t.south&&n<=t.north};var E=new t;return s.subsample=function(t,n,o,i){n=e(n,a.WGS84),o=e(o,0),r(i)||(i=[]);var l=0,c=t.north,f=t.south,_=t.east,R=t.west,h=E;h.height=o,h.longitude=R,h.latitude=c,i[l]=n.cartographicToCartesian(h,i[l]),l++,h.longitude=_,i[l]=n.cartographicToCartesian(h,i[l]),l++,h.latitude=f,i[l]=n.cartographicToCartesian(h,i[l]),l++,h.longitude=R,i[l]=n.cartographicToCartesian(h,i[l]),l++,0>c?h.latitude=c:f>0?h.latitude=f:h.latitude=0;for(var T=1;8>T;++T)h.longitude=-Math.PI+T*u.PI_OVER_TWO,s.contains(t,h)&&(i[l]=n.cartographicToCartesian(h,i[l]),l++);return 0===h.latitude&&(h.longitude=R,i[l]=n.cartographicToCartesian(h,i[l]),l++,h.longitude=_,i[l]=n.cartographicToCartesian(h,i[l]),l++),i.length=l,i},s.MAX_VALUE=i(new s(-Math.PI,-u.PI_OVER_TWO,Math.PI,u.PI_OVER_TWO)),s}),define("Core/BoundingSphere",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./GeographicProjection","./Intersect","./Interval","./Matrix3","./Matrix4","./Plane","./Rectangle"],function(t,e,r,n,o,a,i,u,s,E,l,c,f){"use strict";function _(e,n){this.center=t.clone(r(e,t.ZERO)),this.radius=r(n,0)}var R=new t,h=new t,T=new t,A=new t,d=new t,S=new t,m=new t,C=new t,N=new t,I=new t,p=new t,M=new t;_.fromPoints=function(e,r){if(n(r)||(r=new _),!n(e)||0===e.length)return r.center=t.clone(t.ZERO,r.center),r.radius=0,r;for(var o=t.clone(e[0],m),a=t.clone(o,R),i=t.clone(o,h),u=t.clone(o,T),s=t.clone(o,A),E=t.clone(o,d),l=t.clone(o,S),c=e.length,f=1;c>f;f++){t.clone(e[f],o);var O=o.x,g=o.y,y=o.z;O<a.x&&t.clone(o,a),O>s.x&&t.clone(o,s),g<i.y&&t.clone(o,i),g>E.y&&t.clone(o,E),y<u.z&&t.clone(o,u),y>l.z&&t.clone(o,l)}var F=t.magnitudeSquared(t.subtract(s,a,C)),L=t.magnitudeSquared(t.subtract(E,i,C)),v=t.magnitudeSquared(t.subtract(l,u,C)),D=a,U=s,P=F;L>P&&(P=L,D=i,U=E),v>P&&(P=v,D=u,U=l);var w=N;w.x=.5*(D.x+U.x),w.y=.5*(D.y+U.y),w.z=.5*(D.z+U.z);var B=t.magnitudeSquared(t.subtract(U,w,C)),x=Math.sqrt(B),G=I;G.x=a.x,G.y=i.y,G.z=u.z;var b=p;b.x=s.x,b.y=E.y,b.z=l.z;var z=t.multiplyByScalar(t.add(G,b,C),.5,M),H=0;for(f=0;c>f;f++){t.clone(e[f],o);var V=t.magnitude(t.subtract(o,z,C));V>H&&(H=V);var X=t.magnitudeSquared(t.subtract(o,w,C));if(X>B){var q=Math.sqrt(X);x=.5*(x+q),B=x*x;var W=q-x;w.x=(x*w.x+W*o.x)/q,w.y=(x*w.y+W*o.y)/q,w.z=(x*w.z+W*o.z)/q}}return H>x?(t.clone(w,r.center),r.radius=x):(t.clone(z,r.center),r.radius=H),r};var O=new i,g=new t,y=new t,F=new e,L=new e;_.fromRectangle2D=function(t,e,r){return _.fromRectangleWithHeights2D(t,e,0,0,r)},_.fromRectangleWithHeights2D=function(e,o,a,i,u){if(n(u)||(u=new _),!n(e))return u.center=t.clone(t.ZERO,u.center),u.radius=0,u;o=r(o,O),f.southwest(e,F),F.height=a,f.northeast(e,L),L.height=i;var s=o.project(F,g),E=o.project(L,y),l=E.x-s.x,c=E.y-s.y,R=E.z-s.z;u.radius=.5*Math.sqrt(l*l+c*c+R*R);var h=u.center;return h.x=s.x+.5*l,h.y=s.y+.5*c,h.z=s.z+.5*R,u};var v=[];_.fromRectangle3D=function(t,e,o,i){e=r(e,a.WGS84),o=r(o,0);var u;return n(t)&&(u=f.subsample(t,e,o,v)),_.fromPoints(u,i)},_.fromVertices=function(e,o,a,i){if(n(i)||(i=new _),!n(e)||0===e.length)return i.center=t.clone(t.ZERO,i.center),i.radius=0,i;o=r(o,t.ZERO),a=r(a,3);var u=m;u.x=e[0]+o.x,u.y=e[1]+o.y,u.z=e[2]+o.z;for(var s=t.clone(u,R),E=t.clone(u,h),l=t.clone(u,T),c=t.clone(u,A),f=t.clone(u,d),O=t.clone(u,S),g=e.length,y=0;g>y;y+=a){var F=e[y]+o.x,L=e[y+1]+o.y,v=e[y+2]+o.z;u.x=F,u.y=L,u.z=v,F<s.x&&t.clone(u,s),F>c.x&&t.clone(u,c),L<E.y&&t.clone(u,E),L>f.y&&t.clone(u,f),v<l.z&&t.clone(u,l),v>O.z&&t.clone(u,O)}var D=t.magnitudeSquared(t.subtract(c,s,C)),U=t.magnitudeSquared(t.subtract(f,E,C)),P=t.magnitudeSquared(t.subtract(O,l,C)),w=s,B=c,x=D;U>x&&(x=U,w=E,B=f),P>x&&(x=P,w=l,B=O);var G=N;G.x=.5*(w.x+B.x),G.y=.5*(w.y+B.y),G.z=.5*(w.z+B.z);var b=t.magnitudeSquared(t.subtract(B,G,C)),z=Math.sqrt(b),H=I;H.x=s.x,H.y=E.y,H.z=l.z;var V=p;V.x=c.x,V.y=f.y,V.z=O.z;var X=t.multiplyByScalar(t.add(H,V,C),.5,M),q=0;for(y=0;g>y;y+=a){u.x=e[y]+o.x,u.y=e[y+1]+o.y,u.z=e[y+2]+o.z;var W=t.magnitude(t.subtract(u,X,C));W>q&&(q=W);var Y=t.magnitudeSquared(t.subtract(u,G,C));if(Y>b){var K=Math.sqrt(Y);z=.5*(z+K),b=z*z;var k=K-z;G.x=(z*G.x+k*u.x)/K,G.y=(z*G.y+k*u.y)/K,G.z=(z*G.z+k*u.z)/K}}return q>z?(t.clone(G,i.center),i.radius=z):(t.clone(X,i.center),i.radius=q),i},_.fromEncodedCartesianVertices=function(e,r,o){if(n(o)||(o=new _),!n(e)||!n(r)||e.length!==r.length||0===e.length)return o.center=t.clone(t.ZERO,o.center),o.radius=0,o;var a=m;a.x=e[0]+r[0],a.y=e[1]+r[1],a.z=e[2]+r[2];for(var i=t.clone(a,R),u=t.clone(a,h),s=t.clone(a,T),E=t.clone(a,A),l=t.clone(a,d),c=t.clone(a,S),f=e.length,O=0;f>O;O+=3){var g=e[O]+r[O],y=e[O+1]+r[O+1],F=e[O+2]+r[O+2];a.x=g,a.y=y,a.z=F,g<i.x&&t.clone(a,i),g>E.x&&t.clone(a,E),y<u.y&&t.clone(a,u),y>l.y&&t.clone(a,l),F<s.z&&t.clone(a,s),F>c.z&&t.clone(a,c)}var L=t.magnitudeSquared(t.subtract(E,i,C)),v=t.magnitudeSquared(t.subtract(l,u,C)),D=t.magnitudeSquared(t.subtract(c,s,C)),U=i,P=E,w=L;v>w&&(w=v,U=u,P=l),D>w&&(w=D,U=s,P=c);var B=N;B.x=.5*(U.x+P.x),B.y=.5*(U.y+P.y),B.z=.5*(U.z+P.z);var x=t.magnitudeSquared(t.subtract(P,B,C)),G=Math.sqrt(x),b=I;b.x=i.x,b.y=u.y,b.z=s.z;var z=p;z.x=E.x,z.y=l.y,z.z=c.z;var H=t.multiplyByScalar(t.add(b,z,C),.5,M),V=0;for(O=0;f>O;O+=3){a.x=e[O]+r[O],a.y=e[O+1]+r[O+1],a.z=e[O+2]+r[O+2];var X=t.magnitude(t.subtract(a,H,C));X>V&&(V=X);var q=t.magnitudeSquared(t.subtract(a,B,C));if(q>x){var W=Math.sqrt(q);G=.5*(G+W),x=G*G;var Y=W-G;B.x=(G*B.x+Y*a.x)/W,B.y=(G*B.y+Y*a.y)/W,B.z=(G*B.z+Y*a.z)/W}}return V>G?(t.clone(B,o.center),o.radius=G):(t.clone(H,o.center),o.radius=V),o},_.fromCornerPoints=function(e,r,o){n(o)||(o=new _);var a=o.center;return t.add(e,r,a),t.multiplyByScalar(a,.5,a),o.radius=t.distance(a,r),o},_.fromEllipsoid=function(e,r){return n(r)||(r=new _),t.clone(t.ZERO,r.center),r.radius=e.maximumRadius,r};var D=new t;_.fromBoundingSpheres=function(e,r){if(n(r)||(r=new _),!n(e)||0===e.length)return r.center=t.clone(t.ZERO,r.center),r.radius=0,r;var o=e.length;if(1===o)return _.clone(e[0],r);if(2===o)return _.union(e[0],e[1],r);for(var a=[],i=0;o>i;i++)a.push(e[i].center);r=_.fromPoints(a,r);var u=r.center,s=r.radius;for(i=0;o>i;i++){var E=e[i];s=Math.max(s,t.distance(u,E.center,D)+E.radius)}return r.radius=s,r};var U=new t,P=new t,w=new t;_.fromOrientedBoundingBox=function(e,r){n(r)||(r=new _);var o=e.halfAxes,a=E.getColumn(o,0,U),i=E.getColumn(o,1,P),u=E.getColumn(o,2,w),s=t.magnitude(a),l=t.magnitude(i),c=t.magnitude(u);return r.center=t.clone(e.center,r.center),r.radius=Math.max(s,l,c),r},_.clone=function(e,r){return n(e)?n(r)?(r.center=t.clone(e.center,r.center),r.radius=e.radius,r):new _(e.center,e.radius):void 0},_.packedLength=4,_.pack=function(t,e,n){n=r(n,0);var o=t.center;e[n++]=o.x,e[n++]=o.y,e[n++]=o.z,e[n]=t.radius},_.unpack=function(t,e,o){e=r(e,0),n(o)||(o=new _);var a=o.center;return a.x=t[e++],a.y=t[e++],a.z=t[e++],o.radius=t[e],o};var B=new t,x=new t;_.union=function(e,r,o){n(o)||(o=new _);var a=e.center,i=e.radius,u=r.center,s=r.radius,E=t.subtract(u,a,B),l=t.magnitude(E);if(i>=l+s)return e.clone(o),o;if(s>=l+i)return r.clone(o),o;var c=.5*(i+l+s),f=t.multiplyByScalar(E,(-i+c)/l,x);return t.add(f,a,f),t.clone(f,o.center),o.radius=c,o};var G=new t;_.expand=function(e,r,n){n=_.clone(e,n);var o=t.magnitude(t.subtract(r,n.center,G));return o>n.radius&&(n.radius=o),n},_.intersectPlane=function(e,r){var n=e.center,o=e.radius,a=r.normal,i=t.dot(a,n)+r.distance;return-o>i?u.OUTSIDE:o>i?u.INTERSECTING:u.INSIDE},_.transform=function(t,e,r){return n(r)||(r=new _),r.center=l.multiplyByPoint(e,t.center,r.center),r.radius=l.getMaximumScale(e)*t.radius,r};var b=new t;_.distanceSquaredTo=function(e,r){var n=t.subtract(e.center,r,b);return t.magnitudeSquared(n)-e.radius*e.radius},_.transformWithoutScale=function(t,e,r){return n(r)||(r=new _),r.center=l.multiplyByPoint(e,t.center,r.center),r.radius=t.radius,r};var z=new t;_.computePlaneDistances=function(e,r,o,a){n(a)||(a=new s);var i=t.subtract(e.center,r,z),u=t.dot(o,i);return a.start=u-e.radius,a.stop=u+e.radius,a};for(var H=new t,V=new t,X=new t,q=new t,W=new t,Y=new e,K=new Array(8),k=0;8>k;++k)K[k]=new t;var Z=new i;return _.projectTo2D=function(e,n,o){n=r(n,Z);var a=n.ellipsoid,i=e.center,u=e.radius,s=a.geodeticSurfaceNormal(i,H),E=t.cross(t.UNIT_Z,s,V);t.normalize(E,E);var l=t.cross(s,E,X);t.normalize(l,l),t.multiplyByScalar(s,u,s),t.multiplyByScalar(l,u,l),t.multiplyByScalar(E,u,E);var c=t.negate(l,W),f=t.negate(E,q),R=K,h=R[0];t.add(s,l,h),t.add(h,E,h),h=R[1],t.add(s,l,h),t.add(h,f,h),h=R[2],t.add(s,c,h),t.add(h,f,h),h=R[3],t.add(s,c,h),t.add(h,E,h),t.negate(s,s),h=R[4],t.add(s,l,h),t.add(h,E,h),h=R[5],t.add(s,l,h),t.add(h,f,h),h=R[6],t.add(s,c,h),t.add(h,f,h),h=R[7],t.add(s,c,h),t.add(h,E,h);for(var T=R.length,A=0;T>A;++A){var d=R[A];t.add(i,d,d);var S=a.cartesianToCartographic(d,Y);n.project(S,d)}o=_.fromPoints(R,o),i=o.center;var m=i.x,C=i.y,N=i.z;return i.x=N,i.y=m,i.z=C,o},_.isOccluded=function(t,e){return!e.isBoundingSphereVisible(t)},_.equals=function(e,r){return e===r||n(e)&&n(r)&&t.equals(e.center,r.center)&&e.radius===r.radius},_.prototype.intersectPlane=function(t){return _.intersectPlane(this,t)},_.prototype.distanceSquaredTo=function(t){return _.distanceSquaredTo(this,t)},_.prototype.computePlaneDistances=function(t,e,r){return _.computePlaneDistances(this,t,e,r)},_.prototype.isOccluded=function(t){return _.isOccluded(this,t)},_.prototype.equals=function(t){return _.equals(this,t)},_.prototype.clone=function(t){return _.clone(this,t)},_}),define("Core/Fullscreen",["./defined","./defineProperties"],function(t,e){"use strict";var r,n={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},o={};return e(o,{element:{get:function(){return o.supportsFullscreen()?document[n.fullscreenElement]:void 0}},changeEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenchange:void 0}},errorEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenerror:void 0}},enabled:{get:function(){return o.supportsFullscreen()?document[n.fullscreenEnabled]:void 0}},fullscreen:{get:function(){return o.supportsFullscreen()?null!==o.element:void 0}}}),o.supportsFullscreen=function(){if(t(r))return r;r=!1;var e=document.body;if("function"==typeof e.requestFullscreen)return n.requestFullscreen="requestFullscreen",n.exitFullscreen="exitFullscreen",n.fullscreenEnabled="fullscreenEnabled",n.fullscreenElement="fullscreenElement",n.fullscreenchange="fullscreenchange",n.fullscreenerror="fullscreenerror",r=!0;for(var o,a=["webkit","moz","o","ms","khtml"],i=0,u=a.length;u>i;++i){var s=a[i];o=s+"RequestFullscreen","function"==typeof e[o]?(n.requestFullscreen=o,r=!0):(o=s+"RequestFullScreen","function"==typeof e[o]&&(n.requestFullscreen=o,r=!0)),o=s+"ExitFullscreen","function"==typeof document[o]?n.exitFullscreen=o:(o=s+"CancelFullScreen","function"==typeof document[o]&&(n.exitFullscreen=o)),o=s+"FullscreenEnabled",void 0!==document[o]?n.fullscreenEnabled=o:(o=s+"FullScreenEnabled",void 0!==document[o]&&(n.fullscreenEnabled=o)),o=s+"FullscreenElement",void 0!==document[o]?n.fullscreenElement=o:(o=s+"FullScreenElement",void 0!==document[o]&&(n.fullscreenElement=o)),o=s+"fullscreenchange",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenChange"),n.fullscreenchange=o),o=s+"fullscreenerror",void 0!==document["on"+o]&&("ms"===s&&(o="MSFullscreenError"),n.fullscreenerror=o)}return r},o.requestFullscreen=function(t,e){o.supportsFullscreen()&&t[n.requestFullscreen]({vrDisplay:e})},o.exitFullscreen=function(){o.supportsFullscreen()&&document[n.exitFullscreen]()},o}),define("Core/FeatureDetection",["./defaultValue","./defined","./Fullscreen"],function(t,e,r){"use strict";function n(t){for(var e=t.split("."),r=0,n=e.length;n>r;++r)e[r]=parseInt(e[r],10);return e}function o(){if(!e(S)){S=!1;var t=/ Chrome\/([\.0-9]+)/.exec(d.userAgent);null!==t&&(S=!0,m=n(t[1]))}return S}function a(){return o()&&m}function i(){if(!e(C)&&(C=!1,!o()&&/ Safari\/[\.0-9]+/.test(d.userAgent))){var t=/ Version\/([\.0-9]+)/.exec(d.userAgent);null!==t&&(C=!0,N=n(t[1]))}return C}function u(){return i()&&N}function s(){if(!e(I)){I=!1;var t=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(d.userAgent);null!==t&&(I=!0,p=n(t[1]),p.isNightly=!!t[2])}return I}function E(){return s()&&p}function l(){if(!e(M)){M=!1;var t;"Microsoft Internet Explorer"===d.appName?(t=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(d.userAgent),null!==t&&(M=!0,O=n(t[1]))):"Netscape"===d.appName&&(t=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(d.userAgent),null!==t&&(M=!0,O=n(t[1])))}return M}function c(){return l()&&O}function f(){if(!e(g)){g=!1;var t=/Firefox\/([\.0-9]+)/.exec(d.userAgent);null!==t&&(g=!0,y=n(t[1]))}return g}function _(){return e(F)||(F=/Windows/i.test(d.appVersion)),F}function R(){return f()&&y}function h(){return e(L)||(L="undefined"!=typeof PointerEvent&&(!e(d.pointerEnabled)||d.pointerEnabled)),L}function T(){if(!e(D)){var t=document.createElement("canvas");t.setAttribute("style","image-rendering: -moz-crisp-edges;image-rendering: pixelated;");var r=t.style.imageRendering;D=e(r)&&""!==r,D&&(v=r)}return D}function A(){return T()?v:void 0}var d;d="undefined"!=typeof navigator?navigator:{};var S,m,C,N,I,p,M,O,g,y,F,L,v,D,U={isChrome:o,chromeVersion:a,isSafari:i,safariVersion:u,isWebkit:s,webkitVersion:E,isInternetExplorer:l,internetExplorerVersion:c,isFirefox:f,firefoxVersion:R,isWindows:_,hardwareConcurrency:t(d.hardwareConcurrency,3),supportsPointerEvents:h,supportsImageRenderingPixelated:T,imageRenderingValue:A};return U.supportsFullscreen=function(){return r.supportsFullscreen()},U.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},U.supportsWebWorkers=function(){return"undefined"!=typeof Worker},U}),define("Core/Color",["./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject","./Math"],function(t,e,r,n,o,a){"use strict";function i(t,e,r){return 0>r&&(r+=1),r>1&&(r-=1),1>6*r?t+6*(e-t)*r:1>2*r?e:2>3*r?t+(e-t)*(2/3-r)*6:t}function u(e,r,n,o){this.red=t(e,1),this.green=t(r,1),this.blue=t(n,1),this.alpha=t(o,1)}u.fromCartesian4=function(t,r){return e(r)?(r.red=t.x,r.green=t.y,r.blue=t.z,r.alpha=t.w,r):new u(t.x,t.y,t.z,t.w)},u.fromBytes=function(r,n,o,a,i){return r=u.byteToFloat(t(r,255)),n=u.byteToFloat(t(n,255)),o=u.byteToFloat(t(o,255)),a=u.byteToFloat(t(a,255)),e(i)?(i.red=r,i.green=n,i.blue=o,i.alpha=a,i):new u(r,n,o,a)},u.fromAlpha=function(t,r,n){return e(n)?(n.red=t.red,n.green=t.green,n.blue=t.blue,n.alpha=r,n):new u(t.red,t.green,t.blue,r);
};var s,E,l;n.supportsTypedArrays()&&(s=new ArrayBuffer(4),E=new Uint32Array(s),l=new Uint8Array(s)),u.fromRgba=function(t,e){return E[0]=t,u.fromBytes(l[0],l[1],l[2],l[3],e)},u.fromHsl=function(r,n,o,a,s){r=t(r,0)%1,n=t(n,0),o=t(o,0),a=t(a,1);var E=o,l=o,c=o;if(0!==n){var f;f=.5>o?o*(1+n):o+n-o*n;var _=2*o-f;E=i(_,f,r+1/3),l=i(_,f,r),c=i(_,f,r-1/3)}return e(s)?(s.red=E,s.green=l,s.blue=c,s.alpha=a,s):new u(E,l,c,a)},u.fromRandom=function(r,n){r=t(r,t.EMPTY_OBJECT);var o=r.red;if(!e(o)){var i=t(r.minimumRed,0),s=t(r.maximumRed,1);o=i+a.nextRandomNumber()*(s-i)}var E=r.green;if(!e(E)){var l=t(r.minimumGreen,0),c=t(r.maximumGreen,1);E=l+a.nextRandomNumber()*(c-l)}var f=r.blue;if(!e(f)){var _=t(r.minimumBlue,0),R=t(r.maximumBlue,1);f=_+a.nextRandomNumber()*(R-_)}var h=r.alpha;if(!e(h)){var T=t(r.minimumAlpha,0),A=t(r.maximumAlpha,1);h=T+a.nextRandomNumber()*(A-T)}return e(n)?(n.red=o,n.green=E,n.blue=f,n.alpha=h,n):new u(o,E,f,h)};var c=/^#([0-9a-f])([0-9a-f])([0-9a-f])$/i,f=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i,_=/^rgba?\(\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)(?:\s*,\s*([0-9.]+))?\s*\)$/i,R=/^hsla?\(\s*([0-9.]+)\s*,\s*([0-9.]+%)\s*,\s*([0-9.]+%)(?:\s*,\s*([0-9.]+))?\s*\)$/i;return u.fromCssColorString=function(r,n){e(n)||(n=new u);var o=u[r.toUpperCase()];if(e(o))return u.clone(o,n),n;var a=c.exec(r);return null!==a?(n.red=parseInt(a[1],16)/15,n.green=parseInt(a[2],16)/15,n.blue=parseInt(a[3],16)/15,n.alpha=1,n):(a=f.exec(r),null!==a?(n.red=parseInt(a[1],16)/255,n.green=parseInt(a[2],16)/255,n.blue=parseInt(a[3],16)/255,n.alpha=1,n):(a=_.exec(r),null!==a?(n.red=parseFloat(a[1])/("%"===a[1].substr(-1)?100:255),n.green=parseFloat(a[2])/("%"===a[2].substr(-1)?100:255),n.blue=parseFloat(a[3])/("%"===a[3].substr(-1)?100:255),n.alpha=parseFloat(t(a[4],"1.0")),n):(a=R.exec(r),null!==a?u.fromHsl(parseFloat(a[1])/360,parseFloat(a[2])/100,parseFloat(a[3])/100,parseFloat(t(a[4],"1.0")),n):n=void 0)))},u.packedLength=4,u.pack=function(e,r,n){n=t(n,0),r[n++]=e.red,r[n++]=e.green,r[n++]=e.blue,r[n]=e.alpha},u.unpack=function(r,n,o){return n=t(n,0),e(o)||(o=new u),o.red=r[n++],o.green=r[n++],o.blue=r[n++],o.alpha=r[n],o},u.byteToFloat=function(t){return t/255},u.floatToByte=function(t){return 1===t?255:256*t|0},u.clone=function(t,r){return e(t)?e(r)?(r.red=t.red,r.green=t.green,r.blue=t.blue,r.alpha=t.alpha,r):new u(t.red,t.green,t.blue,t.alpha):void 0},u.equals=function(t,r){return t===r||e(t)&&e(r)&&t.red===r.red&&t.green===r.green&&t.blue===r.blue&&t.alpha===r.alpha},u.equalsArray=function(t,e,r){return t.red===e[r]&&t.green===e[r+1]&&t.blue===e[r+2]&&t.alpha===e[r+3]},u.prototype.clone=function(t){return u.clone(this,t)},u.prototype.equals=function(t){return u.equals(this,t)},u.prototype.equalsEpsilon=function(t,r){return this===t||e(t)&&Math.abs(this.red-t.red)<=r&&Math.abs(this.green-t.green)<=r&&Math.abs(this.blue-t.blue)<=r&&Math.abs(this.alpha-t.alpha)<=r},u.prototype.toString=function(){return"("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},u.prototype.toCssColorString=function(){var t=u.floatToByte(this.red),e=u.floatToByte(this.green),r=u.floatToByte(this.blue);return 1===this.alpha?"rgb("+t+","+e+","+r+")":"rgba("+t+","+e+","+r+","+this.alpha+")"},u.prototype.toBytes=function(t){var r=u.floatToByte(this.red),n=u.floatToByte(this.green),o=u.floatToByte(this.blue),a=u.floatToByte(this.alpha);return e(t)?(t[0]=r,t[1]=n,t[2]=o,t[3]=a,t):[r,n,o,a]},u.prototype.toRgba=function(){return l[0]=u.floatToByte(this.red),l[1]=u.floatToByte(this.green),l[2]=u.floatToByte(this.blue),l[3]=u.floatToByte(this.alpha),E[0]},u.prototype.brighten=function(t,e){return t=1-t,e.red=1-(1-this.red)*t,e.green=1-(1-this.green)*t,e.blue=1-(1-this.blue)*t,e.alpha=this.alpha,e},u.prototype.darken=function(t,e){return t=1-t,e.red=this.red*t,e.green=this.green*t,e.blue=this.blue*t,e.alpha=this.alpha,e},u.prototype.withAlpha=function(t,e){return u.fromAlpha(this,t,e)},u.add=function(t,e,r){return r.red=t.red+e.red,r.green=t.green+e.green,r.blue=t.blue+e.blue,r.alpha=t.alpha+e.alpha,r},u.subtract=function(t,e,r){return r.red=t.red-e.red,r.green=t.green-e.green,r.blue=t.blue-e.blue,r.alpha=t.alpha-e.alpha,r},u.multiply=function(t,e,r){return r.red=t.red*e.red,r.green=t.green*e.green,r.blue=t.blue*e.blue,r.alpha=t.alpha*e.alpha,r},u.divide=function(t,e,r){return r.red=t.red/e.red,r.green=t.green/e.green,r.blue=t.blue/e.blue,r.alpha=t.alpha/e.alpha,r},u.mod=function(t,e,r){return r.red=t.red%e.red,r.green=t.green%e.green,r.blue=t.blue%e.blue,r.alpha=t.alpha%e.alpha,r},u.multiplyByScalar=function(t,e,r){return r.red=t.red*e,r.green=t.green*e,r.blue=t.blue*e,r.alpha=t.alpha*e,r},u.divideByScalar=function(t,e,r){return r.red=t.red/e,r.green=t.green/e,r.blue=t.blue/e,r.alpha=t.alpha/e,r},u.ALICEBLUE=o(u.fromCssColorString("#F0F8FF")),u.ANTIQUEWHITE=o(u.fromCssColorString("#FAEBD7")),u.AQUA=o(u.fromCssColorString("#00FFFF")),u.AQUAMARINE=o(u.fromCssColorString("#7FFFD4")),u.AZURE=o(u.fromCssColorString("#F0FFFF")),u.BEIGE=o(u.fromCssColorString("#F5F5DC")),u.BISQUE=o(u.fromCssColorString("#FFE4C4")),u.BLACK=o(u.fromCssColorString("#000000")),u.BLANCHEDALMOND=o(u.fromCssColorString("#FFEBCD")),u.BLUE=o(u.fromCssColorString("#0000FF")),u.BLUEVIOLET=o(u.fromCssColorString("#8A2BE2")),u.BROWN=o(u.fromCssColorString("#A52A2A")),u.BURLYWOOD=o(u.fromCssColorString("#DEB887")),u.CADETBLUE=o(u.fromCssColorString("#5F9EA0")),u.CHARTREUSE=o(u.fromCssColorString("#7FFF00")),u.CHOCOLATE=o(u.fromCssColorString("#D2691E")),u.CORAL=o(u.fromCssColorString("#FF7F50")),u.CORNFLOWERBLUE=o(u.fromCssColorString("#6495ED")),u.CORNSILK=o(u.fromCssColorString("#FFF8DC")),u.CRIMSON=o(u.fromCssColorString("#DC143C")),u.CYAN=o(u.fromCssColorString("#00FFFF")),u.DARKBLUE=o(u.fromCssColorString("#00008B")),u.DARKCYAN=o(u.fromCssColorString("#008B8B")),u.DARKGOLDENROD=o(u.fromCssColorString("#B8860B")),u.DARKGRAY=o(u.fromCssColorString("#A9A9A9")),u.DARKGREEN=o(u.fromCssColorString("#006400")),u.DARKGREY=u.DARKGRAY,u.DARKKHAKI=o(u.fromCssColorString("#BDB76B")),u.DARKMAGENTA=o(u.fromCssColorString("#8B008B")),u.DARKOLIVEGREEN=o(u.fromCssColorString("#556B2F")),u.DARKORANGE=o(u.fromCssColorString("#FF8C00")),u.DARKORCHID=o(u.fromCssColorString("#9932CC")),u.DARKRED=o(u.fromCssColorString("#8B0000")),u.DARKSALMON=o(u.fromCssColorString("#E9967A")),u.DARKSEAGREEN=o(u.fromCssColorString("#8FBC8F")),u.DARKSLATEBLUE=o(u.fromCssColorString("#483D8B")),u.DARKSLATEGRAY=o(u.fromCssColorString("#2F4F4F")),u.DARKSLATEGREY=u.DARKSLATEGRAY,u.DARKTURQUOISE=o(u.fromCssColorString("#00CED1")),u.DARKVIOLET=o(u.fromCssColorString("#9400D3")),u.DEEPPINK=o(u.fromCssColorString("#FF1493")),u.DEEPSKYBLUE=o(u.fromCssColorString("#00BFFF")),u.DIMGRAY=o(u.fromCssColorString("#696969")),u.DIMGREY=u.DIMGRAY,u.DODGERBLUE=o(u.fromCssColorString("#1E90FF")),u.FIREBRICK=o(u.fromCssColorString("#B22222")),u.FLORALWHITE=o(u.fromCssColorString("#FFFAF0")),u.FORESTGREEN=o(u.fromCssColorString("#228B22")),u.FUSCHIA=o(u.fromCssColorString("#FF00FF")),u.GAINSBORO=o(u.fromCssColorString("#DCDCDC")),u.GHOSTWHITE=o(u.fromCssColorString("#F8F8FF")),u.GOLD=o(u.fromCssColorString("#FFD700")),u.GOLDENROD=o(u.fromCssColorString("#DAA520")),u.GRAY=o(u.fromCssColorString("#808080")),u.GREEN=o(u.fromCssColorString("#008000")),u.GREENYELLOW=o(u.fromCssColorString("#ADFF2F")),u.GREY=u.GRAY,u.HONEYDEW=o(u.fromCssColorString("#F0FFF0")),u.HOTPINK=o(u.fromCssColorString("#FF69B4")),u.INDIANRED=o(u.fromCssColorString("#CD5C5C")),u.INDIGO=o(u.fromCssColorString("#4B0082")),u.IVORY=o(u.fromCssColorString("#FFFFF0")),u.KHAKI=o(u.fromCssColorString("#F0E68C")),u.LAVENDER=o(u.fromCssColorString("#E6E6FA")),u.LAVENDAR_BLUSH=o(u.fromCssColorString("#FFF0F5")),u.LAWNGREEN=o(u.fromCssColorString("#7CFC00")),u.LEMONCHIFFON=o(u.fromCssColorString("#FFFACD")),u.LIGHTBLUE=o(u.fromCssColorString("#ADD8E6")),u.LIGHTCORAL=o(u.fromCssColorString("#F08080")),u.LIGHTCYAN=o(u.fromCssColorString("#E0FFFF")),u.LIGHTGOLDENRODYELLOW=o(u.fromCssColorString("#FAFAD2")),u.LIGHTGRAY=o(u.fromCssColorString("#D3D3D3")),u.LIGHTGREEN=o(u.fromCssColorString("#90EE90")),u.LIGHTGREY=u.LIGHTGRAY,u.LIGHTPINK=o(u.fromCssColorString("#FFB6C1")),u.LIGHTSEAGREEN=o(u.fromCssColorString("#20B2AA")),u.LIGHTSKYBLUE=o(u.fromCssColorString("#87CEFA")),u.LIGHTSLATEGRAY=o(u.fromCssColorString("#778899")),u.LIGHTSLATEGREY=u.LIGHTSLATEGRAY,u.LIGHTSTEELBLUE=o(u.fromCssColorString("#B0C4DE")),u.LIGHTYELLOW=o(u.fromCssColorString("#FFFFE0")),u.LIME=o(u.fromCssColorString("#00FF00")),u.LIMEGREEN=o(u.fromCssColorString("#32CD32")),u.LINEN=o(u.fromCssColorString("#FAF0E6")),u.MAGENTA=o(u.fromCssColorString("#FF00FF")),u.MAROON=o(u.fromCssColorString("#800000")),u.MEDIUMAQUAMARINE=o(u.fromCssColorString("#66CDAA")),u.MEDIUMBLUE=o(u.fromCssColorString("#0000CD")),u.MEDIUMORCHID=o(u.fromCssColorString("#BA55D3")),u.MEDIUMPURPLE=o(u.fromCssColorString("#9370DB")),u.MEDIUMSEAGREEN=o(u.fromCssColorString("#3CB371")),u.MEDIUMSLATEBLUE=o(u.fromCssColorString("#7B68EE")),u.MEDIUMSPRINGGREEN=o(u.fromCssColorString("#00FA9A")),u.MEDIUMTURQUOISE=o(u.fromCssColorString("#48D1CC")),u.MEDIUMVIOLETRED=o(u.fromCssColorString("#C71585")),u.MIDNIGHTBLUE=o(u.fromCssColorString("#191970")),u.MINTCREAM=o(u.fromCssColorString("#F5FFFA")),u.MISTYROSE=o(u.fromCssColorString("#FFE4E1")),u.MOCCASIN=o(u.fromCssColorString("#FFE4B5")),u.NAVAJOWHITE=o(u.fromCssColorString("#FFDEAD")),u.NAVY=o(u.fromCssColorString("#000080")),u.OLDLACE=o(u.fromCssColorString("#FDF5E6")),u.OLIVE=o(u.fromCssColorString("#808000")),u.OLIVEDRAB=o(u.fromCssColorString("#6B8E23")),u.ORANGE=o(u.fromCssColorString("#FFA500")),u.ORANGERED=o(u.fromCssColorString("#FF4500")),u.ORCHID=o(u.fromCssColorString("#DA70D6")),u.PALEGOLDENROD=o(u.fromCssColorString("#EEE8AA")),u.PALEGREEN=o(u.fromCssColorString("#98FB98")),u.PALETURQUOISE=o(u.fromCssColorString("#AFEEEE")),u.PALEVIOLETRED=o(u.fromCssColorString("#DB7093")),u.PAPAYAWHIP=o(u.fromCssColorString("#FFEFD5")),u.PEACHPUFF=o(u.fromCssColorString("#FFDAB9")),u.PERU=o(u.fromCssColorString("#CD853F")),u.PINK=o(u.fromCssColorString("#FFC0CB")),u.PLUM=o(u.fromCssColorString("#DDA0DD")),u.POWDERBLUE=o(u.fromCssColorString("#B0E0E6")),u.PURPLE=o(u.fromCssColorString("#800080")),u.RED=o(u.fromCssColorString("#FF0000")),u.ROSYBROWN=o(u.fromCssColorString("#BC8F8F")),u.ROYALBLUE=o(u.fromCssColorString("#4169E1")),u.SADDLEBROWN=o(u.fromCssColorString("#8B4513")),u.SALMON=o(u.fromCssColorString("#FA8072")),u.SANDYBROWN=o(u.fromCssColorString("#F4A460")),u.SEAGREEN=o(u.fromCssColorString("#2E8B57")),u.SEASHELL=o(u.fromCssColorString("#FFF5EE")),u.SIENNA=o(u.fromCssColorString("#A0522D")),u.SILVER=o(u.fromCssColorString("#C0C0C0")),u.SKYBLUE=o(u.fromCssColorString("#87CEEB")),u.SLATEBLUE=o(u.fromCssColorString("#6A5ACD")),u.SLATEGRAY=o(u.fromCssColorString("#708090")),u.SLATEGREY=u.SLATEGRAY,u.SNOW=o(u.fromCssColorString("#FFFAFA")),u.SPRINGGREEN=o(u.fromCssColorString("#00FF7F")),u.STEELBLUE=o(u.fromCssColorString("#4682B4")),u.TAN=o(u.fromCssColorString("#D2B48C")),u.TEAL=o(u.fromCssColorString("#008080")),u.THISTLE=o(u.fromCssColorString("#D8BFD8")),u.TOMATO=o(u.fromCssColorString("#FF6347")),u.TURQUOISE=o(u.fromCssColorString("#40E0D0")),u.VIOLET=o(u.fromCssColorString("#EE82EE")),u.WHEAT=o(u.fromCssColorString("#F5DEB3")),u.WHITE=o(u.fromCssColorString("#FFFFFF")),u.WHITESMOKE=o(u.fromCssColorString("#F5F5F5")),u.YELLOW=o(u.fromCssColorString("#FFFF00")),u.YELLOWGREEN=o(u.fromCssColorString("#9ACD32")),u.TRANSPARENT=o(new u(0,0,0,0)),u}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(t){"use strict";var e={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,DOUBLE:5130,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,COLOR:6144,DEPTH:6145,STENCIL:6146,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,MAX_3D_TEXTURE_SIZE:32883,UNSIGNED_INT_2_10_10_10_REV:33640,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,MAX_TEXTURE_LOD_BIAS:34045,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,VERTEX_ATTRIB_ARRAY_INTEGER:35069,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,UNSIGNED_INT_10F_11F_11F_REV:35899,RGB9_E5:35901,UNSIGNED_INT_5_9_9_9_REV:35902,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,RASTERIZER_DISCARD:35977,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,UNSIGNED_INT_24_8:34042,DEPTH24_STENCIL8:35056,UNSIGNED_NORMALIZED:35863,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,MAX_SAMPLES:36183,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,VERTEX_ARRAY_BINDING:34229,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,SIGNED_NORMALIZED:36764,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,INVALID_INDEX:4294967295,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,SAMPLER_BINDING:35097,RGB10_A2UI:36975,INT_2_10_10_10_REV:36255,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_SRGB8_ETC2:37493,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37494,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37495,COMPRESSED_RGBA8_ETC2_EAC:37496,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37497,TEXTURE_IMMUTABLE_FORMAT:37167,MAX_ELEMENT_INDEX:36203,TEXTURE_IMMUTABLE_LEVELS:33503};return t(e)}),define("Core/ComponentDatatype",["../Renderer/WebGLConstants","./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject"],function(t,e,r,n,o,a){"use strict";if(!o.supportsTypedArrays())return{};var i={BYTE:t.BYTE,UNSIGNED_BYTE:t.UNSIGNED_BYTE,SHORT:t.SHORT,UNSIGNED_SHORT:t.UNSIGNED_SHORT,FLOAT:t.FLOAT,DOUBLE:t.DOUBLE};return i.getSizeInBytes=function(t){switch(t){case i.BYTE:return Int8Array.BYTES_PER_ELEMENT;case i.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case i.SHORT:return Int16Array.BYTES_PER_ELEMENT;case i.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case i.FLOAT:return Float32Array.BYTES_PER_ELEMENT;case i.DOUBLE:return Float64Array.BYTES_PER_ELEMENT;default:throw new n("componentDatatype is not a valid value.")}},i.fromTypedArray=function(t){return t instanceof Int8Array?i.BYTE:t instanceof Uint8Array?i.UNSIGNED_BYTE:t instanceof Int16Array?i.SHORT:t instanceof Uint16Array?i.UNSIGNED_SHORT:t instanceof Float32Array?i.FLOAT:t instanceof Float64Array?i.DOUBLE:void 0},i.validate=function(t){return r(t)&&(t===i.BYTE||t===i.UNSIGNED_BYTE||t===i.SHORT||t===i.UNSIGNED_SHORT||t===i.FLOAT||t===i.DOUBLE)},i.createTypedArray=function(t,e){switch(t){case i.BYTE:return new Int8Array(e);case i.UNSIGNED_BYTE:return new Uint8Array(e);case i.SHORT:return new Int16Array(e);case i.UNSIGNED_SHORT:return new Uint16Array(e);case i.FLOAT:return new Float32Array(e);case i.DOUBLE:return new Float64Array(e);default:throw new n("componentDatatype is not a valid value.")}},i.createArrayBufferView=function(t,r,o,a){switch(o=e(o,0),a=e(a,(r.byteLength-o)/i.getSizeInBytes(t)),t){case i.BYTE:return new Int8Array(r,o,a);case i.UNSIGNED_BYTE:return new Uint8Array(r,o,a);case i.SHORT:return new Int16Array(r,o,a);case i.UNSIGNED_SHORT:return new Uint16Array(r,o,a);case i.FLOAT:return new Float32Array(r,o,a);case i.DOUBLE:return new Float64Array(r,o,a);default:throw new n("componentDatatype is not a valid value.")}},a(i)}),define("Core/GeometryType",["./freezeObject"],function(t){"use strict";var e={NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3};return t(e)}),define("Core/PrimitiveType",["../Renderer/WebGLConstants","./freezeObject"],function(t,e){"use strict";var r={POINTS:t.POINTS,LINES:t.LINES,LINE_LOOP:t.LINE_LOOP,LINE_STRIP:t.LINE_STRIP,TRIANGLES:t.TRIANGLES,TRIANGLE_STRIP:t.TRIANGLE_STRIP,TRIANGLE_FAN:t.TRIANGLE_FAN,validate:function(t){return t===r.POINTS||t===r.LINES||t===r.LINE_LOOP||t===r.LINE_STRIP||t===r.TRIANGLES||t===r.TRIANGLE_STRIP||t===r.TRIANGLE_FAN}};return e(r)}),define("Core/Geometry",["./defaultValue","./defined","./DeveloperError","./GeometryType","./PrimitiveType"],function(t,e,r,n,o){"use strict";function a(e){e=t(e,t.EMPTY_OBJECT),this.attributes=e.attributes,this.indices=e.indices,this.primitiveType=t(e.primitiveType,o.TRIANGLES),this.boundingSphere=e.boundingSphere,this.geometryType=t(e.geometryType,n.NONE),this.boundingSphereCV=void 0}return a.computeNumberOfVertices=function(t){var n=-1;for(var o in t.attributes)if(t.attributes.hasOwnProperty(o)&&e(t.attributes[o])&&e(t.attributes[o].values)){var a=t.attributes[o],i=a.values.length/a.componentsPerAttribute;if(n!==i&&-1!==n)throw new r("All attribute lists must have the same number of attributes.");n=i}return n},a}),define("Core/GeometryAttribute",["./defaultValue","./defined","./DeveloperError"],function(t,e,r){"use strict";function n(e){e=t(e,t.EMPTY_OBJECT),this.componentDatatype=e.componentDatatype,this.componentsPerAttribute=e.componentsPerAttribute,this.normalize=t(e.normalize,!1),this.values=e.values}return n}),define("Core/GeometryAttributes",["./defaultValue"],function(t){"use strict";function e(e){e=t(e,t.EMPTY_OBJECT),this.position=e.position,this.normal=e.normal,this.st=e.st,this.binormal=e.binormal,this.tangent=e.tangent,this.color=e.color}return e}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,o){"use strict";var a={UNSIGNED_BYTE:t.UNSIGNED_BYTE,UNSIGNED_SHORT:t.UNSIGNED_SHORT,UNSIGNED_INT:t.UNSIGNED_INT};return a.getSizeInBytes=function(t){switch(t){case a.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case a.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case a.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},a.validate=function(t){return e(t)&&(t===a.UNSIGNED_BYTE||t===a.UNSIGNED_SHORT||t===a.UNSIGNED_INT)},a.createTypedArray=function(t,e){return t>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(e):new Uint16Array(e)},a.createTypedArrayFromArrayBuffer=function(t,e,r,n){return t>=o.SIXTY_FOUR_KILOBYTES?new Uint32Array(e,r,n):new Uint16Array(e,r,n)},n(a)}),define("Core/EllipsoidGeodesic",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./Math"],function(t,e,r,n,o,a,i,u){"use strict";function s(t){var e=t._uSquared,r=t._ellipsoid.maximumRadius,n=t._ellipsoid.minimumRadius,o=(r-n)/r,a=Math.cos(t._startHeading),i=Math.sin(t._startHeading),u=(1-o)*Math.tan(t._start.latitude),s=1/Math.sqrt(1+u*u),E=s*u,l=Math.atan2(u,a),c=s*i,f=c*c,_=1-f,R=Math.sqrt(_),h=e/4,T=h*h,A=T*h,d=T*T,S=1+h-3*T/4+5*A/4-175*d/64,m=1-h+15*T/8-35*A/8,C=1-3*h+35*T/4,N=1-5*h,I=S*l-m*Math.sin(2*l)*h/2-C*Math.sin(4*l)*T/16-N*Math.sin(6*l)*A/48-5*Math.sin(8*l)*d/512,p=t._constants;p.a=r,p.b=n,p.f=o,p.cosineHeading=a,p.sineHeading=i,p.tanU=u,p.cosineU=s,p.sineU=E,p.sigma=l,p.sineAlpha=c,p.sineSquaredAlpha=f,p.cosineSquaredAlpha=_,p.cosineAlpha=R,p.u2Over4=h,p.u4Over16=T,p.u6Over64=A,p.u8Over256=d,p.a0=S,p.a1=m,p.a2=C,p.a3=N,p.distanceRatio=I}function E(t,e){return t*e*(4+t*(4-3*e))/16}function l(t,e,r,n,o,a,i){var u=E(t,r);return(1-u)*t*e*(n+u*o*(i+u*a*(2*i*i-1)))}function c(t,e,r,n,o,a,i){var s,E,c,f,_,R=(e-r)/e,h=a-n,T=Math.atan((1-R)*Math.tan(o)),A=Math.atan((1-R)*Math.tan(i)),d=Math.cos(T),S=Math.sin(T),m=Math.cos(A),C=Math.sin(A),N=d*m,I=d*C,p=S*C,M=S*m,O=h,g=u.TWO_PI,y=Math.cos(O),F=Math.sin(O);do{y=Math.cos(O),F=Math.sin(O);var L=I-M*y;c=Math.sqrt(m*m*F*F+L*L),E=p+N*y,s=Math.atan2(c,E);var v;0===c?(v=0,f=1):(v=N*F/c,f=1-v*v),g=O,_=E-2*p/f,isNaN(_)&&(_=0),O=h+l(R,v,f,s,c,E,_)}while(Math.abs(O-g)>u.EPSILON12);var D=f*(e*e-r*r)/(r*r),U=1+D*(4096+D*(D*(320-175*D)-768))/16384,P=D*(256+D*(D*(74-47*D)-128))/1024,w=_*_,B=P*c*(_+P*(E*(2*w-1)-P*_*(4*c*c-3)*(4*w-3)/6)/4),x=r*U*(s-B),G=Math.atan2(m*F,I-M*y),b=Math.atan2(d*F,I*y-M);t._distance=x,t._startHeading=G,t._endHeading=b,t._uSquared=D}function f(r,n,o,a){t.normalize(a.cartographicToCartesian(n,h),R),t.normalize(a.cartographicToCartesian(o,h),h);c(r,a.maximumRadius,a.minimumRadius,n.longitude,n.latitude,o.longitude,o.latitude),r._start=e.clone(n,r._start),r._end=e.clone(o,r._end),r._start.height=0,r._end.height=0,s(r)}function _(t,o,a){var u=r(a,i.WGS84);this._ellipsoid=u,this._start=new e,this._end=new e,this._constants={},this._startHeading=void 0,this._endHeading=void 0,this._distance=void 0,this._uSquared=void 0,n(t)&&n(o)&&f(this,t,o,u)}var R=new t,h=new t;return o(_.prototype,{ellipsoid:{get:function(){return this._ellipsoid}},surfaceDistance:{get:function(){return this._distance}},start:{get:function(){return this._start}},end:{get:function(){return this._end}},startHeading:{get:function(){return this._startHeading}},endHeading:{get:function(){return this._endHeading}}}),_.prototype.setEndPoints=function(t,e){f(this,t,e,this._ellipsoid)},_.prototype.interpolateUsingFraction=function(t,e){return this.interpolateUsingSurfaceDistance(this._distance*t,e)},_.prototype.interpolateUsingSurfaceDistance=function(t,r){
var o=this._constants,a=o.distanceRatio+t/o.b,i=Math.cos(2*a),u=Math.cos(4*a),s=Math.cos(6*a),E=Math.sin(2*a),c=Math.sin(4*a),f=Math.sin(6*a),_=Math.sin(8*a),R=a*a,h=a*R,T=o.u8Over256,A=o.u2Over4,d=o.u6Over64,S=o.u4Over16,m=2*h*T*i/3+a*(1-A+7*S/4-15*d/4+579*T/64-(S-15*d/4+187*T/16)*i-(5*d/4-115*T/16)*u-29*T*s/16)+(A/2-S+71*d/32-85*T/16)*E+(5*S/16-5*d/4+383*T/96)*c-R*((d-11*T/2)*E+5*T*c/2)+(29*d/96-29*T/16)*f+539*T*_/1536,C=Math.asin(Math.sin(m)*o.cosineAlpha),N=Math.atan(o.a/o.b*Math.tan(C));m-=o.sigma;var I=Math.cos(2*o.sigma+m),p=Math.sin(m),M=Math.cos(m),O=o.cosineU*M,g=o.sineU*p,y=Math.atan2(p*o.sineHeading,O-g*o.cosineHeading),F=y-l(o.f,o.sineAlpha,o.cosineSquaredAlpha,m,p,M,I);return n(r)?(r.longitude=this._start.longitude+F,r.latitude=N,r.height=0,r):new e(this._start.longitude+F,N,0)},_}),define("Core/QuadraticRealPolynomial",["./DeveloperError","./Math"],function(t,e){"use strict";function r(t,r,n){var o=t+r;return e.sign(t)!==e.sign(r)&&Math.abs(o/Math.max(Math.abs(t),Math.abs(r)))<n?0:o}var n={};return n.computeDiscriminant=function(t,e,r){var n=e*e-4*t*r;return n},n.computeRealRoots=function(t,n,o){var a;if(0===t)return 0===n?[]:[-o/n];if(0===n){if(0===o)return[0,0];var i=Math.abs(o),u=Math.abs(t);if(u>i&&i/u<e.EPSILON14)return[0,0];if(i>u&&u/i<e.EPSILON14)return[];if(a=-o/t,0>a)return[];var s=Math.sqrt(a);return[-s,s]}if(0===o)return a=-n/t,0>a?[a,0]:[0,a];var E=n*n,l=4*t*o,c=r(E,-l,e.EPSILON14);if(0>c)return[];var f=-.5*r(n,e.sign(n)*Math.sqrt(c),e.EPSILON14);return n>0?[f/t,o/f]:[o/f,f/t]},n}),define("Core/CubicRealPolynomial",["./DeveloperError","./QuadraticRealPolynomial"],function(t,e){"use strict";function r(t,e,r,n){var o,a,i=t,u=e/3,s=r/3,E=n,l=i*s,c=u*E,f=u*u,_=s*s,R=i*s-f,h=i*E-u*s,T=u*E-_,A=4*R*T-h*h;if(0>A){var d,S,m;f*c>=l*_?(d=i,S=R,m=-2*u*R+i*h):(d=E,S=T,m=-E*h+2*s*T);var C=0>m?-1:1,N=-C*Math.abs(d)*Math.sqrt(-A);a=-m+N;var I=a/2,p=0>I?-Math.pow(-I,1/3):Math.pow(I,1/3),M=a===N?-p:-S/p;return o=0>=S?p+M:-m/(p*p+M*M+S),f*c>=l*_?[(o-u)/i]:[-E/(o+s)]}var O=R,g=-2*u*R+i*h,y=T,F=-E*h+2*s*T,L=Math.sqrt(A),v=Math.sqrt(3)/2,D=Math.abs(Math.atan2(i*L,-g)/3);o=2*Math.sqrt(-O);var U=Math.cos(D);a=o*U;var P=o*(-U/2-v*Math.sin(D)),w=a+P>2*u?a-u:P-u,B=i,x=w/B;D=Math.abs(Math.atan2(E*L,-F)/3),o=2*Math.sqrt(-y),U=Math.cos(D),a=o*U,P=o*(-U/2-v*Math.sin(D));var G=-E,b=2*s>a+P?a+s:P+s,z=G/b,H=B*b,V=-w*b-B*G,X=w*G,q=(s*V-u*X)/(-u*V+s*H);return q>=x?z>=x?z>=q?[x,q,z]:[x,z,q]:[z,x,q]:z>=x?[q,x,z]:z>=q?[q,z,x]:[z,q,x]}var n={};return n.computeDiscriminant=function(t,e,r,n){var o=t*t,a=e*e,i=r*r,u=n*n,s=18*t*e*r*n+a*i-27*o*u-4*(t*i*r+a*e*n);return s},n.computeRealRoots=function(t,n,o,a){var i,u;if(0===t)return e.computeRealRoots(n,o,a);if(0===n){if(0===o){if(0===a)return[0,0,0];u=-a/t;var s=0>u?-Math.pow(-u,1/3):Math.pow(u,1/3);return[s,s,s]}return 0===a?(i=e.computeRealRoots(t,0,o),0===i.Length?[0]:[i[0],0,i[1]]):r(t,0,o,a)}return 0===o?0===a?(u=-n/t,0>u?[u,0,0]:[0,0,u]):r(t,n,0,a):0===a?(i=e.computeRealRoots(t,n,o),0===i.length?[0]:i[1]<=0?[i[0],i[1],0]:i[0]>=0?[0,i[0],i[1]]:[i[0],0,i[1]]):r(t,n,o,a)},n}),define("Core/QuarticRealPolynomial",["./CubicRealPolynomial","./DeveloperError","./Math","./QuadraticRealPolynomial"],function(t,e,r,n){"use strict";function o(e,o,a,i){var u=e*e,s=o-3*u/8,E=a-o*e/2+u*e/8,l=i-a*e/4+o*u/16-3*u*u/256,c=t.computeRealRoots(1,2*s,s*s-4*l,-E*E);if(c.length>0){var f=-e/4,_=c[c.length-1];if(Math.abs(_)<r.EPSILON14){var R=n.computeRealRoots(1,s,l);if(2===R.length){var h,T=R[0],A=R[1];if(T>=0&&A>=0){var d=Math.sqrt(T),S=Math.sqrt(A);return[f-S,f-d,f+d,f+S]}if(T>=0&&0>A)return h=Math.sqrt(T),[f-h,f+h];if(0>T&&A>=0)return h=Math.sqrt(A),[f-h,f+h]}return[]}if(_>0){var m=Math.sqrt(_),C=(s+_-E/m)/2,N=(s+_+E/m)/2,I=n.computeRealRoots(1,m,C),p=n.computeRealRoots(1,-m,N);return 0!==I.length?(I[0]+=f,I[1]+=f,0!==p.length?(p[0]+=f,p[1]+=f,I[1]<=p[0]?[I[0],I[1],p[0],p[1]]:p[1]<=I[0]?[p[0],p[1],I[0],I[1]]:I[0]>=p[0]&&I[1]<=p[1]?[p[0],I[0],I[1],p[1]]:p[0]>=I[0]&&p[1]<=I[1]?[I[0],p[0],p[1],I[1]]:I[0]>p[0]&&I[0]<p[1]?[p[0],I[0],p[1],I[1]]:[I[0],p[0],I[1],p[1]]):I):0!==p.length?(p[0]+=f,p[1]+=f,p):[]}}return[]}function a(e,o,a,i){var u=a*a,s=o*o,E=e*e,l=-2*o,c=a*e+s-4*i,f=E*i-a*o*e+u,_=t.computeRealRoots(1,l,c,f);if(_.length>0){var R,h,T=_[0],A=o-T,d=A*A,S=e/2,m=A/2,C=d-4*i,N=d+4*Math.abs(i),I=E-4*T,p=E+4*Math.abs(T);if(0>T||I*N>C*p){var M=Math.sqrt(I);R=M/2,h=0===M?0:(e*m-a)/M}else{var O=Math.sqrt(C);R=0===O?0:(e*m-a)/O,h=O/2}var g,y;0===S&&0===R?(g=0,y=0):r.sign(S)===r.sign(R)?(g=S+R,y=T/g):(y=S-R,g=T/y);var F,L;0===m&&0===h?(F=0,L=0):r.sign(m)===r.sign(h)?(F=m+h,L=i/F):(L=m-h,F=i/L);var v=n.computeRealRoots(1,g,F),D=n.computeRealRoots(1,y,L);if(0!==v.length)return 0!==D.length?v[1]<=D[0]?[v[0],v[1],D[0],D[1]]:D[1]<=v[0]?[D[0],D[1],v[0],v[1]]:v[0]>=D[0]&&v[1]<=D[1]?[D[0],v[0],v[1],D[1]]:D[0]>=v[0]&&D[1]<=v[1]?[v[0],D[0],D[1],v[1]]:v[0]>D[0]&&v[0]<D[1]?[D[0],v[0],D[1],v[1]]:[v[0],D[0],v[1],D[1]]:v;if(0!==D.length)return D}return[]}var i={};return i.computeDiscriminant=function(t,e,r,n,o){var a=t*t,i=a*t,u=e*e,s=u*e,E=r*r,l=E*r,c=n*n,f=c*n,_=o*o,R=_*o,h=u*E*c-4*s*f-4*t*l*c+18*t*e*r*f-27*a*c*c+256*i*R+o*(18*s*r*n-4*u*l+16*t*E*E-80*t*e*E*n-6*t*u*c+144*a*r*c)+_*(144*t*u*r-27*u*u-128*a*E-192*a*e*n);return h},i.computeRealRoots=function(e,n,i,u,s){if(Math.abs(e)<r.EPSILON15)return t.computeRealRoots(n,i,u,s);var E=n/e,l=i/e,c=u/e,f=s/e,_=0>E?1:0;switch(_+=0>l?_+1:_,_+=0>c?_+1:_,_+=0>f?_+1:_){case 0:return o(E,l,c,f);case 1:return a(E,l,c,f);case 2:return a(E,l,c,f);case 3:return o(E,l,c,f);case 4:return o(E,l,c,f);case 5:return a(E,l,c,f);case 6:return o(E,l,c,f);case 7:return o(E,l,c,f);case 8:return a(E,l,c,f);case 9:return o(E,l,c,f);case 10:return o(E,l,c,f);case 11:return a(E,l,c,f);case 12:return o(E,l,c,f);case 13:return o(E,l,c,f);case 14:return o(E,l,c,f);case 15:return o(E,l,c,f);default:return}},i}),define("Core/Ray",["./Cartesian3","./defaultValue","./defined","./DeveloperError"],function(t,e,r,n){"use strict";function o(r,n){n=t.clone(e(n,t.ZERO)),t.equals(n,t.ZERO)||t.normalize(n,n),this.origin=t.clone(e(r,t.ZERO)),this.direction=n}return o.getPoint=function(e,n,o){return r(o)||(o=new t),o=t.multiplyByScalar(e.direction,n,o),t.add(e.origin,o,o)},o}),define("Core/IntersectionTests",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Math","./Matrix3","./QuadraticRealPolynomial","./QuarticRealPolynomial","./Ray"],function(t,e,r,n,o,a,i,u,s,E){"use strict";function l(t,e,r,n){var o=e*e-4*t*r;if(!(0>o)){if(o>0){var a=1/(2*t),i=Math.sqrt(o),u=(-e+i)*a,s=(-e-i)*a;return s>u?(n.root0=u,n.root1=s):(n.root0=s,n.root1=u),n}var E=-e/(2*t);if(0!==E)return n.root0=n.root1=E,n}}function c(e,r,o){n(o)||(o={});var a=e.origin,i=e.direction,u=r.center,s=r.radius*r.radius,E=t.subtract(a,u,A),c=t.dot(i,i),f=2*t.dot(i,E),_=t.magnitudeSquared(E)-s,R=l(c,f,_,C);return n(R)?(o.start=R.root0,o.stop=R.root1,o):void 0}function f(t,e,r){var n=t+e;return a.sign(t)!==a.sign(e)&&Math.abs(n/Math.max(Math.abs(t),Math.abs(e)))<r?0:n}function _(e,r,n,o,E){var l,c=o*o,_=E*E,R=(e[i.COLUMN1ROW1]-e[i.COLUMN2ROW2])*_,h=E*(o*f(e[i.COLUMN1ROW0],e[i.COLUMN0ROW1],a.EPSILON15)+r.y),T=e[i.COLUMN0ROW0]*c+e[i.COLUMN2ROW2]*_+o*r.x+n,A=_*f(e[i.COLUMN2ROW1],e[i.COLUMN1ROW2],a.EPSILON15),d=E*(o*f(e[i.COLUMN2ROW0],e[i.COLUMN0ROW2])+r.z),S=[];if(0===d&&0===A){if(l=u.computeRealRoots(R,h,T),0===l.length)return S;var m=l[0],C=Math.sqrt(Math.max(1-m*m,0));if(S.push(new t(o,E*m,E*-C)),S.push(new t(o,E*m,E*C)),2===l.length){var N=l[1],I=Math.sqrt(Math.max(1-N*N,0));S.push(new t(o,E*N,E*-I)),S.push(new t(o,E*N,E*I))}return S}var p=d*d,M=A*A,O=R*R,g=d*A,y=O+M,F=2*(h*R+g),L=2*T*R+h*h-M+p,v=2*(T*h-g),D=T*T-p;if(0===y&&0===F&&0===L&&0===v)return S;l=s.computeRealRoots(y,F,L,v,D);var U=l.length;if(0===U)return S;for(var P=0;U>P;++P){var w,B=l[P],x=B*B,G=Math.max(1-x,0),b=Math.sqrt(G);w=a.sign(R)===a.sign(T)?f(R*x+T,h*B,a.EPSILON12):a.sign(T)===a.sign(h*B)?f(R*x,h*B+T,a.EPSILON12):f(R*x+h*B,T,a.EPSILON12);var z=f(A*B,d,a.EPSILON15),H=w*z;0>H?S.push(new t(o,E*B,E*b)):H>0?S.push(new t(o,E*B,E*-b)):0!==b?(S.push(new t(o,E*B,E*-b)),S.push(new t(o,E*B,E*b)),++P):S.push(new t(o,E*B,E*b))}return S}var R={};R.rayPlane=function(e,r,o){n(o)||(o=new t);var i=e.origin,u=e.direction,s=r.normal,E=t.dot(s,u);if(!(Math.abs(E)<a.EPSILON15)){var l=(-r.distance-t.dot(s,i))/E;if(!(0>l))return o=t.multiplyByScalar(u,l,o),t.add(i,o,o)}};var h=new t,T=new t,A=new t,d=new t,S=new t;R.rayTriangleParametric=function(e,n,o,i,u){u=r(u,!1);var s,E,l,c,f,_=e.origin,R=e.direction,m=t.subtract(o,n,h),C=t.subtract(i,n,T),N=t.cross(R,C,A),I=t.dot(m,N);if(u){if(I<a.EPSILON6)return;if(s=t.subtract(_,n,d),l=t.dot(s,N),0>l||l>I)return;if(E=t.cross(s,m,S),c=t.dot(R,E),0>c||l+c>I)return;f=t.dot(C,E)/I}else{if(Math.abs(I)<a.EPSILON6)return;var p=1/I;if(s=t.subtract(_,n,d),l=t.dot(s,N)*p,0>l||l>1)return;if(E=t.cross(s,m,S),c=t.dot(R,E)*p,0>c||l+c>1)return;f=t.dot(C,E)*p}return f},R.rayTriangle=function(e,r,o,a,i,u){var s=R.rayTriangleParametric(e,r,o,a,i);if(n(s)&&!(0>s))return n(u)||(u=new t),t.multiplyByScalar(e.direction,s,u),t.add(e.origin,u,u)};var m=new E;R.lineSegmentTriangle=function(e,r,o,a,i,u,s){var E=m;t.clone(e,E.origin),t.subtract(r,e,E.direction),t.normalize(E.direction,E.direction);var l=R.rayTriangleParametric(E,o,a,i,u);return!n(l)||0>l||l>t.distance(e,r)?void 0:(n(s)||(s=new t),t.multiplyByScalar(E.direction,l,s),t.add(E.origin,s,s))};var C={root0:0,root1:0};R.raySphere=function(t,e,r){return r=c(t,e,r),!n(r)||r.stop<0?void 0:(r.start=Math.max(r.start,0),r)};var N=new E;R.lineSegmentSphere=function(e,r,o,a){var i=N;t.clone(e,i.origin);var u=t.subtract(r,e,i.direction),s=t.magnitude(u);return t.normalize(u,u),a=c(i,o,a),!n(a)||a.stop<0||a.start>s?void 0:(a.start=Math.max(a.start,0),a.stop=Math.min(a.stop,s),a)};var I=new t,p=new t;R.rayEllipsoid=function(e,r){var n,o,a,i,u,s=r.oneOverRadii,E=t.multiplyComponents(s,e.origin,I),l=t.multiplyComponents(s,e.direction,p),c=t.magnitudeSquared(E),f=t.dot(E,l);if(c>1){if(f>=0)return;var _=f*f;if(n=c-1,o=t.magnitudeSquared(l),a=o*n,a>_)return;if(_>a){i=f*f-a,u=-f+Math.sqrt(i);var R=u/o,h=n/u;return h>R?{start:R,stop:h}:{start:h,stop:R}}var T=Math.sqrt(n/o);return{start:T,stop:T}}return 1>c?(n=c-1,o=t.magnitudeSquared(l),a=o*n,i=f*f-a,u=-f+Math.sqrt(i),{start:0,stop:u/o}):0>f?(o=t.magnitudeSquared(l),{start:0,stop:-f/o}):void 0};var M=new t,O=new t,g=new t,y=new t,F=new t,L=new i,v=new i,D=new i,U=new i,P=new i,w=new i,B=new i,x=new t,G=new t,b=new e;R.grazingAltitudeLocation=function(e,r){var o=e.origin,u=e.direction,s=r.geodeticSurfaceNormal(o,M);if(t.dot(u,s)>=0)return o;var E=n(this.rayEllipsoid(e,r)),l=r.transformPositionToScaledSpace(u,M),c=t.normalize(l,l),f=t.mostOrthogonalAxis(l,y),R=t.normalize(t.cross(f,c,O),O),h=t.normalize(t.cross(c,R,g),g),T=L;T[0]=c.x,T[1]=c.y,T[2]=c.z,T[3]=R.x,T[4]=R.y,T[5]=R.z,T[6]=h.x,T[7]=h.y,T[8]=h.z;var A=i.transpose(T,v),d=i.fromScale(r.radii,D),S=i.fromScale(r.oneOverRadii,U),m=P;m[0]=0,m[1]=-u.z,m[2]=u.y,m[3]=u.z,m[4]=0,m[5]=-u.x,m[6]=-u.y,m[7]=u.x,m[8]=0;var C,N,I=i.multiply(i.multiply(A,S,w),m,w),p=i.multiply(i.multiply(I,d,B),T,B),z=i.multiplyByVector(I,o,F),H=_(p,t.negate(z,M),0,0,1),V=H.length;if(V>0){for(var X=t.clone(t.ZERO,G),q=Number.NEGATIVE_INFINITY,W=0;V>W;++W){C=i.multiplyByVector(d,i.multiplyByVector(T,H[W],x),x);var Y=t.normalize(t.subtract(C,o,y),y),K=t.dot(Y,u);K>q&&(q=K,X=t.clone(C,X))}var k=r.cartesianToCartographic(X,b);return q=a.clamp(q,0,1),N=t.magnitude(t.subtract(X,o,y))*Math.sqrt(1-q*q),N=E?-N:N,k.height=N,r.cartographicToCartesian(k,new t)}};var z=new t;return R.lineSegmentPlane=function(e,r,o,i){n(i)||(i=new t);var u=t.subtract(r,e,z),s=o.normal,E=t.dot(s,u);if(!(Math.abs(E)<a.EPSILON6)){var l=t.dot(s,e),c=-(o.distance+l)/E;if(!(0>c||c>1))return t.multiplyByScalar(u,c,i),t.add(e,i,i),i}},R.trianglePlaneIntersection=function(e,r,n,o){var a=o.normal,i=o.distance,u=t.dot(a,e)+i<0,s=t.dot(a,r)+i<0,E=t.dot(a,n)+i<0,l=0;l+=u?1:0,l+=s?1:0,l+=E?1:0;var c,f;if((1===l||2===l)&&(c=new t,f=new t),1===l){if(u)return R.lineSegmentPlane(e,r,o,c),R.lineSegmentPlane(e,n,o,f),{positions:[e,r,n,c,f],indices:[0,3,4,1,2,4,1,4,3]};if(s)return R.lineSegmentPlane(r,n,o,c),R.lineSegmentPlane(r,e,o,f),{positions:[e,r,n,c,f],indices:[1,3,4,2,0,4,2,4,3]};if(E)return R.lineSegmentPlane(n,e,o,c),R.lineSegmentPlane(n,r,o,f),{positions:[e,r,n,c,f],indices:[2,3,4,0,1,4,0,4,3]}}else if(2===l){if(!u)return R.lineSegmentPlane(r,e,o,c),R.lineSegmentPlane(n,e,o,f),{positions:[e,r,n,c,f],indices:[1,2,4,1,4,3,0,3,4]};if(!s)return R.lineSegmentPlane(n,r,o,c),R.lineSegmentPlane(e,r,o,f),{positions:[e,r,n,c,f],indices:[2,0,4,2,4,3,1,3,4]};if(!E)return R.lineSegmentPlane(e,n,o,c),R.lineSegmentPlane(r,n,o,f),{positions:[e,r,n,c,f],indices:[0,1,4,0,4,3,2,3,4]}}},R}),define("Core/isArray",["./defined"],function(t){"use strict";var e=Array.isArray;return t(e)||(e=function(t){return"[object Array]"===Object.prototype.toString.call(t)}),e}),define("Core/PolylinePipeline",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./EllipsoidGeodesic","./IntersectionTests","./isArray","./Math","./Matrix4","./Plane"],function(t,e,r,n,o,a,i,u,s,E,l,c){"use strict";function f(t,e,r){var n=p;n.length=t;var o;if(e===r){for(o=0;t>o;o++)n[o]=e;return n}var a=r-e,i=a/t;for(o=0;t>o;o++){var u=e+o*i;n[o]=u}return n}function _(e,r,n,o,a,i,u,s){var E=o.scaleToGeodeticSurface(e,y),l=o.scaleToGeodeticSurface(r,F),c=R.numberOfPoints(e,r,n),_=o.cartesianToCartographic(E,M),h=o.cartesianToCartographic(l,O),T=f(c,a,i);L.setEndPoints(_,h);var A=L.surfaceDistance/c,d=s;_.height=a;var S=o.cartographicToCartesian(_,g);t.pack(S,u,d),d+=3;for(var m=1;c>m;m++){var C=L.interpolateUsingSurfaceDistance(m*A,O);C.height=T[m],S=o.cartographicToCartesian(C,g),t.pack(S,u,d),d+=3}return d}var R={};R.numberOfPoints=function(e,r,n){var o=t.distance(e,r);return Math.ceil(o/n)};var h=new e;R.extractHeights=function(t,e){for(var r=t.length,n=new Array(r),o=0;r>o;o++){var a=t[o];n[o]=e.cartesianToCartographic(a,h).height}return n};var T=new l,A=new t,d=new t,S=new c(t.ZERO,0),m=new t,C=new c(t.ZERO,0),N=new t,I=new t,p=[],M=new e,O=new e,g=new t,y=new t,F=new t,L=new i;return R.wrapLongitude=function(e,o){var a=[],i=[];if(n(e)&&e.length>0){o=r(o,l.IDENTITY);var s=l.inverseTransformation(o,T),E=l.multiplyByPoint(s,t.ZERO,A),f=l.multiplyByPointAsVector(s,t.UNIT_Y,d),_=c.fromPointNormal(E,f,S),R=l.multiplyByPointAsVector(s,t.UNIT_X,m),h=c.fromPointNormal(E,R,C),p=1;a.push(t.clone(e[0]));for(var M=a[0],O=e.length,g=1;O>g;++g){var y=e[g];if(c.getPointDistance(h,M)<0||c.getPointDistance(h,y)<0){var F=u.lineSegmentPlane(M,y,_,N);if(n(F)){var L=t.multiplyByScalar(f,5e-9,I);c.getPointDistance(_,M)<0&&t.negate(L,L),a.push(t.add(F,L,new t)),i.push(p+1),t.negate(L,L),a.push(t.add(F,L,new t)),p=1}}a.push(t.clone(e[g])),p++,M=y}i.push(p)}return{positions:a,lengths:i}},R.generateArc=function(e){n(e)||(e={});var o=e.positions,i=o.length,u=r(e.ellipsoid,a.WGS84),l=r(e.height,0);if(1>i)return[];if(1===i){var c=u.scaleToGeodeticSurface(o[0],y);if(0!==l){var f=u.geodeticSurfaceNormal(c,g);t.multiplyByScalar(f,l,f),t.add(c,f,c)}return[c.x,c.y,c.z]}var h=e.minDistance;if(!n(h)){var T=r(e.granularity,E.RADIANS_PER_DEGREE);h=E.chordLength(T,u.maximumRadius)}var A,d=0;for(A=0;i-1>A;A++)d+=R.numberOfPoints(o[A],o[A+1],h);var S=3*(d+1),m=new Array(S),C=0,N=s(l);for(A=0;i-1>A;A++){var I=o[A],O=o[A+1],F=N?l[A]:l,L=N?l[A+1]:l;C=_(I,O,h,u,F,L,m,C)}p.length=0;var v=o[i-1],D=u.cartesianToCartographic(v,M);D.height=N?l[i-1]:l;var U=u.cartographicToCartesian(D,g);return t.pack(U,m,S-3),m},R.generateCartesianArc=function(e){for(var r=R.generateArc(e),n=r.length/3,o=new Array(n),a=0;n>a;a++)o[a]=t.unpack(r,3*a);return o},R}),define("Core/VertexFormat",["./defaultValue","./defined","./DeveloperError","./freezeObject"],function(t,e,r,n){"use strict";function o(e){e=t(e,t.EMPTY_OBJECT),this.position=t(e.position,!1),this.normal=t(e.normal,!1),this.st=t(e.st,!1),this.binormal=t(e.binormal,!1),this.tangent=t(e.tangent,!1),this.color=t(e.color,!1)}return o.POSITION_ONLY=n(new o({position:!0})),o.POSITION_AND_NORMAL=n(new o({position:!0,normal:!0})),o.POSITION_NORMAL_AND_ST=n(new o({position:!0,normal:!0,st:!0})),o.POSITION_AND_ST=n(new o({position:!0,st:!0})),o.POSITION_AND_COLOR=n(new o({position:!0,color:!0})),o.ALL=n(new o({position:!0,normal:!0,st:!0,binormal:!0,tangent:!0})),o.DEFAULT=o.POSITION_NORMAL_AND_ST,o.packedLength=6,o.pack=function(e,r,n){n=t(n,0),r[n++]=e.position?1:0,r[n++]=e.normal?1:0,r[n++]=e.st?1:0,r[n++]=e.binormal?1:0,r[n++]=e.tangent?1:0,r[n++]=e.color?1:0},o.unpack=function(r,n,a){return n=t(n,0),e(a)||(a=new o),a.position=1===r[n++],a.normal=1===r[n++],a.st=1===r[n++],a.binormal=1===r[n++],a.tangent=1===r[n++],a.color=1===r[n++],a},o.clone=function(t,r){return e(t)?(e(r)||(r=new o),r.position=t.position,r.normal=t.normal,r.st=t.st,r.binormal=t.binormal,r.tangent=t.tangent,r.color=t.color,r):void 0},o}),define("Core/PolylineGeometry",["./arrayRemoveDuplicates","./BoundingSphere","./Cartesian3","./Color","./ComponentDatatype","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./Geometry","./GeometryAttribute","./GeometryAttributes","./GeometryType","./IndexDatatype","./Math","./PolylinePipeline","./PrimitiveType","./VertexFormat"],function(t,e,r,n,o,a,i,u,s,E,l,c,f,_,R,h,T,A){"use strict";function d(t,e,r,o,a){var i=m;i.length=a;var u,s=r.red,E=r.green,l=r.blue,c=r.alpha,f=o.red,_=o.green,R=o.blue,h=o.alpha;if(n.equals(r,o)){for(u=0;a>u;u++)i[u]=n.clone(r);return i}var T=(f-s)/a,A=(_-E)/a,d=(R-l)/a,S=(h-c)/a;for(u=0;a>u;u++)i[u]=new n(s+u*T,E+u*A,l+u*d,c+u*S);return i}function S(t){t=a(t,a.EMPTY_OBJECT);var e=t.positions,o=t.colors,u=a(t.width,1),E=a(t.colorsPerVertex,!1);this._positions=e,this._colors=o,this._width=u,this._colorsPerVertex=E,this._vertexFormat=A.clone(a(t.vertexFormat,A.DEFAULT)),this._followSurface=a(t.followSurface,!0),this._granularity=a(t.granularity,R.RADIANS_PER_DEGREE),this._ellipsoid=s.clone(a(t.ellipsoid,s.WGS84)),this._workerName="createPolylineGeometry";var l=1+e.length*r.packedLength;l+=i(o)?1+o.length*n.packedLength:1,this.packedLength=l+s.packedLength+A.packedLength+4}var m=[];S.pack=function(t,e,o){o=a(o,0);var u,E=t._positions,l=E.length;for(e[o++]=l,u=0;l>u;++u,o+=r.packedLength)r.pack(E[u],e,o);var c=t._colors;for(l=i(c)?c.length:0,e[o++]=l,u=0;l>u;++u,o+=n.packedLength)n.pack(c[u],e,o);s.pack(t._ellipsoid,e,o),o+=s.packedLength,A.pack(t._vertexFormat,e,o),o+=A.packedLength,e[o++]=t._width,e[o++]=t._colorsPerVertex?1:0,e[o++]=t._followSurface?1:0,e[o]=t._granularity};var C=s.clone(s.UNIT_SPHERE),N=new A,I={positions:void 0,colors:void 0,ellipsoid:C,vertexFormat:N,width:void 0,colorsPerVertex:void 0,followSurface:void 0,granularity:void 0};S.unpack=function(t,e,o){e=a(e,0);var u,E=t[e++],l=new Array(E);for(u=0;E>u;++u,e+=r.packedLength)l[u]=r.unpack(t,e);E=t[e++];var c=E>0?new Array(E):void 0;for(u=0;E>u;++u,e+=n.packedLength)c[u]=n.unpack(t,e);var f=s.unpack(t,e,C);e+=s.packedLength;var _=A.unpack(t,e,N);e+=A.packedLength;var R=t[e++],h=1===t[e++],T=1===t[e++],d=t[e];return i(o)?(o._positions=l,o._colors=c,o._ellipsoid=s.clone(f,o._ellipsoid),o._vertexFormat=A.clone(_,o._vertexFormat),o._width=R,o._colorsPerVertex=h,o._followSurface=T,o._granularity=d,o):(I.positions=l,I.colors=c,I.width=R,I.colorsPerVertex=h,I.followSurface=T,I.granularity=d,new S(I))};var p=new r,M=new r,O=new r,g=new r;return S.createGeometry=function(a){var u,s,A,S=a._width,C=a._vertexFormat,N=a._colors,I=a._colorsPerVertex,y=a._followSurface,F=a._granularity,L=a._ellipsoid,v=t(a._positions,r.equalsEpsilon),D=v.length;if(!(2>D)){if(y){var U=h.extractHeights(v,L),P=R.chordLength(F,L.maximumRadius);if(i(N)){var w=1;for(u=0;D-1>u;++u)w+=h.numberOfPoints(v[u],v[u+1],P);var B=new Array(w),x=0;for(u=0;D-1>u;++u){var G=v[u],b=v[u+1],z=N[u],H=h.numberOfPoints(G,b,P);if(I&&w>u){var V=N[u+1],X=d(G,b,z,V,H),q=X.length;for(s=0;q>s;++s)B[x++]=X[s]}else for(s=0;H>s;++s)B[x++]=n.clone(z)}B[x]=n.clone(N[N.length-1]),N=B,m.length=0}v=h.generateCartesianArc({positions:v,minDistance:P,ellipsoid:L,height:U})}D=v.length;var W,Y=4*D-4,K=new Float64Array(3*Y),k=new Float64Array(3*Y),Z=new Float64Array(3*Y),j=new Float32Array(2*Y),Q=C.st?new Float32Array(2*Y):void 0,J=i(N)?new Uint8Array(4*Y):void 0,$=0,tt=0,et=0,rt=0;for(s=0;D>s;++s){0===s?(W=p,r.subtract(v[0],v[1],W),r.add(v[0],W,W)):W=v[s-1],r.clone(W,O),r.clone(v[s],M),s===D-1?(W=p,r.subtract(v[D-1],v[D-2],W),r.add(v[D-1],W,W)):W=v[s+1],r.clone(W,g);var nt,ot;i(J)&&(nt=0===s||I?N[s]:N[s-1],s!==D-1&&(ot=N[s]));var at=0===s?2:0,it=s===D-1?2:4;for(A=at;it>A;++A){r.pack(M,K,$),r.pack(O,k,$),r.pack(g,Z,$),$+=3;var ut=0>A-2?-1:1;if(j[tt++]=2*(A%2)-1,j[tt++]=ut*S,C.st&&(Q[et++]=s/(D-1),Q[et++]=Math.max(j[tt-2],0)),i(J)){var st=2>A?nt:ot;J[rt++]=n.floatToByte(st.red),J[rt++]=n.floatToByte(st.green),J[rt++]=n.floatToByte(st.blue),J[rt++]=n.floatToByte(st.alpha)}}}var Et=new c;Et.position=new l({componentDatatype:o.DOUBLE,componentsPerAttribute:3,values:K}),Et.prevPosition=new l({componentDatatype:o.DOUBLE,componentsPerAttribute:3,values:k}),Et.nextPosition=new l({componentDatatype:o.DOUBLE,componentsPerAttribute:3,values:Z}),Et.expandAndWidth=new l({componentDatatype:o.FLOAT,componentsPerAttribute:2,values:j}),C.st&&(Et.st=new l({componentDatatype:o.FLOAT,componentsPerAttribute:2,values:Q})),i(J)&&(Et.color=new l({componentDatatype:o.UNSIGNED_BYTE,componentsPerAttribute:4,values:J,normalize:!0}));var lt=_.createTypedArray(Y,6*D-6),ct=0,ft=0,_t=D-1;for(s=0;_t>s;++s)lt[ft++]=ct,lt[ft++]=ct+2,lt[ft++]=ct+1,lt[ft++]=ct+1,lt[ft++]=ct+2,lt[ft++]=ct+3,ct+=4;return new E({attributes:Et,indices:lt,primitiveType:T.TRIANGLES,boundingSphere:e.fromPoints(v),geometryType:f.POLYLINES})}},S}),define("Workers/createPolylineGeometry",["../Core/defined","../Core/Ellipsoid","../Core/PolylineGeometry"],function(t,e,r){"use strict";function n(n,o){return t(o)&&(n=r.unpack(n,o)),n._ellipsoid=e.clone(n._ellipsoid),r.createGeometry(n)}return n})}();